#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define x first
#define y second

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int mod = (1e9) + 9, p = 3;
const int modsq = mod * mod;

int powp[200009];
int pref[200009];
int psum[200009][2];
vector<pii> blocks;
int prefbl[200009];
int n;
string s;

void build() {
    powp[0] = 1;
    for (int i = 0; i < n; i ++) {
        powp[i + 1] = (powp[i] * p) % mod;
    }

    for (int i = 0; i < n; i ++) {
        pref[i + 1] = (pref[i] * p + s[i]) % mod;
    }

    for (int i = 0; i < n; i ++) {
        psum[i + 1][0] = psum[i][0];
        psum[i + 1][1] = psum[i][1];
        psum[i + 1][i & 1] += s[i];
    }

    int st = -1;
    for (int i = 0; i < n; i ++) {
        if (s[i] == 1) {
            if (st == -1) st = i;
        }

        else {
            if (st != -1) {
                blocks.emplace_back(st, i - 1);
                st = -1;
            }
        }
    }

    if (st != -1) {
        blocks.emplace_back(st, n - 1);
    }

    for (int i = 0; i < blocks.size(); i ++) {
        prefbl[i + 1] = prefbl[i] + (blocks[i].y - blocks[i].x + 1) / 2;
    }
}

int geth(int l, int r) {
    r++;
    return (pref[r] - pref[l] * powp[r - l] + modsq) % mod;
}

bool cmp(pii a, int x) {
    return a.y < x;
}

bool cmp2(int x, pii a) {
    return x < a.x;
}

int gets(int l, int r) {
    if (l > r) return 0;
    return prefbl[r + 1] - prefbl[l];
}

int cnt_bl(int l, int r) {
    //cout << "ASK: " << l + 1 << ' ' << r + 1 << endl;
    auto retl = lower_bound(blocks.begin(), blocks.end(), l, cmp) - blocks.begin();
    auto retr = upper_bound(blocks.begin(), blocks.end(), r, cmp2) - blocks.begin();
    retr--;
    //cout << "GET: " << retl + 1 << ' ' << retr + 1 << endl;
    if (retl == blocks.size()) return 0;
    if (retr < 0) return 0;

    //cout << "ALIVE: " << retl + 1 << ' ' << retr + 1 << endl;

    int partsum = 0;

    if (retl > retr) return 0;

    if (retl == retr) {
        //cout << "EQUAL: " << (min(blocks[retr].y, r) - max(blocks[retl].x, l) + 1) / 2 << endl;
        return (min(blocks[retr].y, r) - max(blocks[retl].x, l) + 1) / 2;
    }

    if (blocks[retl].x <= l) {
        partsum += (blocks[retl].y - l + 1) / 2;
        retl++;
    }

    if (blocks[retr].y >= r) {
        partsum += (r - blocks[retr].x + 1) / 2;
        retr--;
    }

    partsum += gets(retl, retr);
    //cout << "RETURN: " << partsum << endl;
    return partsum;
}

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    cin >> s;

    for (auto &u : s) {
        u -= '0';
    }

    build();

    int qqq;
    cin >> qqq;

    while (qqq--) {
        int l1, l2, len;
        cin >> l1 >> l2 >> len;
        l1--;
        l2--;

        int r1 = l1 + len - 1, r2 = l2 + len - 1;

        if (geth(l1, r1) == geth(l2, r2)) {
            cout << "Yes\n";
            continue;
        }

        if (psum[r1 + 1][0] - psum[l1][0] != psum[r2 + 1][0] - psum[l2][0] || psum[r1 + 1][1] - psum[l1][1] != psum[r2 + 1][1] - psum[l2][1]) {
            cout << "No\n";
            continue;
        }

        if (cnt_bl(l1, r1) != cnt_bl(l2, r2)) {
            cout << "No\n";
            continue;
        }

        cout << "Yes\n";
    }

    return 0;
}

