#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>
#include <climits>
#include <deque>

#define int long long

using namespace std;

const int N = 2e5 + 100;
vector <int> g[N];
vector <int> g_rev[N];

void solve() {
    int n, m;
    cin >> n >> m;
    for (int _ = 0; _ < m; _++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g_rev[b].push_back(a);
    }

    int k;
    cin >> k;
    vector <int> way(k);
    for (int& i : way) {
        cin >> i;
        i--;
    }
    int finish = way.back();

    vector <int> dist(n, INT_MAX);
    dist[finish] = 0;
    deque <int> q;
    q.push_back(finish);

    while (!q.empty()) {
        int v = q.front();
        q.pop_front();
        for (int i : g_rev[v]) {
            if (dist[i] == INT_MAX) {
                dist[i] = dist[v] + 1;
                q.push_back(i);
            }
        }
    }

    int mn = 0, mx = 0;
    for (int i = 0; i < (int) way.size() - 1; i++) {
        int v = way[i];
        int cnt = 0, temp_mn = INT_MAX;
        for (int j : g[v]) {
            if (dist[j] == dist[way[i + 1]])
                cnt++;
            temp_mn = min(temp_mn, dist[j]);
        }
        if (temp_mn < dist[way[i + 1]]) {
            mn++, mx++;
        } else if (cnt > 1) {
            mx++;
        }
    }
    cout << mn << " " << mx << endl;
}


signed main() {
    int q = 1;
//    cin >> q;
    while (q--) {
        solve();
    }
    return 0;
}
