#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>
#include <climits>
#include <deque>
#include <array>

#define int long long

using namespace std;



void solve() {
    int n, m, p;
    cin >> n >> m >> p;
    vector <pair <int, int>> sword(n);
    for (auto& i : sword)
        cin >> i.first >> i.second;
    vector <pair <int, int>> armor(m);
    for (auto& i : armor)
        cin >> i.first >> i.second;

    vector <array <int, 3>> enemy(p);
    for (auto& i : enemy) {
        cin >> i[0] >> i[1] >> i[2];
    }

    sort(sword.begin(), sword.end(), [](pair <int, int>& a, pair <int, int>& b) { return a.second < b.second;});
    sort(armor.begin(), armor.end(), [](pair <int, int>& a, pair <int, int>& b) { return a.second < b.second;});
    sort(enemy.begin(), enemy.end());

    int sw = 0, ar = 0;
    int cost = sword[sw].second + armor[ar].second;
    int ans = -cost;
    int prize = 0;

    for (int i = 0; i < n; i++) {
        while (sw < n && sword[sw].first <= enemy[i][0])
            sw++;
        while (ar < m && armor[ar].first <= enemy[i][1])
            ar++;
        if (sw == n || ar == m)
            break;
        cost = sword[sw].second + armor[ar].second;
        prize += enemy[i][2];
        ans = max(ans, prize - cost);
    }
    cout << ans << endl;
}


signed main() {
    int q = 1;
//    cin >> q;
    while (q--) {
        solve();
    }
    return 0;
}
