#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>
#include <climits>
#include <deque>
#include <array>

#define int long long

using namespace std;

const int N = (int) 2e5 + 100;
int tree[4 * N];
int change[4 * N];
int a[N];

//void build(int v, int l, int r, vector <pair <int, int>>& a) {
//    if (r - l == 1) {
//        tree[v] = -a[l].second;
//        return;
//    }
//    int m = (l + r) / 2;
//    build(v * 2, l, m, a);
//    build(v * 2 + 1, m, r, a);
//    tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
//}
//
//void upd(int v, int l, int r, int tl, int tr, int val) {
//    if (r <= tl || l >= tr) {
//        return;
//    }
//    tree[v] += change[v];
//    change[v] = 0;
//    if (l >= tl && r <= tr) {
//        change[v * 2] += val;
//        change[v * 2 + 1] += val;
//        tree[v] += val;
//        return;
//    }
//    int m = (l + r) / 2;
//    upd(v * 2, l, m, tl, tr, val);
//    upd(v * 2 + 1, m, r, tl, tr, val);
//    tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
//}

void build(int _, int __, int ___, vector <pair <int, int>>& x) {
    tree[1] = INT_MIN;
    for (int i = 0; i < (int) x.size(); i++) {
        a[i] -= x[i].second;
        tree[1] = max(tree[1], a[i]);
    }
}

void upd(int _, int __, int ___, int l, int r, int val) {
    for (int i = l; i < r; i++) {
        a[i] += val;
        tree[1] = max(tree[1], a[i]);
    }
}

void solve() {
    int n, m, p;
    cin >> n >> m >> p;

    vector<pair<int, int>> sword(n);
    for (auto &i : sword)
        cin >> i.first >> i.second;

    vector<pair<int, int>> armor(m);
    for (auto &i : armor)
        cin >> i.first >> i.second;

    vector<array<int, 3>> enemy(p);
    for (auto &i : enemy) {
        cin >> i[0] >> i[1] >> i[2];
    }

    sort(sword.begin(), sword.end(), [](pair<int, int> &a, pair<int, int> &b) { return a.second < b.second; });
    sort(armor.begin(), armor.end(), [](pair<int, int> &a, pair<int, int> &b) { return a.second < b.second; });
    sort(enemy.begin(), enemy.end());

    vector <pair <int, int>> new_armor;

    int mx = INT_MIN;
    for (int i = 0; i < m; i++) {
        if (armor[i].first > mx) {
            mx = armor[i].second;
            new_armor.push_back(armor[i]);
        }
    }

    armor = new_armor;
    m = armor.size();

    build(1, 0, m, armor);

    int sw = 0;
    int ans = -sword[0].second - armor[0].second;

    for (int i = 0; i < p; i++) {
        while (sw < n && enemy[i][1] >= sword[sw].first)
            sw++;
        int l = -1, r = m;
        while (r - l > 1) {
            int q = (l + r) / 2;
            if (armor[q].first > enemy[i][0])
                r = q;
            else
                l = q;
        }

        if (sw == n || r == m)
            continue;
        upd(1, 0, n, r, m, enemy[i][2]);
        ans = max(ans, tree[1] - sword[sw].second);
    }
    cout << ans << endl;
}


signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);

    int q = 1;
//    cin >> q;
    while (q--) {
        solve();
    }
    return 0;
}
