#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define loop(i, n) for(int i = 0; i<n; ++i)
#define FOR(i, n, m) for(int i = n; i<m; ++i)
#define fr first
#define sc second

const int pivo = 1e9 + 7;
const int INF = 1e18;

struct pol_hash
{
    vector <int> st1, st2, hash1, hash2;
    const int MOD1 = 1e9 + 7, MOD2 = 1e9 + 53;
    const int P1 = 31, P2 = 53;
    pol_hash(string s)
    {
        int n = s.size();
        st1.resize(n + 1, 1), st2.resize(n + 1, 1), hash1.resize(n + 1, 0), hash2.resize(n + 1, 0);
        FOR(i, 1, n + 1) st1[i] = (st1[i - 1] * P1)%MOD1;
        FOR(i, 1, n + 1) st2[i] = (st2[i - 1] * P2)%MOD2;

        FOR(i, 1, n + 1) hash1[i] = ((hash1[i - 1] * P1)%MOD1 + s[i] - 'a' + 1 + MOD1)%MOD1;
        FOR(i, 1, n + 1) hash2[i] = ((hash2[i - 1] * P2)%MOD2 + s[i] - 'a' + 1 + MOD2)%MOD2;
    }
    int get_hash(int l, int r)
    {
        int res1 = (hash1[r + 1] - (hash1[l] * st1[r - l + 1]) % MOD1 + 10 * MOD1)%MOD1;
        int res2 = (hash2[r + 1] - (hash2[l] * st2[r - l + 1]) % MOD2 + 10 * MOD2)%MOD2;
        int f = res1 * MOD2 + res2;
        return f;
    }
};

vector <int> prefix(string s)
{
    int n = s.size();
    vector <int> pi(n, 0);
    FOR(i, 1, n)
    {
        int j = pi[i - 1];
        while(j > 0 && s[i] != s[j])
            j = pi[j - 1];
        if (s[i] == s[j]) ++j;
        pi[i] = j;
    }
    return pi;
}

vector <vector <int> > g,g2;

signed main()
{
    int n, m;
    cin >> n >> m;
    g.resize(n);
    g2.resize(n);
    loop(i, m)
    {
        int a,b;
        cin >> a >> b;
        --a,--b;
        g[a].push_back(b);
        g2[b].push_back(a);
    }
    int q;
    cin >> q;
    vector <int> vec(q);
    loop(i, q) {
        cin >> vec[i];
        vec[i]--;
    }
    int t = vec.back();
    vector <int> d(n, INF);
    d[t] = 0;
    queue <int> bfs;
    bfs.push(t);
    vector <bool> used(n, false);
    used[t] = true;
    while(!bfs.empty())
    {
        int v = bfs.front();
        bfs.pop();
        for(auto u:g2[v])
        {
            if(!used[u])
            {
                bfs.push(u);
                used[u] = true;
                d[u] = d[v] + 1;
            }
        }
    }
    int mn = 0, mx = 0;
    for(int i = 0; i<q - 1; ++i)
    {
        int v = vec[i], to = vec[i + 1];
        if (d[to] != d[v] - 1)
            {++mn,++mx;}
        else for(auto u:g[v]) if (u != to && d[u] == d[v] - 1){
            ++mx;
            break;
        }
    }
    cout << mn << ' ' << mx;
}
