
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <utility>
#include <algorithm>
#include <unordered_map>
using namespace std;

#define FOR(i, a, b) for (int i = a; i <= b; ++i)
#define ROF(i, a, b) for (int i = b; i >= a; --i)

#define sz(a) (int)a.size()
#define mp make_pair

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
typedef pair<ll, ll> pl;
typedef vector<int> vi;
typedef vector<ll> vl;
typedef vector<string> vs;

const int INT_INF = (int)2e9;
const ll LL_INF = (ll)1e18;

template <typename T> int ckmin(T &a, T b) {
	if (a > b){
		a = b;
		return 1;
	}
	return 0;
}

template <typename T> int ckmax(T &a, T b){
	if (a < b){
		a = b;
		return 1;
	}
	return 0;
}

void setIO(){
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
}

const int N = 150;
int dp[N][N];

int valid(string &s, int id, int l, int r){
	if (id + 1 <= r && s[id+1]+1==s[id]) return 1;
	if (id - 1 >=l && s[id-1]+1==s[id]) return 1;
	return 0;
}

int smart(string s){
	int n = sz(s);
	for (int i = 0; i < n; ++i){
		dp[i][i] = 1;
	}
	for (int r = 0; r < n; ++r){
		for (int l = r - 1; l >= 0; --l){
			dp[l][r] = r - l + 1;
			for (int v = l; v <= r; ++v){
				if (valid(s, v, l, r)) ckmin(dp[l][r], dp[l][v-1]+dp[v+1][r]);
			}
		}
	}
	return n - dp[0][n - 1];
}

map<string, int> ans;

int rec(string s, int was = 0){
	if (sz(s) == 1) return 0;
	if (ans.count(s)) return ans[s];
	

	for (int i = 0; i < sz(s); ++i){
		bool val = 0;
		if (i == 0 && s[i+1]+1==s[i]) val = 1;
		else if (i == sz(s) -1 && s[i-1]+1==s[i]) val = 1;
		else if (i != 0 && i != sz(s) - 1 && (s[i+1]+1==s[i] || s[i-1]+1==s[i])) val =1 ;
		if (val){
			string x = s;
			x.erase(x.begin() + i);
			ans[s] = max(ans[s], 1 + rec(x, was + 1));
			break;
		}
	}
	for (int i = sz(s)-1; i >=0; --i){
		bool val = 0;
		if (i == 0 && s[i+1]+1==s[i]) val = 1;
		else if (i == sz(s) -1 && s[i-1]+1==s[i]) val = 1;
		else if (i != 0 && i != sz(s) - 1 && (s[i+1]+1==s[i] || s[i-1]+1==s[i])) val =1 ;
		if (val){
			string x = s;
			x.erase(x.begin() + i);
			ans[s] = max(ans[s], 1 + rec(x, was + 1));
			break;
		}
	}
	return ans[s];
}

int stupid(string s){
	ans.clear();
	return rec(s, 0);
}

int main (){
	setIO();

	/*freopen("output.txt", "w", stdout);

	for (int i = 0; i < 100; ++i)
		cout << char('a' + !(i % 2)) ;*/


	/*int q = 1e6;
	
	while (q--){
		int n = rand() % 10 + 1;
		string s; s.resize(n);

		for (int i = 0; i < n; ++i) s[i] = 'b' + rand() % 4;
		int c1 = smart(s);
		int c2 = stupid(s);

		if (c1 != c2){
			cout << c1 << " " << c2 << " " << s << "\n";
			return 0;
		}

	}
*/

	int n;
	string s;
	cin >> n >> s;

	while (true){
		if (sz(s) == 1) break;
		int was = sz(s);

		for (int i = sz(s) - 1; i >= 0; --i){
			if (valid(s, i, 0, was - 1)){
				s.erase(s.begin() + i);
				break;
			}
		}

		if (sz(s) == was) break;

	}

	cout << n - sz(s);

	return 0;
}