
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <utility>
#include <algorithm>
#include <unordered_map>
using namespace std;

#define FOR(i, a, b) for (int i = a; i <= b; ++i)
#define ROF(i, a, b) for (int i = b; i >= a; --i)

#define sz(a) (int)a.size()
#define mp make_pair

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
typedef pair<ll, ll> pl;
typedef vector<int> vi;
typedef vector<ll> vl;
typedef vector<string> vs;

const int INT_INF = (int)2e9;
const ll LL_INF = (ll)1e18;

template <typename T> int ckmin(T &a, T b) {
	if (a > b){
		a = b;
		return 1;
	}
	return 0;
}

template <typename T> int ckmax(T &a, T b){
	if (a < b){
		a = b;
		return 1;
	}
	return 0;
}

void setIO(){
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
}

int n, m, p;
const int N = 3e5;

struct monster{
	int x,y,cost;
};

bool cmp(monster a, monster b){
	return a.x < b.x;
}

monster v[N];
pi gg[N];
pi def[N];
int f[N];

int t[4*N], psh[4*N];

void push(int i, int tl, int tr){
	t[i] += psh[i];
	if (tl + 1 != tr){
		psh[i * 2] += psh[i];
		psh[i * 2 + 1] += psh[i];
	}
	psh[i] = 0;
}

void modify(int i, int tl, int tr, int l, int r, int ad){
	push(i, tl, tr);
	if (l <= tl && tr <= r){
		psh[i] += ad;
		push(i, tl, tr);
		return;
	}
	else if (tl >= r || l >= tr) return;
	int m = (tl+tr) / 2;
	modify(i * 2, tl, m, l, r, ad);
	modify(i * 2 + 1, m, tr, l, r, ad);
	t[i] = max(t[i * 2], t[i * 2 + 1]);
}

int main (){
	setIO();

	cin >> n >> m >> p;

	for (int i = 0; i < n; ++i){
		cin >> gg[i].first >> gg[i].second;
	}

	for (int i = 0; i < m; ++i){
		cin >> def[i].first >> def[i].second;
	}

	for (int i = 0; i < p; ++i){
		cin >> v[i].x >> v[i].y >> v[i].cost;
	}

	sort(def, def + m);
	sort(gg, gg + n);
	sort(v, v + p, cmp);

	for (int i = 0; i < m; ++i){
		f[i] = def[i].first;
		modify(1, 0, m, i, i + 1, -def[i].second);
	}

	for (int i = n- 2; i >-1;--i) ckmin(gg[i].second, gg[i+1].second);

	int res = -INT_INF;

	int ptr = 0;

	for (int i = 0; i < n; ++i){
		while (ptr < p && v[ptr].x < gg[i].first){
			int id = upper_bound(f, f + m, v[ptr].y) - f;
			modify(1, 0, m, id, m, v[ptr].cost);
			ptr++;
		}
		ckmax(res, t[1] - gg[i].second);
	}
	
	cout << res;

	return 0;
}