#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <iomanip>
#include <chrono>
#include <random>
#include <unordered_map>
#include <numeric>
#include <cmath>
#include <ctime>
#include <queue>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e15;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool maxi(ll &a, ll b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

bool mini(ll &a, ll b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

ll mmax(ll a, ll b) {
    if (a > b) {
        return a;
    }
    return b;
}

ll mmin(ll a, ll b) {
    if (a < b) {
        return a;
    }
    return b;
}

ll n, m, k;
vector <bool> used;
vector <vector <ll>> g, rg;
vector <ll> dist;

void bfs(int v) {
    queue <ll> q;
    q.push(v);
    dist[v] = 0;
    used[v] = true;
    while (!q.empty()) {
        ll cur = q.front();
        q.pop();
        for (auto &u : rg[cur]) {
            if (!used[u]) {
                used[u] = true;
                dist[u] = dist[cur] + 1;
                q.push(u);
            }
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m;
    g.resize(n);
    rg.resize(n);
    for (int i = 0; i < m; ++i) {
        ll v, u;
        cin >> v >> u;
        --v; --u;
        g[v].push_back(u);
        rg[u].push_back(v);
    }
    dist.resize(n, INF);
    used.resize(n, false);
    cin >> k;
    vector <ll> p(k);
    for (auto &x : p) {
        cin >> x;
        --x;
    }
    ll from = p.back();
    bfs(from);
    ll v = p[0];
    ll base = 0, diff = 0;
    for (int i = 0; i < k - 1; ++i) {
        if (dist[p[i + 1]] >= dist[p[i]]) {
            ++base;
        }
        else {
            ll mine = INF, cntm = 0;
            for (auto &u : g[p[i]]) {
                if (mini(mine, dist[u])) {
                    cntm = 1;
                }
                else if (mine == dist[u]) {
                    ++cntm;
                }
            }
            if (dist[p[i + 1]] == mine) {
                if (cntm > 1) {
                    ++diff;
                }
            }
        }
    }
    cout << base << ' ' << base + diff;
    return 0;
}
