#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <iomanip>
#include <chrono>
#include <random>
#include <unordered_map>
#include <numeric>
#include <cmath>
#include <ctime>
#include <queue>
#include <tuple>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e15;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool maxi(ll &a, ll b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

bool mini(ll &a, ll b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

ll mmax(ll a, ll b) {
    if (a > b) {
        return a;
    }
    return b;
}

ll mmin(ll a, ll b) {
    if (a < b) {
        return a;
    }
    return b;
}

ll n, m, k;
vector <bool> used;

struct we {
    ll a, ac;

    we(ll a = 0, ll ac = 0) : a(a), ac(ac) {};
};

struct ar {
    ll b, bc;

    ar(ll b = 0, ll bc = 0) : b(b), bc(bc) {};
};

struct en {
    ll x, y, z;

    en(ll x = 0, ll y = 0, ll z = 0) : x(x), y(y), z(z) {};
};

bool operator < (const en &a, const en &b) {
    return make_tuple(a.x, a.y, a.z) < make_tuple(b.x, b.y, b.z);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll p;
    cin >> n >> m >> p;
    vector <we> a(n);
    for (auto &x : a) {
        cin >> x.a >> x.ac;
    }
    vector <ar> b(m);
    for (auto &x : b) {
        cin >> x.b >> x.bc;
    }
    vector <en> e(p);
    for (auto &x : e) {
        cin >> x.x >> x.y >> x.z;
    }
    set <en> foes;
    for (auto &x : e) {
        foes.insert(x);
    }
    sort(a.begin(), a.end(), [](we& a, we& b) {
            return a.a < b.a || a.a == b.a && a.ac > b.ac;
    });
    for (int i = a.size() - 2; i >= 0; --i) {
        a[i].ac = mmin(a[i].ac, a[i + 1].ac);
    }
    sort(b.begin(), b.end(), [](ar& a, ar& b) {
            return a.b < b.b || a.b == b.b && a.bc > b.bc;
    });
    for (int i = b.size() - 2; i >= 0; --i) {
        b[i].bc = mmin(b[i].bc, b[i + 1].bc);
    }
    ll ans = -INF;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            ll cur = -a[i].ac - b[j].bc;
            for (int l = 0; l < p; ++l) {
                if (e[l].x < a[i].a && e[l].y < b[i].b) {
                    cur += e[l].z;
                }
            }
            maxi(ans, cur);
        }
    }
    cout << ans;
    return 0;
}
