#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <map>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef vector<ll> vl;
const ll INF = 1000000000LL;

ll sizet = 1LL;
struct Tree
{
	vl tree, treeAdd;
	Tree(vl &arr)
	{
		while(sizet < (ll)arr.size()) { sizet *= 2LL; }
		tree.resize(sizet * 2LL);
		treeAdd.resize(sizet * 2LL);
		for(ll i = sizet; i < sizet + (ll)arr.size(); i++)
		{
			tree[i] = arr[i - sizet];
		}
		for(ll i = sizet - 1LL; i > 0LL; i--)
		{
			tree[i] = tree[i * 2LL] + tree[i * 2LL + 1LL];
		}
	}
	void push(ll n = 1LL, ll tl = 0LL, ll tr = sizet)
	{
		if(treeAdd[n] != 0LL)
		{
			tree[n] += treeAdd[n] * (tr - tl);
			if(n < sizet)
			{
				treeAdd[n * 2LL] += treeAdd[n];
				treeAdd[n * 2LL + 1LL] += treeAdd[n];
			}
			treeAdd[n] = 0LL;
		}
	}
	void update(ll l, ll r, ll x, ll n = 1LL, ll tl = 0LL, ll tr = sizet)
	{
		push(n, tl, tr);
		if(l >= tr || tl >= r) { return; }
		if(tl <= l && tr >= r)
		{
			treeAdd[n] = x;
			push(n, tl, tr);
			return;
		}
		ll mid = (tl + tr) / 2LL;
		update(l, r, x, n * 2LL, tl, mid);
		update(l, r, x, n * 2LL + 1LL, mid, tr);
		tree[n] = tree[n * 2LL] + tree[n * 2LL + 1LL];
		return;
	}
	ll result(ll l, ll r, ll n = 1LL, ll tl = 0LL, ll tr = sizet)
	{
		push(n, tl, tr);
		if(l >= tr || tl >= r) { return 0LL; }
		if(tl <= l && tr >= r) { return tree[n]; }
		ll mid = (tl + tr) / 2LL;
		return result(l, r, n * 2LL, tl, mid) + result(l, r, n * 2LL + 1LL, mid, tr);
	}
};

int main()
{
	ll n; cin >> n;
	map<ll, pll> m;
	for(ll i = 0LL; i < n; i++)
	{
		ll x; cin >> x;
		m[x - i].first += i;
		m[x - i].second++;
	}
	ll bestAns = 0LL;
	for(auto it = m.begin(); it != m.end(); it++)
	{
		ll temp = it->first * it->second.second + it->second.first;
		bestAns = max(bestAns, temp);
	}
	cout << bestAns << endl;
	system("Pause");
	return 0LL;
}