#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <map>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef vector<ll> vl;
const ll INF = 1000000000LL;

ll sizet = 1LL;
struct Tree
{
	vl tree, treeAdd;
	Tree(vl &arr)
	{
		while(sizet < (ll)arr.size()) { sizet *= 2LL; }
		tree.resize(sizet * 2LL);
		treeAdd.resize(sizet * 2LL);
		for(ll i = sizet; i < sizet + (ll)arr.size(); i++)
		{
			tree[i] = arr[i - sizet];
		}
		for(ll i = sizet - 1LL; i > 0LL; i--)
		{
			tree[i] = tree[i * 2LL] + tree[i * 2LL + 1LL];
		}
	}
	void push(ll n = 1LL, ll tl = 0LL, ll tr = sizet)
	{
		if(treeAdd[n] != 0LL)
		{
			tree[n] += treeAdd[n] * (tr - tl);
			if(n < sizet)
			{
				treeAdd[n * 2LL] += treeAdd[n];
				treeAdd[n * 2LL + 1LL] += treeAdd[n];
			}
			treeAdd[n] = 0LL;
		}
	}
	void update(ll l, ll r, ll x, ll n = 1LL, ll tl = 0LL, ll tr = sizet)
	{
		push(n, tl, tr);
		if(l >= tr || tl >= r) { return; }
		if(tl <= l && tr >= r)
		{
			treeAdd[n] = x;
			push(n, tl, tr);
			return;
		}
		ll mid = (tl + tr) / 2LL;
		update(l, r, x, n * 2LL, tl, mid);
		update(l, r, x, n * 2LL + 1LL, mid, tr);
		tree[n] = tree[n * 2LL] + tree[n * 2LL + 1LL];
		return;
	}
	ll result(ll l, ll r, ll n = 1LL, ll tl = 0LL, ll tr = sizet)
	{
		push(n, tl, tr);
		if(l >= tr || tl >= r) { return 0LL; }
		if(tl <= l && tr >= r) { return tree[n]; }
		ll mid = (tl + tr) / 2LL;
		return result(l, r, n * 2LL, tl, mid) + result(l, r, n * 2LL + 1LL, mid, tr);
	}
};

int main()
{
	ll n; cin >> n;
	string s; cin >> s;
	n = (ll)s.size();
	ll ans = 0LL;
	vector<pair<ll, pll>> arr(n, make_pair(-1LL, make_pair(-1LL, -1LL)));
	arr[0LL].first = (ll)(s[0LL] - 'a');
	if(n > 1LL)
	{
		arr[0LL].second.second = 1LL;
		arr[n - 1LL].first = (ll)(s[n - 1LL] - 'a');
		arr[n - 1LL].second.first = n - 2LL;
	}
	for(ll i = 1LL; i < n - 1LL; i++)
	{
		arr[i].first = (ll)(s[i] - 'a');
		arr[i].second.first = i - 1LL;
		arr[i].second.second = i + 1LL;
	}
	ll first = 0LL;
	for(ll j = 25LL; j > 0LL; j--)
	{
		for(ll i = first; i != -1LL && i < n; i = arr[i].second.second)
		{
			if(arr[i].first != j) { continue; }
			ll prev = arr[i].second.first, next = arr[i].second.second;
			if(prev != -1LL)
			{
				if(arr[prev].first == j - 1LL)
				{
					ans++;
					arr[prev].second.second = next;
					if(next != -1LL) { arr[next].second.first = prev; }
					arr[i].second.first = -1LL;
					arr[i].second.second = -1LL;
					continue;
				}
			}
			if(next != -1LL)
			{
				if(arr[next].first == j - 1LL)
				{
					ans++;
					arr[next].second.first = prev;
					if(prev != -1LL) { arr[prev].second.second = next; }
					else { first = next; }
					arr[i].second.first = -1LL;
					arr[i].second.second = -1LL;
					continue;
				}
			}
		}
	}
	if(ans > n - 1LL) { return -1LL; }
	cout << ans << endl;
	//system("Pause");
	return 0LL;
}