#include <bits/stdc++.h>

using namespace std;

#define LINF (long long)1e16

struct Tree
{
    unsigned N;
    vector<long long> t, a;

    void build(const vector<long long>& a, unsigned v, unsigned tl, unsigned tr)
    {
        if (tl == tr)
            t[v] = a[tl];
        else
        {
            unsigned tm = (tl + tr) / 2;

            build(a, v * 2, tl, tm);
            build(a, v * 2 + 1, tm + 1, tr);

            t[v] = max(t[v * 2], t[v * 2 + 1]);
        }
    }

    Tree(unsigned N) : N(N), t(4 * N, -LINF), a(4 * N) {}
    Tree(vector<long long>& r) : N(r.size()), t(4 * N, -LINF), a(4 * N)
    {
        build(r, 1, 0, N - 1);
    }

    void push(unsigned v)
    {
        a[v * 2] += a[v]; a[v * 2 + 1] += a[v];
        t[v] += a[v];
        a[v] = 0;
    }


    void add(unsigned v, unsigned tl, unsigned tr, unsigned l, unsigned r, long long val)
    {
        if (l > r) return;

        if (tl == l && r == tr)
            a[v] += val;
        else
        {
            push(v);
            unsigned tm = (tl + tr) / 2;

            add(v * 2, tl, tm, l, min(r, tm), val);
            add(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r, val);

            t[v] = max(t[v * 2] + a[v * 2], t[v * 2 + 1] + a[v * 2 + 1]);
        }
    }

    void add(unsigned l, unsigned r, long long val)
    {
        add(1, 0, N - 1, l, r, val);
    }

    long long get(unsigned v, unsigned tl, unsigned tr, unsigned l, unsigned r)
    {
        if (l > r) return -LINF;

        if (tl == l && r == tr)
            return t[v] + a[v];
        else
        {
            push(v);
            unsigned tm = (tl + tr) / 2;
            return max(get(v * 2, tl, tm, l, min(r, tm)),
                       get(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r));
        }
    }

    long long get(unsigned l, unsigned r)
    {
        return get(1, 0, N - 1, l, r);
    }
};


int main()
{
    cin.tie(0); cout.tie(0); cerr.tie(0);
    ios_base::sync_with_stdio(false);

    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);


    unsigned N, M, K; cin >> N >> M >> K;

    vector<pair<unsigned, long long> > w(N);
    for (auto& v : w) cin >> v.first >> v.second;
    sort(w.begin(), w.end());

    vector<long long> ba(1e6 + 15, -LINF);
    for (unsigned i = 0; i < M; i++)
    {
        unsigned a; cin >> a; a++;
        long long c; cin >> c; c = -c;

        ba[a] = max(ba[a], c);
    }

    for (int i = 1e6 + 1; i >= 0; i--)
        ba[i] = max(ba[i], ba[i + 1]);

    Tree tr(ba);

    vector<pair<pair<unsigned, unsigned>, long long> > m(K);
    for (auto& v : m)
        cin >> v.first.first >> v.first.second >> v.second;
    sort(m.begin(), m.end());

    long long ans = -LINF;
    unsigned r = 0;
    for (unsigned t = 0; t < N; t++)
    {
        while (r < K && m[r].first.first < w[t].first)
        {
            tr.add(m[r].first.second + 1, tr.N - 1, m[r].second);
            r++;
        }

        ans = max(ans, tr.get(0, tr.N - 1) - w[t].second);
    }

    cout << ans;


    return 0;
}
