#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif // _DEV
#include <bits/stdc++.h>

#define $ if (DEV)

using namespace std;

void $main(int test_id);
using ll = long long;
int main() {
    int test_count = 1;
    $ {
        test_count = 100;
        freopen("input.txt", "r", stdin);
    } else {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (int t = 0; t < test_count; ++t) {
        $ printf("--- TEST %d ---\n", t);
        $main(t);
        int ch = -1;
        while (DEV) {
            ch = fgetc(stdin);
            if (ch == -1 || !isspace(ch)) {break;}
        }
        if(ch != -1) {
            ungetc(ch ,stdin);
        } else {break;}

    }
}

template<typename T>
bool relmin(T& pl, T const v) {
    if (pl > v) {
        pl = v;
        return true;
    }
    return false;
}


template<typename T>
bool relmax(T& pl, T const v) {
    if (pl < v) {
        pl = v;
        return true;
    }
    return false;
}

int nodes_pos = 0;


struct Node {
    Node* pl;
    Node* pr;

    ll x = 0;
    ll prom = 0;



    void take_prom(ll p) {
        x += p;
        prom += p;
    }

    void push() {
        if (prom == 0) {return;}
        if(!pl) {return;}
        pl->take_prom(prom);

        pr->take_prom(prom);
        prom = 0;
    }

    void relax() {
        if (pl) {
            x = max(pl->x,pr->x);
        }
    }
};

vector<Node> nodes;
     Node* make(int il, int ir) {
    Node* v = &nodes[nodes_pos++];
        if (ir - il > 1) {
            int im = (il+ir)/2;
            v->pl = make(il, im);
            v->pr = make(im, ir);
        }
        return v;
    }
struct Tree {
    Node* root;
    int n;

    Tree(int _n): root(make(0, _n)), n(_n) {}

    template<typename F>
    void do_go(Node* v, int il, int ir, int ql, int qr, F const& f) {
        if (ql <= il && ir <= qr) {
            f(v);
            return;
        }
        if (qr <= il || ir <= ql) {
            return;
        }
        int im = (il+ir)/2;
        v->push();
        do_go(v->pl, il, im, ql, qr, f);
        do_go(v->pr, im ,ir, ql, qr, f);
        v->relax();
}

 template<class F>
 void go(int ql, int qr, F const& f) {
      do_go(root, 0, n, ql, qr, f);
 }

     void add(int i, ll x) {
         go(i, n, [&](Node* v) {
            v->take_prom(x);
        });
     }

     ll max() {
         return root->x;
     }
};

struct Dick {
    int x;
    int y;
    ll p;
};

struct Event {
    int sort_key;
    bool is_shield;
    ll value;
    int uuid;
    int coord;

    bool operator<(Event const & oth) const {
        if (sort_key != oth.sort_key) {return sort_key < oth.sort_key;}
        int pm = int(is_shield);
        int po = int(oth.is_shield);
        if (pm != po) {
            return pm > po;
        }
        return uuid < oth.uuid;
    }
};
#define all(cont) cont.begin(),cont.end()
void $main(int test_id) {
    int n, m, k;
    cin >> n >> m >> k;
    vector<pair<int, ll>> t1(n);
    for(auto& t: t1) {cin >> t.first >> t.second;}
    vector<pair<int, ll>> t2(m);
    for(auto& t:t2){cin >>t.first >> t.second;}
    vector<Dick> dicks(k);
    for (auto& d : dicks) {cin >> d.x >> d.y >> d.p;}
    sort(all(t1), [&](pair<int, ll> lhs, pair<int, ll> rhs){
             return lhs.first < rhs.first;
         });

         sort(all(t2), [&](pair<int, ll> lhs, pair<int, ll> rhs) {
              return lhs.second < rhs.second;
              });
    vector<pair<int, ll>> good_weapons;

    {
     int cur_max = -1;

    for (int i = 0; i < m; ++i) {
        if(cur_max >= t2[i].first) {
            continue;
        }
        $ printf("accepted weapon: cost=%lld, strength=%d\n", t2[i].second, t2[i].first);
        cur_max = t2[i].first;
        good_weapons.push_back(t2[i]);
    }
    }
    m = good_weapons.size();
    t2.clear();
    int max_coord = good_weapons.back().first + 1;
    for (int i= 0; i < dicks.size(); ++i) {
        relmax(max_coord, dicks[i].y+1);
    }
    nodes.clear();
    nodes_pos = 0;
    nodes.resize(4*max_coord+5);
    Tree st(max_coord+1);
    for (int i = 0; i < m; ++i) {
        ll rel_wei = good_weapons[i].second;
        if (i > 0) {rel_wei -= good_weapons[i-1].second;
        }
        int coord = 0;
        if (i > 0) {
            coord = good_weapons[i-1].first;
        }
        $ printf("adding weapon: relcost %lld, coord %d\n", rel_wei, coord);
        st.add(coord, -rel_wei);
    }
    {
        st.add(good_weapons.back().first, -2000*1000*1000);
    }
    set<Event> evts;
    for (int i = 0; i < n; ++i) {
        Event evt;
        evt.uuid = i;
        evt.sort_key = t1[i].first;
        evt.is_shield = true;
        evt.value = t1[i].second;
        evt.coord = -10;
        evts.insert(evt);
    }
    for (int i = 0; i < k; ++i) {
        Event evt;
        evt.uuid = i;
        evt.sort_key = dicks[i].x;
        evt.coord = dicks[i].y;
        evt.value = dicks[i].p;
        evt.is_shield = false;
        evts.insert(evt);
    }
    ll ans = -2000*1000*1000;
    ans = 5*ans;
    for (Event ev: evts) {
        $ printf("event: uuid=%d, sort_key=%d, is_weapon=%d\n", ev.uuid, ev.sort_key, int(ev.is_shield));
        if (ev.is_shield) {
            $ printf("relaxing using shield: cost=%lld\n", ev.value);
            ll res = st.max()-ev.value;
            relmax(ans, res);
        } else {
            $ printf("adding monster: pos=%d value=%lld\n", ev.coord, ev.value);
            st.add(ev.coord, ev.value);
        }
    }

    cout << ans << "\n";
}
