#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>

using namespace std;

void task_a()
{
    int n; cin >> n;
    vector<int> r(n);
    for (int i = 0; i < n; i++)
    {
        cin >> r[i];
    }

    vector<int> b(n);
    for (int i = 0; i < n; i++)
    {
        cin >> b[i];
    }

    int r_cnt = 0, b_cnt = 0;
    bool same = true;
    for (int i = 0; i < n; i++)
    {
        same = same && (r[i] == b[i]);
        if (r[i] > b[i])
            r_cnt += r[i];
        if (b[i] > r[i])
            b_cnt += b[i];
    }

    if (same || r_cnt == 0)
    {
        cout << -1;
    }
    else
    {
        if (b_cnt % r_cnt == 0)
            cout << b_cnt / r_cnt + 1;
        else
            cout << (r_cnt + b_cnt - 1) / r_cnt;
    }
}

void task_b()
{
    int n; cin >> n;
    map<int,long long> cnt; // d b
    for (int i = 0; i < n; i++)
    {
        int x; cin >> x;
        cnt.insert(pair<int,long long>(i-x, 0)).first->second += x;
    }
    long long res = 0;
    for(map<int,long long>::iterator it = cnt.begin(); it != cnt.end(); it++)
    {
        res = max(res, it->second);
    }
    cout << res;
}

void print(const vector<int>& vec);

string er(const string& s, const vector<int>& ind)
{
    if (ind.size() == 0) return s;
    string res(s.length()-ind.size(), ' ');
    for (int i = 0, j = 0, k = 0; i < s.length(); i++, j++)
    {
        if (k < ind.size() && ind[k] == i)
        {
            k++; j--;
            continue;
        }

        res[j] = s[i];

    }
    return res;
}

vector<int> find2d(const string& s, char c)
{
    vector<int> res;
    if (s.length() == 0) return res;
    if (s[0] == c && s[1] == c - 1)
    {
        res.push_back(0);
    }
    int n = s.length() - 1;
    for (int i = 1; i < n; i++)
    {
        if(s[i] == c)
        {
            if (s[i-1] == c - 1 || s[i+1] == c - 1)
            {
                res.push_back(i++);
            }
        }
    }
    if (s[n] == c && s[n - 1] == c - 1)
    {
        res.push_back(0);
    }
    return res;
}

void print(const vector<int>& vec)
{
    for (int i = 0; i < vec.size(); i++)
    {
        cout << vec[i] << " ";
    }
    cout << endl;
}

void task_c()
{
    int n; cin >> n;
    string s; cin >> s;
    for (char c = 'z'; c > 'a'; c--)
    {

        vector<int> v2d;
        do
        {
            v2d = find2d(s,c);
            s = er(s, v2d);
        } while(v2d.size() > 0);
        //cout << c << ":\t" << s << endl;
    }
    cout << n - s.length();
}


vector<int> bfs_v;
vector<int> bfs_val;

void bfs_d(int v, int d, const vector<vector<int> >& gr, vector<int>& depth)
{
    if (depth[v] != -1) return;
    depth[v] = d;
    for (int i = 0; i < gr[v].size(); i++)
    {
        //cout << v+1 << ":\t";
        if (depth[gr[v][i]] == -1)
        {
            //cout << gr[v][i]+1  << "\t" << d + 1<< endl;
            bfs_v.push_back(gr[v][i]);
            bfs_val.push_back(d+1);
        }
    }
}

void task_d()
{
    //ifstream cin("i.txt");
    int n,m; cin >> n >> m;
    vector<vector<int> > gr(n), grr(n);
    for (int i = 0; i < m; i++)
    {
        int x,y; cin >> x >> y; x--;y--;
        gr[x].push_back(y);
        grr[y].push_back(x);
    }

    int k; cin >> k;
    vector<int> path(k);
    for (int i = 0; i < k; i++)
    {
        cin >> path[i]; path[i]--;
    }


    vector<int> depth(n,-1);
    bfs_v.push_back(path[k-1]);
    bfs_val.push_back(0);
    for (int i = 0; i < bfs_v.size(); i++)
    {
        bfs_d(bfs_v[i], bfs_val[i], grr, depth);
    }
    int res_x = 0, res_n = 0;
    for (int i = 0; i+1 < k; i++)
    {
        int sh = n;
        for (int j = 0; j < gr[path[i]].size(); j++)
        {
            sh = min(sh, depth[gr[path[i]][j]]);
        }

        if (sh < depth[path[i+1]]) { res_x++; res_n++; continue; }

        int cnt = 0;
        for (int j = 0; j < gr[path[i]].size(); j++)
        {
            if (sh == depth[gr[path[i]][j]]) cnt++;
        }
        if (cnt > 1) res_x++;
    }
    cout << res_n << " " << res_x << endl;
}

int main()
{
    //cout << fixed << setprecision(6);
    //
    task_d();
    return 0;
}
