#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <iomanip>
#include <set>
#include <climits>
#include <cmath>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define pb push_back
#define mp make_pair
#define len(v) int(v.size())
#define all(v) v.begin(), v.end()
#define ff first
#define ss second
#define pi pair<int, int>
#define vi vector<int>
#define vvi vector<vi>
#define vpi vector<pi>
#define vvpi vector<vpi>
#define forn(i, n) for(int i = 0; i < int(n); ++i)

const int inf = INT_MAX;
const int max_n = 1e6 + 7;
//*
int max_dt[max_n * 4] = { 0 };
int sum[max_n * 4] = { 0 };
int min_cost[max_n] = { 0 };
int min_or[max_n] = { 0 };
int mod_za[max_n];
int mod_or[max_n];
/*int query(int l, int r, int v, int ql, int qr) {
	if(ql >= qr)
		return 0;
	if(l >= r)
		return 0;
	if(ql == l && qr == r) {
		return tree[v];
	}
	int mid = (ql + qr) / 2;
	int rl = query(l, min(mid, r), v * 2 + 1, ql, mid);
	int rr = query(max(l, mid), r, v * 2 + 2, mid, qr);
}*/
void build(int v, int ql, int qr) {
	if(ql >= qr)
		return;
	if(ql == qr - 1) {
		max_dt[v] = -min_cost[ql];
		return;
	}
	int mid = (ql + qr) / 2;
	build(v * 2 + 1, ql, mid);
	build(v * 2 + 2, mid, qr);
	max_dt[v] = max(max_dt[v * 2 + 1], max_dt[v * 2 + 2]);
}
void push(int v) {
	if(!sum[v])
		return;
	sum[v * 2 + 1] += sum[v];
	sum[v * 2 + 2] += sum[v];
	sum[v] = 0;
}
void suma(int l, int r, int ql, int qr, int v, int x) {
	if(ql >= qr)
		return;
	if(l >= qr)
		return;
	if(l == ql && r == qr) {
		sum[v] += x;
		return;
	}
	push(v);
	int mid = (ql + qr) / 2;
	suma(l, min(mid, r), ql, mid, v * 2 + 1, x);
	suma(max(mid, l), r, mid, qr, v * 2 + 2, x);
	max_dt[v] = max(max_dt[v * 2 + 1] + sum[v * 2 + 1], max_dt[v * 2 + 2] + sum[v * 2 + 2]);
}

//*/

void run() {
	int n, m, p;
	cin >> n >> m >> p;
	forn(i, max_n) {
		mod_za[i] = mod_or[i] = inf;
	}
	forn(i, n) {
		int x, y;
		cin >> x >> y;
		mod_or[x] = min(mod_or[x], y);
	}
	forn(i, m) {
		int x, y;
		cin >> x >> y;
		mod_za[x] = min(mod_za[x], y);
	}
	vector<pair<pi, int>> mon;
	forn(i, p) {
		int x, y, z;
		cin >> x >> y >> z;
		//swap(x, y);
		mon.pb(mp(mp(x, y), z));
	}
	int cc = inf;
	int c2 = inf;
	for(int i = max_n - 1; i >= 0; --i) {
		min_cost[i] = cc;
		min_or[i] = c2;
		cc = min(cc, mod_za[i]);
		c2 = min(c2, mod_or[i]);
	}
	build(0, 0, max_n);
	sort(all(mon));
	int res = -inf;
	for(int i = 0; i < len(mon); ++i) {
		int pos_p = mon[i].ff.ss;
		int pl = mon[i].ss;
		suma(pos_p, max_n, 0, max_n, 0, pl);
		int result = -min_or[mon[i].ff.ff];
		int other = max_dt[0] + sum[0];
		if(result <= -inf || other >= inf)
			continue;
		result += other;
		res = max(res, result);
	}
	cout << res;
}

signed main() {
	/*
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	//*/
	run();
	return 0;
}