#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

struct osu {
    struct node {
        int add, mx;
    };

    int v, tl, tr;
    vector <node> t;

    void init(int n) {
        tl = 0;
        tr = n - 1;
        v = 1;

        t.resize(4 * n);
    }

    void build(int v, int tl, int tr, vector <int> &a) {
        if (tl == tr) {
            t[v].mx = a[tl];
            t[v].add = 0;
        }
        else {
            int tm = tl + tr >> 1;
            build(v << 1, tl, tm, a);
            build(v << 1 | 1, tm + 1, tr, a);

            t[v].mx = max(t[v << 1].mx, t[v << 1 | 1].mx);
        }
    }

    void build(vector <int> &a) {
        build(v, tl, tr, a);
    }

    void push(int v) {
        if (t[v].add) {
            t[v << 1].mx += t[v].add;
            t[v << 1 | 1].mx += t[v].add;

            t[v << 1].add += t[v].add;
            t[v << 1 | 1].add += t[v].add;

            t[v].add = 0;
        }
    }

    void modify(int v, int tl, int tr, int l, int r, int x) {
        if (l > r) {
            return;
        }

        if (tl == l && tr == r) {
            t[v].mx += x;
            t[v].add += x;
        }
        else {
            push(v);

            int tm = tl + tr >> 1;
            modify(v << 1, tl, tm, l, min(r, tm), x);
            modify(v << 1 | 1, tm + 1, tr, max(l, tm + 1), r, x);

            t[v].mx = max(t[v << 1].mx, t[v << 1 | 1].mx);
        }
    }

    void modify(int l, int r, int x) {
        modify(v, tl, tr, l, r, x);
    }

    int get() {
        return t[v].mx;
    }
};

struct sword {
    int dmg, cost;
};

bool operator < (sword a, sword b) {
    return (a.dmg < b.dmg);
}

struct enemy{
    int x, y, cost;
};

bool operator < (enemy a, enemy b) {
    return (a.x < b.x);
}

const int inf = int(1e9) + 10;
const int N = int(1e6) + 10;

int main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    int n, m, p;
    cin >> n >> m >> p;

    vector <sword> a(n);
    for(int i = 0; i < n; i++) {
        cin >> a[i].dmg >> a[i].cost;
    }

    sort(a.begin(), a.end());

    osu tree;

    tree.init(N);
    vector <int> mn(N, 2 * inf);

    for(int i = 0; i < m; i++) {
        int arm, cost;
        cin >> arm >> cost;

        mn[arm] = min(mn[arm], cost);
    }

    for(int i = 0; i < N; i++){
        mn[i] *= -1;
    }


    vector <enemy> c(p);
    for(int i = 0; i < p; i++) {
        cin >> c[i].x >> c[i].y >> c[i].cost;
    }

    sort(c.begin(), c.end());

    tree.build(mn);

    int ans = inf * -2;
    int r = 0;

    for(int i = 0; i < n; i++) {
        int res = -a[i].cost;

        while(r < p && c[r].x < a[i].dmg) {
            tree.modify(c[r].y + 1, N - 1, c[r].cost);
            r++;
        }

        int mx = tree.get();

        ans = max(ans, res + mx);
    }

    cout << ans << "\n";
    return 0;
}
