#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (1 << 20);
const int INF = 1'000'000'007;
const ll LINF = static_cast<const ll>(1e18);

const int SZ = 8 * N + 100;
ll t[SZ];
ll later[SZ];

void Update(int ndx) {
    t[ndx] += later[ndx];
    later[2 * ndx + 1] += later[ndx];
    later[2 * ndx + 2] += later[ndx];
    later[ndx] = 0;
}

ll GetTree(int l, int r, int ndx = 0, int L = 0, int R = N - 1) {
    Update(ndx);
    if (l <= L && R <= r)
        return t[ndx];
    if (r < L || R < l || R < L)
        return -LINF;
    return max(GetTree(l, r, 2 * ndx + 1, L, (L + R) / 2), GetTree(l, r, 2 * ndx + 2, (L + R) / 2 + 1, R));
}

void SetTree(int l, int r, ll value, int ndx = 0, int L = 0, int R = N - 1) {
    Update(ndx);
    if (l <= L && R <= r) {
        later[ndx] += value;
        Update(ndx);
        return;
    }
    if (r < L || R < l || R < L)
        return;
    SetTree(l, r, value, 2 * ndx + 1, L, (L + R) / 2);
    SetTree(l, r, value, 2 * ndx + 2, (L + R) / 2 + 1, R);
    t[ndx] = max(t[2 * ndx + 1], t[2 * ndx + 2]);
}

void Solve() {
    int n, m, p;
    cin >> n >> m >> p;
    vector <ll> a(N, LINF);
    for (int i=0;i< n;i++) {
        ll k, l;
        cin >> k >> l;
        a[k] = min(a[k], l);
    }
    for (int i =N - 2; i >= 0; i--)
        a[i] = min(a[i], a[i+1]);

    for (int i =0; i < N;i++)
        SetTree(i, i, -a[i]);

    vector <pair <ll, ll>> b(m);
    for (int i=0;i < m; i++) {
        cin >> b[i].first >> b[i].second;
    }
    sort(b.begin(), b.end());
    vector <vector <ll>> c;

    for (int i=0;i< p;i++) {
        ll x,y,z;
        cin >> x >>y >> z;
        c.push_back({y, x, z});
    }
    sort(c.rbegin(), c.rend());

    ll ans = -LINF;
    for (auto i : b) {
        while (!c.empty() && c.back().front() < i.first) {
            SetTree(c.back()[1] + 1, N-1, c.back()[2]);
            c.pop_back();
        }
        ans = max(ans, GetTree(0, N-1) - i.second);
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    Solve();
}