#include<bits/stdc++.h>

#define int long long
#define x first
#define y second
#define z third
#define mp make_pair
#define pb push_back
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()
#define TASK ""

using namespace std;

struct triple {
	int first, second, third;
	
	triple() {}
	
	triple(int first, int second, int third): first(first), second(second), third(third) {}
	
	friend bool operator < (const triple &a, const triple &b) {
		return tie(a.first, a.second, a.third) < tie(b.first, b.second, b.third);
	}
};

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 2e5 + 5, M = 2e5 + 5, P = 2e5 + 5;
const int INF = 1e18;

int n, m, p;
pii a[N], b[M];
triple c[P];
int tree[M * 4], add[M * 4];

void push(int v) {
	tree[v * 2 + 1] += add[v];
	tree[v * 2 + 2] += add[v];
	add[v * 2 + 1] += add[v];
	add[v * 2 + 2] += add[v];
	add[v] = 0;
}

void update(int v, int tl, int tr, int L, int R, int val) {
	if (L >= tr || tl >= R) return;
	if (L <= tl && tr <= R) {
		tree[v] += val;
		add[v] += val;
		return;
	}
	push(v);
	int tm = (tl + tr) / 2;
	update(v * 2 + 1, tl, tm, L, R, val);
	update(v * 2 + 2, tm, tr, L, R, val);
	tree[v] = max(tree[v * 2 + 1], tree[v * 2 + 2]);
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
if (strlen(TASK) > 0)
	freopen(TASK".in", "r", stdin),
	freopen(TASK".out", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	cin >> n >> m >> p;
	for (int i = 1; i <= n; ++i) cin >> a[i].x >> a[i].y;
	for (int i = 1; i <= m; ++i) cin >> b[i].x >> b[i].y;
	for (int i = 1; i <= p; ++i) cin >> c[i].x >> c[i].y >> c[i].z;
	sort(a + 1, a + n + 1);
	sort(b + 1, b + m + 1);
	sort(c + 1, c + p + 1);
	for (int i = 1; i <= m; ++i) {
		update(0, 1, m + 1, i, i + 1, -b[i].y);
	}
	int uk = 1, ans = -INF;
	for (int i = 1; i <= n; ++i) {
		while (uk <= p && c[uk].x < a[i].x) {
			int lef = 0, rig = m + 1;
			while (lef + 1 < rig) {
				int mid = (lef + rig) / 2;
				if (c[uk].y < b[mid].x) {
					rig = mid;
				} else {
					lef = mid;
				}
			}
			update(0, 1, m + 1, rig, m + 1, c[uk].z);
			++uk;
		}
		ans = max(ans, tree[0] - a[i].y);
	}
	cout << ans << "\n";
	
	return 0;
}
