#include <iostream>
#include <vector>
#include <map>
#include <queue>
#include <algorithm>

using namespace std;

typedef long long ll;
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)
typedef vector<int> vi;
typedef pair<int, int> pii;
#define F first
#define S second
typedef vector<bool> vb;
typedef vector<vi> vvi;
#define pb push_back
typedef vector<pii> vpii;
#define all(arr) arr.begin(), arr.end()
typedef vector<ll> vll;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;

void init(){
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    //freopen("input.txt", "r", stdin);
}

const int sz = 1 << 20;
const ll inf = 1e12;

vll t(2 * sz);
vll add(2 * sz);

void upd(int v, int vl, int vr, int l, int r, ll d){
    if (l > vr || vl > r) return;
    if (vl >= l && vr <= r){
        add[v] += d;
        t[v] += d;
        return;
    }
    int vm = (vl + vr) >> 1;
    upd(v * 2 + 1, vl, vm, l, r, d);
    upd(v * 2 + 2, vm + 1, vr, l, r, d);
    t[v] = add[v] + max(t[v * 2 + 1], t[v * 2 + 2]);
}

ll query(int v, int vl, int vr, int l, int r){
    if (vl > r || l > vr) return -inf;
    if (vl >= l && vr <= r) return t[v];
    int vm = (vl + vr) >> 1;
    ll q1 = query(v * 2 + 1, vl, vm, l, r);
    ll q2 = query(v * 2 + 2, vm + 1, vr, l, r);
    return add[v] + max(q1, q2);
}

void solve(){
    int n, m, p;
    cin >> n >> m >> p;
    vpll a(n), b(m);
    forn(i, n) cin >> a[i].F >> a[i].S;
    forn(i, m) cin >> b[i].F >> b[i].S;
    sort(all(a));
    sort(all(b));
    vll minc(sz, inf);
    vvi c(p, vi(3));
    forn(i, p){
        forn(j, 3) cin >> c[i][j];
    }
    sort(all(c));
    forn(i, m){
        minc[b[i].F - 1] = min(minc[b[i].F - 1], b[i].S);
    }
    for (int i = sz - 2; i >= 0; --i) minc[i] = min(minc[i], minc[i + 1]);
    ll ans = - a[0].S - b[0].S;
    forn(i, sz){
        upd(0, 0, sz - 1, i, i, -minc[i]);
    }
    int j = -1;
    forn(i, n){
        while (j + 1 < n && c[j + 1][0] < a[i].F){
            j++;
            upd(0, 0, sz - 1, c[j][1], sz - 1, c[j][2]);
        }
        ans = max(ans, add[0] + t[0] - a[i].S);
    }
    cout << ans << '\n';
}

bool multitest = false;

int main(){
    init();
    int t = 1;
    if (multitest) cin >> t;
    forn(i, t) solve();
    return 0;
}