#include <bits/stdc++.h>
#define fi first
#define se second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define out(t, a) copy(all(a), ostream_iterator<t>(cout, " ")); cout << "\n";
//#define DEBUG
#define int long long

using namespace std;

void set_program() {
	#ifdef DEBUG
		freopen("test.in", "r", stdin);
		freopen("test.out", "w", stdout);
	#endif // DEBUG
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
}

typedef long double ld;
typedef long long ll;

const int ALF = 26;
const int LOGN = 20;
const int MOD = 1e9 + 7;
const int MAXN = 2e5;
const int INF = 1e9 + 7;

vector <int> gr[MAXN], trgr[MAXN];

void dfs(int idx, int k, vector <int>& path, int n, vector <int>& d, int& ans_max) {
    if (idx == k - 1) {
        return;
    }
    for (int v : gr[path[idx]]) {
        if (d[v] + 1 == d[path[idx]] && v != path[idx + 1]) {
            ++ans_max;
            break;
        }
    }
    dfs(idx + 1, k, path, n, d, ans_max);
}

vector <int> get_dist(int s, int n) {
    vector <int> d(n, INF), used(n, 0);
    d[s] = 0;
    deque <int> q;
    q.push_back(s);
    for (; q.size(); ) {
        int u = q.front();
        q.pop_front();
        used[u] = 1;
        for (int v : trgr[u]) {
            if (!used[v]) {
                d[v] = d[u] + 1;
                used[v] = 1;
                q.push_back(v);
            }
        }
    }
    return d;
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        gr[i].clear();
        trgr[i].clear();
    }
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        gr[a].push_back(b);
        trgr[b].push_back(a);
    }
    int k;
    cin >> k;
    vector <int> path(k);
    for (int& i : path) {
        cin >> i;
        --i;
    }
    vector <int> d = get_dist(path[k - 1], n);
//    out(int, d);
    int ans_min = 0, ans_max = 0;
    for (int i = 1; i < k; ++i) {
        if (d[path[i]] + 1 != d[path[i - 1]]) {
            ++ans_min;
        }
    }
    dfs(0, k, path, n, d, ans_max);
    cout << ans_min << " " << ans_max << "\n";
}

main() {
	set_program();
	int t;
	#ifdef DEBUG
        t = 3;
    #else
        t = 1;
	#endif // DEBUG
	for (; t--; ) {
        solve();
        cout << "\n";
	}
	return 0;
}
