#include <bits/stdc++.h>
#define fi first
#define se second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define out(t, a) copy(all(a), ostream_iterator<t>(cout, " ")); cout << "\n";
//#define DEBUG
#define int long long

using namespace std;

void set_program() {
	#ifdef DEBUG
		freopen("test.in", "r", stdin);
		freopen("test.out", "w", stdout);
	#endif // DEBUG
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
}

typedef long double ld;
typedef long long ll;

const int ALF = 26;
const int LOGN = 20;
const int MOD = 1e9 + 7;
const int MAXN = 2e5;
const int INF = 1e9 + 7;

struct pt {
    int x, y, z;
};

struct segment_tree {
    vector <int> t;
    void build(int n, vector <pair <int, int>>& a) {
        t.resize(n);
        for (int i = 0; i < n; ++i) {
            t[i] = -a[i].se;
        }
    }
    void upd(int idx, int n, int val) {
        for (int i = idx; i < n; ++i) {
            t[i] += val;
        }
    }
    int get_max() {
        return *max_element(all(t));
    }
};

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    vector <pair <int, int>> a(n), b(m);
    for (auto& i : a) {
        cin >> i.fi >> i.se;
    }
    for (auto& i : b) {
        cin >> i.fi >> i.se;
    }
    vector <pt> p(k);
    for (auto& i : p) {
        cin >> i.x >> i.y >> i.z;
    }
    sort(all(p), [] (const auto& a, const auto& b) {
        return a.y < b.y;
    });
    segment_tree t;
    t.build(n, a);
    int it = 0;
    int ans = -INF;
    for (int i = 0; i < m; ++i) {
        int y = b[i].fi;
        for (; it < k && p[it].y < y; ++it) {
            int idx = upper_bound(all(a), make_pair(p[it].x, INF)) - a.begin();
            t.upd(idx, n, p[it].z);
        }
        int res = t.get_max();
        res -= b[i].se;
        ans = max(ans, res);
    }
    cout << ans << "\n";
}

main() {
	set_program();
	int t;
	#ifdef DEBUG
        t = 1;
    #else
        t = 1;
	#endif // DEBUG
	for (; t--; ) {
        solve();
        cout << "\n";
	}
	return 0;
}
