#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <iomanip>
#include <numeric>
#include <string>
#include <map>

#define all(a) a.begin(), a.end()
#define z(a) fixed << setprecision(a)
#define nl '\n'

using namespace std;

#define int long long

const int MAXN = 1e9 + 10;
const int MOD = 1e9+7;

void IO() {
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
}

string s;
vector<bool> used;

int next_right(int p){
	for (int i=p+1; i<s.size(); i++){
		if (!used[i] && s[i] == s[p] - 1){
			return i;
		}
		if (!used[i]){
			break;
		}
	}
	return -1;
}

int next_left(int p){
	for (int i=p-1; i>=0; i--){
		if (!used[i] && s[i] == s[p] - 1){
			return i;
		}
		if (!used[i]){
			break;
		}
	}
	return -1;
}

inline void solve(){
	int n;
	cin >> n;
	cin >> s;
	used.resize(n, 0);
	for (int j=25; j>=0; j--){
		char c = 'a' + j;
		for (int i=0; i<n; i++){
			if (s[i] == c && !used[i]){
				int ri = next_right(i), le = next_left(i);
				if (max(le, ri) > -1){
					used[i]=1;
				}
			}
		}
		for (int i=n-1; i>=0; i--){
			if (s[i] == c && !used[i]){
				int ri = next_right(i), le = next_left(i);
				if (max(le, ri) > -1){
					used[i]=1;
				}
			}
		}
	}
	int ans = 0;
	for (int i=0; i<n; i++){
		ans+=used[i];
	}
	cout << ans;
}

signed main() {
	IO();
	int t = 1;
	while (t--)
		solve();
	return 0;
}