#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <iomanip>
#include <numeric>
#include <string>
#include <map>

#define all(a) a.begin(), a.end()
#define z(a) fixed << setprecision(a)
#define nl '\n'

using namespace std;

#define int long long

const int MAXN = 1e9 + 10;
const int MOD = 1e9+7;

void IO() {
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
}

vector<vector<int>> g;
int n, m;
vector<int> d, c;

void bfs(int v){
	vector<bool> used(n, 0);
	used[v]=1;
	d[v]=0;
	c[v]=1;
	queue<int> q;
	q.push(v);
	while (q.size()){
		v = q.front();
		q.pop();
		for (int i=0; i<g[v].size(); i++){
			int to = g[v][i];
			if (!used[to]){
				used[to] = 1;
				q.push(to);
				d[to] = d[v]+1;
				c[to] = c[v];
			}
			else if (d[to] == d[v] + 1){
				c[to] +=c[v];
			}
		}
	}
}

inline void solve(){
	cin >> n >> m;
	g.resize(n);
	d.resize(n);
	c.resize(n);
	for (int i=0; i<m; i++){
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		g[b].push_back(a);
	}
	int k;
	cin >> k;
	vector<int> path(k);
	for (int i=0; i<k; i++){
		cin >> path[i];
		path[i]--;
	}
	int s = path[0], f = path.back();
	bfs(f);
	int ma = 0, mi = 0;
	for (int i=1; i<k; i++){
		int len = d[path[i - 1]];
		if (d[path[i]] != len - 1 || c[path[i]] != c[path[i - 1]]){
			ma++;
		}
	}
	for (int i=1; i<k; i++){
		int len = d[path[i - 1]];
		if (d[path[i]] != len - 1){
			mi++;
		}
	}
	cout << mi << ' ' << ma;
}

signed main() {
	IO();
	int t = 1;
	while (t--)
		solve();
	return 0;
}