#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <iomanip>
#include <numeric>
#include <string>
#include <map>
#include <random>

#define all(a) a.begin(), a.end()
//#define z(a) fixed << setprecision(a)
#define nl '\n'

using namespace std;

#define int long long

const int MAXN = 1e6 + 10;
const int MOD = 1e9+7;
const long long LINF = 1e18 + 100;

void IO() {
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
}

mt19937 rnd(48276392);

vector<pair<int, int>> a, b;
vector<int> x, y, z;
int n, m, p;

int get_cost2(int cost, int x1, int x2){
	for (int i=0; i<p; i++){
		if (a[x1].first > x[i] && b[x2].first > y[i]){
			cost += z[i];
		}
	}
	return cost;
}

int get_cost(int x){
	int l = 0, r = m;
	while (r - l > 3){
		int x1 = l + (r - l) / 3, x2 = l + (r - l) / 3 * 2;
		int cost1 = -(a[x].second + b[x1].second);
		int cost2 = -(a[x].second + b[x2].second);
		int ans1 = get_cost2(cost1, x, x1);
		int ans2 = get_cost2(cost2, x, x2);
		if (ans1 > ans2){
			r = x2;
		}
		else if (ans1 < ans2) {
			l = x1;
		}
		else {
			l -= rnd() % (l+1);
			r += rnd() % (n - r);
		}
	}
	int ma = -LINF;
	for (int i=l; i<r; i++){
		int cost = -(a[x].second + b[i].second);
		int ans = get_cost2(cost, x, i);
		ma = max(ma, ans);
	}
	return ma;
}

inline void solve(){
	cin >> n >> m >> p;
	set<pair<int, int>> ss;
	for (int i=0; i<n; i++){
		int q, w;
		cin >> q >> w;
		ss.insert(make_pair(q, w));
	}
	while (ss.size()){
		auto t = *ss.begin();
		ss.erase(ss.begin());
		a.push_back(t);
	}
	for (int i=0; i<m; i++){
		int q, w;
		cin >> q >> w;
		ss.insert(make_pair(q, w));
	}
	while (ss.size()){
		auto t = *ss.begin();
		ss.erase(ss.begin());
		b.push_back(t);
	}
	n = a.size();
	m = b.size();
	for (int i=n-2; i>=0; i--){
		a[i].second = min(a[i].second, a[i + 1].second);
	}
	for (int i=m-2; i>=0; i--){
		b[i].second = min(b[i].second, b[i + 1].second);
	}
	x.resize(p);
	y.resize(p);
	z.resize(p);
	for (int i=0; i<p; i++){
		cin >> x[i] >> y[i] >> z[i];
	}
	int l = 0, r = n;
	while (r - l > 3){
		int x1 = l + (r - l) / 3, x2 = l + (r - l) / 3 * 2;
		int ans1 = get_cost(x1), ans2 = get_cost(x2);
		if (ans1 > ans2){
			r = x2;
		}
		else if (ans1 < ans2) {
			l = x1;
		}
		else {
			l -= rnd() % (l+1);
			r += rnd() % (n - r);
		}
	}
	int ma = -LINF;
	for (int i = l; i<r; i++){
		int ans = get_cost(i);
		ma = max(ma, ans);
	}
	cout << ma;
}

signed main() {
	IO();
	int t = 1;
	while (t--)
		solve();
	return 0;
}