#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <iomanip>
#include <numeric>
#include <string>
#include <map>
#include <random>
#include <math.h>

#define all(a) a.begin(), a.end()
//#define z(a) fixed << setprecision(a)
#define nl '\n'

using namespace std;

#define int long long

const int MAXN = 1e6 + 10;
const int MOD = 1e9+7;
const long long LINF = 1e18 + 100;

void IO() {
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
}

mt19937 rnd(48276392);

vector<pair<int, int>> a, b;
vector<int> x, y, z;
int n, m, p;

double get_cost2(double cost, int x1, int x2){
	for (int i=0; i<p; i++){
		if (a[x1].first > x[i] && b[x2].first > y[i]){
			cost += z[i];
		}
	}
	return cost;
}

double get_cost(double x){
	int p1 = floor(x), p2 = p1+1;
	double q1 = x - p1, q2 = p2 - x;
	double l = 0, r = m;
	while (r - l > 3){
		double x1 = l + (r - l) / 3, x2 = l + (r - l) / 3 * 2;
		int pa1 = floor(x1), pa2 = pa1+1;
		int qa1 = x1 - pa1, qa2 = pa2 - x1;
		double cost1 = -((a[p1].second * q2 + a[p2].second * q1) + (b[pa1].second * qa2 + b[pa2].second * qa1));
		pa1 = floor(x2), pa2 = pa1+1;
		qa1 = x2 - pa1, pa2 = pa2 - x2;
		double cost2 = -((a[p1].second * q2 + a[p2].second * q1) + (b[pa1].second * qa2 + b[pa2].second * qa1));
		double ans1 = get_cost2(cost1, floor(x), floor(x1));
		double ans2 = get_cost2(cost2, floor(x), floor(x2));
		if (ans1 > ans2){
			r = x2;
		}
		else {
			l = x1;
		}
	}
	double ma = -LINF;
	for (int i=l; i<r; i++){
		double cost = -(a[x].second + b[i].second);
		double ans = get_cost2(cost, x, i);
		ma = max(ma, ans);
	}
	return ma;
}

inline void solve(){
	cin >> n >> m >> p;
	set<pair<int, int>> ss;
	for (int i=0; i<n; i++){
		int q, w;
		cin >> q >> w;
		ss.insert(make_pair(q, w));
	}
	while (ss.size()){
		auto t = *ss.begin();
		ss.erase(ss.begin());
		a.push_back(t);
	}
	for (int i=0; i<m; i++){
		int q, w;
		cin >> q >> w;
		ss.insert(make_pair(q, w));
	}
	while (ss.size()){
		auto t = *ss.begin();
		ss.erase(ss.begin());
		b.push_back(t);
	}
	n = a.size();
	m = b.size();
	vector<pair<int, int>> newa;
	newa.push_back(a.back());
	for (int i=n-2; i>=0; i--){
		if (a[i].second <= a[i + 1].second){
			a[i].second = min(a[i].second, a[i + 1].second);
			newa.push_back(a[i]);
			continue;
		}
		a[i].second = min(a[i].second, a[i + 1].second);
	}
	a = newa;
	vector<pair<int, int>> newb;
	newb.push_back(b.back());
	for (int i=m-2; i>=0; i--){
		if (b[i].second <= b[i + 1].second){
			b[i].second = min(b[i].second, b[i + 1].second);
			newb.push_back(b[i]);
			continue;
		}
		b[i].second = min(b[i].second, b[i + 1].second);
	}
	b = newb;
	n = a.size();
	m = b.size();
	sort(all(a));
	sort(all(b));
	x.resize(p);
	y.resize(p);
	z.resize(p);
	for (int i=0; i<p; i++){
		cin >> x[i] >> y[i] >> z[i];
	}
	double l = 0, r = n;
	while (r - l > 3){
		double x1 = l + (r - l) / 3.0, x2 = l + (r - l) / 3.0 * 2;
		double ans1 = get_cost(x1), ans2 = get_cost(x2);
		if (ans1 > ans2){
			r = x2;
		}
		else {
			l = x1;
		}
	}
	double ma = -LINF;
	for (int i = l; i<r; i++){
		double ans = get_cost(i);
		ma = max(ma, ans);
	}
	cout << floor(ma);
}

signed main() {
	IO();
	int t = 1;
	while (t--)
		solve();
	return 0;
}