#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

typedef long long int ll;

const ll INF = 9e18;
const int MAXN = (1 << 20) + 2;
vector<pair<ll, int>> t(3 * MAXN, {-INF, -1});

void change(int v, int tl, int tr, int i, ll x, int m_i) {
    if (tl > i || tr <= i) {
        return;
    }
    if (tr - tl == 1) {
        t[v] = max(t[v], {x, m_i});
        return;
    }

    int tm = (tl + tr) / 2;
    change(2 * v + 1, tl, tm, i, x, m_i);
    change(2 * v + 2, tm, tr, i, x, m_i);
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

pair<ll, int> query(int v, int tl, int tr, int l, int r) {
    if (tl >= r || tr <= l) {
        return {-INF, -1};
    }
    if (tl >= l && tr <= r) {
        return t[v];
    }

    int tm = (tl + tr) / 2;
    return max(query(2 * v + 1, tl, tm, l, r),
               query(2 * v + 2, tm, tr, l, r));
}

int main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif

    int n;
    vector<int> b;

    cin >> n;
    b.resize(n);
    for (int &elem : b) {
        cin >> elem;
    }

    ll ans = 0;
    vector<ll> dp(n);
    for (int i = 0; i < n; ++i) {
        pair<ll, int> max_dp = query(0, 0, MAXN, max(1, b[i] - i), b[i]);
        if (max_dp.second == -1 || b[i] - b[max_dp.second] != i - max_dp.second) {
            dp[i] = b[i];
        } else {
            dp[i] = max(dp[i], max_dp.first + b[i]);
        }

        change(0, 0, MAXN, b[i], dp[i], i);
        ans = max(ans, dp[i]);
    }

    cout << ans << '\n';
    return 0;
}
