#include <iostream>
#include <vector>
#include <algorithm>

#define int long long

using namespace std;

const int INF = 1e18;

struct st{
    int n;
    vector<int> t;
    vector<int> p;

    void init(int _n){
        n = _n;
        t.resize(4 * n);
        p.resize(4 * n);
    }

    void push(int v){
        t[v] += p[v];
        p[2 * v] += p[v];
        p[2 * v + 1] += p[v];
        p[v] = 0;
    }

    void add(int v, int l, int r, int val, int dl, int dr){
        if (l == dl && r == dr){
            p[v] += val;
            return;
        }
        if (l >= r){
            return;
        }
        int dm = (dl + dr) / 2;
        push(v);
        add(2 * v, l, min(r, dm), val, dl, dm);
        add(2 * v + 1, max(l, dm), r, val, dm, dr);
        t[v] = max(t[2 * v] + p[2 * v], t[2 * v + 1] + p[2 * v + 1]);
    }

    void add(int l, int r, int val){
        add(1, l, r, val, 0, n);
    }

    int getmax(int v, int l, int r, int dl, int dr){
        if (dl == l && dr == r){
            return t[v] + p[v];
        }
        if (l >= r){
            return -INF;
        }
        push(v);
        int dm = (dl + dr) / 2;
        int res1 = getmax(2 * v, l, min(r, dm), dl, dm);
        int res2 = getmax(2 * v + 1, max(l, dm), r, dm, dr);
        return max(res1, res2);
    }

    int getmax(int l, int r){
        return getmax(1, l, r, 0, n);
    }
};

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, p;
    cin >> n >> m >> p;
    st t;
    t.init(m);
    vector<pair<int, int> > a(n);
    for (int i = 0; i < n; i++){
        cin >> a[i].first >> a[i].second;
    }
    vector<pair<int, int> > b(m);
    for (int i = 0; i < m; i++){
        cin >> b[i].first >> b[i].second;
    }
    sort(b.begin(), b.end());
    for (int i = 0; i < m; i++){
        t.add(i, i + 1, -b[i].second);
    }
    sort(a.begin(), a.end());
    vector<vector<int> > x(p, vector<int>(3));
    for (int i = 0; i < p; i++){
        cin >> x[i][0] >> x[i][1] >> x[i][2];
    }
    sort(x.begin(), x.end());
    int now = 0;
    int ans = -INF;
    for (int i = 0; i < n; i++){
        int cur = -a[i].second;
        while (now < p && x[now][0] < a[i].first){
            int sup = x[now][1];
            int c = x[now][2];
            if (sup < b[0].first){
                t.add(0, m, c);
            }else if (sup < b[m - 1].first){
                int l = 0;
                int r = m - 1;
                while (r - l > 1){
                    int mid = (r + l) / 2;
                    if (b[mid].first > sup){
                        r = mid;
                    }else{
                        l = mid;
                    }
                }
                t.add(r, m, c);
            }
            now++;
        }
        cur += t.getmax(0, m);
        ans = max(cur, ans);
    }
    cout << ans << endl;
    return 0;
}
