#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <cstdio>
#include <cmath>
#include <set>
#include <map>

#define all(x) x.begin(), x.end()

using namespace std;

typedef long long ll;

const ll inf = ll(1e18) + 228;
const ll cst = 2e5 + 5;
const ll mod = 1e9 + 7;

ll n, m, k;

vector<ll> gr[cst];
vector<ll> gt[cst];

vector<ll> route;

set<ll> pos[cst];

ll ans1;
ll ans2;

int main(){
    cin >> n >> m;
    for(int i = 0; i < m; i++){
        ll a, b;
        cin >> a >> b;
        gr[a].push_back(b);
        gt[b].push_back(a);
    }
    cin >> k;
    for(int i = 0; i < k; i++){
        ll x;
        cin >> x;
        route.push_back(x);
    }
    ll s = route[0], t = route[k - 1];
    vector<ll> d(n + 1, inf);
    d[t] = 0;
    set<pair<ll, ll>> st;
    st.insert({0, t});
    while(!st.empty()){
        ll v = st.begin()->second;
        st.erase(st.begin());
        for(int i = 0; i < gt[v].size(); i++){
            ll u = gt[v][i];
            if(d[u] > d[v] + 1){
                st.erase({d[u], u});
                d[u] = d[v] + 1;
                st.insert({d[u], u});
            }
        }
    }
    for(int i = 1; i <= n; i++){
        for(ll u : gr[i]){
            if(d[u] + 1 == d[i]) pos[i].insert(u);
        }
    }
    for(int i = 0; i < k - 1; i++){
        //for(auto u : pos[route[i]]) cerr << u << " ";
        //cerr << endl;
        if(pos[route[i]].find(route[i + 1]) == pos[route[i]].end()) {
                ans1++;
                ans2++;
        }
        else if(pos[route[i]].size() != 1) ans2++;
    }
    cout << ans1 << " " << ans2;
    return 0;
}








































