#include <iostream>
#include <map>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}

#define int long long

const int maxN = 2e5 + 10, inf = 1e18;

struct segment_tree {
    int t[4 * maxN];
    vector < pair < int, int > > a;

    segment_tree(vector < pair < int, int > > &a): a(a) {
        build(1, 0, a.size() - 1);
    }

    void build(int v, int l, int r) {
        if (l == r) {
            t[v] = -a[l].second;
        } else {
            int m = (r + l) / 2;
            build(v * 2, l, m);
            build(v * 2 + 1, m + 1, r);
            t[v] = max(t[v * 2], t[v * 2 + 1]);
        }
    }

    void add(int v, int l, int r, int ln, int rn, int val) {

        if (l >= ln && r <= rn) {
            //cout << t[v] << " DO" << endl;
            t[v] += val;
            //cout << t[v] << " " << v << " v " << val << endl;
            return;
        }
        if (l > rn || r < ln) {
            return;
        }
        int m = (r + l) / 2;
        add(v * 2, l, m, ln, rn, val);
        add(v * 2 + 1, m + 1, r, ln, rn, val);
        t[v] = max(t[v], max(t[v * 2], t[v * 2 + 1]));
        //cout << t[v] << " " << t[v * 2] << " " << t[v * 2 + 1] << " " << v << " " << l << " " << r << " " << ln << " " << rn << " " << val << endl;
    }

    int get() {
        return t[1];
    }

};

vector < pair < int, int > > cl(vector < pair < int, int > > a) {
    vector < pair < int, int > > res;
    sort(a.begin(), a.end());
    int mn = inf;
    for (int i = a.size() - 1; i >= 0; i--) {
        if (a[i].second < mn) {
            res.push_back(a[i]);
            mn = a[i].second;
        }
    }
    reverse(res.begin(), res.end());
    return res;
}

int n, m, p;
vector < pair < int, int > > a, b;
pair < int, pair < int, int > > c[maxN];

void solve() {// ПОМЕНЯЙ MAXN!
    cin >> n >> m >> p;
    for (int i = 0; i < n; i++) {
        pair < int, int > pr;
        cin >> pr.first >> pr.second;
        a.push_back(pr);
    }
    for (int i = 0; i < m; i++) {
        pair < int, int > pr;
        cin >> pr.first >> pr.second;
        b.push_back(pr);
    }
    for (int i = 0; i < p; i++) {
        cin >> c[i].first >> c[i].second.first >> c[i].second.second;
    }
    a = cl(a);
    n = a.size();
    b = cl(b);
    m = b.size();
    sort(c, c + p);
    int r = 0, ans = -inf;
    segment_tree tree(b);
    for (int i = 0; i < n; i++) {
        while (r < p && a[i].first > c[r].first) {
            int arm = c[r].second.first, val = c[r].second.second;
            int ll = -1, rr = b.size();
            while (ll + 1 < rr) {
                int mm = (rr + ll) / 2;
                if (b[mm].first <= arm) {
                    ll = mm;
                } else {
                    rr = mm;
                }
            }
            //cout << rr << " " << val << endl;
            if (rr != b.size()) {
                tree.add(1, 0, m - 1, rr, m - 1, val);
            }
            r++;
        }
        //cout << tree.get() << " " << a[i].second << endl;
        ans = max(ans, tree.get() - a[i].second);
    }
    cout << ans;
}