#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cmath>
#include <numeric>
#include <iomanip>
#include <utility>
#include <iterator>
#include <map>
#include <set>
#include <string>
#include <algorithm>
#include <climits>
#include <deque>
#include <queue>
#include <unordered_map>
#include <unordered_set>
using namespace std;
#define int long long
struct fenwick{
	int n;
	vector<int> f;
	fenwick(int a){
		n = a;
		f.assign(n,0);
	};
	void add(int val, int i){
		for (; i < n; i |= (i + 1))
			f[i] += val;
	}
	int getsum(int i){
		int sum = 0;
		for (; i >= 0; i &= (i + 1), --i)
			sum += f[i];
		return sum;
	}
	int get(int L, int R){
		return getsum(R) - getsum(L - 1);
	}
};
void solve(){
	int n;
	cin >> n;
	vector<int> a(n), sum(n,0);
	vector<vector<int>> keks(n);
	for (int i = 0; i < n; ++i) cin >> a[i];
	int L = 0;
	for (int i = 0; i < n; ++i){
		bool f = false;
		for (int j = 0; j < L; ++j){
			if (a[i] - a[keks[j].back()] == i - keks[j].back()){
				keks[j].push_back(i);
				sum[j] += a[i];
				f = true;
				break;
			}
		}
		if (!f){
			sum[L] += a[i];
			keks[L].push_back(i);
			++L;
		}
	}
	int ans = 0;
	for (int i = 0; i < n; ++i){
		ans = max(ans,sum[i]);
	}
	cout << ans;
}
signed main(){
#ifdef _DEBUG
	freopen("input.txt","r",stdin);
	freopen("output.txt","w",stdout);
#else
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
	int t;
	t = 1;
	while(t--){
		solve();
	}
}