//#define _FORTIFY_SOURCE 0
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,sse4,popcnt,abm,mmx,avx,tune=native")
#include <bits/stdc++.h>

#define ll long long
#define pll pair<ll, ll>
#define ld long double
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()


const ll inf = 1e18;


using namespace std;


mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());


ll rnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}


ld rnd_double(ld l, ld r) {
    return uniform_real_distribution<ld>(l, r)(rng);
}


template<class T>
istream& operator>>(istream &in, vector<T> &arr) {
    for (T &x : arr) {
        in >> x;
    }
    return in;
};


ll t[4000000], upd[4000000];


struct stree {
    void push(int v, int d) {
        t[v] += upd[v];
        if (d > 0) {
            upd[v * 2] += upd[v];
            upd[v * 2 + 1] += upd[v];
        }
        upd[v] = 0;
    }

    void add(int v, int l, int r, int ql, int qr, ll d) {
        push(v, r - l);
        if (ql <= l and r <= qr) {
            upd[v] += d;
            push(v, r - l);
            return;
        }
        if (l > qr or r < ql) {
            return;
        }
        int mid = (l + r) / 2;
        add(v * 2, l, mid, ql, qr, d);
        add(v * 2 + 1, mid + 1, r, ql, qr, d);
        t[v] = max(t[v * 2] + 0, t[v * 2 + 1] + 0);
    }

    ll get_ans() {
        push(1, 1);
        return t[1];
    }
};


void solve() {
    ll n, m, p;
    cin >> n >> m >> p;
    vector<pll> a(n), b(m);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }

    for (int i = 0; i < m; i++) {
        cin >> b[i].first >> b[i].second;
    }
    a.pb({0, 0});
    sort(all(a));
    sort(all(b));
    vector<pll> real_weapons, real_armor;
    for (int i = 0; i < n + 1;) {
        real_weapons.pb(a[i]);
        int j = i;
        while (j < n + 1 and a[i].first == a[j].first) {
            j++;
        }
        i = j;
    }

    for (int i = 0; i < m;) {
        real_armor.pb(b[i]);
        int j = i;
        while (j < m and b[i].first == b[j].first) {
            j++;
        }
        i = j;
    }

    for (int i = real_weapons.size() - 1; i > 0;) {
        if (real_weapons[i].second <= real_weapons[i - 1].second) {
            real_weapons[i - 1] = real_weapons[i];
            real_weapons.pop_back();
        }
        i--;
    }

    for (int i = real_armor.size() - 1; i > 0;) {
        if (real_armor[i].second <= real_armor[i - 1].second) {
            real_armor[i - 1] = real_armor[i];
            real_armor.pop_back();
        }
        i--;
    }
    multiset<vector<ll>> enemies;
    for (int i = 0; i < p; i++) {
        vector<ll> monster(3);
        cin >> monster;
        swap(monster[0], monster[1]);
        enemies.insert(monster);
    }

    stree tree;
    ll ans = -inf;

    for (int i = 0; i < real_weapons.size() - 1; i++) {
        tree.add(1, 0, 1000000, real_weapons[i].first, real_weapons[i + 1].first - 1, -real_weapons[i + 1].second);
    }
    tree.add(1, 0, 1000000, real_weapons.back().first, 1000000, -inf);
    for (auto armor : real_armor) {
        while (!enemies.empty() and (*enemies.begin())[0] < armor.first) {
            vector<ll> en = *enemies.begin();
            enemies.erase(enemies.begin());
            tree.add(1, 0, 1000000, en[1] + 1, 1000000, en[2]);
        }
        ans = max(ans, -armor.second + tree.get_ans());
    }
    cout << ans;
}


int main() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(30);
    solve();
    return 0;
}