#pragma GCC optimize ("fast-math,unroll-loops")
#pragma GCC target ("avx,sse,sse2,sse3,sse4.1,sse4.2")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <string>
#include <queue>

#define fr first
#define se second
#define ll long long
#define sz(v) (int)v.size()
#define ld long double
#define pii pair<int, int>
#define hm unordered_map
#define pb push_back

#define int ll

#define __LOCAL

using namespace std;

#ifdef __LOCAL
    #define dbg(x) cerr << #x << " : " << x <<'\n';
#else
    #define dbg(x)
#endif

const ll inf = 2e9;
const int MAXLOG = 20;
const int MAXN = 2e5 + 100;
const ll mod = 1e9 + 7;
const ll ns = 97;

random_device rd;
mt19937_64 rnd(rd());

// tg: galebickosikasa

struct Tree {
    vector<int> t;
    int size = 0, capacity;

    Tree (vector<int>& v) {
        while ((1 << size) < sz(v)) ++size;
        ++size;
        size = 1 << size;
        capacity = size >> 1;
        t = vector<int>(size);
        for (int i = 0; i < sz(v); ++i) t[i + capacity] = v[i];
        for (int i = capacity - 1; i > 0; --i) t[i] = max(t[i * 2], t[i * 2 + 1]);
    }

    int get (int cur, int left, int right, int l, int r) {
        if (cur >= size) return 0;
        else if (left > r || right < l) return 0;
        else if (l <= left && r >= right) return t[cur];
        else {
            return max(get(cur * 2, left, (left + right) / 2, l, r),
                       get(cur * 2 + 1, (left + right) / 2 + 1, right, l, r));
        }
    }

    int get (int l, int r) {
        return get(1, 0, capacity - 1, l, r);
    }

    void set (int i, int x) {
        i += capacity;
        t[i] = x;
        i /= 2;
        while (i) {
            t[i] = min(t[i * 2], t[i * 2 + 1]);
            i /= 2;
        }
    }

};

struct Tree_mas {
    vector<int> t, assign;
    int size = 0, capacity;

    Tree_mas (vector<int>& v) {
        while ((1 << size) < sz(v)) ++size;
        ++size;
        size = 1 << size;
        capacity = size >> 1;
        t = assign = vector<int>(size);
        for (int i = 0; i < sz(v); ++i) t[i + capacity] = v[i];
        for (int i = capacity - 1; i > 0; --i) t[i] = max(t[i * 2], t[i * 2 + 1]);
    }

    void push (int cur) {
        assign[cur * 2] += assign[cur];
        assign[cur * 2 + 1] += assign[cur];
        assign[cur] = 0;
    }

    void render (int cur) {
        t[cur] = max(t[cur * 2] + assign[cur * 2], t[cur * 2 + 1] + assign[cur * 2 + 1]);
    }

    int get (int cur, int left, int right, int l, int r) {
        if (cur >= size) return 0;
        else if (left > r || right < l) return 0;
        else if (l <= left && r >= right) return t[cur] + assign[cur];
        else {
            push (cur);
            int ans = max(get(cur * 2, left, (left + right) / 2, l, r),
                       get(cur * 2 + 1, (left + right) / 2 + 1, right, l, r));
            render (cur);
            return ans;
        }
    }

    int get (int l, int r) {
        return get(1, 0, capacity - 1, l, r);
    }

    void add (int cur, int left, int right, int l, int r, int x) {
        if (cur >= size) return;
        else if (left > r || right < l) return;
        else if (l <= left && r >= right) assign[cur] += x;
        else {
            push(cur);
            add (cur * 2, left, (left + right) / 2, l, r, x);
            add (cur * 2 + 1, (left + right) / 2 + 1, right, l, r, x);
        }
    }

    void add (int l, int r, int x) {
        add(1, 0, capacity - 1, l, r, x);
    }

};

struct fenwick {
    vector<int> t;

    fenwick(int s) {
        t = vector<int>(s + 1);
    }

    void add(int i, int x) {
        for (; i < sz (t); i += i & -i)
            t[i] += x;
    }

    int get(int i) {
        int ans = 0;
        for (; i > 0; i -= i & -i)
            ans += t[i];
        return ans;
    }

    int get(int i, int j) {
        return get(j) - get(i - 1);
    }

};

vector<vector<int>> g, _g;

vector<int> bfs (int s) {
    int n = sz (g);
    vector<int> d(n, inf);
    d[s] = 0;
    queue<int> a;
    a.push(s);
    while (!a.empty()) {
        int v = a.front();
        a.pop();
        for (auto &u: g[v]) {
            if (d[u] > d[v] + 1) {
                d[u] = d[v] + 1;
                a.push(u);
            }
        }
    }
    return d;
}

vector<int> _bfs (int s) {
    int n = sz (g);
    vector<int> d(n, inf);
    d[s] = 0;
    queue<int> a;
    a.push(s);
    while (!a.empty()) {
        int v = a.front();
        a.pop();
        for (auto &u: _g[v]) {
            if (d[u] > d[v] + 1) {
                d[u] = d[v] + 1;
                a.push(u);
            }
        }
    }
    return d;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    g = _g = vector<vector<int>> (n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        g[a].pb(b);
        _g[b].pb (a);
    }
    int k;
    cin >> k;
    vector<int> order (k);
    for (auto& x: order) cin >> x;
    for (auto& x: order) --x;
    int s = order.front();
    int t = order.back();
    auto d1 = bfs (s);
    auto d2 = _bfs (t);
    int mn = 0, mx = 0;
    int D = d1[t];
    for (int i = 1; i < k; ++i) {
        int v = order[i];
        int d = d2[v];
        if (d > D - 1) {
            ++mn, D = d;
        } else --D;
    }
    D = d1[t];
    for (int i = 1; i < k; ++i) {
        int v = order[i];
        int d = d2[v];
        if (d > D - 1) {
            ++mx, D = d;
        } else {
            int p = order[i - 1];
            int cnt = 0;
            for (auto &u: g[p]) {
                if (u == v) continue;
                if (d2[u] == d2[v]) ++cnt;
            }
            mx += cnt > 0;
            --D;
        }
    }
    cout << mn << ' ' << mx;





}
