#pragma GCC optimize ("fast-math,unroll-loops")
#pragma GCC target ("avx,sse,sse2,sse3,sse4.1,sse4.2")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <string>
#include <queue>

#define fr first
#define se second
#define ll long long
#define sz(v) (int)v.size()
#define ld long double
#define pii pair<int, int>
#define hm unordered_map
#define pb push_back
#define all(x) x.begin(), x.end()

#define int ll

#define __LOCAL

using namespace std;

#ifdef __LOCAL
    #define dbg(x) cerr << #x << " : " << x <<'\n';
#else
    #define dbg(x)
#endif

const ll inf = 2e9;
const int MAXLOG = 20;
const int MAXN = 2e5 + 100;
const ll mod = 1e9 + 7;
const ll ns = 97;

random_device rd;
mt19937_64 rnd(rd());

// tg: galebickosikasa

struct Tree {
    vector<int> t;
    int size = 0, capacity;

    Tree (int s) {
        while ((1 << size) < s) ++size;
        ++size;
        size = 1 << size;
        capacity = size >> 1;
        t = vector<int>(size);
    }

    int get (int cur, int left, int right, int l, int r) {
        if (cur >= size) return 0;
        else if (left > r || right < l) return 0;
        else if (l <= left && r >= right) return t[cur];
        else {
            return get(cur * 2, left, (left + right) / 2, l, r) +
                       get(cur * 2 + 1, (left + right) / 2 + 1, right, l, r);
        }
    }

    int get (int l, int r) {
        return get(1, 0, capacity - 1, l, r);
    }

    void add (int i, int x) {
        i += capacity;
        t[i] += x;
        i /= 2;
        while (i) {
            t[i] = t[i * 2] + t[i * 2 + 1];
            i /= 2;
        }
    }

};

struct Tree_mas {
    vector<int> t, assign;
    int size = 0, capacity;

    Tree_mas (vector<int>& v) {
        while ((1 << size) < sz(v)) ++size;
        ++size;
        size = 1 << size;
        capacity = size >> 1;
        t = assign = vector<int>(size);
        for (int i = 0; i < sz(v); ++i) t[i + capacity] = v[i];
        for (int i = capacity - 1; i > 0; --i) t[i] = max(t[i * 2], t[i * 2 + 1]);
    }

    void push (int cur) {
        assign[cur * 2] += assign[cur];
        assign[cur * 2 + 1] += assign[cur];
        assign[cur] = 0;
    }

    void render (int cur) {
        t[cur] = max(t[cur * 2] + assign[cur * 2], t[cur * 2 + 1] + assign[cur * 2 + 1]);
    }

    int get (int cur, int left, int right, int l, int r) {
        if (cur >= size) return 0;
        else if (left > r || right < l) return 0;
        else if (l <= left && r >= right) return t[cur] + assign[cur];
        else {
            push (cur);
            int ans = max(get(cur * 2, left, (left + right) / 2, l, r),
                       get(cur * 2 + 1, (left + right) / 2 + 1, right, l, r));
            render (cur);
            return ans;
        }
    }

    int get (int l, int r) {
        return get(1, 0, capacity - 1, l, r);
    }

    void add (int cur, int left, int right, int l, int r, int x) {
        if (cur >= size) return;
        else if (left > r || right < l) return;
        else if (l <= left && r >= right) assign[cur] += x;
        else {
            push(cur);
            add (cur * 2, left, (left + right) / 2, l, r, x);
            add (cur * 2 + 1, (left + right) / 2 + 1, right, l, r, x);
        }
    }

    void add (int l, int r, int x) {
        add(1, 0, capacity - 1, l, r, x);
    }

};

struct fenwick {
    vector<int> t;

    fenwick(int s) {
        t = vector<int>(s + 1);
    }

    void add(int i, int x) {
        for (; i < sz (t); i += i & -i)
            t[i] += x;
    }

    int get(int i) {
        int ans = 0;
        for (; i > 0; i -= i & -i)
            ans += t[i];
        return ans;
    }

    int get(int i, int j) {
        return get(j) - get(i - 1);
    }

};

struct enemy {
    int x, y, z;

    bool operator < (const enemy& other) const {
        return x < other.x;
    }

};

struct q {
    int x, y, i;

    bool operator < (const q& other) const {
        return x < other.x;
    }

};

vector<q> qs;
vector<int> ans;

void solve (vector<enemy>& enemys) {
    sort(all (qs));
    int prev = -1, i = 0, j = 0;
    Tree goo(1e6 + 10);
    while (i < sz (enemys)) {
        while (i < sz (enemys) && enemys[i].x == prev) {
            goo.add(enemys[i].y, enemys[i].z);
            ++i;
        }
        while (j < sz (qs) && qs[j].x <= prev) {
            ans[qs[j].i] += goo.get(0, qs[j].y);
            ++j;
        }
        if (i < sz (enemys)) prev = enemys[i].x;
    }
    while (j < sz (qs)) {
        ans[qs[j].i] += goo.get(0, qs[j].y);
        ++j;
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, p;
    cin >> n >> m >> p;
    vector<pii> wearon (n);
    vector<pii> bron (m);
    for (auto& x: wearon) cin >> x.fr >> x.se;
    for (auto& x: bron) cin >> x.fr >> x.se;
    sort (all (wearon));
    sort (all (bron));
    vector<int> tmp1, tmp2, _tmp1, _tmp2;
    for (auto& x: wearon) tmp1.pb (x.se);
    for (auto& x: bron) tmp2.pb (x.se);
    for (auto& x: wearon) _tmp1.pb (x.fr);
    for (auto& x: bron) _tmp2.pb (x.fr);
    vector<pii> min_suf1, min_suf2;

    for (int i = 0; i < sz (wearon); ++i) {
        min_suf1.pb({wearon[i].se, i});
    }
    for (int i = 0; i < sz (bron); ++i) {
        min_suf2.pb({bron[i].se, i});
    }
    for (int i = sz (min_suf1) - 2; i >= 0; --i) {
        min_suf1[i] = min(min_suf1[i], min_suf1[i + 1]);
    }
    for (int i = sz (min_suf2) - 2; i >= 0; --i) {
        min_suf2[i] = min(min_suf2[i], min_suf2[i + 1]);
    }

    vector<enemy> enemys (p);
    for (auto& x: enemys) cin >> x.x >> x.y >> x.z;
    sort (all (enemys));
    ans = vector<int> (p);

    for (int i = 0; i < p; ++i) {
        int a = upper_bound(all (_tmp1), enemys[i].x) - _tmp1.begin();
        int b = upper_bound(all (_tmp2), enemys[i].y) - _tmp2.begin();

        int x = min_suf1[a].se;
        int y = min_suf2[b].se;

        ans[i] = -wearon[x].se - bron[y].se;

        qs.pb({wearon[x].fr - 1, bron[y].fr - 1, i});
    }

    solve (enemys);
    int mx = -inf;
    for (auto & x: ans) mx = max (mx, x);

    cout << mx;



}
