#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <random>
#include <numeric>
#include <bitset>
#include <iomanip>
#include <deque>
using namespace std;
#define kekek ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define int long long
#define sp system("pause")

template <class T>
istream& operator >>(istream& s, vector<T>& v){
	for (int i = 0; i < v.size(); i++){
		cin >> v[i];
	}
	return s;
}

struct node{
	int mx, plus;
};

int inf = 1e9 + 7;

struct segtree{
	int n;
	vector<node> tr;
	
	void pull(int v){
		tr[v].mx = max(tr[2 * v].mx, tr[2 * v + 1].mx);
	}

	void push(int v){
		if (tr[v].plus){
			tr[2*v].plus += tr[v].plus;
			tr[2 * v + 1].plus += tr[v].plus;
			tr[2*v].mx += tr[v].plus;
			tr[2*v+1].mx += tr[v].plus;
			tr[v].plus = 0;
		}
	}

	void build(int v, int l, int r, vector<int>& kek){
		if (l == r){
			tr[v].mx = kek[l];
			return;
		}

		int m = (l+ r) / 2;
		build(2 * v, l, m, kek);
		build(2 * v + 1, m + 1, r, kek);
		pull(v);
	}

	void create(vector<int>& kek){
		n = kek.size();
		node aaaa;
		aaaa.mx = -inf;
		aaaa.plus = 0;
		tr.resize(4 * n + 5, aaaa);
		build(1, 0, n - 1, kek);
	}

	void add(int v, int l, int r, int ql, int qr, int val){
		if (ql > r || l > qr || l > r) return;
		if (ql <= l && qr >= r){
			tr[v].plus += val;
			tr[v].mx += val;
			return;
		}
		push(v);
		int m = (l + r) / 2;
		add(2 * v, l, m, ql, qr, val);
		add(2 * v + 1, m + 1, r, ql, qr, val);
		pull(v);
	}

	int get(int v, int l, int r, int ql, int qr){
		if (ql > r || l > qr || l > r) return -inf;
		if (ql <= l && qr >= r){
			return tr[v].mx;
		}
		push(v);
		int m = (l + r) / 2;
		int L = get(2 * v, l, m, ql, qr);
		int R = get(2 * v + 1, m + 1, r, ql, qr);
		pull(v);
		return max(L, R);
	}
};

signed main(){
	kekek;
	int n, m, p;
	cin >> n >> m >> p;
	vector<pair<int, int>> a(n), b(m);
	for (int i = 0; i < n; i++){
		cin >> a[i].first >> a[i].second;
		a[i].first--;
	}
	for (int i = 0; i < m; i++){
		cin >> b[i].first >> b[i].second;
		b[i].first--;
	}

	vector<vector<pair<int, int>>> keks(1e6 + 1);
	for (int i = 0; i < p; i++){
		int x,y,c;
		cin >> x >> y >> c;
		keks[x].push_back(make_pair(y, c));
	}
	a.push_back(make_pair(-1, inf));
	sort(b.begin(), b.end());
	sort(a.begin(), a.end());

	vector<int> zxc(m);
	vector<int> kek(m);
	for (int i = 0; i < m; i++){
		kek[i] = -b[i].second;
		zxc[i] = b[i].first;
	}

	segtree sg;
	sg.create(kek);

	int ans = -inf;
	for (int i = 0; i <= n; i++){
		ans = max(ans, sg.get(1, 0, m - 1, 0, m - 1) - a[i].second);

		if (i != n){
			for (int j = a[i].first + 1; j <= a[i + 1].first; j++){
				for (int k = 0; k < keks[j].size(); k++){
					int keke = lower_bound(zxc.begin(), zxc.end(), keks[j][k].first) - zxc.begin();
					sg.add(1, 0, m - 1, keke, m - 1, keks[j][k].second);
				}
			}
		}
	}

	cout << ans;

	//sp;
	return 0;
}