#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <numeric>
#include <iomanip>
#include <stack>
#include <queue>
#include <deque>
#include <list>
#include <random>

using namespace std;
#pragma warning(disable : 4996)

#define nl '\n'
#define all(a) (a).begin(), (a).end()
#define allr(a) (a).rbegin(), (a).rend()
#define mineq(a, b) (a) = min(a, b)
#define maxeq(a, b) (a) = max(a, b)

typedef long long ll;
typedef double dl;

const int INF = numeric_limits<int>::max();
const ll LINF = numeric_limits<ll>::max();
const dl EPS = 1e-8;
mt19937 rnd(2345234);

void IO() {
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cout.setf(ios::fixed);
	cout.precision(10);
}

const int N = (int)2e5 + 10;

void getVec(int& n, vector<pair<int, int>>& a) {
	vector<pair<int, int>> tmp;
	tmp.resize(n);
	for (int i = 0; i < n; i++)
		cin >> tmp[i].first >> tmp[i].second;

	sort(all(tmp));
	for (int i = 0; i < n; i++) {
		while (!a.empty() && a.back().second >= tmp[i].second)
			a.pop_back();
		a.push_back(tmp[i]);
	}
	n = (int)a.size();
}

struct Point {
	int x, y;
	int cost;

	Point(int x, int y, int z): x(x), y(y), cost(z) {}
};

ll check(int a, int b, const vector<Point>& c) {
	ll ans = 0;
	for (int i = 0; i < (int)c.size(); i++) {
		ans += (a > c[i].x && b > c[i].y) * c[i].cost;
	}
	return ans;
}

ll bs(int a, const vector<pair<int, int>>& b, const vector<Point>& c) {
	int dn = -1, up = (int)c.size();
	while (up - dn > 2) {
		int md1 = dn + (up - dn) / 3;
		int md2 = up - (up - dn) / 3;
		auto it1 = upper_bound(all(b), make_pair(c[md1].x, -1));
		auto it2 = upper_bound(all(b), make_pair(c[md2].x, -1));
		int b1 = it1->first;
		int b2 = it2->first;
		ll ans1 = check(a, b1, c) - it1->second;
		ll ans2 = check(a, b2, c) - it2->second;
		if (ans1 < ans2) {
			up = md2;
		}
		else {
			dn = md1;
		}
	}

	ll ans = -LINF;
	for (int i = max(0, dn); i <= min(up, (int)c.size() - 1); i++) {
		auto it = upper_bound(all(b), make_pair(c[i].x, -1));
		ll lans = check(a, it->first, c) - it->second;
		maxeq(ans, lans);
	}
	return ans;
}

void solve() {
	int n, m, p;
	cin >> n >> m >> p;
	vector<pair<int, int>> a, b;
	getVec(n, a);
	getVec(m, b);

	vector<Point> c;
	for (int i = 0; i < p; i++) {
		int x, y, z;
		cin >> x >> y >> z;
		if (x >= a.back().first || y >= b.back().first)
			continue;
		c.push_back(Point(x, y, z));
	}

	int dn = -1, up = (int)c.size();
	while (up - dn > 2) {
		int md1 = dn + (up - dn) / 3;
		int md2 = up - (up - dn) / 3;
		auto it1 = upper_bound(all(a), make_pair(c[md1].x, -1));
		auto it2 = upper_bound(all(a), make_pair(c[md2].x, -1));
		int a1 = it1->first;
		int a2 = it2->first;
		ll ans1 = bs(a1, b, c) - it1->second;
		ll ans2 = bs(a2, b, c) - it2->second;
		if (ans1 < ans2) {
			up = md2;
		}
		else {
			dn = md1;
		}
	}

	ll ans = -LINF;
	for (int i = max(0, dn); i <= min(up, (int)c.size() - 1); i++) {
		auto it = upper_bound(all(a), make_pair(c[i].x, -1));
		ll lans = bs(it->first, b, c) - it->second;
		maxeq(ans, lans);
	}

	cout << ans << nl;
}

int main() {
	IO();
	//int t;
	//cin >> t;
	//while (t--)
	solve();
	return 0;
}
