#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

//#define int long long
#define INF 1e10 + 7
#define maxn 1000007

int t[4 * maxn], pu[4* maxn];
vector<pair<int, int>>b;

void build(int v, int tl, int tr){
    if (tl + 1 == tr){
        t[v] = -b[tl].second;
        return;
    }
    int tm = (tl + tr) / 2;
    build(v * 2 + 1, tl, tm);
    build(v * 2 + 2, tm, tr);
    t[v] = max(t[v *2 + 1], t[v * 2 + 2]);
}
void pus(int v, int tl, int tr){
    if (tl == tr - 1){
        t[v] += pu[v];
        pu[v] = 0;
    }
    else if (pu[v] != 0){
        t[v] += pu[v];
        pu[v * 2 + 1] += pu[v];
        pu[v * 2 + 2] += pu[v];
        pu[v] = 0;
    }
}
void upd(int v, int tl, int tr, int l, int r, int val){
    if (l >= r) return;
    if (tl >= tr) return;
    if (l >= tr || r <= tl) return;
    if (l <= tl && tr <= r){
        pu[v] += val;
        pus(v, tl, tr);
        return;
    }
    pus(v, tl, tr);
    int tm = (tl + tr) / 2;
    upd(v *2 + 1, tl, tm, l, min(r, tm), val);
    upd(v *2 + 2, tm, tr, max(l, tm), r, val);
    t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
}

int bin(int x){
    int l  = -1, r = b.size() - 1;
    while(l + 1 != r){
        int mm = (l + r) / 2;
        if (b[mm].first > x) r = mm;
        else l =mm;
    }
    return r;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, p;
    cin >> n>> m  >> p;
    vector<pair<int, int>>a;
    long long ma = INF, mb = INF;
    for (int i =0 ; i < n; i++){
        int x, y;
        cin >> x >> y;
        a.push_back({x, -y});
        ma = min(ma, (long long)y);
    }

    for (int i =0 ; i < m; i++){
        int x, y;
        cin >> x >> y;
        b.push_back({x, y});
        mb = min(mb, (long long)y);
    }
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    vector<pair<int, int>> plo;
    plo.push_back({a[n - 1].first, -a[n - 1].second});
    for(int i = n - 1; i >= 0; i--){
        if (-a[i].second < plo[plo.size() - 1].second){
            plo.push_back({a[i].first, -a[i].second});
        }
    }
    reverse(plo.begin(), plo.end());
    swap(plo, a);

    vector<pair<int, pair<int, int>>> lst;
    for (int i = 0; i < p; i++){
        int x, y, z;
        cin>> x >> y >> z;
        lst.push_back({x, {y, z}});
    }
    sort(lst.begin(), lst.end());
    build(0, 0, m);
    int cur =0;
    long long ans = -INF;
    for (int i = 0; i < p; i++){
        while (cur + 1 != a.size() && a[cur].first <= lst[i].first){
            cur++;
        }
        if (a[cur].first <= lst[i].first) break;
        int x = bin(lst[i].second.first);
        if (b[x].first <= lst[i].second.first) continue;
        upd(0, 0, m, x, m, lst[i].second.second);
        //cerr << t[0] << " " << lst[i].second.second <<  " " << x << "\n";
        ans = max(ans, t[0] - (long long)a[cur].second);
    }
    ans = max(ans, -ma -mb);
    cout << ans;


    return 0;
}