#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <iomanip>
#include <cstring>
#include <numeric>
#include <cmath>
#include <cstdio>
#include <ctime>
#include <cassert>
#include <random>
#include <algorithm>



/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("popcnt")*/


#define lb lower_bound
#define ub upper_bound
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fi1(a, b) for (int i = a - 1; i >= b; --i)
#define fj1(a, b) for (int j = a - 1; j >= b; --j)
#define fk1(a, b) for (int k = a - 1; k >= b; --k)
#define fx(x, a) for (auto &x : a)
#define rep(i, a, b) for (int i = a; i < b; ++i)
#define rep1(i, a, b) for (int i = a - 1; i >= b; --i)
#define siz(x) (int)x.size()
#define all(x) x.begin(), x.end()


using namespace std;


typedef vector<int> vi;
typedef vector<vi> vvi;
typedef string str;
typedef vector<str> vs;
typedef char ch;
typedef vector<char> vch;
typedef vector<vch> vvch;
typedef set<char> sch;
typedef set<int> st;
typedef long long ll;
typedef unsigned long long ull;


#ifdef LOCAL
const int INF = 200;
const ll BIG = 200;
const int MX = 6;
const int D = 5;
#else
const int INF  = (int)2e9 + 50;
const int BIG = (int)2e18 + 228;
const int MX = 1000010;
const int D = 320;
#endif



struct inf  {
    int mn;
    int add;
};

inf t[4 * MX];
int arr[MX];


void push(int v) {
    t[2 * v].add += t[v].add;
    t[2 * v + 1].add += t[v].add;
    t[v].add = 0;
};

void updvert(int v) {
    t[v].mn = min(t[2 * v].mn + t[2 * v].add, t[2 * v + 1].mn + t[2 * v + 1].add);
}

void build(int v, int l, int r) {
    if (l + 1 == r)
        t[v].mn = arr[l];
    else {
        int m = (r + l) >> 1;
        build(2 * v, l, m);
        build(2 * v + 1, m, r);
        t[v].mn = min(t[2 * v].mn, t[2 * v + 1].mn);
    }
}


int get(int v, int l, int r, int cl, int cr) {
    if (l >= cr || r <= cl)
        return -INF;
    else if (cl >= l && cr <= r)
        return t[v].mn + t[v].add;
    else {
        int m = (cl + cr) >> 1;
        push(v);
        return min(get(2 * v, l, r, cl, m), get(2 * v + 1, l, r, m, cr));
    }
}

void upd(int v, int l, int r,  int x, int cl, int cr) {
    if (l >= cr || r <= cl)
        return;
    else if (cl >= l && cr <= r)
        t[v].add += x;
    else {
        int m = (cl + cr) >> 1;
        push(v);
        upd(2 * v, l, r, x, cl, m);
        upd(2 * v + 1, l, r, x, m, cr);
        updvert(v);
    }
}


struct item {
    int val;
    int val2;
    int cost;
    bool operator < (const item &i) const {
        return val < i.val;
    }
};


vector<item> acts[MX];

int32_t main() {
#ifdef LOCAL
    freopen("/home/olymp/CLionProjects/untitled/input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m, p;
    cin >> n >> m >> p;
    fill(arr, arr + MX, INF);
    int mn1 = INF, mn2 = INF;
    vector<item> wep(n);
    fi(0, n) {
        cin >> wep[i].val >> wep[i].cost;
        arr[wep[i].val] = min(arr[wep[i].val], wep[i].cost);
        mn1 = min(mn1, wep[i].cost);
    }
    build(1, 0, MX);
    vector<item> arm(m);
    fi(0, m) {
        cin >> arm[i].val >> arm[i].cost;
        arm[i].val2 = -1;
        acts[arm[i].val].push_back(arm[i]);
        mn2 = min(mn2, arm[i].cost);
    }
    vector<item> beast(p);
    fi(0, p) {
        cin >> beast[i].val >> beast[i].val2 >> beast[i].cost;
        acts[beast[i].val2].push_back(beast[i]);
    }
    int ans = -mn1 - mn2;
    fi(0, MX) {
        fx(act, acts[i]) {
            if (act.val2 != -1)
                continue;
            ans = max(ans, -act.cost - (t[1].add + t[1].mn));
        }
        fx(act, acts[i]) {
            if (act.val2 == -1)
                continue;
            upd(1, act.val + 1, MX, -act.cost, 0, MX);
        }
        //cout << t[1].add + t[1].mn << ' ' << ans << endl;
    }
    cout << ans;
}


