#include <iostream>
#include <utility>
#include <vector>
#include <cmath>
#include <algorithm>
using namespace std;

const int INF = 1e9;
template <typename T, typename P>
istream& operator >> (istream& in, pair<T, P>& p) {
	in >> p.first >> p.second;
	return in;
}

template <typename T, typename P>
ostream& operator << (ostream& out, pair<T, P> const& p) {
	out << p.first << p.second;
	return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
	for (T& el : vec) {
		in >> el;
	}

	return in;
}

template <typename T>
ostream& operator << (ostream& out, vector<T> const& vec) {
	for (T const& el : vec) {
		out << el << ' ';
	}
	return out;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n;
	cin >> n;

	vector<int> res_a(n), res_b(n);
	cin >> res_a >> res_b;

	int l = 0, r = INF;

	while (l + 1 < r) {
		int m = (l + r) / 2;
		long long val_bal = 0;

		for (int i = 0; i < n; i++) {
			if (res_a[i] && res_b[i]) {
				continue;
			}

			if (res_a[i]) {
				val_bal += m;
			} else if (res_b[i]) {
				--val_bal;
			}
		}

		if (val_bal > 0) {
			r = m;
		} else {
			l = m;
		}
	}

	if (r == INF) {
		cout << "-1\n";
	} else {
		cout << r << '\n';
	}
}