#include <iostream>
#include <utility>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>
using namespace std;

const int INF = 1e9;
template <typename T, typename P>
istream& operator >> (istream& in, pair<T, P>& p) {
	in >> p.first >> p.second;
	return in;
}

template <typename T, typename P>
ostream& operator << (ostream& out, pair<T, P> const& p) {
	out << p.first << p.second;
	return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
	for (T& el : vec) {
		in >> el;
	}

	return in;
}

template <typename T>
ostream& operator << (ostream& out, vector<T> const& vec) {
	for (T const& el : vec) {
		out << el << ' ';
	}
	return out;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n;
	cin >> n;

	map<int, long long> mp_dp;
	for (int i = 0, b; i < n; ++i) {
		cin >> b;
		mp_dp[b - i] += b;
	}
	long long ans = 0;
	for (auto p : mp_dp){
		ans = max(p.second, ans);
	}
	cout << ans << '\n';
}