#include <iostream>
#include <utility>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>
using namespace std;

const int INF = 1e9, N = 200;
template <typename T, typename P>
istream& operator >> (istream& in, pair<T, P>& p) {
	in >> p.first >> p.second;
	return in;
}

template <typename T, typename P>
ostream& operator << (ostream& out, pair<T, P> const& p) {
	out << p.first << p.second;
	return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
	for (T& el : vec) {
		in >> el;
	}

	return in;
}

template <typename T>
ostream& operator << (ostream& out, vector<T> const& vec) {
	for (T const& el : vec) {
		out << el << ' ';
	}
	return out;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	vector<pair<char, int>> block;
	int n;
	cin >> n;

	for (int i = 0; i < n; ++i) {
		char c;
		cin >> c;
		if (block.empty() || block.back().first != c) {
			block.push_back({ c, 1 });
		} else {
			++block.back().second;
		}
	}

	int ans = 0;

	for (char c = 'z'; c > 'a'; c--) {
		vector<pair<char, int>> n_block;
		for (int i = 0; i < block.size(); i++) {
			if (block[i].first != c) {
				if (n_block.empty() || n_block.back().first != block[i].first) {
					n_block.push_back(block[i]);
				} else {
					n_block.back().second += block[i].second;
				}

				continue;

			}

			if ((i > 0 && block[i - 1].first == char(c - 1)) || (i + 1 < block.size() && block[i + 1].first == char(c - 1))) {
				ans += block[i].second;
			} else {
				if (n_block.empty() || n_block.back().first != block[i].first) {
					n_block.push_back(block[i]);
				} else {
					n_block.back().second += block[i].second;
				}
			}
		}

		block.swap(n_block);
	}

	cout << ans << '\n';
}