#include <iostream>
#include <utility>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>
#include <queue>
using namespace std;

const int INF = 1e8, N = 2e5 + 1;
template <typename T, typename P>
istream& operator >> (istream& in, pair<T, P>& p) {
	in >> p.first >> p.second;
	return in;
}

template <typename T, typename P>
ostream& operator << (ostream& out, pair<T, P> const& p) {
	out << p.first << p.second;
	return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
	for (T& el : vec) {
		in >> el;
	}

	return in;
}

template <typename T>
ostream& operator << (ostream& out, vector<T> const& vec) {
	for (T const& el : vec) {
		out << el << ' ';
	}
	return out;
}

vector<int> g[N], g_r[N];
int dst[N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n, m, k;
	cin >> n >> m;
	fill(dst, dst + n + 1, INF);

	for (int i = 0, v, u; i < m; i++) {
		cin >> v >> u;
		g[v].push_back(u);
		g_r[u].push_back(v);
	}

	cin >> k;
	vector<int> path(k);
	cin >> path;

	dst[path.back()] = 0;
	queue<int> q;
	q.push(path.back());

	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (int u : g_r[v]) {
			if (dst[u] > dst[v] + 1) {
				dst[u] = dst[v] + 1;
				q.push(u);
			}
		}
	}

	int ans_min = 0, ans_max = 0;

	for (int i = 0; i + 1 < k; i++) {
		int dst_min = INF, dst_k_cnt = 0;
		for (int u : g[path[i]]) {
			dst_min = min(dst_min, dst[u]);
			if (dst[u] == dst[path[i + 1]]) {
				++dst_k_cnt;
			}
		}

		if (dst[path[i + 1]] != dst_min) {
			++ans_min;
			++ans_max;
		} else if (dst_k_cnt > 1) {
			++ans_max;
		}
	}

	cout << ans_min << ' ' << ans_max << '\n';
}