#include <iostream>
#include <utility>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>
#include <queue>
using namespace std;

const int INF = 1e9 + 1, N = 2e5 + 1;
template <typename T, typename P>
istream& operator >> (istream& in, pair<T, P>& p) {
	in >> p.first >> p.second;
	return in;
}

template <typename T, typename P>
ostream& operator << (ostream& out, pair<T, P> const& p) {
	out << p.first << p.second;
	return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
	for (T& el : vec) {
		in >> el;
	}

	return in;
}

template <typename T>
ostream& operator << (ostream& out, vector<T> const& vec) {
	for (T const& el : vec) {
		out << el << ' ';
	}
	return out;
}

struct act {
	int	pos, t, a, b;
	bool operator < (act const& other) {
		if (pos != other.pos) {
			return pos < other.pos;
		}

		return t < other.t;
	}
};

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n, m, p;
	cin >> n >> m >> p;

	vector<pair<int, int>> weapon, armor, w_in(n), a_in(m);
	cin >> w_in >> a_in;

	sort(w_in.begin(), w_in.end());
	sort(a_in.begin(), a_in.end());

	for (auto [val, cost] : w_in) {
		while (!weapon.empty() && weapon.back().second >= cost) {
			weapon.pop_back();
		}
		weapon.push_back({val, cost});
	}
	vector<pair<int, int>>().swap(w_in);

	for (auto[val, cost] : a_in) {
		while (!armor.empty() && armor.back().second >= cost) {
			armor.pop_back();
		}
		armor.push_back({ val, cost });
	}

	vector<long long> power_cost(weapon.back().first + 1, -INF);
	for (auto[val, cost] : weapon) {
		power_cost[val] = -cost;
	}

	for (int i = power_cost.size() - 1; i > 0; i--) {
		power_cost[i - 1] = max(power_cost[i - 1], power_cost[i]);
	}

	vector<act> line;

	for (int i = 0, x, y, z; i < p; i++) {
		cin >> x >> y >> z;
		line.push_back({y, 0, x, z});
	}

	for (auto [val, cost] : armor) {
		line.push_back({ val, 1, cost, 0 });
	}

	sort(line.begin(), line.end());
	long long g_max = *max_element(power_cost.begin(), power_cost.end());
	long long ans = -INF;

	for (auto[pos, t, a, b] : line) {
		if (t == 0) {
			power_cost[a] += b;
			g_max = max(g_max, power_cost[a]);
		} else {
			ans = max(ans, g_max - a);
		}
	}

	cout << ans << '\n';
}