#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>
#include <math.h>
#include <algorithm>
#include <bitset>
#include <bitset>
//#include <clock>
#include <random>
#include <unordered_set>
#include <unordered_map>
#include <deque>

#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define nn '\n'
#define pp ' '

using namespace std;

typedef long long ll;
typedef long double ld;

template<typename T>
bool uax(T &a, T b){
	if (b > a){
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool uin(T &a, T b){
	if (b < a){
		a = b;
		return true;
	}
	return false;
}

template <typename T>
void debug(string name, T val){
	cout << name << " = " << val << nn;
}
#define value(x) debug(#x, x);

mt19937 rnd(1928);

const int N = 2e5 + 7;
const int MOD1 = 1e9 + 7;
const int MOD2 = 1e9 + 9;
const int P = 31;

pair<int, int> poww[N];

struct Hash{
	int h1, h2;
	Hash(){
		h1 = h2 = 0;
	};
	Hash(int h1_, int h2_){
		h1 = h1_;
		h2 = h2_;
	}
	bool operator==(Hash q){
		return (h1 == q.h1 && h2 == q.h2);
	}
	void add(char q){
		h1 = (ll(h1) * P + ll(q - '0' + 1)) % MOD1;
		h2 = (ll(h2) * P + ll(q - '0' + 1)) % MOD2;
	}
	Hash operator+(Hash t){
		int nh1 = (h1 + t.h1) % MOD1;
		int nh2 = (h2 + t.h2) % MOD2;
		return Hash(nh1, nh2);
	}
	Hash operator-(Hash t){
		int nh1 = (h1 - t.h1 + MOD1) % MOD1;
		int nh2 = (h2 - t.h2 + MOD2) % MOD2;
		return Hash(nh1, nh2);
	}
	Hash operator*(int ind){
		int nh1 = (ll(h1) * poww[ind].first) % MOD1;
		int nh2 = (ll(h2) * poww[ind].second) % MOD2;
		return Hash(nh1, nh2);
	}
};

const Hash BAD = Hash(-1, -1);

int n, q;
string s;

string ns;
vector<Hash> nh;
int pos[N];
vector<int> posn;

int pc[N], pn[N];

int psumc(int l ,int r){
	if (!l) return pc[r];
	return pc[r] - pc[l - 1];
}

int psumn(int l ,int r){
	if (!l) return pn[r];
	return pn[r] - pn[l - 1];
}

Hash get_h(int l, int r){
	if (!l) return nh[r];
	return (nh[r] - nh[l - 1] * (r - l + 1));
}

void build(){
	int cur = 0;
	int nssz = 0;
	for (int i = 0; i < n; i++){
		if (s[i] == '0'){
			if (cur % 2 == 1){
				ns += '1';
				nssz++;
			}
			cur = 0;
			pos[i] = nssz;
			ns += '0';
			nssz++;
		}
		else cur++;
	}
	nh.resize(nssz);
	Hash t = Hash();
	for (int i = 0; i < nssz; i++){
		t.add(ns[i]);
		nh[i] = t;
	}
}

Hash gett(int l, int r){
	int fz = lower_bound(all(posn), l) - posn.begin();
	int lz = upper_bound(all(posn), r) - posn.begin() - 1;
	uin(lz, int(posn.size()) - 1);
	uax(fz, 0);
	if (fz > lz) return BAD;
	lz = posn[lz];
	fz = posn[fz];
	Hash cur = get_h(pos[fz], pos[lz]);
	int curlen = pos[lz] - pos[fz] + 1;
	if ((fz - l) % 2 == 1){
		Hash e = Hash();
		e.add('1');
		cur = (cur + e * curlen);
		curlen++;
	}
	if ((r - lz) % 2 == 1){
		Hash e = Hash();
		e.add('1');
		cur = (cur * 1 + e);
		curlen++;
	}
	return cur;
}

bool check(int l1, int r1, int l2, int r2){
	if (gett(l1, r1) == gett(l2, r2)) return true;
	return false;
}

void precalc(){
	poww[0] = mp(1, 1);
	for (int i = 1; i < N; i++){
		poww[i].first = (ll(poww[i - 1].first) * P) % MOD1;
		poww[i].second = (ll(poww[i - 1].second) * P) % MOD2;
	}
}

int main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#endif
	cout << fixed << setprecision(15);
	precalc();
	cin >> n;
	cin >> s;
	if (s[0] == '0'){
		pc[0]++;
		posn.pb(0);
	}
	for (int i = 1; i < n; i++){
		pc[i] = pc[i - 1];
		pn[i] = pn[i - 1];
		if (s[i] == '0'){
			posn.pb(i);
			if (i % 2 == 0) pc[i]++;
			else pn[i]++;
		}
	}
	build();
	cin >> q;
	int l1, l2, len;
	while (q--){
		cin >> l1 >> l2 >> len;
		l1--; l2--;
		int r1 = l1 + len - 1;
		int r2 = l2 + len - 1;
		if (l1 % 2 == l2 % 2){
			if (psumc(l1, r1) == psumc(l2, r2) && psumn(l1, r1) == psumn(l2, r2)){
				if (check(l1, r1, l2, r2)){
					cout << "Yes" << nn;
				}
				else cout << "No" << nn;
			}
			else {
				cout << "No" << nn;
			}
		}
		else {
			if (psumc(l1, r1) == psumn(l2, r2) && psumn(l1, r1) == psumc(l2, r2)){
				if (check(l1, r1, l2, r2)){
					cout << "Yes" << nn;
				}
				else cout << "No" << nn;
			}
			else {
				cout << "No" << nn;
			}
		}
	}
}