#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define f first
#define s second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define len(x) ((int)x.size())

using namespace std;

namespace IOF {
    #define UNIT template <typename T>
    UNIT istream &operator >>(istream &inp, vector <T> &a) {
        for (auto &el : a)
            inp >> el;
        return inp;
    }
    UNIT ostream &operator <<(ostream &out, vector <T> &a) {
        for (auto &el : a)
            out << el << ' ';
        return out;
    }
}

using namespace IOF;

/**void my_file_in_out() {
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
}*/

const int MAXN = 4e5 + 100;
const int INF = 2e9 + 7;

struct node {
    int z, x;
    int l, r, lc, rc;
    vector <pair <int, int>> pr;
    node() {
        l = r = 0;
        lc = rc = 0;
    }
};

int razm = 1;
node tree[MAXN];

vector <pair <int, pair <int, int>>> c;

int build(int l, int r) {
    int T = razm++;
    tree[T].l = l;
    tree[T].r = r;
    for (int i = l; i <= r; i++)
        tree[T].pr.push_back(c[i].s);
    sort(all(tree[T].pr));
    for (int i = 1; i < r - l + 1; i++)
        tree[T].pr[i].s += tree[T].pr[i - 1].s;
    if (l != r) {
        int m = (l + r) / 2;
        tree[T].lc = build(l, m);
        tree[T].rc = build(m + 1, r);
    }
    return T;
}

int qvr(int T, int l, int r, int x) {
    if (tree[T].l > r || tree[T].r < l)
        return 0;
    if (tree[T].l >= l && tree[T].r <= r) {
        auto it = lower_bound(all(tree[T].pr), make_pair(x + 1, 0)) - tree[T].pr.begin() - 1;
        //it -= tree[T].pr.begin() + 1;
        if (it == -1)
            return 0;
        return tree[T].pr[it].s;
    }
    int a1 = qvr(tree[T].lc, l, r, x);
    int a2 = qvr(tree[T].rc, l, r, x);
    return a1 + a2;
}

signed main()
{
    ios::sync_with_stdio(0);
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n, m, p;
    cin >> n >> m >> p;

    vector <pair <int, int>> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i].f >> a[i].s;
    sort(all(a));
    vector <pair <int, int>> aa;
    for (int i = 0; i < n; i++) {
        while (!aa.empty() && aa.back().s >= a[i].s)
            aa.pop_back();
        aa.push_back(a[i]);
    }
    a = aa;
    n = len(a);

    vector <pair <int, int>> b(m);
    for (int i = 0; i < m; i++)
        cin >> b[i].f >> b[i].s;
    sort(all(b));
    vector <pair <int, int>> bb;
    for (int i = 0; i < m; i++) {
        while (!bb.empty() && bb.back().s >= b[i].s)
            bb.pop_back();
        bb.push_back(b[i]);
    }
    b = bb;
    m = len(b);


    //vector <int> comp;
    for (int i = 0; i < p; i++) {
        int x, y, z;
        cin >> x >> y >> z;
        c.push_back({x, {y, z}});
        //comp.push_back(x);
    }

    ///vector <int> comp;
    /**for (int i = 0; i < n; i++)
        comp.push_back(a[i].f);*/
    //sort(all(comp));
    //comp.erase(unique(all(comp)), comp.end());

    /**for (auto el : b)
        cout << el.f << ' ' << el.s << endl;*/

    sort(all(c));
    int T = build(0, p - 1);

    int ans = -INF;

    int u = 0;

    //cout << qvr(T, 0, p - 1, 2) << endl;
    int y = 0;

    for (int i = 0; i < p; i++) {
        while (u < n && a[u].f <= c[i].f)
            u++;
        if (u == n)
            break;
        y = max(y, c[i].s.f);
        auto it = upper_bound(all(b), make_pair(y, INF)) - b.begin();
        if (it == m)
            continue;
        int cost = qvr(T, 0, i, y);
        //cout << u << ' ' << it << ' ' << cost << ' ' << c[i].s.f << endl;
        int tmp = cost - a[u].s - b[it].s;
        ans = max(ans, tmp);
    }

    /*if (ans == -INF)
        ans = -a[0].s - b[0].s;*/

    cout << ans;

    return 0;
}
