#include "bits/stdc++.h"

#define pb push_back
#define mp make_pair
#define mt make_tuple
#define le(v) ((int)v.size())
#define x first
#define y second

using namespace std;

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v) is >> x;
	return is;
}

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &pp) {
	is >> pp.x >> pp.y;
	return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v) os << x << " ";
	os << "\n";
	return os;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &pp) {
	os << pp.x << " " << pp.y;
	return os;
}

typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;


int n;
vector<vector<int>> g;
vector<int> jump[20];
vector<int> tin, tout;
vector<int> depth;
int timer = 0;

void dfs(int v, int _p) {
	tin[v] = timer++;
	jump[0][v] = _p;
	for (int sub : g[v]) {
		if (sub == _p) continue;
		depth[sub] = depth[v] + 1;
		dfs(sub, v);
	}
	tout[v] = timer++;
}

bool dom(int base, int sub) {
	return (tin[base] <= tin[sub] && tout[sub] <= tout[base]);
}
int lca(int a, int b) {
	if (dom(a, b)) return a;
	if (dom(b, a)) return b;
	for (int k = 19; ~k; k--) {
		if (!dom(jump[k][a], b)) {
			a = jump[k][a];
		}
	}
	return jump[0][a];
}

struct Virus {
	int id, v, s;
};

map<int, vector<int>> h;

vector<Virus> vir0;

int K;
int calc_time(int dist, int k, int id, int s) {
	if (dist == 0) return -1;
	int t = (dist + s - 1) / s;
	return t * k + id;
}
int get_dist(int a, int b) {
	return depth[a] + depth[b] - 2 * depth[lca(a, b)];
}
int calc_time(int node, Virus v) {
	if (v.id == -1) return 1e9;
	return calc_time(get_dist(node, v.v),
		K, v.id, v.s
	);
}

void dfs0(int v) {
	for (int sub : h[v]) {
		dfs0(sub);
		if (calc_time(v, vir0[v]) > calc_time(v, vir0[sub])) {
			vir0[v] = vir0[sub];
		}
	}
}

void dfs1(int v) {
	for (int sub : h[v]) {
		if (calc_time(sub, vir0[v])
				< calc_time(sub, vir0[sub])) {
			vir0[sub] = vir0[v];
		}
	}
	for (int sub : h[v]) {
		dfs1(sub);
	}
}


void run() {
	cin >> n;
	tin.resize(n); tout.resize(n);
	g.resize(n); depth.resize(n);
	vir0.resize(n, {-1, -1, -1});
	for (int i = 0; i < n - 1; i++) {
		int a, b; cin >> a >> b; a--; b--;
		g[a].pb(b); g[b].pb(a);
	}
	for (int i = 0; i < 20; i++) {
		jump[i].resize(n);
	}
	dfs(0, -1);
	jump[0][0] = 0;
	for (int i = 1; i < 20; i++) {
		for (int j = 0; j < n; j++) {
			int sub = jump[i - 1][j];
			if (sub != -1) sub = jump[i - 1][sub];
			jump[i][j] = sub;
		}
	}
	int q; cin >> q;
	for (int i = 0; i < q; i++) {
		int k, m; cin >> k >> m; K = k;
		vector<pii> virus(k);
		vector<int> cities(m);
		vector<int> nodes;
		for (int i = 0; i < k; i++) {
			cin >> virus[i]; virus[i].x--;
			nodes.pb(virus[i].x);
		}
		for (int i = 0; i < m; i++) {
			cin >> cities[i]; cities[i]--;
			nodes.pb(cities[i]);
		}
		sort(nodes.begin(), nodes.end(), [](int a, int b) {
			return tin[a] < tin[b];
		});
		nodes.resize(unique(nodes.begin(), nodes.end()) - nodes.begin());
		h.clear();
		vector<int> nnodes;
		for (int i = 0; i < le(nodes); i++) {
			nnodes.pb(lca(nodes[i], nodes[(i + 1) % le(nodes)]));
		}
		nodes.insert(nodes.end(), nnodes.begin(), nnodes.end());
		sort(nodes.begin(), nodes.end(), [](int a, int b) {
			return tin[a] < tin[b];
		});
		nodes.resize(unique(nodes.begin(), nodes.end()) - nodes.begin());
		vector<int> stack;
		for (int i = 0; i < le(nodes); i++) {
			while (!stack.empty() && !dom(stack.back(), nodes[i])) {
				stack.pop_back();
			}
			if (!stack.empty()) {
				h[stack.back()].pb(nodes[i]);
			}
			stack.pb(nodes[i]);
		}
		int root = nodes[0];
		for (int i = 0; i < le(virus); i++) {
			vir0[virus[i].x] = {i, virus[i].x, virus[i].y};
		}
		dfs0(root);
		dfs1(root);
		for (int c : cities) {
			cout << vir0[c].id + 1 << " ";
		}
		cout << "\n";
		for (int i : nodes) {
			vir0[i] = {-1, -1, -1};
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	// freopen("test.in", "r", stdin);
	run();
}