#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define ull unsigned long long
#define fi first
#define se second
#define ld long double

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAXN = 200005;

struct node
{
    bool v1 = 0, v2 = 0;
    int cnt0 = 0, cnt1 = 0;
    int sum = 0;
    ull hsh = 0;
};

ull pw[MAXN];
ull ml;

string s;

node tr[MAXN*4];

node combine(node a, node b)
{
    if(a.cnt0 == -1)
        return b;
    if(b.cnt0 == -1)
        return a;
    node c;
    c.v1 = a.v1; c.v2 = b.v2;
    c.sum = a.sum + b.sum;
    c.cnt0 = a.cnt0 + b.cnt0;
    c.cnt1 = a.cnt1 + b.cnt1;
    if(a.v2)
        c.cnt1--;
    if(b.v1)
        c.cnt1--;
    if(a.v2 ^ b.v1)
    {
        c.cnt1++;
    }
    if(b.cnt0 == 0)
    {
        c.v2 = a.v2 ^ b.v1;
    }
    if(a.cnt0 == 0)
    {
        c.v1 = a.v2 ^ b.v1;
    }
    if(a.v2 && b.v1)
    {
        c.hsh -= pw[a.cnt0]*2;
    }
    c.hsh += a.hsh + b.hsh*pw[a.cnt0];
    return c;
}

void Build(int v, int l, int r)
{
    if(l == r)
    {
        if(s[l] == '0')
        {
            tr[v].cnt0 = 1;
            tr[v].cnt1 = 0;
            tr[v].sum = 0;
            tr[v].hsh = 0;
            tr[v].v1 = tr[v].v2 = 0;
        }
        else
        {
            tr[v].cnt0 = 0;
            tr[v].cnt1 = 1;
            tr[v].sum = 1;
            tr[v].hsh = 1;
            tr[v].v1 = tr[v].v2 = 1;
        }
        return;
    }
    int m = (l+r) / 2;
    Build(v*2, l, m);
    Build(v*2+1, m+1, r);
    tr[v] = combine(tr[v*2], tr[v*2+1]);
//    cout << l << " - " << r << ": " << tr[v].hsh << '\n';
}

node bad;

node Get(int l, int r, int L, int R, int v)
{
    if(l >= L && r <= R)
    {
//        cout << "gt " << l << ' ' << r << '\n';
        return tr[v];
    }
    if(l > R || r < L)
        return bad;
    int m = (l+r) / 2;
    return combine(Get(l, m, L, R, v*2), Get(m+1, r, L, R, v*2+1));
}

//mt19937 rnd(chrono::steady_clock().count());

int main()
{
    srand(time(0));
    ml = rand() % (1000000-100) + 100;
//ml= 2;
    pw[0] = 1;
    for(int i = 1; i < MAXN; i++)
    {
        pw[i] = pw[i-1] * ml;
    }
    int n; cin >> n;
    cin >> s;
    Build(1, 0, n-1);
    int q; cin >> q;
    for(int i = 0; i < q; i++)
    {
        int l1, l2, len; cin >> l1 >> l2 >> len; l1--; l2--;
        auto i1 = Get(0, n-1, l1, l1+len-1, 1), i2  = Get(0, n-1, l2, l2+len-1, 1);
//        cout << i1.sum << ' ' << i1.cnt0 << ' ' << i1.cnt1 << ' ' << i1.hsh << '\n';
//        cout << i2.sum << ' ' << i2.cnt0 << ' ' << i2.cnt1 << ' ' << i2.hsh << '\n';
        if(i1.sum-i1.cnt1 == i2.sum-i2.cnt1 && i1.cnt1 == i2.cnt1 && i1.hsh == i2.hsh)
        {
            cout << "Yes\n";
        }
        else cout << "No\n";
    }
}




















/// Slava Ykraine
/// YA KAZINAK_1488 ETO KYC

