#include <iostream>
#include <vector>
#include <deque>
#include <set>

using namespace std;

const int MAX_N = 2e5 + 10;
const int INF = 10 * MAX_N;

vector<int> g[MAX_N];
vector<int> gRev[MAX_N];

int n, m;

int d[MAX_N];

int main() {
#ifdef LOCAL
    freopen("D.in", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    int mn = 0, mx = 0;
    for (int i = 0; i < m; i++) {
        int from, to;
        cin >> from >> to;
        g[from].push_back(to);
        gRev[to].push_back(from);
    }
    fill(d, d + MAX_N, INF);
    int k;
    cin >> k;
    vector<int> path(k);
    for (int i = 0; i < k; i++) {
        cin >> path[i];
    }
    int s = path[0];
    int t = path.back();
    d[t] = 0;
    deque<int> q;
    q.push_back(t);
    while (!q.empty()) {
        int v = q.front();
        q.pop_front();
        for (int u : gRev[v]) {
            if (d[u] > d[v] + 1) {
                d[u] = d[v] + 1;
                q.push_back(u);
            }
        }
    }
    for (int i = 0; i < k - 1; i++) {
        int curV = path[i];
        bool one = false;
        bool two = false;
        set<int> aplV;
        for (int u : g[curV]) {
            if (d[u] + 1 == d[curV]) {
                aplV.insert(u);
            }
        }
        if (aplV.count(path[i + 1]) > 0) {
            one = true;
        }
        auto it = aplV.find(path[i + 1]);
        if (it != aplV.end()) {
            aplV.erase(it);
        }
        if (aplV.size() > 0) {
            two = true;
        }
        if (one && !two) {

        } else if (two && !one) {
            mn++;
            mx++;
        } else if (two && one) {
            mx++;
        }
    }
    cout << mn << " " << mx << "\n";

    return 0;
}