#include <iostream>
#include <vector>
#include <climits>
#include <algorithm>

using namespace std;
const int MAX_X = 1e6 + 10;

struct Point {
    int x, y, w;

    Point(int x, int y, int w) : x(x), y(y), w(w) {}
};

struct Node {
    int mx = INT_MIN;
    int add = 0;
};

const int MAX_N = 2e5 + 10;

struct Tree {
    Node nodes[4 * MAX_N];

    int mx(int v, int l, int r, int qL, int qR) {
        push(v);
        if (qR < l || qL > r) {
            return 0;
        }
        if (qL <= l && qR >= r) {
            return nodes[v].mx;
        }
        int m = (r + l) / 2;
        nodes[v].mx = max(nodes[2 * v + 1].mx, nodes[2 * v + 2].mx);
        return max(mx(2 * v + 1, l, m, qL, qR), mx(2 * v + 2, m + 1, r, qL, qR));
    }

    int mxP(int qL, int qR) {
        return mx(0, 0, MAX_N - 3, qL, qR);
    }

    void push(int v) {
        Node &cur = nodes[v];
        nodes[2 * v + 1].mx += cur.add;
        nodes[2 * v + 1].add += cur.add;
        nodes[2 * v + 2].mx += cur.add;
        nodes[2 * v + 2].add += cur.add;
        cur.add = 0;
    }

    void set(int v, int l, int r, int ind, int x) {
        push(v);
        if (ind < l || ind > r) {
            return;
        }
        if (l == r) {
            nodes[v].mx = x;
            return;
        }
        int m = (r + l) / 2;
        set(2 * v + 1, l, m, ind, x);
        set(2 * v + 2, m + 1, r, ind, x);
        nodes[v].mx = max(nodes[2 * v + 1].mx, nodes[2 * v + 2].mx);
    }

    void setP(int ind, int x) {
        set(0, 0, MAX_N - 3, ind, x);
    }

    void addSeg(int v, int l, int r, int qL, int qR, int add) {
        push(v);
        if (qR < l || qL > r) {
            return;
        }
        if (qL <= l && qR >= r) {
            nodes[v].add += add;
            nodes[v].mx += add;
            return ;
        }
        int m = (l + r) / 2;
        addSeg(2 * v + 1, l, m, qL, qR, add);
        addSeg(2 * v + 2, m + 1, r, qL, qR, add);
        nodes[v].mx = max(nodes[2 * v + 1].mx, nodes[2 * v + 2].mx);
    }

    void addSegPub(int qL, int qR, int add) {
        addSeg(0, 0, MAX_N - 3, qL, qR, add);
    }
};

vector<Point> pointsByX[MAX_X];

int ans = INT_MIN;


Tree t;

int main() {
#ifdef LOCAL
    freopen("E.in", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m, p;
    cin >> n >> m >> p;
    vector<pair<int, int>> vA(n);
    for (int i = 0; i < n; i++) {
        auto &[a, cA] = vA[i];
        cin >> a >> cA;
    }
    sort(vA.begin(), vA.end());
    vector<pair<int, int>> vB(m);
    for (int i = 0; i < m; i++) {
        auto &[b, cB] = vB[i];
        cin >> b >> cB;
        t.setP(i, -cB);
    }
    sort(vB.begin(), vB.end());
    for (int i = 0; i < p; i++) {
        int x, y, w;
        cin >> x >> y >> w;
        pointsByX[x].push_back(Point(x, y, w));
    }
    int curX = 0;
    for (int i = 0; i < n; i++) {
        auto &[a, cA] = vA[i];
        while (curX < a) {
            for (Point &point : pointsByX[curX]) {
                int l = -1;
                int r = vB.size();
                while (r - l > 1) {
                    int m = (r + l) / 2;
                    if (vB[m].first > point.y) {
                        r = m;
                    } else {
                        l = m;
                    }
                }
                //binsearch
                if (r <= vB.size() - 1) {
                    t.addSegPub(r, vB.size() - 1, point.w);
                }
            }
            curX++;
        }
        ans = max(ans, t.mxP(0, vB.size() - 1) - cA);
        // -cA
    }

    cout << ans << "\n";

    return 0;
}