#include <bits/stdc++.h>
using namespace std;
#define int int64_t

const int MAXN = 1e6, INF = 1e18;
int tree[MAXN], add[MAXN];

void pull(int v) {
    int v1 = v * 2;
    int v2 = v * 2 + 1;
    tree[v] = max(tree[v1] + add[v1], tree[v2] + add[v2]);
}

void push(int v) {
    int v1 = v * 2;
    int v2 = v * 2 + 1;
    add[v1] += add[v];
    add[v2] += add[v];
    tree[v] += add[v];
    add[v] = 0;
}

int get(int v, int vl, int vr, int l, int r) {
    push(v);
    if (l >= vr || r <= vl) {
        return -INF;
    }
    if (l <= vl && r >= vr) {
        return tree[v];
    }
    int vm = (vl + vr) / 2;
    int res1 = get(v * 2, vl, vm, l, r);
    int res2 = get(v * 2 + 1, vm, vr, l, r);
    return max(res1, res2);
}

void update(int v, int vl, int vr, int l, int r, int val) {
    push(v);
    if (l >= vr || r <= vl) {
        return;
    }
    if (l <= vl && r >= vr) {
        add[v] += val;
        return;
    }
    int vm = (vl + vr) / 2;
    update(v * 2, vl, vm, l, r, val);
    update(v * 2 + 1, vm, vr, l, r, val);
    pull(v);
}

array<int, 2> a[MAXN], b[MAXN];
array<int, 3> mon[MAXN];

main() {
    int n, m, p;
    cin >> n >> m >> p;
    for (int i = 0; i < n; ++i) {
        cin >> a[i][0] >> a[i][1];
    }
    for (int i = 0; i < m; ++i) {
        cin >> b[i][0] >> b[i][1];
    }
    sort(a, a + n);
    vector<array<int, 2>> a1;
    for (int i = 0; i < n; ++i) {
        while (!a1.empty() && a1.back()[1] > a[i][1]) {
            a1.pop_back();
        }
        if (a1.empty() || a[i][0] != a1.back()[0]) {
            a1.push_back(a[i]);
        }
    }
    n = a1.size();
    for (int i = 0; i < n; ++i) {
        a[i] = a1[i];
    }
    sort(b, b + n);
    vector<array<int, 2>> b1;
    for (int i = 0; i < m; ++i) {
        while (!b1.empty() && b1.back()[1] > b[i][1]) {
            b1.pop_back();
        }
        if (b1.empty() || b[i][0] != b1.back()[0]) {
            b1.push_back(b[i]);
        }
    }
    m = b1.size();
    for (int i = 0; i < m; ++i) {
        b[i] = b1[i];
    }
    for (int i = 0; i < p; ++i) {
        cin >> mon[i][0] >> mon[i][1] >> mon[i][2];
    }
    sort(mon, mon + p);
    int ans = -INF;
    for (int i = 0; i < m; ++i) {
        update(1, 0, m, i, i + 1, -b[i][1]);
    }
    int ind = 0;
    for (int i = 0; i < p; ++i) {
        while (ind < n && a[ind][0] <= mon[i][0]) {
            ind++;
        }
        if (ind == n) {
            break;
        }
        int res = -a[ind][1];
        int k = mon[i][1];
        array<int, 2> ka = {k, 0};
        int x = upper_bound(b, b + m, ka) - b;
        update(1, 0, m, x, m, mon[i][2]);
        res += get(1, 0, m, 0, m);
        ans = max(ans, res);
    }
    cout << ans;
    return 0;
}
