#include <iostream>
#include <vector>
#include <queue>

typedef long long ll;
using namespace std;

vector<vector<int> > g;
vector<vector<int> > rg;
vector<int> dist;

void bfs(int t)
{
	queue<int> q;
	q.push(t);
	dist[t] = 0;
	while (!q.empty())
	{
		int v = q.front();
		q.pop();
		for (int u : rg[v])
		if (dist[u] == -1)
		{
			dist[u] = dist[v] + 1;
			q.push(u);
		}
	}
}

int main()
{
	int n, m;
	cin >> n >> m;
	g.resize(n);
	rg.resize(n);
	dist.resize(n, -1);
	for (int i = 0; i < m; ++i)
	{
		int a, b;
		cin >> a >> b;
		g[a - 1].push_back(b - 1);
		rg[b - 1].push_back(a - 1);
	}
	int k;
	cin >> k;
	vector<int> pth(k);
	for (int i = 0; i < k; ++i)
		cin >> pth[i], --pth[i];
	bfs(pth[k - 1]);
	int mx = 0, mn = 0;
	bool ws = 1;
	for (int i = 0; i < k - 1; ++i)
	{
		int v = pth[i];
		int opt = -1;
		for (int u : g[v])
		if (u != pth[i + 1] && dist[u] + 1 == dist[v])
			opt = u;
		if (opt != -1)
			++mx;
	}
	for (int i = k - 2; i >= 0; --i)
	{
		if (dist[pth[i]] != dist[pth[i + 1]] + 1)
			++mn;
	}
	cout << mn << ' ' << mx;
	//system("pause");
}
