#include <bits/stdc++.h>

using namespace std;
struct monster
{
    long long def, off, money;
    monster(long long def, long long off, long long money) : def(def), off(off), money(money) {}
};

bool operator < (monster a, monster b)
{
    return (a.off < b.off) || (a.off == b.off && a.def < b.def) || (a.off == b.off && a.def == b.def && a.money > b.money);
}
vector<pair<long long, long long> > def;
int first_def(long long x)
{
    int l = -1;
    int r = def.size();
    while (r - l > 1)
    {
        int m = (l + r) / 2;
        if (def[m].first >= x)
            r = m;
        else
            l = m;
    }
    return r;
}
vector<long long> tree(1000000, 0);

void update(int v, int vl, int vr, long long x, int i)
{
//    cout << vl << " " << vr << endl;
    if (vl > i || vr < i) return;
    if (vl == i && vr == i)
    {
        tree[v] += x;
        return;
    }
    int m = (vl + vr) / 2;
    update(2 * v, vl, m, x, i);
    update(2 * v + 1, m + 1, vr, x, i);
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

long long getans(int v, int vl, int vr, int l, int r)
{
    if (vl > r || vr < l) return 0;
    if (vl >= l && vr <= r) return tree[v];
    int m = (vl + vr) / 2;
    return getans(2 * v, vl, m, l, r) + getans(2 * v + 1, m + 1, vr, l, r);
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, m, p;
    cin >> n >> m >> p;
    vector<pair<long long, long long> > weapon;
    for (int i = 0; i < n; i++)
    {
        long long x, y;
        cin >> x >> y;
        weapon.push_back({x, y});
    }
    sort(weapon.begin(), weapon.end());

    for (int i = 0; i < m; i++)
    {
        long long x, y;
        cin >> x >> y;
        def.push_back({x, y});
    }
    sort(def.begin(), def.end());
    vector<monster> monsters;
    for (int i = 0; i < p; i++)
    {
        long long x, y, z;
        cin >> x >> y >> z;
        monsters.push_back(monster(x, y, z));
    }
    sort(monsters.begin(), monsters.end());
    long long atk = 0;
    long long answer = -(weapon[0].second + def[0].second);
    vector<long long> pref(m, 0);
    long long cur_pref = 0;
    int N = 1;
    while (N < m) N *= 2;
    for (int mon = 0; mon < p; mon++)
    {
        while ((atk < n) && (weapon[atk].first <= monsters[mon].off)) atk++;
        cur_pref = monsters[mon].money;
        if (atk == n) break;
        long long deff = first_def(monsters[mon].def + 1);
        update(1, 1, N, cur_pref, deff + 1);
//        for (int i = 1; i < 2 * N; i++)
//        {
//            cout << tree[i] << " ";
//        }
//        cout << endl;
//        cout << atk << " " << deff << " " << pref[deff] - def[deff].second - weapon[atk].second << " " << cur_pref << endl;
        answer = max(answer, getans(1, 1, N, 1, deff + 1) - def[deff].second - weapon[atk].second);
    }
    cout << answer;
}
