#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18;

struct segtree {
    vector<ll> t, mod;
    segtree(int n) {
        int _n = 1;
        while (_n < n) _n *= 2;
        n = _n;
        t.resize(2 * n, -INF), mod.resize(2 * n);
    }
    void push(int v) {
        mod[2 * v] += mod[v], t[2 * v] += mod[v];
        mod[2 * v + 1] += mod[v], t[2 * v + 1] += mod[v];
        mod[v] = 0;
    }
    void recalc(int v) {
        t[v] = max(t[2 * v], t[2 * v + 1]) + mod[v];
    }
    void _plus_val(int v, int vl, int vr, int l, int r, ll val) {
        if (vr <= l || r <= vl) return;
        if (vl >= l && vr <= r) {
            mod[v] += val;
            t[v] += val;
            return;
        }
        int vm = (vl + vr) / 2;
        push(v);
        _plus_val(2 * v, vl, vm, l, r, val);
        _plus_val(2 * v + 1, vm, vr, l, r, val);
        recalc(v);
    }
    ll _get_max(int v, int vl, int vr, int l, int r) {
        if (vr <= l || r <= vl) return -INF;
        if (vl >= l && vr <= r) return t[v];
        int vm = (vl + vr) / 2;
        push(v);
        return max(_get_max(2 * v, vl, vm, l, r), _get_max(2 * v + 1, vm, vr, l, r));
    }
    void plus_val(int l, int r, ll val) {
        _plus_val(1, 0, (int)t.size() / 2, l, r, val);
    }
    ll get_max(int l, int r) {
        return _get_max(1, 0, (int)t.size() / 2, l, r);
    }
    void set(int i, ll x) {
        ll old = get_max(i, i + 1);
        plus_val(i, i + 1, x - old);
    }
};

int main() {
    ios::sync_with_stdio(0);
    int n, m, k;
    cin >> n >> m >> k;
    vector<pair<int, int> > a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    vector<pair<int, int> > b(m);
    for (int i = 0; i < m; i++) {
        cin >> b[i].first >> b[i].second;
    }
    vector<array<int, 3> > kek(k);
    for (int i = 0; i < k; i++) {
        cin >> kek[i][0] >> kek[i][1] >> kek[i][2];
    }
    sort(a.begin(), a.end());
    sort(kek.begin(), kek.end());
    int j = 0;
    int sz = 1000000;
    segtree cur(sz + 1);
    for (int j = 0; j < m; j++) {
        int pos = b[j].first, w = b[j].second;
        cur.set(pos, -w);
        //cout << "set " << pos << ' ' << -w << endl;
    }
    ll ans = -INF;
    for (int i = 0; i < n; i++) {
        while (j < k && kek[j][0] < a[i].first) {
            int pos = kek[j][1], w = kek[j][2];
            cur.plus_val(pos + 1, sz + 1, w);
            //cout << "plus " << pos + 1 << ' ' << sz + 1 << ' ' << w << endl;
            j++;
        }
        ll tmp = cur.get_max(0, sz + 1);
        //cout << "tmp = " << tmp << endl;
        ans = max(ans, tmp - a[i].second);
    }
    cout << ans << endl;
    return 0;
}
