#define _CRT_SECURE_NO_WARNINGS
#define pb push_back

#include <iostream>
#include <cstdio>
#include <iomanip>

#include <algorithm>
#include <functional>
#include <cctype>

#include <cmath>
#include <climits>

#include <string>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <bitset>
#include <queue>

using namespace std;

#define int long long
typedef pair<int,int> pii;
typedef long long ll;

const int N = 2e5 + 5;
const int INF = 1e18;

vector<int> g[N];
int d[N];
int cnt[N];
bool ok[N];
int path[N];

void bfs(int s) {
	queue<int> q;
	q.push(s);
	d[s] = 0;
	while(!q.empty()) {
		int v = q.front();
		q.pop();
		for (int i = 0; i < g[v].size(); ++i) {
			int to = g[v][i];
			if (d[v] + 1 < d[to]) {
				d[to] = d[v] + 1;
				cnt[to] = 1;
				if (path[v] == to) ok[to] = true;
				q.push(to);
			} 
			else if (d[v] + 1 == d[to]) {
				cnt[to]++;
				if (path[v] == to) ok[to] = true;
			}
		}
	}
}

signed main() {
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
#else
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	

	fill(d, d + N, INF);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		g[b].pb(a);
	}
	int k;
	cin >> k;
	vector<int> p(k);
	for (int i = 0; i < k; ++i) {
		cin >> p[i];
	}
	for (int i = 1; i < k; ++i) {
		path[p[i]] = p[i - 1];
	}
	bfs(p[k - 1]);
	int ans1 = 0;
	int ans2 = 0;
	for (int i = 0; i < k - 2; ++i) {
		ans1 += cnt[p[i]] - ok[p[i]];
		ans2 += (ok[p[i]] == 0);
	}
	cout << ans2 << ' ' << ans1 << endl;
}