#define _CRT_SECURE_NO_WARNINGS
#define pb push_back

#include <iostream>
#include <cstdio>
#include <iomanip>

#include <algorithm>
#include <functional>
#include <cctype>

#include <cmath>
#include <climits>

#include <string>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <bitset>
#include <queue>

using namespace std;

#define int long long
typedef pair<int,int> pii;
typedef long long ll;

const int N = 2e5 + 5;
const int INF = 1e18;

set<int> g[N];
int d[N];
int cnt[N];
bool ok[N];
int last[N];

int ans1 = 0, ans2 = 0;
int ans[N];

void bfs(int s) {
	queue<int> q;
	q.push(s);
	d[s] = 0;
	while(!q.empty()) {
		int v = q.front();
		q.pop();
		for (auto it = g[v].begin(); it != g[v].end(); ++it) {
			int to = *it;
			if (d[v] + 1 < d[to]) {
				d[to] = d[v] + 1;
				cnt[to] = 1;
				if (last[to] == last[v] - 1) {
					ok[to] = 1;
				}
				else last[to] = min(last[to], last[v]);
				ok[to] |= ok[v];
				q.push(to);
			} 
			else if (d[v] + 1 == d[to]) {
				cnt[to]++;
				if (last[to] == last[v] - 1) {
					ok[to] = 1;
				}
				else last[to] = min(last[to], last[v]);
				ok[to] |= ok[v];
			}
		}
	}
}

signed main() {
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
#else
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	

	fill(d, d + N, INF);
	fill(last, last + N, INF);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		g[b].insert(a);
	}
	int k;
	cin >> k;
	vector<int> p(k);
	for (int i = 0; i < k; ++i) {
		cin >> p[i];
		last[p[i]] = i + 1;
	}
	bfs(p[k - 1]);
	for (int i = 0; i < k - 1; ++i) {
		ans1 += cnt[p[i]] - ok[p[i]];
		ans2 += (ok[p[i]] == 0);
	}
	cout << ans2 << ' ' << ans1 << endl;
}