#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <queue>

using namespace std;

typedef long long ll;
typedef vector<ll> lvec;
typedef pair<ll, ll> lpair;

#ifdef LOCAL
#define TEST "D"
#endif
#ifndef LOCAL
#pragma GCC optimize("-Ofast")
#pragma GCC optimize("unroll-loops")
#endif
const ll INF = 1e9;

int main() {
#ifdef LOCAL
    if (!freopen(TEST ".in", "r", stdin)) cerr << "Test opening error";
    //freopen("Out", "w", stdout);
#endif
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(false);
    ll n, m;
    cin >> n >> m;
    vector<lvec> g(n);
    for (ll i = 0; i < m; i++) {
        ll u, v;
        cin >> u >> v;
        g[--v].push_back(--u);
    }
    ll k;
    cin >> k;
    lvec p(k);
    for (auto &el : p) cin >> el, el--;
    ll t = p.back();
    queue<ll> q;
    q.push(t);
    lvec d(n, INF), ways(n, 0), used(n, false);
    d[t] = 0;
    while(!q.empty()) {
        ll v = q.front();
        q.pop();
        if(used[v]) continue;
        used[v] = true;
        ll dist = d[v] + 1;
        for (auto u : g[v]) {
            if(d[u] < dist) continue;
            if(d[u] == dist) ways[u]++;
            if(d[u] > dist) {
                ways[u] = 1;
                d[u] = dist;
                q.push(u);
            }
        }
    }
    ll Min = 0, Max = p.size() - 1;
    for (ll i = 0 ; i < p.size() - 1; i ++) {
        ll v = p[i], u = p[i + 1];
        if(d[v] - 1 != d[u]) Min ++;
        else if(ways[v] == 1) Max --;
    }
    cout << Min << " " << Max;
    return 0;
}
