#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef vector<ll> lvec;
typedef pair<ll, ll> lpair;

#ifdef LOCAL
#define TEST "E"
#endif
#ifndef LOCAL
#pragma GCC optimize("-Ofast")
#pragma GCC optimize("unroll-loops")
#endif

const ll INF = 1e18, MAXN = 8e5 + 1;

ll val[MAXN], add[MAXN];

void push(int v, int left, int right) {
    val[v] += add[v];
    if (right - left != 1) {
        add[2 * v] += add[v];
        add[2 * v + 1] += add[v];
    }
    add[v] = 0;
}

ll req_left, req_right, delta;

ll get(int v, int left, int right) {
    push(v, left, right);
    if (req_right <= left || right <= req_left) return INF;
    push(v, left, right);
    if (req_left <= left && right <= req_right) return val[v];
    return max(get(2 * v, left, (left + right) / 2), get(2 * v + 1, (left + right) / 2, right));

}

void update(int v, int left, int right) {
    push(v, left, right);
    if (req_right <= left || right <= req_left) return;
    if (req_left <= left && right <= req_right) {
        add[v] += delta;
        push(v, left, right);
        return;
    }
    push(v, left, right);
    update(2 * v, left, (left + right) / 2);
    update(2 * v + 1, (left + right) / 2, right);
    val[v] = max(val[2 * v], val[2 * v + 1]);
}

struct mob {
    int atk, def, cost;

    mob() {
        cin >> atk >> def >> cost;
    }
};

bool weakest_m(mob a, mob b) {
    return a.atk < b.atk;
}

struct weapon {
    int atk, cost;
    weapon() {
        cin >> atk >> cost;
    }
};

bool weakest_w(weapon a, weapon b) {
    return a.atk < b.atk;
}

struct armor{
    int def , cost;
    armor() {
        cin >> def >> cost;
    }
};

bool weakest_a(armor a,  armor b) {
    return a.def  <b.def;
}

int main() {
#ifdef LOCAL
    if (!freopen(TEST ".in", "r", stdin)) cerr << "Test opening error";
    //freopen("Out", "w", stdout);
#endif
fill(val, val + MAXN, 0);
    fill(add, add + MAXN, 0);

    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(false);
    ll n, m, p;
    cin >> n >> m >> p;
    vector<weapon> w(n);
    vector<armor> a(m);
    vector<mob> e(p);
    vector<int> defs;
    sort(w.begin(), w.end(), weakest_w);
    sort(a.begin(), a.end(), weakest_a);
    sort(e.begin(), e.end(), weakest_m);
    for(auto el : a) defs.push_back(el.def);
    for (ll i = 0 ; i < m; i ++) {
        req_left = i;
        req_right = i + 1;
        delta = -a[i].cost;
        update(1, 0, m);
    }
    ll i = 0;
    ll total = -INF;
    for (auto Weapon: w ) {
        ll ans = -Weapon.cost;
        while(i < p && e[i].atk < Weapon.atk) {
            req_left = upper_bound(defs.begin(), defs.end(), e[i].def) - defs.begin();
            req_right = m;
            delta = e[i].cost;
            update(1, 0, m);
            i++;
        }
        ans += val[1];
        total = max(total, ans);
    }
    cout << total;
    return 0;
}