#include <bits/stdc++.h>

#pragma GCC optimize("O3")

#define sq(x) ((x)*(x))
#define err(x) cerr << "["#x"]  " << (x) << "\n";
#define errv(x) {cerr << "["#x"]  [";for (const auto& iii : (x)) cerr << (iii) << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  [";for (int iii = 0; iii < (n); ++iii) cerr << ((x)[iii]) << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n";

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());

int getrnd(int a, int b) {
    return uniform_int_distribution<int>(a, b)(rng);
}

template<typename T1, typename T2>
bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T1, typename T2>
bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

///////////////////////////////////////////////

struct monster {
    ll x, y, z;
    monster() {}
    monster(ll a, ll b, ll c) : x(a), y(b), z(c) {}
};

const int N = 2e5 + 3;
const ll INF = 1e16;

bool cmpa(const monster& a, const monster& b) {
    return a.x < b.x;
}

ll tree[4 * N], lazy[4 * N];

void build(int v, int tl, int tr, vector<ll>& a) {
    if (tl == tr) {
        tree[v] = a[tl];
    }
    else {
        int tm = (tl + tr) / 2;
        build(2 * v, tl, tm, a);
        build(2 * v + 1, tm + 1 ,tr, a);
        tree[v] = max(tree[2 * v], tree[2 * v + 1]);
    }
}

int upd(int v, ll x) {
    tree[v] += x;
    lazy[v] += x;
}

void push(int v) {
    if (lazy[v]) {
        upd(2 * v, lazy[v]);
        upd(2 * v + 1, lazy[v]);
        lazy[v] = 0;
    }
}

void update(int v, int tl, int tr, int l, int r, ll x) {
    if (l > r) return;
    if (tl == l && tr == r)
        upd(v, x);
    else {
        int tm = (tl + tr) / 2;
        push(v);
        update(2 * v, tl, tm , l, min(r, tm), x);
        update(2 * v + 1, tm + 1, tr, max(l, tm + 1), r ,x);
        tree[v] = max(tree[2 * v], tree[2 * v + 1]);
    }
}

ll get(int v, int tl, int tr, int l, int r) {
    if (l > r) return -INF;
    if (tl == l && tr == r)
        return tree[v];
    else {
        int tm = (tl + tr) / 2;
        push(v);
        return max(get(2 * v, tl, tm, l, min(r, tm)), get(2 * v + 1, tm + 1, tr, max(tm + 1, l), r));
    }
}

void solve() {
    int n, m, p;
    cin >> n >> m >> p;

    vector<pair<ll, ll>> a(n), b(m);
    for (int i = 0; i < n; ++i)
        cin >> a[i].first >> a[i].second;
    for (int i = 0; i < m; ++i)
        cin >> b[i].first >> b[i].second;
    vector<monster> c(p);
    for (int i = 0; i < p; ++i)
        cin >> c[i].x >> c[i].y >> c[i].z;

    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    sort(c.begin(), c.end(), cmpa);

    vector<ll> prec(p), sums(m);
    for (int i = 0; i < m; ++i) {
        sums[i] = -b[i].second;
    }
    build(1, 0, m - 1, sums);

    for (int i = 0; i < p; ++i) {
        auto pos = upper_bound(b.begin(), b.end(), make_pair(c[i].y + 1, -1LL));
        if (pos == b.end()) continue;
        int j = pos - b.begin();

        update(1, 0, m - 1, j, m - 1, c[i].z);
        prec[i] = get(1, 0, m - 1, 0, m - 1);
    }

    ll ans = -INF, mna = INF, mnb = INF;
    for (int i = 0; i < n; ++i)
        relax(mna, a[i].second);
    for (int i = 0; i < m; ++i)
        relax(mnb, b[i].second);
    ans = -(mna + mnb);

    int j = 0;
    for (int i = 0; i < n; ++i) {
        while (j < p && c[j].x < a[i].first)
            ++j;
        if (j == 0) continue;

        ll res = -a[i].second + prec[j - 1];
        strain(ans, res);
    }
    cout << ans << '\n';
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();

    return 0;
}
