#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define pb emplace_back
#define mp make_pair
#define fi first
#define se second
#define em emplace
#define all(x) (x).begin(), (x).end()
#define in(x); { for (auto &i : x) cin >> i; }
#define out(x); { for (auto &i : x) cout << i << ' '; cout << endl; }
#define pack(x); { sort(all(x)); (x).resize(unique(all(x)) - (x).begin()); }
#define int long long

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF = 2e9;
const long long INFll = 2e18;
const int MAXN = 1e6;

struct node {
    int z, w;
    int sum, mp;
    int fr, lt;
    node *left, *right;

    node(int l, int r) {
        z = 0;
        w = 0;
        sum = 0;
        mp = 0;
        fr = INF;
        lt = -INF;
        if (l + 1 == r) {
            left = NULL;
            right = NULL;
            return;
        }
        int m = (l + r) / 2;
        left = new node(l, m);
        right = new node(m, r);
    }

    int prev(int l, int r, int x) {
        if (l + 1 == r) {
            return -INF;
        }
        int m = (l + r) / 2;
        if (x < m) {
            return left->prev(l, m, x);
        } else {
            return max(left->lt, right->prev(m, r, x));
        }
    }

    int next(int l, int r, int x) {
        if (l + 1 == r) {
            return INF;
        }
        int m = (l + r) / 2;
        //cout << l << ' ' << r << ' ' << right->sum << ' ' << right->w << ' ' << fr << ' ' << lt << ' ' << left->sum << endl;
        if (x < m) {
            return min(left->next(l, m, x), right->fr);
        } else {
            return right->next(m, r, x);
        }
    }

    void recalc() {
        sum = left->sum + right->sum;
        mp = max(left->mp, left->sum + right->mp);
        w = left->w + right->w;
    }

    int cost(int l, int r, int p) {
        if (l + 1 == r) {
            return w;
        }
        int m = (l + r) / 2;
        if (p < m)
            return left->cost(l, m, p);
        else
            return right->cost(m, r, p) + left->w;
    }

    void ch(int l, int r, int p, int x) {
        if (l + 1 == r) {
            w -= x;
            sum = z - w;
            mp = max((int)0, sum);
            //cout << "ch " << l << ' ' << w << ' ' << sum << endl;
            return;
        }

        int m = (l + r) / 2;
        if (p < m)
            left->ch(l, m, p, x);
        else
            right->ch(m, r, p, x);

        this->recalc();
    }
};

vector <int> a, ca, b, cb;
node st = node(1, 1e6 + 1);
int x[300000], y[300000], z[300000];

void add(node &n, int l, int r, int x, int zz, int pr, int nx) {
    if (l + 1 == r) {
        //cout << l << ' ' << r << ' ' << ' ' << zz << ' ' << pr << ' ' << nx << endl;
        if (n.z == 0) {
            n.w = ca[upper_bound(all(a), x) - a.begin()];
            if (pr != -INF)
                n.w -= st.cost(1, 1e6 + 1, pr);
            if (nx != INF)
                st.ch(1, 1e6 + 1, nx, n.w);
        }
        n.fr = l;
        n.lt = l;
        n.z += zz;

        n.sum = n.z - n.w;
        n.mp = max((int)0, n.sum);
        //cout << n.z << ' ' << n.w << ' ' << n.mp << endl;
        return;
    }

    int m = (l + r) / 2;
    if (x < m)
        add(*(n.left), l, m, x, zz, pr, nx);
    else
        add(*(n.right), m, r, x, zz, pr, nx);

    n.recalc();
    n.fr = min(x, n.fr);
    n.lt = max(x, n.lt);
    //cout << "up " << l << ' ' << r << ' ' << n.sum << ' ' << n.mp << endl;
}

void solve() {
    int n, m, p;
    cin >> n >> m >> p;
    vector <pair <int, int>> va(n), vb(n);
    for (int i = 0; i < n; i++)
        cin >> va[i].fi >> va[i].se;
    for (int i = 0; i < m; i++)
        cin >> vb[i].fi >> vb[i].se;

    sort(all(va));
    for (int i = 0; i < n; i++) {
        while (!a.empty()) {
            if (ca.back() > va[i].se) {
                a.pop_back();
                ca.pop_back();
            } else break;
        }

        a.pb(va[i].fi);
        ca.pb(va[i].se);
    }

    sort(all(vb));
    for (int i = 0; i < m; i++) {
        while (!b.empty()) {
            if (cb.back() > vb[i].se) {
                b.pop_back();
                cb.pop_back();
            } else break;
        }

        b.pb(vb[i].fi);
        cb.pb(vb[i].se);
    }

    ca.pb(INFll);
    cb.pb(INFll);

    vector <int> id(p);
    for (int i = 0; i < p; i++) {
        cin >> x[i] >> y[i] >> z[i];
        id[i] = i;
    }

    sort(all(id), [](int i, int j) {
         return (y[i] < y[j]);
    });

    st = node(1, 1e6 + 1);

    int ans = -INF;
    for (int i = 0; i < p; i++) {
        add(st, 1, 1e6 + 1, x[id[i]], z[id[i]], st.prev(1, 1e6 + 1, x[id[i]]), st.next(1, 1e6 + 1, x[id[i]]));
        ans = max(ans, st.mp - cb[upper_bound(all(b), y[id[i]]) - b.begin()]);
        //cout << st.mp << endl;
    }

    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    solve();
}
