#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef vector <int> vi;
typedef long double ld;
typedef pair <int, int> pii;

#define pb push_back
#define f first
#define s second

const int MAXN = 2 * 1e5 + 10;
const ll INF = 1e9 + 10;
const ll MOD = 1e9 + 7;

void fastIO(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int n, m, k;
vector <vi> gr, rev;
vi path;
int min_dist[MAXN];

void calc_min_dist() {
    queue <pii> q;
    q.push({path.back(), 0});
    vector <bool> was(n, 0);
    was[path.back()] = 1;
    while (q.size() > 0) {
        int ver = q.front().f, cur_dist = q.front().s;
        min_dist[ver] = cur_dist;
        q.pop();
        for (auto to : rev[ver]) {
            if (was[to] == 0) {
                was[to] = 1;
                q.push({to, cur_dist + 1});
            }
        }
    }
  //  for (int i = 0; i < n; i++)
    //    cerr << min_dist[i] << ' ';
}

int main() {
    fastIO();
    cin >> n >> m;
    gr.resize(n);
    rev.resize(n);
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        gr[x - 1].pb(y - 1);
        rev[y - 1].pb(x - 1);
    }
    cin >> k;
    path.resize(k);
    for (int i = 0; i < k; i++) {
        cin >> path[i];
        path[i]--;
    }
    calc_min_dist();
    int min_ans = 0;
    for (int i = 0; i < k - 1; i++) {
        int cur = path[i], nxt = path[i + 1];
        if (min_dist[cur] != min_dist[nxt] + 1)
            min_ans++;
    }
    cout << min_ans << ' ';
    int max_ans = 0;
    for (int i = 0; i < k - 1; i++) {
        int cur = path[i], nxt = path[i + 1];
        bool only_one = true;
        for (auto to : gr[cur]) {
            if (to != nxt && min_dist[cur] == min_dist[to] + 1)
                only_one = false;
        }
        if (!only_one)
            max_ans++;
    }
    cout << max_ans;



    return 0;
}
