#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef vector <int> vi;
typedef long double ld;
typedef pair <ll, ll> pii;

#define pb push_back
#define f first
#define s second

const int MAXN = 2 * 1e5 + 10;
const ll INF = 1e9 + 10;
const ll MOD = 1e9 + 7;

void fastIO(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int n, m, p;
vector <pii> a, b;
vector < pair <pii, ll> > c;
pii tree[8 * MAXN];

void build(int u, int l, int r) {
    if (l == r) {
        tree[u].f = -b[l].s;
        return;
    }
    int mid = (l + r) / 2;
    build(u * 2 + 1, l, mid);
    build(u * 2 + 2, mid + 1, r);
    tree[u].f = max(tree[u * 2 + 1].f, tree[u * 2 + 2].f);
}

void push(int u) {
    tree[u].f += tree[u].s;
    tree[u * 2 + 1].s += tree[u].s;
    tree[u * 2 + 2].s += tree[u].s;
    tree[u].s = 0;
}

void upd(int u, int l, int r, int ql, int qr, ll val) {
    push(u);
    if (ql <= l && r <= qr) {
        tree[u].s += val;
        return;
    }
    if (l > qr || r < ql)
        return;
    int mid = (l + r) / 2;
    upd(u * 2 + 1, l, mid, ql, qr, val);
    upd(u * 2 + 2, mid + 1, r, ql, qr, val);
    tree[u].f = max(tree[u * 2 + 1].f + tree[u * 2 + 1].s, tree[u * 2 + 2].f + tree[u * 2 + 2].s);
}



int main() {
    fastIO();
    cin >> n >> m >> p;
    a.resize(n);
    for (int i = 0; i < n; i++)
        cin >> a[i].f >> a[i].s;
    sort(a.begin(), a.end());
    b.resize(m);
    for (int i = 0; i < m; i++)
        cin >> b[i].f >> b[i].s;
    sort(b.begin(), b.end());
    c.resize(p);
    for (int i = 0; i < p; i++)
        cin >> c[i].f.f >> c[i].f.s >> c[i].s;
    sort(c.begin(), c.end());
    build(0, 0, m - 1);
    ll ans = -INF * INF;
    for (int i = 0, it = 0; i < n; i++) {
        while (it < p && c[it].f.f < a[i].f) {
            pii gg = make_pair(c[it].f.s, INF);
            int pos = upper_bound(b.begin(), b.end(), gg) - b.begin();
           // cerr << pos << endl;
            upd(0, 0, m - 1, pos, m - 1, c[it].s);
            it++;
        }
       // for (int j = 0; j < 5; j++)
         //   cerr << tree[j].f << ' ' << tree[j].s << endl;
        //return  0;
        ans = max(ans, -a[i].s + tree[0].f + tree[0].s);
    }
    cout << ans;



    return 0;
}


