#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>

using namespace std;
const int inf = 1e9;

int main()
{
    int n = 0, m = 0;
    cin >> n >> m;

    vector <vector <int> > g1(n), g2(n);
    for (int i = 0; i < m; ++i)
    {
        int u = 0, v = 0;
        cin >> u >> v;
        --u, --v;
        g1[v].push_back(u);
        g2[u].push_back(v);
    }

    int k = 0;
    cin >> k;
    vector <int> p(k);
    for (int i = 0; i < k; ++i)
    {
        cin >> p[i];
        --p[i];
    }
    int s = p.front(), t = p.back();

    vector <int> dist(n, inf);
    dist[t] = 0;
    queue <int> q;
    q.push(t);
    vector <bool> used(n, false);
    used[t] = true;
    while (!q.empty())
    {
        int v = q.front();
        q.pop();

        for (int i = 0; i < g1[v].size(); ++i)
        {
            if (!used[g1[v][i]])
            {
                dist[g1[v][i]] = dist[v] + 1;
                used[g1[v][i]] = true;
                q.push(g1[v][i]);
            }
        }
    }

    int min_reb = 0, max_reb = 0;
    for (int i = 0; i < k - 1; ++i)
    {
        if (dist[p[i + 1]] + 1 != dist[p[i]])
            ++min_reb;

        for (int j = 0; j < g2[p[i]].size(); ++j)
        {
            int v = g2[p[i]][j];
            if (dist[v] + 1 == dist[p[i]] && v != p[i + 1])
            {
                ++max_reb;
                break;
            }
        }
    }

    cout << min_reb << ' ' << max_reb;

    return 0;
}
