#include <iostream>
#include <algorithm>
#include <vector>

#pragma GCC optimization("Ofast")

using namespace std;
typedef long long ll;
const int max_power = 1e6 + 57;
const ll inf = 1e18;

ll t[4 * max_power], add[4 * max_power];
void push(int v, int l, int r)
{
    if (r - l != 1)
    {
        add[2 * v + 1] += add[v];
        add[2 * v + 2] += add[v];
    }

    t[v] += add[v];
    add[v] = 0;
}

void update(int v, int l, int r, int ql, int qr, ll val)
{
    push(v, l, r);

    if (r <= l)
        return;
    if (l >= qr || r <= ql)
        return;
    if (l >= ql && r <= qr)
    {
        add[v] += val;
        push(v, l, r);
        return;
    }

    int m = (l + r) >> 1;
    update(2 * v + 1, l, m, ql, qr, val);
    update(2 * v + 2, m, r, ql, qr, val);
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

ll get()
{
    push(0, 0, max_power);
    return t[0];
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int n = 0, m = 0, p = 0;
    cin >> n >> m >> p;
    pair <ll, ll> a[n], b[m];
    pair <ll, pair <ll, ll> > x[p];

    for (int i = 0; i < n; ++i)
        cin >> a[i].first >> a[i].second;

    for (int i = 0; i < m; ++i)
        cin >> b[i].first >> b[i].second;

    for (int i = 0; i < p; ++i)
        cin >> x[i].first >> x[i].second.first >> x[i].second.second;

    sort(x, x + p);
    sort(a, a + n);
    sort(b, b + m);

    ll prev_power = 0;
    for (int i = 0; i < m; ++i)
    {
        update(0, 0, max_power, prev_power, b[i].first, -b[i].second);
        prev_power = b[i].first;
    }
    update(0, 0, max_power, prev_power, max_power, -inf);

    ll ans = -inf;
    int r = 0;
    for (int i = 0; i < n; ++i)
    {
        if (r == p)
            break;

        while (r < p && x[r].first < a[i].first)
        {
            update(0, 0, max_power, x[r].second.first, max_power, x[r].second.second);
            ++r;
        }

        ans = max(ans, get() - a[i].second);
    }

    cout << ans;

    return 0;
}
