#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <math.h>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
using namespace std;

#define int long long

const int MOD1 = 228228227;
const int MOD2 = 922111127;
const int BASE = 257;

struct hashs {
	vector <pair <int, int>> hs;
	
	hashs(const string& s) {
		hs.resize(s.size() + 1);
		int k1 = 1, k2 = 1;
		for (int i = 0; i < s.size(); ++i) {
			hs[i + 1].first = (hs[i].first + ((s[i] * k1) % MOD1)) % MOD1;
			hs[i + 1].second = (hs[i].second + ((s[i] * k2) % MOD2)) % MOD2;
			k1 = (k1 * BASE) % MOD1;
			k2 = (k2 * BASE) % MOD2;
		}
	}

	pair <int, int> get_hash(int l, int r) {
		pair <int, int> p;
		p.first = (hs[r].first - hs[l].first + MOD1) % MOD1;
		p.second = (hs[r].second - hs[l].second + MOD2) % MOD2;
		return p;
	}
};

signed main() {
	ios_base::sync_with_stdio();
	cin.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n;
	cin >> n;
	string s;
	cin >> s;
	hashs h(s);
	vector <int> p(n + 2);
	for (int i = 0; i < n - 1; ++i) {
		p[i + 2] = p[i + 1];
		if (s[i + 1] - '0' && s[i] - '0') {
			p[i + 2]++;
		}
	}

	int q;
	cin >> q;
	while (q--) {
		int l1, l2, k;
		cin >> l1 >> l2 >> k;
		l1--; l2--;
		if (p[l1 + k] - p[l1 + 1] && p[l2 + k] - p[l2 + 1]) {
			cout << "YES\n";
		}
		else  {
			if (h.get_hash(l1, l1 + k) == h.get_hash(l2, l2 + k))
			cout << "YES\n";
			else
			cout << "NO\n";
		}
	}
}