#include <bits/stdc++.h>
using namespace std;

#define ll long long

const ll INF = 1e18;
const int N = 1e6 + 5;
ll t[N * 4], b[N], up[N * 4];
vector<pair<ll, ll>> add[N];
vector<ll> qr[N];

void build(int v, int L, int R) {
	if (L == R) {
		t[v] = -b[L];
	}
	else {
		int m = (L + R) >> 1;
		build(v * 2, L, m);
		build(v * 2 + 1, m + 1, R);
		t[v] = max(t[v * 2], t[v * 2 + 1]);
	}
}

void push(int v, int L, int R) {
	if (up[v]) {
		if (L != R) {
			up[v * 2] += up[v];
			up[v * 2 + 1] += up[v];
		}
		t[v] += up[v];
		up[v] = 0;
	}
}

void upd(int l, int r, ll x, int v, int L, int R) {
	push(v, L, R);
	if (l > r)
		return;
	if (l == L && r == R) {
		up[v] += x;
		push(v, L, R);
	}
	else {
		int m = (L + R) >> 1;
		upd(l, min(m, r), x, v * 2, L, m);
		upd(max(m + 1, l), r, x, v * 2 + 1, m + 1, R);
		t[v] = max(t[v * 2], t[v * 2 + 1]);
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int n, m, p;
	cin >> n >> m >> p;

	fill(b, b + N, INF);

	for (int i = 0; i < n; i++) {
		ll x, y;
		cin >> x >> y;
		qr[x].push_back(y);
	}

	for (int i = 0; i < m; i++) {
		ll x, y;
		cin >> x >> y;
		b[x] = min(b[x], y);
	}

	for (int i = 0; i < p; i++) {
		ll x, y, z;
		cin >> x >> y >> z;
		add[x].push_back({y, z});
	}

	build(1, 0, N - 1);

	ll ans = -INF;

	for (int i = 0; i < N; i++) {
		push(1, 0, N - 1);
		for (ll x : qr[i]) {
			ans = max(ans, t[1] - x);
		}
		for (auto p : add[i]) {
			upd(p.first + 1, N - 1, p.second, 1, 0, N - 1);
		}
	}

	cout << ans << "\n";

	return 0;
}