#include <bits/stdc++.h>
using namespace std;

#define ll long long 
#define all(aaa) aaa.begin(), aaa.end()


const int N = 2e5 + 5, M[2] = {1000000103, 1000000123}, X[2] = {1000033, 1000037};
string s;
int n;

struct H {
	ll val[2] = {0, 0}, p[2] = {1, 1};
	int len = 0;

	H() {}
	H(int x) {
		val[0] = val[1] = x;
		p[0] = X[0];
		p[1] = X[1];
		len = 1;
	}
};

H operator + (H a, H b) {
	H c;
	c.len = a.len + b.len;
	for (int i = 0; i < 2; i++) {
		c.val[i] = (b.val[i] * a.p[i] + a.val[i]) % M[i];
		c.p[i] = a.p[i] * b.p[i] % M[i];
	}
	return c;
}

struct Node {
	int len = 0, l = 0, r = 0, lz = 0, rz = 0, ct = 0;
	int cc[2] = {0, 0};
	H h;
} t[N * 4];

bool operator == (H a, H b) {
	return a.len == b.len && a.val[0] == b.val[0] && a.val[1] == b.val[1];
}

bool operator == (Node a, Node b) {
	return a.h == b.h && a.cc[0] == b.cc[0] && a.cc[1] == b.cc[1];
}

Node operator + (Node a, Node b) {
	if (a.len == 0)
		return b;
	if (b.len == 0)
		return a;

	Node c;
	c.len = a.len + b.len;
	c.cc[0] = a.cc[0] + b.cc[0];
	c.cc[1] = a.cc[1] + b.cc[1];
	c.ct = a.ct + b.ct;

	H mid;

	c.l = a.l;
	c.r = b.r;

	if (a.len == a.l)
		c.l += b.l;
	if (b.len == b.r)
		c.r += a.r;

	if (a.len != a.r && b.len != b.l &&
		(a.r + b.l) % 2) {

		c.ct++;

		if (a.ct) {
			mid = mid + H(a.rz);
		}
		if (b.ct) {
			mid = mid + H(b.lz);
		}

		if (a.ct) {
			c.lz = a.lz;
		}
		else {
			c.lz = a.cc[0];
		}

		if (b.ct) {
			c.rz = b.rz;
		}
		else {
			c.rz = b.cc[0];
		}

	}
	else {
		if (a.ct && b.ct) {
			mid = mid + H(a.rz + b.lz);
			c.lz = a.lz;
			c.rz = b.rz;
		}
		else if (!a.ct && !b.ct) {
			c.rz = c.lz = a.lz + b.lz;
		}
		else if (a.ct) {
			c.lz = a.lz;
			c.rz = a.rz + b.rz;
		}
		else {
			c.rz = b.rz;
			c.lz = a.lz + b.lz;
		}
	}


	c.h = a.h + mid + b.h;

	return c;
}

void build(int v, int L, int R) {
	if (L == R) {
		t[v].len = 1;
		t[v].cc[s[L] - '0'] = 1;
		t[v].rz = t[v].lz = t[v].cc[0];
		t[v].r = t[v].l = t[v].cc[1];
	}
	else {
		int m = (L + R) >> 1;
		build(v * 2, L, m);
		build(v * 2 + 1, m + 1, R);
		t[v] = t[v * 2] + t[v * 2 + 1];
	}
}

Node que(int l, int r, int v, int L, int R) {
	if (l > r)
		return Node();
	if (l == L && r == R)
		return t[v];
	int m = (L + R) >> 1;
	return que(l, min(m, r), v * 2, L, m) +
		que(max(m + 1, l), r, v * 2 + 1, m + 1, R);
}

Node get_substr(int l, int r) {
	Node res = que(l, r, 1, 0, n - 1);

	// cout << res.lz << " " << res.rz << "\n";

	Node ln;
	ln.ct = 1;
	ln.len = 2;
	ln.cc[0] = 1;
	ln.cc[1] = 1;
	ln.l = 1;
	ln.r = 0;
	ln.rz = 1;
	ln.lz = 0;

	Node rn;

	rn.ct = 1;
	rn.len = 2;
	rn.cc[0] = 1;
	rn.cc[1] = 1;
	rn.l = 0;
	rn.r = 1;
	rn.rz = 0;
	rn.lz = 1;

	return ln + res + rn;
}

void pr(Node node) {
	// cout << node.h.val[0] << " " << node.h.val[1] << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	cin >> n >> s;

	build(1, 0, n - 1);

	int q;
	cin >> q;

	while (q--) {
		int l1, l2, len;
		cin >> l1 >> l2 >> len;
		l1--;
		l2--;

		Node node1 = get_substr(l1, l1 + len - 1),
			node2 = get_substr(l2, l2 + len - 1);

		// pr(node1);
		// pr(node2);

		cout << (node1 == node2 ? "Yes\n" : "No\n");
	}

	return 0;
}