#include <bits/stdc++.h>
using namespace std;
#define fir first
#define sec second
#define len(v) ((int)v.size())
typedef long long llint;

int n, m, p;
const int N = (int)2e5;
pair<int, int> a[N];
pair<int, int> b[N];
array<int, 3> z[N];

const llint INF = (llint)1e18;

struct SegTree {
    int n;
    vector<llint> data;
    vector<llint> ladd;

    SegTree(int n): n(n) {
        data = vector<llint>(4*n, 0);
        ladd = vector<llint>(4*n, 0);
        build(0, n-1, 1);
    }

    void build(int cl, int cr, int id) {
        if (cl == cr) {
            data[id] = -b[cl].sec;
            return;
        }
        int mid = (cl + cr) / 2;
        build(cl, mid, id*2);
        build(mid+1, cr, id*2+1);
        data[id] = max(data[id*2], data[id*2+1]);
    }

    void push(int id) {
        data[id*2] += ladd[id];
        ladd[id*2] += ladd[id];
        data[id*2+1] += ladd[id];
        ladd[id*2+1] += ladd[id];
        ladd[id] = 0;
    }

    void inc(int l, int r, int d) {
        inc(l, r, d, 0, n-1, 1);
    }

    void inc(int l, int r, int d, int cl, int cr, int id) {
        if (cr < l || r < cl) {
            return;
        }
        if (l <= cl && cr <= r) {
            ladd[id] += d;
            data[id] += d;
            return;
        }
        push(id);
        int mid = (cl + cr) / 2;
        inc(l, r, d, cl, mid, id*2);
        inc(l, r, d, mid+1, cr, id*2+1);
        data[id] = max(data[id*2], data[id*2+1]);
    }

    llint get() {
        return data[1];
    }
};

int main() {
#ifdef LOCAL
    freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    cin >> n >> m >> p;
    for (int i = 0; i < n; i++)
        cin >> a[i].fir >> a[i].sec;
    sort(a, a+n);
    for (int i = 0; i < m; i++)
        cin >> b[i].fir >> b[i].sec;
    sort(b, b+m);
    for (int i = 0; i < p; i++) {
        cin >> z[i][0] >> z[i][1] >> z[i][2];
    }
    sort(z, z+p);

    int j = 0;
    SegTree t(m);
    llint ans = -INF;
    for (int i = 0; i < n; i++) {
        while (j < p && z[j][0] < a[i].fir) {
            int k = upper_bound(b, b+m, z[j][1], [&](int x, pair<int, int> a) { return x < a.fir; }) - b;
            if (k < m)
                t.inc(k, m-1, z[j][2]);
            j++;
        }
        ans = max(ans, t.get()-a[i].sec);
    }
    cout << ans << "\n";
    return 0;
}
