#include <bits/stdc++.h>

#define int long long
#define ld long double

#define vi vector<int>
#define vii vector<vi>
#define vb vector<bool>

#define all(a) a.begin(), a.end()

#define pb push_back

#define fori(n) for(int i = 0; i < n; ++i)
#define Fori(n) for(int i = 1; i < n; ++i)
#define forj(n) for(int j = 0; j < n; ++j)
#define Forj(n) for(int j = 1; j < n; ++j)
#define fork(n) for(int k = 0; k < n; ++k)
#define Fork(n) for(int k = 1; k < n; ++k)
#define forl(n) for(int l = 0; l < n; ++l)
#define Forl(n) for(int l = 1; l < n; ++l)

using namespace std;

struct Fenwick {
    vi f;

    Fenwick(int sz) {
        f.assign(sz + 1, 0);
    }

    void add(int id, int x) {
        for (int i = id; i < f.size(); i += (i & (-i)))
            f[i] += x;
    }

    int sum(int r) {
        int s = 0;
        for (int i = r; i > 0; i -= (i & (-i)))
            s += f[i];
        return s;
    }

    int sum(int l, int r) {
        return sum(r) - sum(l - 1);
    }
};

struct SegTree {
    int neutral = 0;

    int m = 1;
    vi t;
    vi d;

    SegTree(int n) {
        while (m < n) m <<= 1;
        t.assign(2 * m, neutral);
        d.assign(2 * m, neutral);
    }

    void push(int v, int l, int r) {
        if (l > r) return;

        if (v < m) {
            t[v] += d[v] * (r - l + 1);
            d[v * 2] += d[v];
            d[v * 2 + 1] += d[v];
            d[v] = 0;
        } else {
            t[v] += d[v];
            d[v] = 0;
        }
    }

    int sum(int l, int r) {
        return sum(1, 1, m, l, r);
    }

    int sum(int v, int tl, int tr, int l, int r) {
        push(v, tl, tr);

        if (tl > r || tr < l)
            return neutral;

        if (tl >= l && tr <= r) {
            return t[v];
        }

        int mid = (tl + tr) >> 1;

        return sum(v * 2, tl, mid, l, r) + sum(v * 2 + 1, mid + 1, tr, l, r);
    }

    void add(int l, int r, int x) {
        add(1, 1, m, l, r, x);
    }

    void add(int v, int tl, int tr, int l, int r, int x) {
        push(v, tl, tr);

        if (tl > r || tr < l)
            return;

        if (tl >= l && tr <= r) {
            d[v] += x;
            push(v, tl, tr);
            return;
        }

        int mid = (tl + tr) >> 1;

        add(v * 2, tl, mid, l, r, x);
        add(v * 2 + 1, mid + 1, tr, l, r, x);

        if (v < m) t[v] = t[v * 2] + t[v * 2 + 1];
    }
};

struct DSU {
    vi id;
    vi sz;

    DSU(int n) {
        id.resize(n);
        sz.assign(n, 1);

        fori(n) id[i] = i;
    }

    int findd(int p) {
        int root = p;
        while (root != id[root])
            root = id[root];

        while (p != root) {
            int t = id[p];
            id[p] = root;
            p = t;
        }

        return root;
    }

    bool connected(int p, int q) {
        return findd(p) == findd(q);
    }

    void unite(int p, int q) {
        p = findd(p);
        q = findd(q);

        if (p == q) return;

        if (sz[p] > sz[q]) {
            id[q] = p;
            sz[p] += sz[q];
        } else {
            id[p] = q;
            sz[q] += sz[p];
        }
    }
};

vi zfunc(string s) {
    int n = s.length();
    vi z(n, 0);

    for(int i = 1, l = 0, r = 0; i < n; ++i) {
        if (i <= r)
            z[i] = min(r - i + 1, z[i - l]);
        while (i + z[i] < n && s[z[i]] == s[i + z[i]])
            ++z[i];
        if (i + z[i] - 1 > r) {
            l = i;
            r = i + z[i] - 1;
        }
    }

    return z;
}

vi pifunc(string s) {

    int n = s.length();
    vi pi(n, 0);
    for (int i = 1; i < n; ++i) {
        int j = pi[i - 1];
        while (j > 0 && s[i] != s[j])
            j = pi[j - 1];

        if (s[i] == s[j]) ++j;

        pi[i] = j;
    }

    return pi;
}

bool isSimple(int x) {
    if (x < 2) return false;
    if (x == 2) return true;
    if (x % 2) return false;

    int sq = sqrt(x);

    for (int i = 3; i <= sq; i += 2) {
        if (x % i == 0)
            return false;
    }

    return true;
}

int pow(int a, int n, int mod) {
    if (n == 0) return 1;

    if (n % 2) {
        return (a * pow(a, n - 1, mod)) % mod;
    } else {
        int c = pow (a, n / 2, mod);
        return (c * c) % mod;
    }
}

int gcd(int a, int b) {
    if (a == 0 || b == 0) return a + b;
    return gcd(b, a % b);
}

int lcm(int a, int b) {
    return a / gcd(a, b) * b;
}

vi ginv[200001];
vi g[200001];
vi dist(200001, 1e6);
vi c(200001, 0);
int n;

void finddist(int s) {
    queue<int> q;
    q.push(s);

    while (!q.empty()) {
        for (int sz = q.size(); sz > 0; sz--) {
            int t = q.front();
            q.pop();

            for (auto w : ginv[t]) {
                if (dist[w] == 1e6) {
                    dist[w] = dist[t] + 1;
                    q.push(w);
                }
            }
        }
    }
}

void findc() {
    Fori(n + 1) {
        for (auto w : g[i]) {
            if (dist[w] == dist[i] - 1) {
                c[i]++;
            }
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int m;
    cin >> n >> m;

    fori(m) {
        int a, b;
        cin >> a >> b;

        ginv[b].pb(a);
        g[a].pb(b);
    }

    int q;
    cin >> q;

    vi p(q);
    fori(q) cin >> p[i];

    dist[p[q - 1]] = 0;
    finddist(p[q - 1]);
    findc();
    c[p[q - 1]] = 1;

    int mn = 0, mx = 0;

    fori (q - 1) {
        if (dist[p[i]] == dist[p[i + 1]] + 1) {
            if (c[p[i]] > 1) ++mx;
        } else {
            ++mn; ++mx;
        }
    }

    cout << mn << " " << mx;
}
