#include <bits/stdc++.h>

#define int long long
#define ld long double

#define vi vector<int>
#define vii vector<vi>
#define vb vector<bool>

#define all(a) a.begin(), a.end()

#define pb push_back

#define fori(n) for(int i = 0; i < n; ++i)
#define Fori(n) for(int i = 1; i < n; ++i)
#define forj(n) for(int j = 0; j < n; ++j)
#define Forj(n) for(int j = 1; j < n; ++j)
#define fork(n) for(int k = 0; k < n; ++k)
#define Fork(n) for(int k = 1; k < n; ++k)
#define forl(n) for(int l = 0; l < n; ++l)
#define Forl(n) for(int l = 1; l < n; ++l)

using namespace std;

struct Fenwick {
    vi f;

    Fenwick(int sz) {
        f.assign(sz + 1, 0);
    }

    void add(int id, int x) {
        for (int i = id; i < f.size(); i += (i & (-i)))
            f[i] += x;
    }

    int sum(int r) {
        int s = 0;
        for (int i = r; i > 0; i -= (i & (-i)))
            s += f[i];
        return s;
    }

    int sum(int l, int r) {
        return sum(r) - sum(l - 1);
    }
};

struct SegTree {
    int neutral = 0;

    int m = 1;
    vi t;
    vi d;

    SegTree(int n) {
        while (m < n) m <<= 1;
        t.assign(2 * m, neutral);
        d.assign(2 * m, neutral);
    }

    void push(int v, int l, int r) {
        if (l > r) return;

        if (v < m) {
            t[v] += d[v] * (r - l + 1);
            d[v * 2] += d[v];
            d[v * 2 + 1] += d[v];
            d[v] = 0;
        } else {
            t[v] += d[v];
            d[v] = 0;
        }
    }

    int sum(int l, int r) {
        return sum(1, 1, m, l, r);
    }

    int sum(int v, int tl, int tr, int l, int r) {
        push(v, tl, tr);

        if (tl > r || tr < l)
            return neutral;

        if (tl >= l && tr <= r) {
            return t[v];
        }

        int mid = (tl + tr) >> 1;

        return sum(v * 2, tl, mid, l, r) + sum(v * 2 + 1, mid + 1, tr, l, r);
    }

    void add(int l, int r, int x) {
        add(1, 1, m, l, r, x);
    }

    void add(int v, int tl, int tr, int l, int r, int x) {
        push(v, tl, tr);

        if (tl > r || tr < l)
            return;

        if (tl >= l && tr <= r) {
            d[v] += x;
            push(v, tl, tr);
            return;
        }

        int mid = (tl + tr) >> 1;

        add(v * 2, tl, mid, l, r, x);
        add(v * 2 + 1, mid + 1, tr, l, r, x);

        if (v < m) t[v] = t[v * 2] + t[v * 2 + 1];
    }
};

struct DSU {
    vi id;
    vi sz;

    DSU(int n) {
        id.resize(n);
        sz.assign(n, 1);

        fori(n) id[i] = i;
    }

    int findd(int p) {
        int root = p;
        while (root != id[root])
            root = id[root];

        while (p != root) {
            int t = id[p];
            id[p] = root;
            p = t;
        }

        return root;
    }

    bool connected(int p, int q) {
        return findd(p) == findd(q);
    }

    void unite(int p, int q) {
        p = findd(p);
        q = findd(q);

        if (p == q) return;

        if (sz[p] > sz[q]) {
            id[q] = p;
            sz[p] += sz[q];
        } else {
            id[p] = q;
            sz[q] += sz[p];
        }
    }
};

vi zfunc(string s) {
    int n = s.length();
    vi z(n, 0);

    for(int i = 1, l = 0, r = 0; i < n; ++i) {
        if (i <= r)
            z[i] = min(r - i + 1, z[i - l]);
        while (i + z[i] < n && s[z[i]] == s[i + z[i]])
            ++z[i];
        if (i + z[i] - 1 > r) {
            l = i;
            r = i + z[i] - 1;
        }
    }

    return z;
}

vi pifunc(string s) {

    int n = s.length();
    vi pi(n, 0);
    for (int i = 1; i < n; ++i) {
        int j = pi[i - 1];
        while (j > 0 && s[i] != s[j])
            j = pi[j - 1];

        if (s[i] == s[j]) ++j;

        pi[i] = j;
    }

    return pi;
}

bool isSimple(int x) {
    if (x < 2) return false;
    if (x == 2) return true;
    if (x % 2) return false;

    int sq = sqrt(x);

    for (int i = 3; i <= sq; i += 2) {
        if (x % i == 0)
            return false;
    }

    return true;
}

int pow(int a, int n, int mod) {
    if (n == 0) return 1;

    if (n % 2) {
        return (a * pow(a, n - 1, mod)) % mod;
    } else {
        int c = pow (a, n / 2, mod);
        return (c * c) % mod;
    }
}

int gcd(int a, int b) {
    if (a == 0 || b == 0) return a + b;
    return gcd(b, a % b);
}

int lcm(int a, int b) {
    return a / gcd(a, b) * b;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m, p;
    cin >> n >> m >> p;

    vector<pair<int, int> > atk(n);
    fori(n) {
        cin >> atk[i].first >> atk[i].second;
    }
    sort(all(atk));
    vector<pair<int, int> > a;
    a.pb(atk[0]);
    Fori(n) {
        while (!a.empty() && atk[i].second <= a[a.size() - 1].second)
            a.pop_back();

        a.pb(atk[i]);
    }

    vector<pair<int, int> > def(m);
    fori(m) {
        cin >> def[i].first >> def[i].second;
    }
    sort(all(def));
    vector<pair<int, int> > b;
    b.pb(def[0]);
    Fori(m) {
        while (!b.empty() && def[i].second <= b[b.size() - 1].second)
            b.pop_back();

        b.pb(def[i]);
    }

    vector<pair<int, pair<int, int> > > mon(p);
    fori(p) {
        cin >> mon[i].first >> mon[i].second.first >> mon[i].second.second;
    }
    sort(all(mon));

    ////////////////////////////////

    set<int > s;
    map<int, int> c;
    map<int, int> sum;
    fori(m) {
        s.insert(b[i].first);
        c[b[i].first] = -b[i].second;
    }
    s.insert(1e18);
    c[1e18] = -1e18;

    int answ = -1e18;

    int l = 0;
    int r = *s.upper_bound(0);

    fori(n) {
        int power = a[i].first;
        int price = a[i].second;

        int x = -1e18;

        while (l < p && mon[l].first < power) {
            int u = *s.upper_bound(mon[l].second.first);
            int y = mon[l].second.second;

            if (u <= r) {
                sum[r] += y;
            } else {
                sum[u] += y;
                if (sum[u] > c[r] - c[u]) {
                    sum[u] += sum[r];
                    //cout << sum[u] << "\n\n";
                    r = u;
                }
            }

            x = max(x, sum[r] + c[r]);
            ++l;
        }

        answ = max(answ, x - price);
    }

    cout << max(answ, -a[0].second - b[0].second);
}
