#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <ctime>
#include <queue>
#include <set>
#include <map>
using namespace std;

struct E{

    long long x, y, z;

    E(){}

};

bool operator<(E a, E b){
    return a.x<b.x;
}

vector<pair<long long, long long> > tr;
vector<pair<long long, long long> > a, b;

void build(long long l, long long r, long long it){
    if(l>=r)
        return;
    if(l+1==r){
        tr[it] = {-b[l].second, 0};
        return;
    }
    long long m = (l+r)/2;
    build(l, m, 2*it);
    build(m, r, 2*it+1);
    tr[it] = {max(tr[2*it].first+tr[2*it].second, tr[2*it+1].first+tr[2*it+1].second), 0};
}

void upd(long long l, long long r, long long x, long long y, long long dl, long long it){
    if(l>=r)
        return;
    if(r<=x||y<=l)
        return;
    if(x<=l&&r<=y){
        tr[it].second += dl;
        return;
    }
    long long m = (l+r)/2;
    upd(l, m, x, y, dl, 2*it);
    upd(m, r, x, y, dl, 2*it+1);
    tr[it].first = max(tr[2*it].first+tr[2*it].second, tr[2*it+1].first+tr[2*it+1].second);
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    long long n, m, p;
    cin >> n >> m >> p;
    a.resize(n);
    b.resize(m);
    tr.resize(4*m);
    for(long long i = 0; i<n; i++)
        cin >> a[i].first >> a[i].second;
    for(long long i = 0; i<m; i++)
        cin >> b[i].first >> b[i].second;
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    build(0, m, 1);
    vector<E> c(p);
    for(long long i = 0; i<p; i++)
        cin >> c[i].x >> c[i].y >> c[i].z;
    sort(c.begin(), c.end());
    long long it = 0;
    long long ans = -4'000'000'000'000'000'000;
    for(long long i = 0; i<p; i++){
        while(it<n&&a[it].first<=c[i].x){
            ans = max(ans, tr[1].first+tr[1].second-a[it].second);
            it++;
        }
        long long l = -1, r = m-1;
        while(r-l>1){
            long long m = (l+r)/2;
            if(b[m].first>c[i].y)
                r = m;
            else
                l = m;
        }
        upd(0, m, r, m, c[i].z, 1);
    }
    while(it<n){
        ans = max(tr[1].first+tr[1].second-a[it].second, ans);
        it++;
    }
    cout << ans;

    return 0;
}
