#include <bits/stdc++.h>

#define int long long
#define endl "\n"
#define pii pair<int, int>
#define B begin
#define E end
#define F first
#define S second

using namespace std;

typedef long long ll;

const int INF = 1e15 + 1;
const ll P = 1e9 + 7;


void hello()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
}

void show(vector <int>& arr)
{
    for (auto i : arr)
        cout << i << " ";
    cout << endl;
}

void show(vector <vector <int>>& arr)
{
    for (auto i : arr)
        show(i);
    cout << endl;
}


struct mr
{
    int x, y, c;
    mr(){}
    mr(int tx, int ty, int tc)
    {
        x = tx;
        y = ty;
        c = tc;
    }
};

bool cmp(mr l, mr r)
{
    return l.x < r.x;
}

const int MAXN = 4e5 * 4 + 1;

int tree[MAXN];
int push[MAXN];

void build(int v, int cl, int cr, vector <int>& data)
{
    if (cl == cr)
    {
        tree[v] = data[cl];
        return;
    }

    int cm = (cl + cr) / 2;
    build(2 * v, cl, cm, data);
    build(2 * v + 1, cm + 1, cr, data);
    tree[v] = max(tree[2 * v], tree[2 * v + 1]);
}

void mpush(int v, int cl, int cr)
{
    tree[v] += push[v];
    if (cl == cr)
    {
        push[v] = 0;
        return;
    }
    push[2 * v] += push[v];
    push[2 * v + 1] += push[v];
    push[v] = 0;
}

void change(int v, int cl, int cr, int l, int r, int val)
{
    mpush(v, cl, cr);
    if (cl >= l && cr <= r)
    {
        push[v] += val;
        mpush(v, cl, cr);
        return;
    }
    if (cl > r || l > cr)
        return;

    int cm = (cl + cr) / 2;
    change(2 * v, cl, cm, l, r, val);
    change(2 * v + 1, cm + 1, cr, l, r, val);
    tree[v] = max(tree[2 * v], tree[2 * v + 1]);
}


signed main()
{
    hello();

    int n, m, p;
    cin >> n >> m >> p;
    vector <pii> seq(n);
    vector <pii> fin(m);
    vector <mr> mrs(p);
    vector <int> order;

    for (int i = 0; i < n; ++i)
        cin >> seq[i].F >> seq[i].S;

    for (int i = 0; i < m; ++i)
    {
        cin >> fin[i].F >> fin[i].S;
        order.push_back(fin[i].F);
    }

    for (int i = 0; i < p; ++i)
    {
        cin >> mrs[i].x >> mrs[i].y >> mrs[i].c;
        order.push_back(mrs[i].y);
    }

    sort(order.B(), order.E());
    sort(seq.B(), seq.E());
    sort(mrs.B(), mrs.E(), cmp);
    order.resize(unique(order.B(), order.E()) - order.B());
    vector <int> data(order.size(), -INF);
    for (int i = 0; i < m; ++i)
    {
        int ind = lower_bound(order.B(), order.E(), fin[i].F) - order.B();
        data[ind] = max(data[ind], -fin[i].S);
    }

    for (auto& val : mrs)
        val.y = lower_bound(order.B(), order.E(), val.y) - order.B();

    m = order.size();
    build(1, 0, m - 1, data);

    int last = -1;
    int res = -INF;
    for (auto val : seq)
    {
        while (last != p - 1 && mrs[last + 1].x < val.F)
        {
            ++last;
            change(1, 0, m - 1, mrs[last].y + 1, m - 1, mrs[last].c);
        }

        mpush(1, 0, m - 1);
        res = max(res, tree[1] - val.S);
    }

    cout << res << endl;
}
