#include <iostream>
#include<math.h>
#include<vector>
#include<algorithm>
#include<set>
#include <string>
#include <unordered_set>
#include <map>
#include <iomanip>
#include <random>
#include <time.h>

#define ll long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define dbg(x) cout << #x << ": " << x;

using namespace std;

int gcd(int a, int b){
    if(a== 0) return b;
    else return gcd(b % a, a);
}

ll bin_pow(int x, int b){
    ll res = 1;
    while(b > 0){
        if(b%2) res *= x;
        b = b >> 1;
    }
    return res;
}

struct node{
    node *l, *r;
    ll kl = 0;
    node(int p =0):l(nullptr),r(nullptr),kl(p){};
};
struct segment_tree{
    node *root;

    void build(node *h, int l, int r){
        if(l == r){
            h->kl=0;
            return;
        }
        int w = (l+r)/2;
        h->l = new node();
        h->r = new node();
        build(h->l, l, w);
        build(h->r, w+1, r);
        h->kl = 0;
    }

    void update(node *h, int l, int r, int x, int k){
        if(l == r){
            h->kl = k;
            return;
        }
        int w = (l + r) / 2;
        if(x <= w) update(h->l, l, w, x, k);
        else update(h->r, w+1, r, x, k);
        h->kl = h->l->kl+h->r->kl;
    }

    ll get(node *h, int l, int r, int x, int y){
        if(x>y) return 0;
        if(l == x && r == y) return h->kl;
        int w = (l + r) / 2;
        return get(h->l, l, w, x, min(y, w)) + get(h->r, w+1, r, max(r,w+1), y);
    }
};

inline void IO(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int del(string s, int l, int r, bool is_l, bool is_r, bool fl, char d){
    if(l == r || d == ('z')){
        return 0;
    }
    for(int i = l; i < r; i++){
        if(s[i] == d){
            int tmp1 = del(s, l, i, fl, true, false, d + 1);
            bool fl2 = false;
            if(tmp1 == i - l) fl2 = true;
            int tmp2 = del(s, i + 1, r, fl2, is_r, true, d);
            if((fl2 && is_l)|| (tmp2 == r - (i + 1) && is_r)){
                return tmp1 + tmp2 + 1;
            }else{
                return tmp1 + tmp2;
            }
        }
    }
    return del(s, l, r, fl, false, false, d + 1);
}

int main() {
    IO();
    int n;
    string s;
    cin >> n >> s;
    cout << del(s, 0, n, false, false, false, 'a');

    return 0;
}