#include <iostream>
#include<math.h>
#include<vector>
#include<algorithm>
#include<set>
#include <string>
#include <unordered_set>
#include <map>
#include <iomanip>
#include <random>
#include <time.h>

#define ll long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define dbg(x) cout << #x << ": " << x;

using namespace std;

int gcd(int a, int b){
    if(a== 0) return b;
    else return gcd(b % a, a);
}

ll bin_pow(int x, int b){
    ll res = 1;
    while(b > 0){
        if(b%2) res *= x;
        b = b >> 1;
    }
    return res;
}

struct node{
    node *l, *r;
    ll kl = 0;
    node(int p =0):l(nullptr),r(nullptr),kl(p){};
};
struct segment_tree{
    node *root;

    void build(node *h, int l, int r){
        if(l == r){
            h->kl=0;
            return;
        }
        int w = (l+r)/2;
        h->l = new node();
        h->r = new node();
        build(h->l, l, w);
        build(h->r, w+1, r);
        h->kl = 0;
    }

    void update(node *h, int l, int r, int x, int k){
        if(l == r){
            h->kl = k;
            return;
        }
        int w = (l + r) / 2;
        if(x <= w) update(h->l, l, w, x, k);
        else update(h->r, w+1, r, x, k);
        h->kl = h->l->kl+h->r->kl;
    }

    ll get(node *h, int l, int r, int x, int y){
        if(x>y) return 0;
        if(l == x && r == y) return h->kl;
        int w = (l + r) / 2;
        return get(h->l, l, w, x, min(y, w)) + get(h->r, w+1, r, max(r,w+1), y);
    }
};

inline void IO(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main() {
    IO();
    int n, m;
    cin >> n >> m;
    vector<vector<int>> gr(n);
    for(int i =0; i <m; i++){
        int u, v;
        cin >> u >> v;
        gr[v - 1].push_back(u - 1);
    }
    int k;
    cin >> k;
    vector<int> p(k);
    for(int i = 0; i <k; i++){
        cin >> p[i];
        p[i]--;
    }
    vector<int> mass(n, -1);
    vector<vector<int>> w(n);
    set<int> use;
    use.insert(p.back());
    mass[p.back()] = 0;
    while(use.size()){
        set<int> nt;
        for(int it : use){
            for(auto e : gr[it]){
                if(mass[e] == -1 || mass[e] == mass[it] + 1){
                    mass[e] = mass[it] + 1;
                    w[e].push_back(it);
                    nt.insert(e);
                }
            }
        }
        use = nt;
    }
    int ans_l = 0, ans_r = 0;

    for(int i =0; i < k - 1; i++) {
        bool fl = false;
        for(auto e : w[p[i]]){
            if(e == p[i + 1]){
                fl = true;
            }
        }
        if(fl){
            if(w[p[i]].size() > 1) ans_r++;
        }else{
            ans_r++;
            ans_l++;
        }
    }
    cout << ans_l << " " << ans_r;

    return 0;
}