#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define pb push_back
#define mp make_pair
#define debug(x) std::cout << #x << ": " << x << '\n';
typedef long long ll;
const int N = 2e5 + 100;
struct seg_tree
{
	int push[4 * N];
	int tree[4 * N];
	seg_tree() {
		memset(tree, 0, sizeof(tree));
		memset(push, 0, sizeof(push));
	}
	void doPush(int v) {
		tree[v] += push[v];
		if (2 * v < 4 * N) {
			push[2 * v] += push[v];
			push[2 * v + 1] += push[v];
		}
		push[v] = 0;
	}
	void upd(int v, int tl, int tr, int l, int r, int x) {
		doPush(v);
		if (l > r) return;
		if (tl == l && tr == r) {
			push[v] += x;
			doPush(v);
			return;
		}
		int tm = (tl + tr) / 2;
		upd(v * 2, tl, tm, l, std::min(r, tm), x);
		upd(v * 2 + 1, tm + 1, tr, std::max(l, tm + 1), r, x);
		tree[v] = std::max(tree[v * 2], tree[v * 2 + 1]);
	}
};
seg_tree tree;
struct en
{
	int a1, b1, c;	
};
bool cmp(en a, en b) {
	return a.a1 < b.a1;
}
int main() {
	std::ios::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(0);
	int n, m, p;
	std::cin >> n >> m >> p;
	std::vector<std::pair<int,int>> sword(n), armor(m);
	std::vector<en> v(p);
	FOR(i, n) {
		std::cin >> sword[i].first >> sword[i].second;
	}
	std::sort(sword.begin(), sword.end());
	std::vector<int> compress;
	FOR(i, m) {
		std::cin >> armor[i].first >> armor[i].second;
		compress.pb(armor[i].first);
	}
	std::sort(compress.begin(), compress.end());
	std::sort(armor.begin(), armor.end());
	compress.resize(std::unique(compress.begin(), compress.end()) - compress.begin());
	int newM = compress.size(), pointer = 0;
	FOR(i, m) {
		if (i - 1 >= 0 && armor[i].first == armor[i - 1].first) continue;
		tree.upd(1, 0, newM - 1, pointer, pointer, -armor[i].second);
		pointer++;
	}
	// debug(newM << ' ' << pointer << ' ' << tree.tree[1])
	FOR(i, p) {
		std::cin >> v[i].a1 >> v[i].b1 >> v[i].c;
	}
	std::sort(v.begin(), v.end(), cmp);
	int r = 0;
	int max = -2e9;
	FOR(i, n) {
		while (r < p && v[r].a1 < sword[i].first) {
			auto it = std::upper_bound(compress.begin(), compress.end(), v[r].b1) - compress.begin();
			tree.upd(1, 0, newM - 1, it, newM - 1, v[r].c);
			++r;
		}
		// debug(r << ' ' << tree.tree[0]);
		max = std::max(max, tree.tree[1] - sword[i].second);
	}
	std::cout << max;
}