#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define pb push_back
#define mp make_pair
#define debug(x) std::cout << #x << ": " << x << '\n';
typedef long long ll;
const int N = 2e5 + 10, LG = 20;
std::vector<int> g[N], g2[N];
int LCA[N][LG], h[N], tin[N], tout[N];
int timer = 0;
void dfs(int v, int p) {
	LCA[v][0] = p;
	FOR(i, LG - 1) {
		LCA[v][i + 1] = LCA[LCA[v][i]][i];
	}
	tin[v] = timer++;
	for (auto e : g[v]) {
		if (e != p) {
			h[e] = h[v] + 1;
			dfs(e, v);
		}
	}
	tout[v] = timer++;
}
bool is_pred(int a, int b) {
	return tin[a] <= tin[b] && tout[a] >= tout[b];
}
int lca(int a, int b) {
	if (a == b) return a;
	if (is_pred(a, b)) return a;
	if (is_pred(b, a)) return b;
	for (int i = LG - 1; i >= 0; --i) {
		if (!is_pred(LCA[a][i], b)) {
			a = LCA[a][i];
		}
	}
	return LCA[a][0];
}
int height(int a, int b) {
	return h[a] + h[b] - 2 * h[lca(a, b)];
}
bool cmp(int a, int b) {
	return tin[a] < tin[b];
}
bool cmp1(std::pair<int,int> a, std::pair<int,int> b) {
	return cmp(a.first, b.first);
}
const int INF = 1e9;
int main() {
	std::ios::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(0);
	int n;
	std::cin >> n;
	FOR(i, n - 1) {
		int a, b;
		std::cin >> a >> b;
		--a; --b;
		g[a].pb(b);
		g[b].pb(a);
	}
	dfs(0, 0);
	int q;
	std::cin >> q;
	while(q--) {
		int k, m;
		std::cin >> k >> m;
		std::vector<std::pair<int,int>> poison(k);
		std::map<int, std::pair<int,int>> byVertex;
		std::vector<int> check(m);
		FOR(i, k) {
			std::cin >> poison[i].first >> poison[i].second;
			--poison[i].first;
			byVertex[poison[i].first] = {i, poison[i].second};
		}
		std::sort(poison.begin(), poison.end(), cmp1);
		FOR(i, m) {
			std::cin >> check[i];
			--check[i];
		}
		std::vector<int> compressedGraph;
		FOR(i, k) {
			if (i != 0) {
				compressedGraph.pb(lca(poison[i - 1].first, poison[i].first));
			}
			compressedGraph.pb(poison[i].first);
		}
		std::sort(compressedGraph.begin(), compressedGraph.end(), cmp);
		compressedGraph.resize(std::unique(compressedGraph.begin(), compressedGraph.end()) - compressedGraph.begin());
		std::vector<std::pair<int,int>> dp(compressedGraph.size());
		std::vector<int> nxt(compressedGraph.size()), pred(compressedGraph.size());
		FOR(i, (int)nxt.size()) {
			nxt[i] = i + 1;
		}
		// for (auto e : compressedGraph) {
		// 	debug(e + 1)
		// }
		for (int i = (int)compressedGraph.size() - 1; i >= 0; --i) {
			int t = nxt[i];
			std::vector<int> p;
			while (t < (int)compressedGraph.size() && is_pred(compressedGraph[i], compressedGraph[t])) {
				p.pb(t);
				pred[t] = i;
				t = nxt[t];
			}
			nxt[i] = t;
			dp[i] = {INF, INF};
			int minDay = INF, minKek = INF;

			if (byVertex.count(compressedGraph[i])) {
				dp[i] = {i, byVertex[compressedGraph[i]].second};
				minDay = 0, minKek = 0;
			}
			// debug(i << ' ')
			// for (auto e : p) {
			// 	debug(e + 1)
			// }
			for (auto e : p) {
				int nowDay = (height(compressedGraph[i], compressedGraph[dp[e].first]) + dp[e].second - 1) / dp[e].second;
				// debug(nowDay << ' ' << compressedGraph[dp[e].first] + 1)
				// debug(minKek)
				if (nowDay < minDay) {
					minDay = nowDay;
					dp[i] = dp[e];
					minKek = byVertex[compressedGraph[dp[e].first]].first;
				}
				else if (nowDay == minDay && minKek > byVertex[compressedGraph[dp[e].first]].first) {
					minDay = nowDay;
					dp[i] = dp[e];
					minKek = byVertex[compressedGraph[dp[e].first]].first;
				}
			}
			// debug(i << ' ' << compressedGraph[i] + 1 << ' ' << dp[i].first << ' ' << minKek)
		}
		for (auto e : check) {
			int ind = std::lower_bound(compressedGraph.begin(), compressedGraph.end(), e, cmp) - compressedGraph.begin();
			int answ = -1;
			// debug(e + 1 << ' ' << ind)
			if (ind == 0) {
				answ = dp[ind].first;
				// debug(compressedGraph[answ]);
				// debug(dp[ind].first)
				// std::cout << byVertex[compressedGraph[dp[ind].first]].second + 1 << ' ';
			} 
			else if (ind == (int)compressedGraph.size()) {
				answ = dp[ind - 1].first;
				// std::cout << byVertex[compressedGraph[dp[ind - 1].first]].second + 1 << ' ';
			}
			else {
				// debug(ind);
				int check1 = dp[ind].first;
				int check2 = dp[pred[ind]].first;
				// debug(check1 << ' ' << pred[check1])
				// debug(compressedGraph[check2] + 1 << ' ' << compressedGraph[check1] + 1)
				if (!is_pred(e, compressedGraph[dp[ind].first])) {
					answ = dp[ind - 1].first;
				}
				{
					// debug(ind)
					int num1 = byVertex[compressedGraph[check1]].first;
					int num2 = byVertex[compressedGraph[check2]].first;
					std::pair<int,int> a1 = {(height(e, compressedGraph[check1]) + dp[ind].second - 1) / dp[ind].second, num1};
						std::pair<int,int> a2 = {(height(e, compressedGraph[check2]) + dp[ind - 1].second - 1) / dp[ind - 1].second, num2};
					if (a1 < a2) {
						answ = check1;
					}
					else {
						answ = check2;
					}
				}
			}
			// debug(compressedGraph[answ])
			std::cout << byVertex[compressedGraph[answ]].first + 1 << ' ';
		}
		std::cout << '\n';

	}
}