#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define pb push_back
#define mp make_pair
#define debug(x) std::cout << #x << ": " << x << '\n';
typedef long long ll;
const int N = 2e5 + 10, LG = 20;
std::vector<int> g[N];
std::vector<std::pair<int,int>> g2[N];
int LCA[N][LG], h[N], tin[N], tout[N];
int timer = 0;
void dfs(int v, int p) {
	LCA[v][0] = p;
	FOR(i, LG - 1) {
		LCA[v][i + 1] = LCA[LCA[v][i]][i];
	}
	tin[v] = timer++;
	for (auto e : g[v]) {
		if (e != p) {
			h[e] = h[v] + 1;
			dfs(e, v);
		}
	}
	tout[v] = timer++;
}
bool is_pred(int a, int b) {
	return tin[a] <= tin[b] && tout[a] >= tout[b];
}
int lca(int a, int b) {
	if (a == b) return a;
	if (is_pred(a, b)) return a;
	if (is_pred(b, a)) return b;
	for (int i = LG - 1; i >= 0; --i) {
		if (!is_pred(LCA[a][i], b)) {
			a = LCA[a][i];
		}
	}
	return LCA[a][0];
}
int height(int a, int b) {
	return h[a] + h[b] - 2 * h[lca(a, b)];
}
bool cmp(int a, int b) {
	return tin[a] < tin[b];
}
bool cmp1(std::pair<int,int> a, std::pair<int,int> b) {
	return cmp(a.first, b.first);
}
struct rofl
{
	int dist, num, vertex, byDay;

	rofl() {
	}
	rofl(int a, int b, int c, int d) {
		dist = a, num = b, vertex = c, byDay = d;
	}

	friend bool operator<(rofl a, rofl b) {
		int d1 = (a.dist + a.byDay - 1) / a.byDay, d2 = (b.dist + b.byDay - 1) / b.byDay;
		if (d1 == d2) {
			if (a.num == b.num) {
				if (a.vertex == b.vertex)
					return a.dist < b.dist;
				return a.vertex < b.vertex;
			}
			return a.num < b.num;
		}
		return d1 < d2;
	}
};
const int INF = 1e9;
int main() {
	std::ios::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(0);
	int n;
	std::cin >> n;
	FOR(i, n - 1) {
		int a, b;
		std::cin >> a >> b;
		--a; --b;
		g[a].pb(b);
		g[b].pb(a);
	}
	dfs(0, 0);
	int q;
	std::cin >> q;
	while(q--) {
		int k, m;
		std::cin >> k >> m;
		std::vector<std::pair<int,int>> poison(k);
		std::vector<int> check(m);

		std::vector<int> allVertex;

		std::map<int,int> getPoison, getAnsw;

		FOR(i, k) {
			std::cin >> poison[i].first >> poison[i].second;
			--poison[i].first;

			getPoison[poison[i].first] = i;

			allVertex.pb(poison[i].first);
		}

		FOR(i, m) {
			std::cin >> check[i];
			--check[i];

			getAnsw[check[i]] = i;

			allVertex.pb(check[i]);
		}

		std::sort(allVertex.begin(), allVertex.end(), cmp);

		std::vector<int> compressedGraph;
		FOR(i, (int)allVertex.size()) {
			if (i != 0) {
				compressedGraph.pb(lca(allVertex[i - 1], allVertex[i]));
			}
			compressedGraph.pb(allVertex[i]);
		}
		std::sort(compressedGraph.begin(), compressedGraph.end(), cmp);
		compressedGraph.resize(std::unique(compressedGraph.begin(), compressedGraph.end()) - compressedGraph.begin());
		std::vector<int> nxt(compressedGraph.size());
		FOR(i, (int)nxt.size()) {
			nxt[i] = i + 1;
			g2[i].clear();
		}

		for (int i = (int)compressedGraph.size() - 1; i >= 0; --i) {
			int t = nxt[i];
			while (t < (int)compressedGraph.size() && is_pred(compressedGraph[i], compressedGraph[t])) {
				int h1 = height(compressedGraph[i], compressedGraph[t]);
				g2[i].pb({t, h1});
				g2[t].pb({i, h1});
				// debug(compressedGraph[i] + 1 << ' ' << compressedGraph[t] + 1)
				t = nxt[t];
			}
			nxt[i] = t;
		}
		std::vector<rofl> d(compressedGraph.size(), {INF, -1, -1, 1});
		std::set<rofl> q;
		FOR(i, (int)compressedGraph.size()) {
			if (getPoison.count(compressedGraph[i])) {
				d[i] = rofl(0, getPoison[compressedGraph[i]], i, poison[getPoison[compressedGraph[i]]].second);
				q.insert({0, getPoison[compressedGraph[i]], i, poison[getPoison[compressedGraph[i]]].second});
			}
		}
		while (!q.empty()) {
			auto v = *q.begin();
			// debug(compressedGraph[v.vertex] + 1 << ' ' << d[v.vertex].num);
			q.erase(q.begin());
			for (auto e : g2[v.vertex]) {
				int to = e.first, cost = e.second;
				auto newD = d[v.vertex];
				newD.dist += cost;
				newD.vertex = to;
				if (newD < d[to]) {
					q.erase(d[to]);
					// debug(compressedGraph[newD.vertex] + 1)
					d[to] = newD;
					q.insert(d[to]);
				}
			}
		}
		std::vector<int> answ(m + 1);
		FOR(i, (int)compressedGraph.size()) {
			int v = compressedGraph[i];
			if (getAnsw.count(v)) {
				answ[getAnsw[v]] = d[i].num;
			}
		}
		FOR(i, m) {
			std::cout << answ[i] + 1 << ' ';
		}
		std::cout << '\n';

	}
}