#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <set>
#include <map>

#define speed ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

using namespace std;

void bfs(vector <vector <int>> &g, vector <vector <int> > &p, int start)
{
	int n = g.size();
	queue <int> q;
	q.push(start);
	vector <int> d(n, 1e8);
	d[start] = 0;
	while (!q.empty())
	{
		int v = q.front();
		q.pop();
		for (int i = 0; i < g[v].size(); i++)
		{
			int to = g[v][i];
			if (d[to] > d[v] + 1)
			{
				d[to] = d[v] + 1;
				p[to].resize(0);
				p[to].push_back(v);
				q.push(to);
			}
			else
				if (d[to] == d[v] + 1)
					p[to].push_back(v);
		}
	}
}

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n, m;
	cin >> n >> m;
	vector <vector <int>> g(n);
	vector <vector <int>> gt(n);
	vector <vector <int>> p(n);
	for (int i = 0; i < m; i++)
	{
		int from, to;
		cin >> from >> to;
		from--; to--;
		g[from].push_back(to);
		gt[to].push_back(from);
	}
	int k;
	cin >> k;
	vector <int> path(k);
	for (int i = 0; i < k; i++)
	{
			cin >>  path[i];
			path[i]--;
	}
	bfs(gt, p, path[k - 1]);
	int ansmin = 0, ansmax = 0;
	for (int i = 0; i < k - 1; i++)
	{
		int cur = path[i];
		int next = path[i + 1];
		bool fmax = false, fmin = false;
		for (int j = 0; j < p[cur].size(); j++)
			{
				if (p[cur][j] == next)
					fmin = true;
				if (p[cur][j] != next)
					fmax = true;
			}
		if (fmax)
			ansmax++;
		if (fmin == false)
			ansmin++;			
	}
	cout << ansmin << ' ' << ansmax;
    return 0;
}