#include <bits/stdc++.h>
#include <immintrin.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define all(x) begin(x), end(x)
#define fastream ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define endl '\n'
#define mp make_pair
typedef long long ll;
typedef pair<int, int> pii;
typedef long double ldb;

ll t[800000], t_add[800000];
struct segment_tree {
    int n;

    segment_tree(int n, pii a[]) : n(n) {
        build(1, 0, n, a);
    }

    void pull(int v) {
        t[v] = max(t[v << 1], t[(v << 1) + 1]);
    }

    void push(int v, int vl, int vr) {
        if (vl + 1 < vr) {
            t_add[v << 1] += t_add[v];
            t_add[(v << 1) + 1] += t_add[v];
        }
        t[v] += t_add[v];
        t_add[v] = 0;
    }

    void build(int v, int vl, int vr, pii a[]) {
        if (vl + 1 == vr) {
            t[v] = -a[vl].second;
            return;
        }
        int m = (vl + vr) >> 1;
        build(v << 1, vl, m, a);
        build((v << 1) + 1, m, vr, a);
        pull(v);
    }

    void add(int v, int vl, int vr, int l, int r, int val) {
        push(v, vl, vr);
        if (l >= r) {
            return;
        }
        if (vl == l && vr == r) {
            t_add[v] += val;
            push(v, vl, vr);
            return;
        }
        int m = (vl + vr) >> 1;
        add(v << 1, vl, m, l, min(r, m), val);
        add((v << 1) + 1, m, vr, max(l, m), r, val);
        pull(v);
    }

    void add(int l, int r, int val) {
        add(1, 0, n, l, r, val);
    }

    int query(int v, int vl, int vr, int l, int r) {
        push(v, vl, vr);
        if (l >= r) {
            return -2e9;
        }
        if (vl == l && vr == r) {
            return t[v];
        }
        int m = (vl + vr) >> 1;
        int r1 = query(v << 1, vl, m, l, min(r, m));
        int r2 = query((v << 1) + 1, m, vr, max(l, m), r);
        return max(r1, r2);
    }

    int query(int l, int r) {
        return query(1, 0, n, l, r);
    }
};

struct mob {
    int dmg, def, cost;

    mob() = default;
    mob(int dmg, int def, int cost) : dmg(dmg), def(def), cost(cost) {}

    friend istream& operator>>(istream &in, mob &m) {
        in >> m.dmg >> m.def >> m.cost;
        return in;
    }
} mobs[200000];

map<int, int> sta, stb;
pii a[200000], b[200000];
map<int, ll> ar[1000001];

signed main() {
    fastream;
    int n, m, k;
    cin >> n >> m >> k;
    int val, cost;
    for (int i = 0; i < n; i++) {
        cin >> val >> cost;
        if (sta.find(cost) == sta.end()) {
            sta[cost] = val;
        } else {
            sta[cost] = max(sta[cost], val);
        }
    }
    for (int i = 0; i < m; i++) {
        cin >> val >> cost;
        if (stb.find(cost) == stb.end()) {
            stb[cost] = val;
        } else {
            stb[cost] = max(stb[cost], val);
        }
    }
    for (int i = 0; i < k; i++) {
        cin >> mobs[i];
    }
    int mx = 0;
    n = 0;
    for (auto &i : sta) {
        if (i.second > mx) {
            mx = i.second;
            a[n++] = {i.second, i.first};
        }
    }
    mx = 0;
    m = 0;
    for (auto &i : stb) {
        if (i.second > mx) {
            mx = i.second;
            b[m++] = {i.second, i.first};
        }
    }
    for (int i = 0; i < k; i++) {
        ar[mobs[i].dmg][mobs[i].def] = mobs[i].cost;
    }
    int res = -2e9;
    segment_tree stree(m, b);
    for (int i = 0; i < (int)1e6 + 1; i++) {
        for (auto &j : ar[i]) {
            int it = upper_bound(b, b + m, mp(j.first, (int)2e9)) - b;
            if (it == m) {
                continue;
            }
            stree.add(it, m, j.second);
        }
        int it = upper_bound(a, a + n, mp(i, (int)2e9)) - a;
        if (it == n) {
            continue;
        }
        res = max(res, stree.query(0, n) - a[it].second);
    }
    cout << res;
}