#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <queue>
#include <algorithm>

#define pr pair
#define pii pair<int, int>
#define mp make_pair
#define ft first
#define sd second
#define ll long long

using namespace std;

const int INF = 1000000000;

const int MAX_N = 200001;

vector<pii> goodarmor(0);

int c[MAX_N * 4];
int maxincome[MAX_N * 4];

inline void update(int n) {
	maxincome[n] = max(maxincome[2 * n + 1] + c[2 * n + 1], + maxincome[2 * n + 2] + c[2 * n + 2]) ;
}

inline void push (int n) {
	c[2 * n + 1] += c[n];
	c[2 * n + 2] += c[n];
	c[n] = 0;
}

void build(int n, int l, int r) {
	if (r - l == 1)
		maxincome[n] = -goodarmor[l].second;
	else {
		int m = (l + r) / 2;
		build(2 * n + 1, l, m);
		build(2 * n + 2, m, r);
		update(n);
	}
}

void addseg(int n, int l, int r, int l1, int r1, int val) {
	if (l >= r1 || r <= l1)
		return;
	if (l >= l1 && r <= r1) {
		c[n] += val;
		return;
	}
	push(n);
	int m = (l + r) / 2;
	addseg(2 * n + 1, l, m, l1, r1, val);
	addseg(2 * n + 2, m, r, l1, r1, val);
	update(n);
}

int ask(int n, int l, int r) {
	if (l == r - 1)
		return maxincome[n] + c[n];
	int m = (l + r) / 2;
	push(n);
	int ans;
	if (maxincome[2 * n + 1] + c[2 * n + 1] > maxincome[2 * n + 2] + c[2 * n + 2])
		ans = ask(2 * n + 1, l, m);
	else
		ans = ask(2 * n + 2, m, r);
	update(n);
	return ans;
}

struct monster {
	int x, y, z;
	monster(){};
	inline monster(int a, int b, int c) {
		x = a;
		y = b;
		z = c;
	}
	const bool operator<(const monster& other) {
		return x < other.x  || (x == other.x && y < other.x);
	}
};

int main() {
	cin.tie(NULL);
	cout.tie(NULL);
	ios_base::sync_with_stdio(false);
	int n, m, p;
	cin >> n >> m >> p;
	vector<pair<int, int>> weapons(n), armor(m);
	for (int i = 0; i < n; i++) {
		cin >> weapons[i].ft >> weapons[i].sd;
		weapons[i].sd *= -1;
	}
	for (int i = 0; i < m; i++) {
		cin >> armor[i].ft >> armor[i].sd;
		armor[i].sd *= -1;
	}

	sort(weapons.begin(), weapons.end());
	vector<pii> goodweapons(0);
	goodweapons.reserve(n);
	goodweapons.push_back(weapons[n - 1]);
	goodweapons.back().second *= -1;
	for (int i = n - 2; i >= 0; i--)
		if (weapons[i].first < goodweapons.back().first && weapons[i].second > -goodweapons.back().second) {
			goodweapons.push_back(weapons[i]);
			goodweapons.back().second *= -1;
		}
	reverse(goodweapons.begin(), goodweapons.end());

	sort(armor.begin(), armor.end());
	
	goodarmor.reserve(m);
	goodarmor.reserve(n);
	goodarmor.push_back(armor[m - 1]);
	goodarmor.back().second *= -1;
	for (int i = m - 2; i >= 0; i--)
		if (armor[i].first < goodarmor.back().first && armor[i].second > -goodarmor.back().second) {
			goodarmor.push_back(armor[i]);
			goodarmor.back().second *= -1;
		}
	reverse(goodarmor.begin(), goodarmor.end());
	
	int k = p;
	vector<monster> monsters(k);
	for (int i = 0; i < k; i++) {
		int x, y, z;
		cin >> x >> y >> z;
		monsters[i] = monster(x, y, z);
	}
	sort(monsters.begin(), monsters.end());

	m = goodarmor.size();
	n = goodweapons.size();
	build(0, 0, m);
	int ans = -2 * INF - 228;
	for (int i = 0; i < k; i++) {
		int curweapon = upper_bound(goodweapons.begin(), goodweapons.end(), mp(monsters[i].x + 1, -1)) - goodweapons.begin();
		if (curweapon == n)
			break;
		int curans = -goodweapons[curweapon].second;
		int curarmor = upper_bound(goodarmor.begin(), goodarmor.end(), mp(monsters[i].y + 1, -1)) - goodarmor.begin();
		addseg(0, 0, m, curarmor, m, monsters[i].z);
		curans += ask(0, 0, m);
		ans = max(ans, curans);
	}
	cout << ans;
	int zero = 0;
}