#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include "queue"
#define all(a) (a).begin(), (a).end()
#define ll long long
#define int long long
#define F first
#define S second

using namespace std;

const int INF = 1000000000;

int n, m, k, s, t;
const int MAXN = 200007;
vector<int> graph[MAXN], rgraph[MAXN];
int dist[MAXN];
vector<int> from[MAXN];
int p[MAXN];


signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(0);
    cin.sync_with_stdio(0);
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        graph[u].push_back(v);
        rgraph[v].push_back(u);
    }
    cin >> k;
    for (int i = 0; i < k; ++i) {
        cin >> p[i];
        --p[i];
    }
    s = p[0];
    t = p[k - 1];
    for (int i = 0; i < n; ++i) {
        dist[i] = INF;
    }
    dist[t] = 0;
    int ans_min = 0, ans_max = 0;
    queue<int> q;
    q.push(t);
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        for (auto v : rgraph[u]) {
            if (dist[v] > dist[u] + 1) {
                from[v].clear();
                dist[v] = dist[u] + 1;
                from[v].push_back(u);
                q.push(v);
            } else if (dist[v] == dist[u] + 1) {
                from[v].push_back(u);
            }
        }
    }
    for (int i = 0; i + 1 < k; ++i) {
        int u = p[i], v = p[i + 1];
        if (dist[u] != dist[v] + 1) {
            ++ans_min;
            ++ans_max;
        } else {
            if (from[u].size() > 1) {
                ++ans_max;
            }
        }

    }
    cout << ans_min << ' ' << ans_max;
    return 0;
}