#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

//#define int ll
#define sz(a) (int)a.size()
#define ALL(a) a.begin(), a.end()
#define RALL(a) a.rbegin(), a.rend()
#define F first
#define S second
#define pb push_back
#define eb emplace_back

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<double> vd;
typedef vector<char> vc;
typedef vector<bool> vb;
typedef vector<pii> vpii;
typedef vector<pll> vpll;
typedef tuple<int, int, int> tiii;
typedef vector<tiii> vtiii;

const int INF = 1e9;
const ll INFLL = 1e18;
//const int M = 1e9 + 7;

class Tree {
public:
    Tree(int n_) {
        n = 1;
        while (n < n_)
            n *= 2;
        t.assign(2 * n, 0);
        d.assign(2 * n, 0);
    }

    //[l; r)
    void update(int l, int r, int x) {
        _update(1, 0, n, l, r, x);
    }

    //[l; r)
    int query(int l, int r) {
        return _query(1, 0, n, l, r);
    }

private:
    int n;
    vi t, d;

    void push(int p) {
        d[2 * p] += d[p];
        d[2 * p + 1] += d[p];
        t[p] += d[p];
        d[p] = 0;
    }

    void recalc(int p) {
        t[p] = max(t[2 * p] + d[2 * p], t[2 * p + 1] + d[2 * p + 1]);
    }

    void _update(int p, int a, int b, int l, int r, int x) {
        if (b <= l || r <= a)
            return;
        if (l <= a && b <= r) {
            d[p] += x;
            return;
        }
        int m = (a + b) / 2;
        push(p);
        _update(2 * p, a, m, l, r, x);
        _update(2 * p + 1, m, b, l, r, x);
        recalc(p);
    }

    int _query(int p, int a, int b, int l, int r) {
        if (b <= l || r <= a)
            return -2 * INF;
        if (l <= a && b <= r)
            return t[p] + d[p];
        int m = (a + b) / 2;
        push(p);
        int f = max(_query(2 * p, a, m, l, r),
                _query(2 * p + 1, m, b, l, r));
        recalc(p);
        return f;
    }
};

void testTree() {
    int n = 1000;
    vi a(n, 0);
    Tree tree(n);
    srand(time(0));
    for (int i = 0; i < n; ++i) {
        int l = rand() % n;
        int r = rand() % (n - l) + l;
        int t = rand() % 2;
        if (t) {
            int v = rand() % 1000 - 500;
            for (int j = l; j < r; ++j)
                a[j] += v;
            tree.update(l, r, v);
        } else {
            int v = -INF;
            for (int j = l; j < r; ++j)
                v = max(v, a[j]);
            if (tree.query(l, r) != v)
                throw;
        }
    }
    cout << "";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

//    testTree();

    int n, m, p;
    cin >> n >> m >> p;

    vi a(n), ca(n), seq_a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i] >> ca[i], seq_a[i] = i;

    vi b(m), cb(m), seq_b(m), t_b(m);
    vpii tos_b(m);
    for (int i = 0; i < m; ++i)
        cin >> b[i] >> cb[i], seq_b[i] = i, tos_b[i] = {b[i], i};
    sort(ALL(tos_b));

    vi x(p), y(p), z(p), seq_x(p), seq_y(p), t_y(p);
    vpii tos_y(p);
    for (int i = 0; i < p; ++i)
        cin >> x[i] >> y[i] >> z[i], seq_x[i] = i, seq_y[i] = i;


    sort(ALL(seq_a), [&](int i, int j) -> bool {
        return a[i] < a[j];
    });
    sort(ALL(seq_b), [&](int i, int j) -> bool {
        return b[i] < b[j];
    });
    sort(ALL(seq_x), [&](int i, int j) -> bool {
        return x[i] < x[j];
    });
    sort(ALL(seq_y), [&](int i, int j) -> bool {
        return y[i] < y[j];
    });

    for (int i = 0; i < p; ++i)
        t_y[seq_y[i]] = i;
    for (int i = 0; i < m; ++i)
        t_b[seq_b[i]] = i;

    Tree tree(p);
    vi suffmin(m, INF);
    suffmin[m - 1] = cb[seq_b[m - 1]];
    for (int i = m - 2; i >= 0; --i)
        suffmin[i] = min(cb[seq_b[i]], suffmin[i + 1]);
    int max_p = p;
    for (int i = 0; i < p; ++i) {
        int v = seq_y[i];
        auto it = upper_bound(ALL(tos_b), pii(y[v], INF));
        if (it != tos_b.end()) {
            tree.update(i, i + 1, -suffmin[t_b[it->S]]);
        } else {
            max_p = i;
            break;
        }
    }

    int h = -1;
    ll ans = -*min_element(ALL(ca)) -*min_element(ALL(cb));
    for (int i : seq_a) {
        while (h + 1 < p && x[seq_x[h + 1]] < a[i]) {
            ++h;
            int j = seq_x[h];
            if (t_y[j] < max_p) {
                tree.update(t_y[j], max_p, z[j]);
                ll q = tree.query(0, max_p);
                ans = max(ans, q - ca[i]);
            }
        }
    }
    cout << ans << "\n";
}
