#define _CRT_SECURE_NO_WARNINGS
#include <cassert>
#include <iostream>
#include <vector>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <queue>
#include <iomanip>

using namespace std;

#define mp make_pair
#define mt make_tuple
#define size(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.begin(), x.rend()

typedef long long LL;
typedef long double LD;

template <typename T>
bool uin(T &a, const T &b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template <typename T> 
bool uax(T &a, const T &b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const LL LINF = 1e15;
const int N = (int)2e5 + 7;
const int INF = (int)1e9 + 7;
const int MOD = (int)1e9 + 7;
const int MAXN = (int)1e6 + 7;

/////////////////////////////////////////////////////////////////////////

int n, m, k, p[N];
pair <int, int> dist[N];
vector <int> gr[N], rg[N];

void bfs() {
	int s = p[0], t = p[k - 1];
	fill(dist, dist + n, mp(INF, 1));
	queue <int> q;
	q.push(t);
	dist[t] = mp(0, 1);
	while (!q.empty()) {
		int u = q.front();
		q.pop();
		for (int i = 0; i < size(rg[u]); i++) {
			int v = rg[u][i];
			if (uin(dist[v].first, dist[u].first + 1)) {
				dist[v] = dist[u];
				dist[v].first++;
				q.push(v);
				continue;
			}
			if (dist[v].first == dist[u].first + 1) 
				dist[v].second += dist[u].second;
		}
	}
}

int main() {
	cout << fixed << setprecision(20);
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	cin.tie(0), cout.tie(0);
	ios_base::sync_with_stdio(0);
#endif 
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--, v--;
		gr[u].push_back(v);
		rg[v].push_back(u);
	}
	cin >> k;
	for (int i = 0; i < k; i++) {
		cin >> p[i];
		p[i]--;
	}
	bfs();
	int mn = 0, mx = 0;
	for (int i = 0; i < k - 1; i++) {
		int u = p[i], v = p[i + 1];
		if (dist[u].first == dist[v].first + 1 && dist[u].second == dist[v].second) 
			continue;
		mx++;
		if (dist[u].first < dist[v].first + 1) 
			mn++;
	}
	cout << mn << ' ' << mx;
}