#define _CRT_SECURE_NO_WARNINGS
#include <cassert>
#include <iostream>
#include <vector>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <iomanip>

using namespace std;

#define mp make_pair
#define mt make_tuple
#define size(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.begin(), x.rend()

typedef long long LL;
typedef long double LD;

template <typename T>
bool uin(T &a, const T &b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template <typename T> 
bool uax(T &a, const T &b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const LL LINF = 1e15;
const int N = (int)2e5 + 7;
const int INF = (int)1e9 + 7;
const int MOD = (int)1e9 + 7;
const int MAXN = (int)1e6 + 7; 

/////////////////////////////////////////////////////////////////////////

int n, m, p, kek[N];
pair <int, int> a[N], b[N];
pair <pair<int, int>, int> mon[N];

LL tr[N], ph[N];

void push(int v, int l, int r) {
	tr[v] += ph[v];
	if (l == r) {
		ph[v] = 0;
		return;
	}
	ph[2 * v] += ph[v];
	ph[2 * v + 1] += ph[v];
	ph[v] = 0;
}

void relax(int v) {
	tr[v] = max(tr[2 * v], tr[2 * v + 1]);
}

void build(int v, int l, int r) {
	if (l == r) {
		tr[v] = -b[l].second;
		return;
	}
	int m = (r + l) / 2;
	build(2 * v, l, m);
	build(2 * v + 1, m + 1, r);
	relax(v);
}

void update(int v, int l, int r, int ql, int qr, int val) {
	push(v, l, r);
	if (ql <= l && r <= qr) {
		ph[v] += val;
		push(v, l, r);
		return;
	}
	if (l > qr || ql > r) 
		return;
	int m = (r + l) / 2;
	update(2 * v, l, m, ql, qr, val);
	update(2 * v + 1, m + 1, r, ql, qr, val);
	relax(v);
}

LL get_max() {
	return tr[1];
}

int main() {
	cout << fixed << setprecision(20);
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	cin.tie(0), cout.tie(0);
	ios_base::sync_with_stdio(0);
#endif 
	cin >> n >> m >> p;
	for (int i = 0; i < n; i++) 
		cin >> a[i].first >> a[i].second;
	for (int i = 0; i < m; i++) {
		cin >> b[i].first >> b[i].second;
		kek[i] = b[i].first;
	}
	for (int i = 0; i < p; i++) 
		cin >> mon[i].first.first >> mon[i].first.second >> mon[i].second;
	sort(a, a + n);
	sort(b, b + m);
	sort(kek, kek + m);
	sort(mon, mon + p);
	build(1, 0, m - 1);
	int ind = 0;
	LL ans = -LINF;
	for (int i = 0; i < n; i++) {
		while (ind < p && a[i].first > mon[ind].first.first) {
			int pos = upper_bound(kek, kek + m, mon[ind].first.second) - kek;
			if (pos == m) {
				ind++;
				continue;
			}
			update(1, 0, m - 1, pos, m - 1, mon[ind].second);
			ind++;
		}
		LL res = get_max() - a[i].second;
		uax(ans, res);
	}
	cout << ans;
}