#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <queue>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
typedef long long ll;
typedef long double ld;

const ll SIZE = 1e5 * 8, INF = 1e9;

vector<ll> vec;
vector<vector<ll>> graph, normGr;
ll q, dist[SIZE];
bool used[SIZE];

ll gcd(ll a, ll b) {
	if(a == 0) {
		return b;
	} else {
		return gcd(b % a, a);
	}
}

void bfs(int v) {
	used[v] = true;
	dist[v] = 0;
	queue<ll> q;
	q.push(v);
	while(!q.empty()) {
		ll v = q.front();
		q.pop();

		for(auto to : graph[v]) {
			if(!used[to]) {
				used[to] = true;
				dist[to] = dist[v] + 1;
				q.push(to);
			}
		}
	}
}

int main() {
	fastInp;

	ll n, m;
	cin >> n >> m;

	graph.resize(n);
	normGr.resize(n);
	for(int i = 0; i < n; i++) dist[i] = INF;
	for(int i = 0; i < m; i++) {
		ll u, v;
		cin >> u >> v;
		u--; v--;
		graph[v].push_back(u);
		normGr[u].push_back(v);
	}

	vector<ll> w;
	ll t;
	cin >> t;
	w.resize(t);
	for (int i = 0; i < w.size(); i++) cin >> w[i];
	for(int i = 0; i < w.size(); i++) w[i]--;
	bfs(w[w.size() - 1]);

	ll minN = 0, maxN = 0, prev;

	prev = dist[w[0]];
	for(int i = 0; i < w.size(); i++) {
		if(dist[w[i]] != prev) {
			minN++;
			prev = dist[w[i]];
			prev--;
			maxN++;
		} else {
			if(i > 0) {
				bool flag = false;
				for(auto to : normGr[w[i - 1]]) {
					if(dist[to] == dist[w[i]] && to != w[i]) flag = true;
				}
				maxN += flag;
			}
			prev--;
		}
	}

	cout << minN << " " << maxN;
	return 0;
}