#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <queue>
#include <map>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
typedef long long ll;
typedef long double ld;

const ll SIZE = 16, INF = 1e9;

struct bl {
	ll x, y, z;
};
vector<ll> vec;
vector<vector<ll>> graph, normGr;
ll q, dist[SIZE];
bool used[SIZE];
vector<pair<ll, ll>> weap, arm;
vector<bl> enem;
map<ll, ll> pr;

bool comp(bl bl1, bl bl2) {
	if(bl1.x < bl2.x) return true;
	if(bl2.x < bl1.x) return false;
	if(bl1.y < bl2.y) return true;
	if(bl2.y < bl1.y) return false;
	if(bl1.z < bl2.z) return true;
	return false;
}

ll tree[SIZE * 16], pushing[SIZE * 16], tree2[SIZE * 16];

void push(int v, int l, int r) {
	tree[v] += pushing[v] * (r - l);
	tree2[v] += pushing[v];
	pushing[v * 2 + 1] += pushing[v];
	pushing[v * 2 + 2] += pushing[v];
	pushing[v] = 0;
}

void upd(int v, int l, int r, int askl, int askr, int val, int k = -1) {
	push(v, l, r);
	if(r <= askl || l >= askr) return;

	if(l >= askl && r <= askr) {
		pushing[v] += val;
		push(v, l, r);
		return;
	}

	int mid = (l + r) / 2;
	upd(v * 2 + 1, l, mid, askl, askr, val);
	upd(v * 2 + 2, mid, r, askl, askr, val);

	tree[v] = tree[v * 2 + 1] + tree[v * 2 + 2];
	tree2[v] = max(tree2[v * 2 + 1], tree2[v * 2 + 2]);
}

ll get(int v, int l, int r, int askl, int askr) {
	push(v, l, r);
	if(r <= askl || l >= askr) return 0;

	if(l >= askl && r <= askr) {
		return tree[v];
	}

	int mid = (l + r) / 2;
	return get(v * 2 + 1, l, mid, askl, askr) + get(v * 2 + 2, mid, r, askl, askr);
}


int main() {
	fastInp;

	ll n, m, p;
	cin >> n >> m >> p;
	weap.resize(n);

	for(int i = 0; i < n; i++) {
		cin >> weap[i].first >> weap[i].second;
		weap[i].first;
	}

	weap.push_back({ SIZE, INF });
	sort(weap.begin(), weap.end());
	for(int i = 0; i < weap.size(); i++) {
		if(i > 0 && weap[i].first >= weap[i - 1].first && weap[i].second <= weap[i - 1].second) {
			weap[i - 1].second = weap[i].second;
		} else {
			ll st = 0;
			if(i > 0) st = weap[i - 1].first + 1;
			upd(0, 0, SIZE, st, weap[i].first + 1, -weap[i].second);
		}
	}

	arm.resize(m);
	for(int i = 0; i < m; i++) {
		cin >> arm[i].first >> arm[i].second;
		arm[i].first;
	}

	sort(arm.begin(), arm.end());
	for(int i = 0; i < arm.size(); i++) {
		if(i > 0 && arm[i].first >= arm[i - 1].first && arm[i].second <= arm[i - 1].second) {
			arm[i - 1].second = arm[i].second;
		}
	}

	enem.resize(p);
	for(int i = 0; i < p; i++) {
		cin >> enem[i].x >> enem[i].y >> enem[i].z;
		enem[i].x++;
		enem[i].y++;
	}

	sort(enem.begin(), enem.end(), comp);

	ll curArm = 0, ans = -INF;
	for(int i = 0; i < enem.size(); i++) {
		while(arm[curArm].first < enem[i].y) curArm++;
		upd(0, 0, SIZE, enem[i].x, SIZE, enem[i].z, 1);
		ans = max(ans, -arm[curArm].second + tree2[0]);
	}

	cout << ans;
	return 0;
}