#include <bits/stdc++.h>
#define pb push_back

typedef long long ll;
using namespace std;

const ll MAXN = +100500 * 2;
const ll INF  = 1e18;

struct Monster {
    ll atk;
    ll def;
    ll rew;
    Monster() {
        atk = def = rew = 0;
    }
    void input() {
        cin >> def >> atk >> rew;
    }
};

bool comp_def(Monster a, Monster b) {
    return a.def < b.def;
}

struct Device {
    ll efi;
    ll cost;
    Device() {
        efi = cost = 0;
    }
    void input() {
        cin >> efi >> cost;
    }
};

bool comp_efi(Device a, Device b) {
    return a.efi < b.efi;
}

ll n, m, p;

ll base[MAXN];
ll t[MAXN * 4];
ll mark[MAXN * 4];

void build(ll v = 0, ll tl = 0, ll tr = m) {
    if (tr - tl == 1) {
        t[v] = base[tl];
        return;
    }
    ll mid = (tl + tr) / 2;
    build (v * 2 + 1, tl, mid);
    build (v * 2 + 2, mid, tr);
    t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
}

void push(ll v, bool is_leaf = false) {
    t[v] += mark[v];
    if (!is_leaf) {
        mark[v * 2 + 1] += mark[v];
        mark[v * 2 + 2] += mark[v];
    }
    mark[v] = 0;
}

void upd(ll border, ll val, ll v = 0, ll tl = 0, ll tr = m) {
    if (tr <= border) return;
    push(v, (tr - 1 == tl));
    if (tl >= border) {
        mark[v] += val;
        push(v, (tr - 1 == tl));
        return;
    }
    ll mid = (tl + tr) / 2;
    upd(border, val, v * 2 + 1, tl, mid);
    upd(border, val, v * 2 + 2, mid, tr);
    t[v] = max (t[v * 2 + 1], t[v * 2 + 2]);
}

Device sword[MAXN];
Device shield[MAXN];
Monster menace[MAXN];

int main() {
    cin >> n >> m >> p;
    for (int i = 0; i < n; i++) {
        sword[i].input();
    }
    for (int j = 0; j < m; j++) {
        shield[j].input();
    }
    for (int i = 0; i < p; i++) {
        menace[i].input();
    }
    sort (sword, sword + n, comp_efi);
    sort (shield, shield + m, comp_efi);
    sort (menace, menace + p, comp_def);
    for (int i = 0; i < m; i++) {
        base[i] = -shield[i].cost;
    }
    build();
    ll cur_monster = 0;
    ll cur_sword = 0;
    ll mx = -INF;
    while (cur_monster != p) {
        while (cur_sword < n && sword[cur_sword].efi <= menace[cur_monster].def) {
            cur_sword++;
        }
        if (cur_sword == n) break;
        ll l = 0;
        ll r = m;
        while (r - l > 1) {
            ll mid = (r + l) / 2;
            if (shield[mid].efi > menace[cur_monster].atk) {
                r = mid;
            } else {
                l = mid;
            }
        }
        ll cur_shield = r;
        if (shield[l].efi > menace[cur_monster].atk) cur_shield = l;
        if (cur_shield != m) {
            upd (cur_shield, menace[cur_monster].rew);
        }
        mx = max(mx, t[0] + mark[0] - sword[cur_sword].cost);
        cur_monster++;
    }
    cout << mx;
}
