#include<bits/stdc++.h>
using namespace std;
#define int long long
#define pii pair<int, int>
#define all(a) (a).begin(), (a).end()
int n, m, p;

const int maxp = 1e6 + 10;



struct segment_tree {
    vector<int> tree;
    vector<int> push;
    int n;
    segment_tree() {}

    void build(const vector<int> &a, int v, int tl, int tr) {
        if (tl + 1 == tr) {
            tree[v] = a[tl];
            return;
        }
        int tm = (tl + tr) / 2;
        build(a, 2 * v + 1, tl, tm);
        build(a, 2 * v + 2, tm, tr);
        tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
    }

    void push_f(int v, int sz) {
        tree[v] += push[v];
        if (sz != 1) {
            push[2 * v + 1] += push[v];
            push[2 * v + 2] += push[v];
        }
        push[v] = 0;
    }

    segment_tree(const vector<int> &a) {
        n = a.size();
        tree.resize(4 * n);
        push.resize(4 * n);
        build(a, 0, 0, n);
    }

    void upd(int v, int tl, int tr, int l, int r, int p) {
        push_f(v, tr - tl);
        if (tl >= r || tr <= l) return;
        if (tl >= l && tr <= r) {
            push[v] += p;
            push_f(v, tr - tl);
            return;
        }
        int tm = (tl + tr) / 2;
        upd(2 * v + 1, tl, tm, l, r, p);
        upd(2 * v + 2, tm, tr, l, r, p);
        tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
    }
    void update(int l, int pl) {
        upd(0, 0, n, l, maxp, pl);
    }
    int get() {
        return tree[0];
    }
};





struct pr {
     int v;
     int c;
    pr() {}
    pr(int v_, int c_) {
        v = v_;
        c = c_;
    }
};

struct tr {
     int x, y, z;
    tr() {}
    tr(int x_, int y_, int z_) {
        x = x_; y = y_; z = z_;
    }
};

bool cmp(pr a, pr b) {
    if (a.c == b.c) {
        return a.v > b.v;
    }
    return a.c < b.c;
}

bool cmp1(tr a, tr b) {
    return a.x < b.x;
}



vector<pr> at;
vector<pr> br;
vector<tr> mn;

void clear(vector<pr> &vec) {
    int mxv = -1;
    int pos = 0;
    for (int i = 0; i < vec.size(); i++) {
        if (vec[i].v > mxv) {
            mxv = vec[i].v;
            vec[pos] = vec[i];
            pos++;
        }
    }
    vec.resize(pos);
}

void solve() {
    sort(all(at), cmp);
    sort(all(br), cmp);
    clear(at);
    clear(br);

   

    n = at.size();
    m = br.size();
    sort(all(mn), cmp1);
    
    // for (int i = 0; i < m; i++) {
    //     cout << br[i].v << ' ' << br[i].c << '\n';
    // }


    vector<int> money(maxp);

    int posb = 0;
    br.push_back(pr(1e7, 5e9));
    for (int i = 0; i < maxp; i++) {
        while (br[posb].v <= i) {
            posb++;
        }
        money[i] = -br[posb].c;
    }
    // for (int i = 0; i < 10; i++) {
    //     cout << money[i] << ' ';
    // }
    // cout << '\n';

    segment_tree tree = segment_tree(money);    

    int pos_mn = 0;
    int ans = -3e9;
    for (int i = 0; i < n; i++) {
        // cout << at[i].v << '\n';
        // cout << mn[pos_mn].x << ' '  << at[i].v << '\n';
        while(pos_mn < p && mn[pos_mn].x < at[i].v) {
            tree.update(mn[pos_mn].y, mn[pos_mn].z);
            // cout << mn[pos_mn].y << ' ' << mn[pos_mn].z << '\n';
            pos_mn++;
        }
        ans = max(ans, tree.get() - at[i].c);
        // cout << tree.get() - at[i].c << '\n';
    }
    cout << ans;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> p;
    at.resize(n);
    br.resize(m);
    mn.resize(p);
    int v, c;
    for (int i = 0; i < n; i++) {
        cin >> v >> c;
        at[i] = pr(v, c);
    }
    for (int i = 0; i < m; i++) {
        cin >> v >> c;
        br[i] = pr(v, c);
    }
    int x, y, z;
    for (int i = 0; i < p; i++) {
        cin >> x >> y >> z;
        mn[i] = tr(x, y, z);
    }

    solve();
}