/*
	cCreated by Kazalika for Technocup 2020
*/

#define _CRT_SECURE_NO_WARNINGS
#include <vector>
#include <string>
#include <iostream>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
using namespace std;
typedef long long ll;
typedef double db;
typedef long double ldb;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vint;
typedef vector<ll> vll;
#define forn(a, i, n) for (int i = a; i < n; ++i)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) int(x.size())
const int N = 1e6 + 10;
const ll inf = 1e12;
const ll base = 257, MOD = 1e9 + 7;

ll sq(ll a) {return a * a;}
ll gcd(ll a, ll b) { 
	if (a < b) swap(a, b);
	if (a % b == 0) return b;
	return gcd(b, a % b);
}
ll lcm(ll a, ll b) { return a / gcd(a, b) * b; }

struct Segment_Tree {
	int size;
	vector <ll> tree, add;
	void build(int t, int l, int r, vll & v) {
		if (l + 1 == r) {
			tree[t] = v[l];
			return;
		}
		int mid = r + l >> 1;
		build(t * 2 + 1, l, mid, v);
		build(t * 2 + 2, mid, r, v);
		tree[t] = max(tree[t * 2 + 1], tree[t * 2 + 2]);
	}
	void push(int t, int l, int r) {
		if (add[t] == 0) return;
		tree[t] += add[t];
		if (l + 1 != r) {
			add[t * 2 + 1] += add[t];
			add[t * 2 + 2] += add[t];
		}
		add[t] = 0;
	}
	Segment_Tree(vll & v) {
		size = sz(v);
		tree.resize(4 * size);
		add.resize(4 * size);
		build(0, 0, size, v);
	}
	Segment_Tree(int size) : size(size) {
		tree.resize(4 * size);
		add.resize(4 * size);
	}
	void modify(int t, int l, int r, int x, int y, ll val) {
		push(t, l, r);
		if (l >= y || r <= x) return;
		if (l >= x && r <= y) {
			add[t] += val;
			push(t, l, r);
			return;
		}
		int mid = (r + l) >> 1;
		modify(t * 2 + 1, l, mid, x, y, val);
		modify(t * 2 + 2, mid, r, x, y, val);
		tree[t] = max(tree[t * 2 + 1], tree[t * 2 + 2]);
	}
	ll get(int t, int l, int r, int x, int y) {
		push(t, l, r);
		if (l >= y || r <= x) return -inf;
		if (l >= x && r <= y) 
			return tree[t];
		int mid = (r + l) >> 1;
		return max(get(t * 2 + 1, l, mid, x, y), get(t * 2 + 2, mid, r, x, y));
	}
	ll get(int l, int r) {
		return get(0, 0, size, l, r + 1);
	}
	void modify(int l, int r, ll val) {
		modify(0, 0, size, l, r + 1, val);
	}
};

struct mon {
	ll x, y, z, cost;
	mon() {}
	mon(ll x, ll y, ll z) : x(x), y(y), z(z) {}
};

int n, m, p;
vector <pll> A, B;
vector <mon> MON;

bool cmp(pll a, pll b) {
	return a.second < b.second || a.second == b.second && a.first > b.first;
}


int main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0); 
	//calcPowers();
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	
	cin >> n >> m >> p;
	A.resize(n); B.resize(m); MON.resize(p);
	forn(0, i, n) {
		cin >> A[i].first >> A[i].second;
	}
	sort(all(A), cmp);
	forn(1, i, n) 
		A[i].first = max(A[i].first, A[i - 1].first);
	
	forn(0, i, m) {
		cin >> B[i].first >> B[i].second;
	}
	sort(all(B), cmp);
	forn(1, i, m) 
		B[i].first = max(B[i].first, B[i - 1].first);

	forn(0, i, p) {
		cin >> MON[i].x >> MON[i].y >> MON[i].z;
	}
	sort(all(MON), [&](mon a, mon b) { return a.y < b.y; } );

	vll inST(N + 10, inf);
	int j = m - 1;
	ll minv = inf;
	for (int i = N + 9; i >= 0; i--) {
		while (j >= 0 && B[j].first >= i) {
			minv = min(minv, B[j].second);
			j--;
		}
		inST[i] = -minv;
	}

	Segment_Tree ST(inST);

	j = 0;
	forn(0, i, p) {
		while (j < m && B[j].first <= MON[i].y) j++;
		if (j < m)
			MON[i].cost = B[j].first;
		else
			MON[i].cost = inf;
	}
	j = 0;
	sort(all(MON), [&](mon a, mon b) { return a.x < b.x; } );
	ll res = -inf;
	forn(0, i, n) {
		while (j < p && MON[j].x < A[i].first) {
			if (MON[j].cost <= N) {
				ST.modify(MON[j].cost, N + 1, MON[j].z);
			}
			j++;
		}
		res = max(res, ST.get(0, N + 1) - A[i].second);
	}
	cout << res;
	
	
}