#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <queue>
#include <unordered_set>


using namespace std;


const int INF = (int)1e6;


void optmize() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}


int main() {
    int n, m;
    cin >> n >> m;

    vector<vector<int>> graph(n), rgraph(n);

    int from, to;
    for (int i = 0; i < m; ++i) {
        cin >> from >> to;

        --from;
        --to;

        graph[from].push_back(to);
        rgraph[to].push_back(from);
    }

    int k;
    cin >> k;

    vector<int> p(k);
    for (int i = 0; i < k; ++i) {
        cin >> p[i];

        --p[i];
    }

    int s = p[0];
    int t = p[k - 1];

    vector<int> d(n, INF);
    d[t] = 0;
    queue<int> bfs;
    bfs.push(t);

    while (bfs.size()) {
        int v = bfs.front();

        bfs.pop();

        for (int u : rgraph[v]) {
            if (d[u] > d[v] + 1) {
                d[u] = d[v] + 1;

                bfs.push(u);
            }
        }
    }

    vector<unordered_set<int>> choice(n);
    for (int v = 0; v < n; ++v) {
        for (int u : graph[v]) {
            if (d[u] == d[v] - 1) {
                choice[v].insert(u);
            }
        }
    }

    int mina = 0, maxa = 0;
    for (int i = 0; i < k - 1; ++i) {
        int cv = p[i];
        int nv = p[i + 1];

        if (choice[cv].find(nv) == choice[cv].end()) {
            ++mina;
        }

        if (choice[cv].size() > 1 || *choice[cv].begin() != nv) {
            ++maxa;
        }
    }

    cout << mina << ' ' << maxa;

    return 0;
}
