#include <iostream>
#include <vector>
#include <string>
#include <algorithm>


using namespace std;


#define int long long


void optmize() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}


int M = (int)1e7 + 9;
int P = 57;


const int MAXN = (int)2e5 + 1;

int PPOW[MAXN];


vector<int> ph[2], zcnt;


int mod(int x) {
    x %= M;

    if (x < 0) {
        return x + M;
    }

    return x;
}


int shash(int a, int len) {
    int disp = a % 2;

    return mod(ph[disp][a + len] - ph[disp][a] * PPOW[zcnt[a + len] - zcnt[a]]);
}


signed main() {
    optmize();

    PPOW[0] = 1;
    for (int i = 1; i < MAXN; ++i) {
        PPOW[i] = PPOW[i - 1] * P % M;
    }

    int n;
    string s;
    cin >> n >> s;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        a[i] = (s[i] == '0');
    }

    ph[0].resize(n + 1);
    ph[1].resize(n + 1);
    zcnt.resize(n + 1);

    for (int i = 0; i < n; ++i) {
        zcnt[i + 1] = zcnt[i];

        if (a[i] == 0) {
            ph[0][i + 1] = ph[0][i];
            ph[1][i + 1] = ph[1][i];

            continue;
        }

        ++zcnt[i + 1];

        int par = i % 2;

        for (int c = 0; c < 2; ++c) {
            ph[c][i + 1] = (ph[c][i] * P + 1 + (par ^ c)) % M;
        }
    }

    int q;
    cin >> q;

    int l1, l2, len;
    while (q--) {
        cin >> l1 >> l2 >> len;

        --l1;
        --l2;

        if (shash(l1, len) == shash(l2, len)) {
            cout << "Yes";
        } else {
            cout << "No";
        }

        cout << '\n';
    }

    return 0;
}

/*

10
1101110111
10


*/