#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define int long long
#define ff first
#define ss second
#define pb push_back
#define all(v) v.begin(), v.end()

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int N = 200000 + 5, M = 1000005;
const ll inf = 1000000000000000000;
ll t[M * 4], mod[M * 4];

int n, m, p;
ll cost_a[M], cost_b[M];

void build(int v, int tl, int tr){
    if (tl == tr){
        t[v] = -cost_b[tl];
        return;
    }
    int tm = (tl + tr) / 2;
    build(v * 2, tl, tm);
    build(v * 2 + 1, tm + 1, tr);
    t[v] = max(t[v * 2], t[v * 2 + 1]);
}

void push(int v){
    if (mod[v]){
        if (v * 2 < 4 * M){
            mod[v * 2] += mod[v];
            t[v * 2] += mod[v];
        }
        if (v * 2 + 1 < 4 * M){
            mod[v * 2 + 1] += mod[v];
            t[v * 2 + 1] += mod[v];
        }
        mod[v] = 0;
    }
}

void add(int v, int tl, int tr, int l, int r, int val){
    if (l > r) return;
    if (tl == l && tr == r){
        mod[v] += val;
        t[v] += val;
        return;
    }
    push(v);
    int tm = (tl + tr) / 2;
    add(v * 2, tl, tm, l, min(tm, r), val);
    add(v * 2 + 1, tm + 1, tr, max(tm + 1, l), r, val);
    t[v] = max(t[v * 2], t[v * 2 + 1]);
}

ll get_max(int v, int tl, int tr, int l, int r){
    if (l > r) return -inf;
    if (tl == l && tr == r){
        return t[v];
    }
    push(v);
    int tm = (tl + tr) / 2;
    return max(
        get_max(v * 2, tl, tm, l, min(r, tm)),
        get_max(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r)
    );
}

struct obj{
    int x, y, z;
    obj(){}
    obj(int _x, int _y, int _z){
        x = _x;
        y = _y;
        z = _z;
    }
};

vector <obj> v;

bool cmp(obj a, obj b){
    return a.x < b.x;
}

int32_t main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m >> p;
    fill(cost_a, cost_a + M, inf);
    fill(cost_b, cost_b + M, inf);
    for (int i = 0; i < n; i++){
        ll a, ca;
        cin >> a >> ca;
        a--;
        cost_a[a] = min(cost_a[a], ca);
    }
    ll mn = inf;
    for (int i = M - 1; i >= 0; i--){
        mn = min(mn, cost_a[i]);
        cost_a[i] = mn;
    }
    for (int i = 0; i < m; i++){
        ll b, cb;
        cin >> b >> cb;
        b--;
        cost_b[b] = min(cost_b[b], cb);
    }
    mn = inf;
    for (int i = M - 1; i >= 0; i--){
        mn = min(mn, cost_b[i]);
        cost_b[i] = mn;
    }
    v.resize(p);
    for (int i = 0; i < p; i++){
        cin >> v[i].x >> v[i].y >> v[i].z;
    }
    sort(all(v), cmp);

    /// ----------------------------------------- ///

    build(1, 0, M - 1);
    ll ans = -inf;
    for (int i = 0; i < p; i++){
        ll cost = cost_a[v[i].x];
        add(1, 0, M - 1, v[i].y, M - 1, v[i].z);
        ans = max(ans, t[1] - cost);
    }
    cout << ans;

    return 0;
}
