#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

void StepForward(vector <pair<int, int> > &a, vector <pair<int, int> > &b,
                vector <pair<int, pair<int, int> > > &smth, int n, int m, int p);

int BinSearch_a(int atk, vector <pair<int, pair<int, int> > > &smth, int p);
int BinSearch_mob(int def, vector<pair<int, int> > &mob, int amount);


int main()
{
    int n, m, p;
    cin >> n >> m >> p;

    vector <pair<int, int> > a(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i].first >> a[i].second;
    }
    sort(a.begin(), a.end());

    vector <pair<int, int> > b(m);
    for (int j = 0; j < m; j++)
    {
        cin >> b[j].first >> b[j].second;
    }

    vector <pair<int, pair<int, int> > > smth(p);
    for (int k = 0; k < p; k++)
    {
        cin >> smth[k].first >> smth[k].second.first >> smth[k].second.second;
    }
    sort(smth.begin(), smth.end());

    StepForward(a, b, smth, n, m, p);

    return 0;
}

void StepForward(vector <pair<int, int> > &a, vector <pair<int, int> > &b,
                 vector <pair<int, pair<int, int> > > &smth, int n, int m, int p)
{
    int prev = -1;
    int best = -2e9;
    vector <pair<int, int> > mob(p);
    int amount = 0;
    vector <int> prize(p);
    mob.clear();

    for (int i = 0; i < n; i++)
    {
        int ind = BinSearch_a(a[i].first, smth, p);
        for (int j = prev + 1; j <= ind; j++)
        {
            mob.push_back(smth[j].second);
        }
        sort(mob.begin(), mob.begin() + amount);
        amount += ind - prev;

        if (amount) prize[0] = mob[0].second;
        for (int j = 1; j < amount; j++)
        {
            prize[j] = prize[j - 1] + mob[j].second;
        }

        for (int j = 0; j < m; j++)
        {
            int temp = BinSearch_mob(b[j].first, mob, amount);
            if (temp != -1)
            {
                int sum = prize[temp] - a[i].second - b[j].second;
                if (sum > best)
                {
                    best = sum;
                }
            }
        }
        prev = ind;
    }
    cout << best << "\n";
}

int BinSearch_a(int atk, vector <pair<int, pair<int, int> > > &smth, int p)
{
    int L = -1, R = p - 1;
    while (L < R)
    {
        int temp = (L + R + 1) / 2;
        if (atk > smth[temp].first) L = temp;
        else R = temp - 1;
    }
    return L;
}

int BinSearch_mob(int def, vector<pair<int, int> > &mob, int amount)
{
    int L = -1, R = amount - 1;
    while (L < R)
    {
        int temp = (L + R + 1) / 2;
        if (def > mob[temp].first) L = temp;
        else R = temp - 1;
    }
    return L;
}
