#include <bits/stdc++.h>

#define len(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define endl '\n'
#define dbg(a) cout << #a << ' ' << a << '\n'

using namespace std;
typedef long long ll;
typedef long double ld;

const int MAX = (int)(2e5) + 7;
const int INF_INT = (int)(1e9) + 7;
const int MOD = (int)(1e9) + 7;
const ll INF_LL = (ll)(1e18) + 7;

void solve();
void boot_up() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << endl; }

template<typename T1, typename T2> inline bool chkmin(T1 & a, T2 & b) { if (a > b) { a = b; return true; } return false; }

template<typename T1, typename T2> inline bool chkmax(T1 & a, T2 & b) { if (a < b) { a = b; return true; } return false; }

template<typename T> inline void init(vector<T> & v, size_t _size, T value = 0) { v.assign(_size, value); }



int n, m, k;
vector<int> dp;
vector<int> gph[MAX];
vector<int> inv[MAX];
vector<int> path;

inline void bfs(int s);

signed main() {
    boot_up();

    while (cin >> n >> m) {
        solve();
    }
}

void solve() {
    for (int i = 1; i <= m; ++i) {
        int v, u;
        cin >> v >> u;

        gph[u].emplace_back(v);
        inv[v].emplace_back(u);
    }

    cin >> k;
    init(path, k);
    for (auto & it : path) {
        cin >> it;
    }

    int s, f;
    s = path[0];
    f = path[k - 1];

    bfs(f);

    int min_change = 0, max_change = 0;

    for (int i = 0; i < len(path) - 1; ++i) {
        int v = path[i];
        int u = path[i + 1];

        int min_path = INF_INT;
        int cnt_min = 0;
        for (const auto & vrt : inv[v]) {
            if (min_path > dp[vrt]) {
                cnt_min = 1;
                min_path = dp[vrt];
            }
            else if (min_path == dp[vrt]) {
                ++cnt_min;
            }
        }

        if (dp[u] != min_path) {
            ++min_change;
        }

        if (dp[u] != min_path || cnt_min > 1) {
            ++max_change;
        }
    }

    cout << min_change << ' ' << max_change << endl;
}

inline void bfs(int s) {
    init(dp, n + 1, INF_INT);
    dp[s] = 0;

    deque<int> q;
    q.push_back(s);

    while (len(q)) {
        int v = q[0];
        q.pop_front();

        for (const auto & u : gph[v]) {
            if (dp[u] > dp[v] + 1) {
                dp[u] = dp[v] + 1;
                q.push_back(u);
            }
        }
    }
}
