#pragma optimize("fast-math")
#pragma optimize("unroll-loops")
#pragma optimize("Ofast")
#pragma target("avx,avx2,sse,sse2,ssse3,sse4,popcnt")
#include <bits/stdc++.h>

#define len(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define endl '\n'
#define dbg(a) cout << #a << ' ' << a << '\n'

using namespace std;
typedef long long ll;
typedef long double ld;

const int MAX = (int)(2e5) + 7;
const int INF_INT = (int)(1e9) + 7;
const int MOD = (int)(1e9) + 7;
const ll INF_LL = (ll)(1e18) + 7;

void solve();
void boot_up() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << endl; }

template<typename T1, typename T2> inline bool chkmin(T1 & a, T2 & b) { if (a > b) { a = b; return true; } return false; }

template<typename T1, typename T2> inline bool chkmax(T1 & a, T2 & b) { if (a < b) { a = b; return true; } return false; }

template<typename T> inline void init(vector<T> & v, size_t _size, T value = 0) { v.assign(_size, value); }


struct Weapon {
    int a, cost;

    Weapon() : a(0), cost(0) {}

    Weapon(int a_, int cost_) : a(a_), cost(cost_) {}

    bool operator < (const Weapon & other) {
        if (a != other.a) {
            return a < other.a;
        }
        return cost < other.cost;
    }
};

struct Armour {
    int b, cost;

    Armour() : b(0), cost(0) {}

    Armour(int b_, int cost_) : b(b_), cost(cost_) {}

    bool operator < (const Armour & other) {
        if (b != other.b) {
            return b > other.b;
        }
        return cost > other.cost;
    }
};

struct Monster {
    int x, y, z;

    Monster() : x(0), y(0), z(0) {}

    Monster(int x_, int y_, int z_) : x(x_), y(y_), z(z_) {}

    bool operator < (const Monster & other) {
        if (x != other.x) {
            return x < other.x;
        }

        if (y != other.y) {
            return y < other.y;
        }

        return z < other.z;
    }
};

class SegmentTree {
private:
    int size;
    vector<ll> seg_max;
    vector<ll> modify;

    inline void push(int v, int vl, int vr) {
        if (modify[v] != 0) {
            seg_max[v] += modify[v];

            if (vl != vr) {
                modify[2 * v] += modify[v];
                modify[2 * v + 1] += modify[v];
            }

            modify[v] = 0;
        }
    }

    inline void pull(int v, int vl, int vr) {
        push(v, vl, vr);

        int vm = vl + (vr - vl) / 2;

        push(2 * v, vl, vm);
        push(2 * v + 1, vm + 1, vr);

        seg_max[v] = max(seg_max[2 * v], seg_max[2 * v + 1]);
    }

    void build(vector<int> & a, int v, int vl, int vr) {
        if (vl == vr) {
            seg_max[v] = a[vl];
            return;
        }

        int vm = vl + (vr - vl) / 2;

        build(a, 2 * v, vl, vm);
        build(a, 2 * v + 1, vm + 1, vr);

        pull(v, vl, vr);
    }

    void update(int v, int vl, int vr, int l, int r, ll add) {
        if (vr < l || r < vl) {
            return;
        }

        push(v, vl, vr);

        if (l <= vl && vr <= r) {
            modify[v] += add;
            return;
        }

        int vm = vl + (vr - vl) / 2;

        update(2 * v, vl, vm, l, r, add);
        update(2 * v + 1, vm + 1, vr, l, r, add);

        pull(v, vl, vr);
    }

    ll get_max(int v, int vl, int vr, int l, int r) {
        if (vr < l || r < vl) {
            return -INF_LL;
        }

        push(v, vl, vr);

        if (l <= vl && vr <= r) {
            return seg_max[v];
        }


        int vm = vl + (vr - vl) / 2;

        ll left_child  = get_max(2 * v, vl, vm, l, r);
        ll right_child = get_max(2 * v + 1, vm + 1, vr, l, r);

        return max(left_child, right_child);
    }
public:
    SegmentTree(vector<int> & a) : size(len(a)) {
        init(seg_max, 4 * size, -INF_LL);
        init(modify, 4 * size);

        build(a, 1, 0, size - 1);
    }

    ll get_max(int l, int r) {
        return get_max(1, 0, size - 1, l, r);
    }

    void update(int l, int r, ll add) {
        update(1, 0, size - 1, l, r, add);
    }
};


int n, m, p;
vector<Weapon> a;
vector<Armour> b;
vector<Monster> c;

signed main() {
    boot_up();

    while (cin >> n >> m >> p) {
        solve();
    }
}

void solve() {
    a.reserve(n);
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;

        a.emplace_back(x, y);
    }

    b.reserve(m);
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;

        b.emplace_back(x, y);
    }

    c.reserve(p);
    for (int i = 0; i < p; ++i) {
        int x, y, z;
        cin >> x >> y >> z;

        c.emplace_back(x, y, z);
    }


    sort(all(a));
    sort(all(b));
    sort(all(c));

    vector<int> tmp(m);
    for (int i = 0; i < m; ++i) {
        tmp[i] = -b[i].cost;
    }

    SegmentTree tree(tmp);


    int ptr = 0;
    ll ans = -INF_LL;
    for (int i = 0; i < n; ++i) {
        while (ptr < p && c[ptr].x < a[i].a) {
            if (b[0].b <= c[ptr].y) {
                ++ptr;
                continue;
            }

            int l = 0, r = m;
            while (r - l > 1) {
                int mid = l + (r - l) / 2;

                if (b[mid].b > c[ptr].y) {
                    l = mid;
                }
                else {
                    r = mid;
                }
            }

            tree.update(0, l, c[ptr].z);
            ++ptr;
        }

        ll curr_ans = tree.get_max(0, m - 1) - a[i].cost;

        chkmax(ans, curr_ans);
    }

    cout << ans << endl;
}
