#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

vector<vector<ll>> grf;

const ll INF = 1e18;

struct monstr {
    ll i, j, z;
};

struct Node {
    ll sum = 0;
    ll add = 0;
};

vector<Node> a;

void push(ll v, ll l, ll r) {
    if (a[v].add == 0) {
        return;
    }
    if (l + 1 == r) {
        a[v].sum += a[v].add;
        a[v].add = 0;
        return;
    }
    a[2 * v + 1].add += a[v].add;
    a[2 * v + 2].add += a[v].add;
    a[v].sum += a[v].add;
    a[v].add = 0;
}

void update(ll v, ll l, ll r, ll ql, ll qr, ll val) {
    push(v, l, r);
    if (ql >= r || l >= qr) {
        return;
    }
    if (l >= ql && r <= qr) {
        a[v].add += val;
        push(v, l, r);
        return;
    }
    ll m = (l + r) / 2;
    update(2 * v + 1, l, m, ql, qr, val);
    update(2 * v + 2, m, r, ql, qr, val);
    a[v].sum = a[2 * v + 1].sum + a[2 * v + 2].sum;
}

ll query(ll v, ll l, ll r, ll ql, ll qr) {
    push(v, l, r);
    if (ql >= r || l >= qr) {
        return 0;
    }
    if (l >= ql && r <= qr) {
        return a[v].sum;
    }
    ll m = (l + r) / 2;
    return query(2 * v + 1, l, m, ql, qr) + query(2 * v + 2, m, r, ql, qr);
}

signed main()
{
    ll n, m, p;
    cin >> n >> m >> p;
    vector<pair<ll, ll>> m1(n);
    vector<ll> mn1(n + 1, INF);
    a.resize(4 * m);
    vector<ll> mn2(m + 1, INF);
    for (ll i = 0; i < n; i++) {
        cin >> m1[i].first >> m1[i].second;
    }
    vector<pair<ll, ll>> m2(m);
    for (ll i = 0; i < m; i++) {
        cin >> m2[i].first >> m2[i].second;
    }
    sort(m1.begin(), m1.end());
    sort(m2.begin(), m2.end());
    for (ll i = n - 1; i >= 0; i--) {
        mn1[i] = min(m1[i].second, mn1[i + 1]);
    }
    for (ll j = m - 1; j >= 0; j--) {
        mn2[j] = min(m2[j].second, mn2[j + 1]);
    }
    vector<vector<pair<ll, ll>>> mas(n + 1);
    for (ll i = 0; i < p; i++) {
        ll x, y, z;
        cin >> x >> y >> z;
        ll pos_i = upper_bound(m1.begin(), m1.end(), make_pair(x, INF)) - m1.begin();
        ll pos_j = upper_bound(m2.begin(), m2.end(), make_pair(y, INF)) - m2.begin();
        if (pos_j == m) {
            continue;
        }
        mas[pos_i].push_back({pos_j, z});
    }
    for (auto& el : mas) {
        sort(el.begin(), el.end());
    }
    ll ans = -INF;
    for (ll i = 0; i < n; i++) {
        ll cur_cost = mn1[i];
        for (auto& el : mas[i]) {
            ll val = mn2[el.first];
            update(0, 0, m, el.first, el.first + 1, el.second);
            ll sum = query(0, 0, m, 0, el.first + 1);
            ans = max(ans, sum - (cur_cost + val));
            if (el.first != 0) {
                ll val2 = mn2[el.first - 1];
                ll sum2 = query(0, 0, m, 0, el.first);
                ans = max(ans, sum2 - val2 - cur_cost);
            }
        }
    }
    cout << ans;
    return 0;
}
