#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <string>
#include <queue>

using namespace std;

const int INF = 1000'000'000;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//ifstream cin("in.txt");
	//ofstream cout("out.txt");
	int n, m;
	cin >> n >> m;
	vector <vector <int>> G(n);
	vector <vector <int>> rev_G(n);
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v, u--, v--;
		G[u].emplace_back(v);
		rev_G[v].emplace_back(u);
	}
	int k;
	cin >> k;
	vector <int> way(k);
	for (int i = 0; i < k; i++) 
		cin >> way[i], way[i]--;

	queue <int> q;
	vector <int> dist(n, INF);
	q.push(way.back());
	dist[way.back()] = 0;
	while (q.size()) {
		int top = q.front();
		//cout << "bf " << top << '\n';
		q.pop();
		for (auto u : rev_G[top]) {
			if (dist[u] > dist[top] + 1) {
				dist[u] = dist[top] + 1;
				q.push(u);
			}
		}
	}
	//for (auto u : dist)
	    //cout << u << ' ';
	//cout << '\n';
	int min_ans = 0, max_ans = 0;
	for (int i = 0; i < k - 1; i++) {
		int min_dist = INF;
		for (auto u : G[way[i]]) 
			min_dist = min(min_dist, dist[u]);
		int cnt_min = 0;
		for (auto u : G[way[i]])
			if (min_dist == dist[u])
				cnt_min++;
		if (dist[way[i + 1]] == min_dist) {
			if (cnt_min != 1) {
			    max_ans++;
			    //cout << "+i" << '\n';
			}
		} else {
			min_ans++, max_ans++;
			//cout << "~i" << '\n';
		}
	}
	cout << min_ans << ' ' << max_ans;
}