#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <string>
#include <queue>

using namespace std;

const int INF = 2000'000'001;

vector <int> tree, mod;

void push(int v, int vL, int vR) {
	if (vL + 1 < vR) {
		mod[2 * v] += mod[v];
		mod[2 * v + 1] += mod[v];
	}
	tree[v] += mod[v];
	mod[v] = 0;
}

void upd(int v, int vL, int vR, int ind, int val) {
	push(v, vL, vR);
	if (ind < vL || vR <= ind)
		return;
	if (vL + 1 >= vR) {
		tree[v] = val;
		return;
	}
	int vM = (vL + vR) / 2;
	upd(2 * v, vL, vM, ind, val);
	upd(2 * v + 1, vM, vR, ind, val);
	tree[v] = max(tree[2 * v], tree[2 * v + 1]);
}

void upd(int v, int vL, int vR, int L, int R, int val) {
	push(v, vL, vR);
	if (L <= vL && vR <= R) {
		mod[v] += val;
		push(v, vL, vR);
		return;
	}
	if (R <= vL || vR <= L)
		return;
	int vM = (vL + vR) / 2;
	upd(2 * v, vL, vM, L, R, val);
	upd(2 * v + 1, vM, vR, L, R, val);
	tree[v] = max(tree[2 * v], tree[2 * v + 1]);
}

int get_max(int v, int vL, int vR, int L, int R) {
	push(v, vL, vR);
	if (L <= vL && vR <= R)
		return tree[v];
	if (R <= vL || vR <= L)
		return -INF;
	int vM = (vL + vR) / 2;
	return max(get_max(2 * v, vL, vM, L, R), get_max(2 * v + 1, vM, vR, L, R));
}

struct MOB {
	int x, y, z;
	MOB(int x = 0, int y = 0, int z = 0) : x(x), y(y), z(z) {}
};

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//ifstream cin("in.txt");
	//ofstream cout("out.txt");
	int n, m, p;
	cin >> n >> m >> p;
	vector <pair <int, int>> a(n), b(m);
	vector <MOB> c(p);
	vector <int> all_def;
	for (int i = 0; i < n; i++) {
		cin >> a[i].first >> a[i].second;
	}
	for (int i = 0; i < m; i++) {
		cin >> b[i].first >> b[i].second;
		all_def.push_back(b[i].first);
	}
	for (int i = 0; i < p; i++) {
		cin >> c[i].x >> c[i].y >> c[i].z;
		all_def.push_back(c[i].y);
	}
	all_def.push_back(INF);
	sort(all_def.begin(), all_def.end());
	all_def.resize(unique(all_def.begin(), all_def.end()) - all_def.begin());
	for (int i = 0; i < m; i++) {
		b[i].first = lower_bound(all_def.begin(), all_def.end(), b[i].first) - all_def.begin();
	}
	for (int i = 0; i < p; i++) {
		c[i].y = lower_bound(all_def.begin(), all_def.end(), c[i].y) - all_def.begin();
	}
	tree.resize((all_def.size() + 1) * 4, -INF);
	mod.resize(tree.size(), 0);
	for (int i = 0; i < m; i++) {
		if (get_max(1, 0, all_def.size(), b[i].first, b[i].first + 1) < -b[i].second) {
			upd(1, 0, all_def.size(), b[i].first, -b[i].second);
		}
	}
	vector <pair <int, int>> scan;
	for (int i = 0; i < n; i++) {
		scan.push_back(make_pair(a[i].first, i));
	}
	for (int i = 0; i < p; i++) {
		scan.push_back(make_pair(c[i].x, i + n));
	}
	sort(scan.begin(), scan.end());
	int ans = -INF;
	for (int i = 0; i < scan.size(); i++) {
		if (scan[i].second < n) {
			ans = max(ans, -a[scan[i].second].second + 
				get_max(1, 0, all_def.size(), 0, all_def.size()));
		} else {
			upd(1, 0, all_def.size(), c[scan[i].second - n].y + 1,
			 all_def.size(), c[scan[i].second - n].z);
		}
	}
	cout << ans;
}