//#define USE_PRAGMAS
#include<bits/stdc++.h>
#ifdef USE_PRAGMAS
#pragma GCC optimize("-Ofast, unroll-loops")
#pragma GCC target("sse4.2,avx,avx2,tune=native")
#endif
#define int long long
using namespace std;

struct treap
{
    int k, v, p;

    treap *l, *r;
    int sum;
    int pm;
    treap(int key, int value)
    {
        k = key;
        v = value;
        p = rand();
        l = r = nullptr;
        sum = value;
        pm = value;
    }
};
void upd(treap *v)
{
    v->sum = v->v;
    if (v->l == nullptr)
    {
        v->pm = v->v;
        return;
    }
    v->sum += v->l->sum;
    v->pm = max(v->l->pm, v->l->sum + v->v);
    if (v->r == nullptr)
        return;
    v->sum += v->r->sum;
    v->pm = max(v->pm, v->l->sum + v->v + v->r->pm);
}
treap* merge(treap *l, treap *r)
{
    if (l == nullptr)
        return r;
    if (r == nullptr)
        return l;
    if (l->p < r->p)
    {
        l->r = merge(l->r, r);
        upd(l);
        return l;
    }
    else
    {
        r->l = merge(l, r->l);
        upd(r);
        return r;
    }
}
pair<treap*, treap*> split(treap *v, int k)
{
    if (v == nullptr)
        return {nullptr, nullptr};
    if (v->k >= k)
    {
        auto tmp = split(v->l, k);
        v->l = tmp.second;
        upd(v);
        return {tmp.first, v};
    }
    else
    {
        auto tmp = split(v->r, k);
        v->r = tmp.first;
        upd(v);
        return {v, tmp.second};
    }
}
treap* insert(treap *v, treap *inst)
{
    auto tmp = split(v, inst->k);
    return merge(tmp.first, merge(inst, tmp.second));
}
struct monster
{
    int x, y, z;
};
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, p;
    cin >> n >> m >> p;

    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i].first >> a[i].second;
    }
    sort(a.begin(), a.end());

    vector<pair<int, int>> b(m);
    for (int i = 0; i < m; i++)
    {
        cin >> b[i].first >> b[i].second;
    }
    sort(b.begin(), b.end());

    treap *root = new treap(0, -b[0].second);
    for (int i = 1; i < m; i++)
    {
        root = merge(root, new treap(b[i - 1].first + 1, -(b[i].second - b[i - 1].second)));
    }

    vector<pair<pair<int, int>,int>> k(p);
    for (int i = 0; i < p; i++)
    {
        cin >> k[i].first.first >> k[i].first.second >> k[i].second;
    }
    sort(k.begin(), k.end());

    int ans = -INT_MAX, ptr = 0;
    for (int i = 0; i < n; i++)
    {
        while (ptr < p && k[ptr].first.first < a[i].first)
        {
            root = insert(root, new treap(k[ptr].first.second, k[ptr].second));
            ptr++;
        }
        ans = max(ans, root->pm - a[i].second);
    }
    cout << ans;
}
