#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <functional>
#include <tuple>
#include <numeric>
#include <deque>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> os_tree;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> adj(n), adj_rev(n);
    for (ll i = 0; i < m; i++) {
        ll u, v;
        cin >> u >> v;
        u--, v--;
        adj[u].push_back(v);
        adj_rev[v].push_back(u);
    }
    ll k;
    cin >> k;
    vector<ll> p(k);
    for (ll i = 0; i < k; i++) {
        cin >> p[i];
        p[i]--;
    }
    vector<ll> dist(n, -1), ways(n, 0);
    deque<ll> queue;
    dist[p.back()] = 0;
    ways[p.back()] = 1;
    queue.push_back(p.back());
    while (!queue.empty()) {
        ll u = queue.front();
        queue.pop_front();
        for (ll v : adj_rev[u]) {
            if (dist[v] == -1) {
                dist[v] = dist[u] + 1;
                ways[v] = 1;
                queue.push_back(v);
            } else if (dist[v] == dist[u] + 1) {
                ways[v]++;
            }
        }
    }
    ll a = 0, b = 0;
    for (ll i = 1; i < k; i++) {
        if (dist[p[i - 1]] != k - i) {
            a++;
            b++;
        } else if (ways[p[i - 1]] > 1) {
            b++;
        }
    }
    cout << a << " " << b << endl;
    return 0;
}
