#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <functional>
#include <tuple>
#include <numeric>
#include <deque>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> os_tree;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, m, p;
    cin >> n >> m >> p;
    vector<pair<ll, ll>> a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    for (ll i = n - 2; i >= 0; i--) {
        a[i].second = min(a[i].second, a[i + 1].second);
    }
    sort(a.begin(), a.end());
    vector<pair<ll, ll>> b(m);
    for (ll i = 0; i < m; i++) {
        cin >> b[i].first >> b[i].second;
    }
    sort(b.begin(), b.end());
    for (ll i = m - 2; i >= 0; i--) {
        b[i].second = min(b[i].second, b[i + 1].second);
    }
    vector<tuple<ll, ll, ll>> c(p);
    for (ll i = 0; i < p; i++) {
        cin >> get<0>(c[i]) >> get<1>(c[i]) >> get<2>(c[i]);
    }
    sort(c.begin(), c.end());
    vector<ll> g;
    for (ll i = 0; i < p; i++) {
        g.push_back(get<1>(c[i]));
    }
    sort(g.begin(), g.end());
    g.erase(unique(g.begin(), g.end()), g.end());
    vector<ll> bit(g.size() + 1);
    auto bit_add = [&](ll x, ll y) {
        for (x++; x < (ll) bit.size(); x += x & -x) {
            bit[x] += y;
        }
    };
    auto bit_query = [&](ll x) {
        ll y = 0;
        for (x++; x > 0; x -= x & -x) {
            y += bit[x];
        }
        return y;
    };
    ll o = -a[0].first - b[0].first;
    for (ll i = 0; i < p; i++) {
        bit_add(get<1>(c[i]), get<2>(c[i]));
        auto f = [&](ll j) {
            ll q = 0;
            if (upper_bound(g.begin(), g.end(), j) != g.begin()) {
                q = bit_query(prev(upper_bound(g.begin(), g.end(), j)) - g.begin());
            }
            q -= upper_bound(a.begin(), a.end(), pair<ll, ll>{get<0>(c[i]), -1})->second;
            q -= upper_bound(b.begin(), b.end(), pair<ll, ll>{j, -1})->second;
            return q;
        };
        if (a.back().first > get<0>(c[i])) {
            long double l = 0, r = b.back().first - 1;
            while (r - l > 10) {
                if (f(l + (r - l) / 3) > f(r - (r - l) / 3)) {
                    r -= (r - l) / 3;
                } else {
                    r += (r - l) / 3;
                }
            }
            for (ll j = l; j <= r; j++) {
                o = max(o, f(j));
            }
        }
    }
    cout << o << endl;
    return 0;
}
