#include <bits/stdc++.h>

using namespace std;

typedef int ll;
typedef long double ld;

#define fori(i, n) for(ll i = 0; i < (n); ++i)
#define forI(i, n) for(ll i = 1; i <= (n); ++i)

#define pll pair<ll, ll>
#define ff first
#define ss second

#pragma GCC optimize(Ofast)
#pragma GCC optimize(fast-math)
#pragma GCC optimize(unroll-loops)
#pragma GCC target(sse,sse2,sse3,ssse3,sse4,abm,mmx,popcnt,tune=native)

struct Fenwick{
    vector<ll> t;

    Fenwick(ll n){
        t.resize(n);
    }

    void setv(ll i, ll val){
        for(; i < t.size(); i |= i + 1){
            t[i] += val;
        }
    }

    ll sum(ll r){
        ll res = 0;
        for(; r >= 0; r = (r & (r + 1)) - 1){
            res += t[r];
        }
        return res;
    }
};


ll n, m;

ll a[100];
ll b[100];

void solve(){
    cin >> n;
    fori(i, n) cin >> a[i];
    fori(i, n) cin >> b[i];

    ll c1 = 0;
    ll c2 = 0;

    fori(i, n){
        if(a[i] != b[i]){
            if(a[i] == 1) ++c1;
            else ++c2;
        }
    }
    if(c1 == 0){
        cout << -1;
        return;
    }

    ll l = 0, r = 100 * 1000;
    while(l + 1 < r){
        ll mid = (l + r) >> 1;

        if(mid * c1 > c2) r = mid;
        else l = mid;
    }
    cout << r;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    #define DEBUG0
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
    #endif

    solve();
}
