import java.io.*;
import java.util.HashMap;
import java.util.Locale;
import java.util.StringTokenizer;

public class A {
    static class Parser{
        private BufferedReader bf;
        private StringTokenizer st;


        Parser(){
            bf = new BufferedReader(new InputStreamReader(System.in));
        }

        Parser(int a) throws FileNotFoundException {
            bf = new BufferedReader(new FileReader("input.txt"));
        }

        String next() throws IOException {
            while(st == null || !st.hasMoreTokens()) st = new StringTokenizer(bf.readLine());
            return st.nextToken();
        }

        int nextInt() throws IOException {
            return Integer.parseInt(next());
        }

        long nextLong() throws IOException {
            return Long.parseLong(next());
        }
    }

    static Parser in;
    static PrintWriter out;

    static int n, m;

    static void solve() throws IOException {
        n = in.nextInt();
        HashMap<Integer, Long> map = new HashMap<>();
        for (int i = 0; i < n; i++) {
            int a = in.nextInt();

            Long val = map.get(a - i);
            if(val == null) map.put(a - i, (long)a);
            else map.put(a - i, val + a);
        }
        long ans = 0;
        for(HashMap.Entry<Integer, Long> e: map.entrySet()){
            ans = Math.max(ans, e.getValue());
        }
        out.println(ans);
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        in = new Parser();
        out = new PrintWriter(System.out);

        solve();

        out.close();
    }
}
