import java.io.*;
import java.util.*;

public class A {
    static class Parser{
        private BufferedReader bf;
        private StringTokenizer st;


        Parser(){
            bf = new BufferedReader(new InputStreamReader(System.in));
        }

        Parser(int a) throws FileNotFoundException {
            bf = new BufferedReader(new FileReader("input.txt"));
        }

        String next() throws IOException {
            while(st == null || !st.hasMoreTokens()) st = new StringTokenizer(bf.readLine());
            return st.nextToken();
        }

        int nextInt() throws IOException {
            return Integer.parseInt(next());
        }

        long nextLong() throws IOException {
            return Long.parseLong(next());
        }
    }

    static Parser in;
    static PrintWriter out;

    static int n, m;
    
    static class pair{
        int f, s;

        public pair(int f, int s) {
            this.f = f;
            this.s = s;
        }
    }
    
    static class pr{
        int f;
        ArrayList<Integer> s;

        public pr(int f, int ... e) {
            this.f = f;

            s = new ArrayList<>(e.length);
            for (int i = 0; i < e.length; i++) s.add(e[i]);

        }
    }
    
    static final int MAXN = 200 * 1000 + 1;

    static ArrayList<Integer>[] g = new ArrayList[MAXN];
    static ArrayList<Integer>[] inv_g = new ArrayList[MAXN];
    static int[] root = new int[MAXN];
    static ArrayList<Integer>[] near = new ArrayList[MAXN];

    static int[] dist = new int[MAXN];
    static ArrayList<Integer>[] edges = new ArrayList[MAXN];

    static boolean areRootNeighbours(int a, int b){
        for (int neigh: near[a]) if(neigh == b) return true;
        return false;
    }
    
    static void bfs(int v){
        boolean[] used = new boolean[MAXN];
        for (int i = 1; i <= n; i++){
            dist[i] = (int)1e8;
            edges[i] = new ArrayList<>();
        }
        dist[v] = 0;

        Queue<pair> que = new LinkedList<>();
        que.add(new pair(v, 1));
        while(!que.isEmpty()){
            pair ww = que.remove();
            v = ww.f;
            int ind = ww.s;

            if(used[v]) continue;
            used[v] = true;

            for(int to: inv_g[v]){
                if(dist[to] > ind + 1){
                    dist[to] = ind + 1;
                    edges[to].add(v);

                }else if(dist[to] == ind + 1){
                    if(areRootNeighbours(to, v)){

                        if(edges[to].isEmpty()) edges[to].add(v);
                        else {
                            int temp = edges[to].get(0);
                            edges[to].set(0, v);
                            if(edges[to].size() < 2) edges[to].add(temp);
                        }
                    }else if(edges[to].size() < 2) edges[to].add(v);
                }

                que.add(new pair(to, ind + 1));
            }
        }
    }

    static void solve() throws IOException {
        n = in.nextInt();
        m = in.nextInt();
        for (int i = 1; i <= n; i++) {
            g[i] = new ArrayList<>();
            inv_g[i] = new ArrayList<>();
            near[i] = new ArrayList<>();
            edges[i] = new ArrayList<>();
        }

        for (int i = 0; i < m; i++) {
            int a = in.nextInt();
            int b = in.nextInt();
            g[a].add(b);
            inv_g[b].add(a);
        }

        int q = in.nextInt();
        for(int i = 0; i < q; ++i) root[i] = in.nextInt();
        for (int i = 0; i < q; i++) {
            if(i > 0) near[root[i]].add(root[i - 1]);
            if(i + 1 < q) near[root[i]].add(root[i + 1]);
        }

        bfs(root[q - 1]);

        int c1 = 0, c2 = 0;
        for(int i = 0; i < q - 1; ++i){
            int pt = root[i];
            int next = root[i + 1];

            boolean isok = false;
            for(int to: edges[pt]){
                if(to == next){
                    isok = true;
                    break;
                }
            }

            if(!isok) ++c1;
            if(!isok || edges[pt].size() > 1) ++c2;
        }

        out.println(c1 + " " + c2);
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        in = new Parser();
        out = new PrintWriter(System.out);

        solve();

        out.close();
    }
}
