#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <deque>
#define ll long long
#define ld long double

using namespace std;

struct att{
    ll a;
    ll c;
    att(){}
    att(ll a, ll c) : a(a), c(c) {}
};

struct def{
    ll b;
    ll c;
    def(){}
    def(ll b, ll c) : b(b), c(c) {}
};

struct monst{
    ll a;
    ll b;
    ll c;
    monst(){}
    monst(ll a, ll b, ll c) : a(a), b(b), c(c) {}
};

bool cmp1(att &A, att &B){
    return A.a < B.a;
}

bool cmp3(monst &A, monst &B){
    return A.a < B.a;
}

void zip(vector<int> &all, map<int, int> &numb){
    sort(all.begin(), all.end());
    for (int i = 0; i < all.size(); i++){
        if (i == 0 || all[i - 1] != all[i]){
            int val = all[i];
            int ind = numb.size();
            numb[val] = ind;
        }
    }
}

struct node{
    int l = -1;
    int r = -1;
    ll x = 0;
    ll more = 0;
    node(){}
};

const int MAXN = 2e5;
const ll inf = 1e15;
node pool[MAXN * 4 + 10];
int pt1 = 0;

int build(int L, int R, vector<ll> &a){
    if (L == R - 1){
        node A;
        A.x = a[L];
        pool[pt1] = A;
        pt1++;
        return pt1 - 1;
    }
    int M = (L + R) / 2;
    node A;
    A.l = build(L, M, a);
    A.r = build(M, R, a);
    A.x = max(pool[A.l].x, pool[A.r].x);
    pool[pt1] = A;
    pt1++;
    return pt1 - 1;
}

void push(int root){
    int left = pool[root].l;
    int right = pool[root].r;
    ll val = pool[root].more;
    pool[left].x += val;
    pool[left].more += val;
    pool[right].x += val;
    pool[right].more += val;
    pool[root].more = 0;
}

void relax(int root){
    int left = pool[root].l;
    int right = pool[root].r;
    pool[root].x = max(pool[left].x, pool[right].x);
}

ll get(int root, int L, int R, int l, int r){
    //cout << L << "/" << R << endl;
    if (L == l && R == r){
        return pool[root].x;
    }
    push(root);
    int M = (L + R) / 2;
    ll res1 = -inf, res2 = -inf;
    if (l < M)
        res1 = get(pool[root].l, L, M, l, min(M, r));
    if (r > M)
        res2 = get(pool[root].r, M, R, max(l, M), r);
    return max(res1, res2);
}

void upd(int root, int L, int R, int l, int r, ll x){
    //cout << L << "#" << R << endl;
    if (L == l && R == r){
        pool[root].x += x;
        pool[root].more += x;
        return;
    }
    push(root);
    int M = (L + R) / 2;
    if (l < M)
        upd(pool[root].l, L, M, l, min(M, r), x);
    if (r > M)
        upd(pool[root].r, M, R, max(l, M), r, x);
    relax(root);
}

int main(){
    int n, m, p;
    cin >> n >> m >> p;
    vector<att> a(n);
    vector<def> b(m);
    vector<monst> z(p);
    vector<int> all1, all2;
    map<int, int> numb1, numb2;
    for (int i = 0; i < n; i++){
        ll A, c;
        cin >> A >> c;
        a[i] = {A, c};
        all1.push_back(A);
    }
    sort(a.begin(), a.end(), cmp1);
    for (int i = 0; i < m; i++){
        ll B, c;
        cin >> B >> c;
        b[i] = {B, c};
        all2.push_back(B);
    }
    for (int i = 0; i < p; i++){
        ll A, B, c;
        cin >> A >> B >> c;
        z[i] = {A, B, c};
        all1.push_back(A);
        all2.push_back(B);
    }
    sort(z.begin(), z.end(), cmp3);
    zip(all1, numb1);
    zip(all2, numb2);
    for (int i = 0; i < n; i++){
        a[i].a = numb1[a[i].a];
    }
    for (int i = 0; i < m; i++){
        b[i].b = numb2[b[i].b];
    }
    for (int i = 0; i < p; i++){
        z[i].a = numb1[z[i].a];
        z[i].b = numb2[z[i].b];
    }
    int M = numb2.size() + 1;
    vector<ll> now(M);
    for (int i = 0; i < M; i++)
        now[i] = -inf;
    for (int i = 0; i < m; i++){
        if (b[i].b == 0)
            continue;
        ll val = b[i].b - 1;
        now[val] = max(now[val], -b[i].c);
    }
    int root = build(0, M, now);
    ll ans = -inf;
    int pt = 0;
    for (int i = 0; i < n; i++){
        ll A = a[i].a;
        ll cost = -a[i].c;
        while (pt < p){
            if (z[pt].a >= A)
                break;
            upd(root, 0, M, z[pt].b, M, z[pt].c);
            pt++;
        }
        cost += get(root, 0, M, 0, M);
        ans = max(ans, cost);
    }
    cout << ans << endl;
}
