//
// Created by student on 3/1/20.
//

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

void fastio() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int n, m;
vector<vector<int>> g;
vector<int> path;
vector<vector<int>> bestWays;
vector<int> dist;

const int inf  = 1e9;

void bfs(int u) {
    bestWays.resize(n);
    dist.resize(n, inf);
    dist[u] = 0;
    queue<int> q;
    q.push(u);
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        for (int v: g[u]) {
            if (dist[v] > dist[u] + 1) {
                bestWays[v].clear();
                dist[v] = dist[u] + 1;
                q.push(v);
            }
            if (dist[v] == dist[u] + 1) {
                bestWays[v].push_back(u);
            }
        }
    }
}

int main() {
    fastio();
    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[v].push_back(u); // reversed order
    }
    int len;
    cin >> len;
    path.resize(len);
    for (int i = 0; i < len; ++i) {
        cin >> path[i];
        --path[i];
    }
    bfs(path.back());
    /*for (int i = 0; i < n; ++i) {
        cerr << "vertex = " << i + 1 << " " << "dist: " << dist[i] << '\n';
        cerr << "bestWays:\n";
        for (auto t : bestWays[i]) {
            cerr << t + 1 << ' ';
        }
        cerr << '\n';
    }*/
    int mx = 0, mn = 0;
    for (int i = 0; i + 1 < len; ++i) {
        int u = path[i];
        int v = path[i + 1];
        if (find(bestWays[u].begin(), bestWays[u].end(), v) == bestWays[u].end()) {
            mx += 1;
            mn += 1;
        } else if (bestWays[u].size() > 1) {
            mx += 1;
        }
    }
    cout << mn << ' ' << mx << '\n';
    return 0;
}
