#include <bits/stdc++.h>

#define F first
#define S second
#define rsz resize
#define pb push_back

using namespace std;
using ll = long long;
using ld = double;
using pi = pair<int, int>;
using vi = vector<int>;
using vpi = vector<pi>;

template<class T> bool ckmin(T& a, T b) { return b < a ? (a = b, true) : false; }
template<class T> bool ckmax(T& a, T b) { return b > a ? (a = b, true) : false; }

const int INF = 2e9;
const ll LINF = 1e18;
const ld PI = atan((ld)1)*4;

mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());

const int MOD = 1e9+7;
struct Modular {
    int x;

    Modular(int x = 0) : x(x) { }
    Modular operator + (Modular b) { return Modular((x+b.x)%MOD); }
    Modular operator - (Modular b) { return Modular((x-b.x+MOD)%MOD); }
    Modular operator * (Modular b) { return Modular(((ll)x*b.x)%MOD); }

    Modular& operator += (Modular b) { x = (x+b.x)%MOD;     return *this; }
    Modular& operator -= (Modular b) { x = (x-b.x+MOD)%MOD; return *this; }
    Modular& operator *= (Modular b) { x = ((ll)x*b.x)%MOD; return *this; }

    bool operator == (Modular b) { return x==b.x; }
    bool operator != (Modular b) { return x!=b.x; }
    bool operator >= (Modular b) { return x>=b.x; }
    bool operator <= (Modular b) { return x<=b.x; }
    bool operator > (Modular b) { return x > b.x; }
    bool operator < (Modular b) { return x < b.x; }
};

template<class T> T fast_pow(T x, int n) {
    T res = 1;
    for(; n != 0; n >>= 1, x *= x) if(n&1) res *= x;
    return res;
}

int rev(int a, int m = MOD) {
    return a == 1 ? 1 : m - (ll) m * rev(m%a, a) / a;
}

const int N = 2e5;

bool u[N];
int n, sz[N], d[N], pred, gsz, p[N], c, typ[N];
ll a[N], b[N];
vi g[N];

int dfs_sz(int v, int p = -1) {
    sz[v] = 1;
    for(int to : g[v]) if(to != p && !u[to]) d[to] = d[v]+1, sz[v] += dfs_sz(to, v);
    return sz[v];
}

int find_centroid(int v, int p = -1) {
    int m = 0;
    for(int to : g[v]) if(to != p && !u[to]) ckmax(m, sz[to]);
    if(2*m <= gsz) return v;
    for(int to : g[v])
        if(to != p && !u[to] && sz[to]*2 > gsz)
            return find_centroid(to, v);
    return v;
}

int make_centroid(int v) {
    d[v] = 1, gsz = dfs_sz(v);
    v = find_centroid(v); u[v] = 1; p[v] = -1;
    for(int to : g[v])
        if(!u[to]) p[make_centroid(to)] = v;
    return v;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    cin >> n;
    for(int i = n; --i; ) {
        int x, y; cin >> x >> y;
        g[x-1].pb(y-1), g[y-1].pb(x-1);
    }
    c = make_centroid(0);
    for(int i= 0 ;i < n; ++i) a[i] = LINF;

    int q; cin >> q;
    while(q--) {
        int k, m; cin >> k >> m;
        vi v(k), u(m), s(k);
        for(int i = 0; i < k; ++i) {
            cin >> v[i] >> s[i]; --v[i];
            a[v[i]] = i+1, b[v[i]] = 0;
            for(int j = v[i]; p[j] >= 0; j = p[j]) {
                if(ckmin(a[p[j]], a[j] + (d[j]-b[j]+s[i]-1)/s[i]*(ll)N))
                    b[p[j]] = (b[j] - d[j] + (ll)N*s[i]) % s[i];
                else break;
            }
        }

        for(int i = 0; i < m; ++i) {
            cin >> u[i]; --u[i];
            vi arr(1, u[i]); while(p[arr.back()] >= 0) arr.pb(p[arr.back()]);
            ll prv_a = a[c], prv_b = b[c], tmp_a, tmp_b;
            for(int _j = arr.size() - 1; _j--; ) {
                const int j = arr[_j];
                tmp_a = a[j], tmp_b = b[j];
                if(ckmin(tmp_a, prv_a + (d[j]-prv_b+s[prv_a%n-1]-1)/s[prv_a%n-1]*(ll)N))
                    tmp_b = (prv_b - d[j] + (ll)N*s[prv_a%n-1]) % s[prv_a%n-1];
                //cout << j << " => " << tmp_a << ' ' << tmp_b << endl;
                prv_a = tmp_a, prv_b = tmp_b;

            }
            //cout << prv_a%N << " : : : " << endl;
            cout << prv_a%N << ' ';
        }

        cout << '\n';

        for(int i : v) for(; i >= 0; i = p[i]) a[i] = LINF, b[i] = 0;
    }
}
