#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<istream>
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pb push_back
#define sz(c) (ll)(c).size()
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()

const ll MAXN = 2e5 + 1;
const ll INF = 1e18;

ll n, m;


ll tree[4 * MAXN], a[MAXN], add[4 * MAXN];

void build(ll ind, ll l, ll r) {
    if ((r - l) == 1) {
        tree[ind] = a[l];
        return;
    }
    ll m = (l + r) / 2;
    build(ind * 2 + 1, l, m);
    build(ind * 2 + 2, m, r);
    tree[ind] = max(tree[ind * 2 + 1], tree[ind * 2 + 2]);
}

void push(ll ind, ll l, ll r) {
    tree[ind] += add[ind];
    if ((r - l) > 1) {
        add[ind * 2 + 1] += add[ind];
        add[ind * 2 + 2] += add[ind];
    }
    add[ind] = 0;
}

ll query_max(ll ind, ll l, ll r, ll q_l, ll q_r) {
    push(ind, l, r);
    if (l >= q_r || r <= q_l) {
        return -INF;
    }
    if (l >= q_l && r <= q_r) {
        return tree[ind];
    }
    ll m = (l + r) / 2;
    return max(query_max(ind * 2 + 1, l, m, q_l, q_r), query_max(ind * 2 + 2, m, r, q_l, q_r));
}

void add_segm(ll ind, ll l, ll r, ll q_l, ll q_r, ll del) {
    push(ind, l, r);
    //cout << 000 << endl;
    if (l >= q_r || r <= q_l) {
        return;
    }
    //cout << 111 << endl;
    if (l >= q_l && r <= q_r) {
        add[ind] += del;
        push(ind, l, r);
        return;
    }
    //cout << 222 << endl;
    ll m = (l + r) / 2;
    add_segm(ind * 2 + 1, l, m, q_l, q_r, del);
    //cout << 333 << endl;
    add_segm(ind * 2 + 2, m, r, q_l, q_r, del);
    //cout << 444;
    tree[ind] = max(tree[ind * 2 + 1], tree[ind * 2 + 2]);
    //cout << 555 << endl;
}



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    ll p;
    cin >> n >> m >> p;
    vector<pair<ll, ll>> a1(n), b1(m), monst1(p);
    for (ll i = 0; i < n; ++i) {
        cin >> a1[i].first >> a1[i].second;
    }
    for (ll i = 0; i < m; ++i) {
        cin >> b1[i].first >> b1[i].second;
    }
    sort(rall(a1));
    sort(rall(b1));
    stack<pair<ll, ll>> st;
    for (ll i = 0; i < n; ++i) {
        while (!st.empty() && st.top().first == a1[i].first) {
            st.pop();
        }
        if (!st.empty() && st.top().first > a1[i].first && st.top().second <= a1[i].second) {
            continue;
        }
        st.push(a1[i]);
    }
    vector<ll> a0, ac;
    while (!st.empty()) {
        a0.pb(st.top().first);
        ac.pb(st.top().second);
        st.pop();
    }
    //--------------------------------------
    for (ll i = 0; i < m; ++i) {
        while (!st.empty() && st.top().first == b1[i].first) {
            st.pop();
        }
        if (!st.empty() && st.top().first > b1[i].first && st.top().second <= b1[i].second) {
            continue;
        }
        st.push(b1[i]);
    }
    vector<ll> b0, bc;
    while (!st.empty()) {
        b0.pb(st.top().first);
        bc.pb(st.top().second);
        st.pop();
    }
    //------------------------------------------
    /*cout << endl;
    for (ll i = 0; i < sz(a0); ++i) {
        cout << a0[i] << " " << ac[i] << endl;
    }
    cout << endl;
    for (ll i = 0; i < sz(b0); ++i) {
        cout << b0[i] << " " << bc[i] << endl;
    }
    cout << "lol" << endl;*/
    vector<vector<pair<ll, ll>>> mp(sz(b0));
    for (ll i = 0; i < p; ++i) {
        ll x, y, z;
        cin >> x >> y >> z;
        ll x1 = (upper_bound(all(a0), x) - a0.begin());
        ll y1 = (upper_bound(all(b0), y) - b0.begin());
        if (x1 == sz(a0) || y1 == sz(b0)) {
            continue;
        }
        //cout << x1 << " " << y1 << endl;
        mp[y1].pb({x1, z});
    }
    //cout << "lol" << endl;
    n = sz(a0);
    m = sz(b0);
    //cout << "n == " << n << endl;

    for (ll i = 0; i < n; ++i) {
        a[i] = -ac[i];
    }
    build(0, 0, n);
    //cout << "lol" << endl;
    ll ans = -INF;
    for (ll i = 0; i < m; ++i) {
        //cout << i << endl;
        for (auto p : mp[i]) {
            ll x1 = p.first;
            ll del = p.second;
            //cout << x1 << " " << del << endl;
            add_segm(0, 0, n, x1, n, del);
        }
        //cout << i << endl;
        ans = max(ans, query_max(0, 0, n, 0, n) - bc[i]);
    }
    cout << ans;
    return 0;
}






