#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define fr first
#define sc second

const int inf = (int)1e9 + 7;
const ll linf = (ll)1e18 + 7;

const int N = (int)2e5 + 7;

int n;
vector <int> gr[N];
int sz[N], del[N], par[N];
pair <int, int> ss[N];
int tin[N], tout[N], h[N];
int up[18][N];
int tiktak;

struct fen {
	int tree[N + N];
	fen() {
		memset(tree, 0, sizeof tree);
	}
	void upd(int pos, int val) {
		while (pos < N + N) {
			tree[pos] += val;
			pos = pos | pos + 1;
		}
	}
	int get(int r) {
		int res = 0;
		while (r >= 0) {
			res += tree[r];
			r = (r & r + 1) - 1;
		}
		return res;
	}
	int get(int l, int r) {
		return get(r) - get(l - 1);
	}
};
fen tr;

void dfs(int v, int pr) {
	tin[v] = ++tiktak;
	up[0][v] = pr;
	for (int i = 1; i < 18; i++) {
		up[i][v] = up[i - 1][up[i - 1][v]];
	}
	for (int to : gr[v]) {
		if (to == pr) continue;
		h[to] = h[v] + 1;
		dfs(to, v);
	}
	
	tout[v] = ++tiktak;
}

bool upper(int a, int b) {
	return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int lca(int a, int b) {
	if (upper(a, b)) return a;
	if (upper(b, a)) return b;
	for (int i = 17; i >= 0; i--) {
		if (!upper(up[i][a], b)) a = up[i][a];
	}
	return up[0][a];
}

int dist(int a, int b) {
	return h[a] + h[b] - 2 * h[lca(a, b)];
}

void predfs(int v, int pr) {
	sz[v] = 1;
	for (int to : gr[v]) {
		if (del[to] || to == pr) continue;
		predfs(to, v);
		sz[v] += sz[to];
	}
}

int findcen(int v, int pr) {
	int cur = v;
	bool ok = 1;
	while (ok) {
		ok = 0;
		for (int to : gr[cur]) {
			if (del[to] || to == pr) continue;
			if (sz[to] * 2 > sz[v]) {
				pr = cur;
				cur = to;
				ok = 1;
				break;
			}
		}
	}
	return cur;
}

void build(int v, int pr) {
	predfs(v, v);
	int cen = findcen(v, v);
	del[cen] = 1;
	par[cen] = pr;
	for (int to : gr[cen]) {
		if (del[to]) continue;
		build(to, cen);
	}
}

int V[N], S[N];
int sp[N];

int get(int a, int b) {
	if (tin[a] > tin[b]) swap(a, b);
	if (upper(a, b)) return tr.get(tin[a], tin[b]);
	int lc = lca(a, b);
	int res = tr.get(tin[lc], tin[a]);
	res += tr.get(tin[lc], tin[b]);
	res -= sp[lc];
	return res;
}

void add(int j) {
	int vv = V[j];
	int v = vv;
	while (v) {
		pair<int, int> res = {(dist(vv, v) + S[j] - 1) / S[j], j};
		if (ss[v].sc == (int)1e9)
			ss[v] = min(ss[v], res);
		else {
			if (get(v, vv) == 1) {
				ss[v] = min(ss[v], res);
			}
		}
		// if (ss[v].sc != j) break;
		// ss[v].insert({(dist(vv, v) + S[j] - 1) / S[j], j});
		v = par[v];
	}
}

void dell(int j) {
	int vv = V[j];
	int v = vv;
	while (v) {
		ss[v] = {1e9, 1e9};
		v = par[v];
	}
}

int query(int v) {
	pair<int, int> ans = {1e9, 1e9};
	int vv = v;
	if (sp[v]) {
		return ss[v].sc;
	}
	while (v) {
		int j = ss[v].sc;
		if (j != (int)1e9) {
			if (get(v, vv) == sp[v])
				ans = min(ans, {(dist(V[j], vv) + S[j] - 1) / S[j], j});
		}
		v = par[v];
	}
	return ans.sc;
}

main() {
	scanf("%d", &n);
	for (int i = 1; i < n; i++) {
		int u, v;
		scanf("%d %d", &u, &v);
		gr[u].push_back(v);
		gr[v].push_back(u);
	}
	for (int i = 1; i <= n; i++) {
		ss[i] = {1e9, 1e9};
	}
	dfs(1, 1);
	build(1, 0);
	int q;
	scanf("%d", &q);
	while (q--) {
		int k, m;
		scanf("%d %d", &k, &m);
		for (int i = 0; i < k; i++) {
			int v, s;
			scanf("%d %d", &v, &s);
			V[i] = v;
			S[i] = s;
			tr.upd(tin[v], 1);
			tr.upd(tout[v], -1);
			sp[v] = 1;
		}
		for (int i = 0; i < k; i++) {
			add(i);
		}
		for (int i = 0; i < m; i++) {
			int x;
			scanf("%d", &x);
			printf("%d ", query(x) + 1);
		}
		for (int i = 0; i < k; i++) {
			dell(i);
			tr.upd(tin[V[i]], -1);
			tr.upd(tout[V[i]], 1);
			sp[V[i]] = 0;
		}
		puts("");
	}
}
/*
7
1 2
1 3
2 4
2 5
3 6
3 7
3
2 2
4 1
7 1
1 3
2 2
4 3
7 1
1 3
3 3
1 1
4 100
7 100
1 2 3
*/
