#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <stack>
#include <cstring>
#include <cmath>
#include <cassert>
#include <iostream>
#include <string>
#include <tuple>

#define inf (1000000000)
#define mod (1000000000 + 7)
#define N (200000 + 19)
typedef long long ll;

std::pair<int,int> a[N];
std::pair<int,int> b[N];

struct Event {
	int x;
	int yl;
	int yr;
	int z;
	int t;
	Event(int x, int yl, int yr, int z, int t) : x(x), yl(yl), yr(yr), z(z), t(t) {}
};

bool cmp ( Event a, Event b) {
	return a.x < b.x || (a.x == b.x && a.t < b.t);
}

#define OPEN (-1)
#define CLOSE (1)

ll t[N];

void add(int l, int r, ll x) {
	for(int i=l;i<=r;i++) {
		t[i]+=x;
	}
}

ll get_max() {
	return *std::max_element(t,t+N);
}

int main() {
	int n,m,p;
	scanf("%d%d%d", &n, &m, &p);
	for(int i = 0; i < n; i++) {
		scanf("%d%d", &a[i].first, &a[i].second);
	}
	for(int i = 0; i < m; i++) {
		scanf("%d%d", &b[i].first, &b[i].second);
	}
	sort(a, a+n);
	sort(b, b+m);
	std::vector<Event> events;
	for(int i=0;i<p;i++) {
		int xk, yk, zk;
		scanf("%d%d%d", &xk, &yk, &zk);
		int xl = std::upper_bound(a, a + n, std::make_pair(xk,inf)) - a;
		int yl = std::upper_bound(b, b + m, std::make_pair(yk,inf)) - b;
		if(xl == n || yl == m) continue;
		events.push_back(Event(n - 1, yl, m - 1, zk, OPEN));
		events.push_back(Event(xl, yl, m - 1, zk, CLOSE));
	}
	ll ans=-b[0].second - a[0].second;
	for(int i=0;i<m;i++) {
		add(i, i, -b[i].second);
	}
	for(int i = 0; i < events.size(); i++) {
		if(events[i].t == OPEN) {
			add(events[i].yl, events[i].yr, events[i].z);
		}
		ans = std::max(ans, get_max() - a[events[i].x].second);
		if(events[i].t == CLOSE) {
			add(events[i].yl, events[i].yr, -events[i].z);
		}
	}
	printf("%lld", ans);
	return 0;
}