#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <stack>
#include <cstring>
#include <cmath>
#include <cassert>
#include <iostream>
#include <string>
#include <tuple>

#define inf (1000000000)
#define infll ((ll)inf * inf)
#define mod (1000000000 + 7)
#define N (200000 + 19)
typedef long long ll;

std::pair<int,int> a[N];
std::pair<int,int> b[N];

struct Event {
	int x;
	int yl;
	int yr;
	int z;
	int t;
	Event(int x, int yl, int yr, int z, int t) : x(x), yl(yl), yr(yr), z(z), t(t) {}
};

bool cmp ( Event a, Event b) {
	return a.x > b.x || (a.x == b.x && a.t < b.t);
}

#define OPEN (-1)
#define CLOSE (1)

#define Q (1<<19)

ll t[2*Q];
ll d[2*Q];

int n,m,p;

void push(int v) {
	d[2 * v] += d[v];
	d[2 * v + 1] += d[v];
	d[v] = 0;
}

void pull(int v) {
	t[v] = std::max(t[2 * v] + d[2 * v], t[2 * v + 1] + d[2 * v + 1]);
}

void add_(int v, int l, int r, int lx, int rx, int x) {
	if(l > rx || r < lx) {
		return;
	}
	if(lx <= l && r <= rx) {
		d[v]+=x;
		return;
	}
	push(v);
	int M = (l + r) / 2;
	add_(2 * v, l, M, lx, rx, x);
	add_(2 * v + 1, M + 1, r, lx, rx, x);
	pull(v);
}

void add(int l, int r ,int x) {
	add_(1, 0, Q - 1, l, r, x);
}

ll get_max() {
	return t[1] + d[1];
}

int main() {
	for(int i = 0; i < 2 * Q; i++) {
		t[i] = -infll;
	}
	scanf("%d%d%d", &n, &m, &p);
	int min_a = inf;
	int min_b = inf;
	for(int i = 0; i < n; i++) {
		scanf("%d%d", &a[i].first, &a[i].second);
		min_a = std::min(min_a, a[i].second);
	}
	for(int i = 0; i < m; i++) {
		scanf("%d%d", &b[i].first, &b[i].second);
		min_b = std::min(min_a, b[i].second);
	}
	sort(a, a+n);
	sort(b, b+m);
	std::vector<Event> events;
	for(int i=0;i<p;i++) {
		int xk, yk, zk;
		scanf("%d%d%d", &xk, &yk, &zk);
		int xl = std::upper_bound(a, a + n, std::make_pair(xk,inf)) - a;
		int yl = std::upper_bound(b, b + m, std::make_pair(yk,inf)) - b;
		if(xl == n || yl == m) continue;
		events.push_back(Event(n - 1, yl, m - 1, zk, OPEN));
		events.push_back(Event(xl, yl, m - 1, zk, CLOSE));
	}
	sort(events.begin(),events.end(),cmp);
	ll ans = -min_a-min_b;
	for(int i=0;i<m;i++) {
		t[i + Q] = -b[i].second;
	}
	for(int i=Q - 1; i >= 0; i--) {
		t[i] = std::max(t[i * 2], t[i * 2 + 1]);
	}
	reverse(events.begin(),events.end());
	for(int x=n - 1;x>=0;x--) {
		while(events.size() && events.back().x == x && events.back().t == OPEN) {
			add(events.back().yl, events.back().yr, events.back().z);
			events.pop_back();
		}
		ans = std::max(ans, get_max() - a[x].second);
		while(events.size() && events.back().x == x && events.back().t == CLOSE) {
			add(events.back().yl, events.back().yr, -events.back().z);
			events.pop_back();
		}
	}
	printf("%lld", ans);
	return 0;
}