#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <queue>
#include <iomanip>

using namespace std;

#define FOR(i, l, r) for(int i = l; i < r; i++)
#define DFOR(i, r, l) for(int i = r; i > l; i--)
#define ASKS(t) for(cin >> t; t; t--)
#define fi first
#define se second

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef set<int> si;
typedef set<ll> sll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

struct segtree{
    int mn;
    int lb, rb;
    segtree *l = 0, *r = 0;

    segtree(int lq, int rq){
        lb = lq;
        rb = rq;
        if(rb - lb > 1){
            int t = (lb + rb) / 2;
            l = new segtree(lb, t);
            r = new segtree(t, rb);
        }
        else{
            // TODO
        }
    }

    int get(int lq, int rq){
        if(lq <= lb && rb <= rq)
            return mn;
        else if(max(lb, lq) >= min(rb, rq))
            return 1000000000;
        else
            return min(l->get(lq, rq), r->get(lq, rq));
    }

    void set(int p, int x){
        if(l){
            if(p < l->rb)
                l->set(p, x);
            else
                r->set(p, x);
            mn = min(l->mn, r->mn);
        }
        else
            mn = x;
    }
};


int main()
{
    cin.tie(0); cout.tie(0); ios::sync_with_stdio(0);

    int n, m, k;
    cin >> n >> m;
    vector<vi> gr(n), obr(n);
    FOR(i, 0, m){
        int a, b;
        cin >> a >> b;
        a--, b--;
        gr[a].push_back(b);
        obr[b].push_back(a);
    }

    cin >> k;
    vi way(k);
    FOR(i, 0, k){
        cin >> way[i];
        way[i]--;
    }

    queue<int> qu;
    vi f(n, -1), b(n, -1);

    qu.push(way.back());
    b[way.back()] = 0;
    while(qu.size()){
        int p = qu.front();
        qu.pop();
        FOR(i, 0, int(obr[p].size())){
            if(b[obr[p][i]] == -1){
                qu.push(obr[p][i]);
                b[obr[p][i]] = b[p] + 1;
            }
        }
    }

    map<int, si> mp;
    qu.push(way[0]);
    f[way[0]] = 0;
    while(qu.size()){
        int p = qu.front();
        qu.pop();
        int mn = 2000000000;
        FOR(i, 0, int(gr[p].size())){
            mn = min(b[gr[p][i]], mn);
            if(f[gr[p][i]] == -1){
                qu.push(gr[p][i]);
                f[gr[p][i]] = f[p] + 1;
            }
        }
        FOR(i, 0, int(gr[p].size())){
            if(b[gr[p][i]] == mn){
                mp[p].insert(gr[p][i]);
            }
        }
    }
    int mn = 0, mx = 0;
    FOR(i, 1, k-1){
        if(mp[way[i-1]].count(way[i]) == 0)
            mn++, mx++;
        else if(mp[way[i-1]].size() > 1)
            mx++;
    }
    cout << mn << ' ' << mx;

    return 0;
}




















