#include <bits/stdc++.h>

using namespace std;

typedef int64_t ll;

const int MOD = 1e9 + 7;
const int MAXN = 2e5 + 15;
const int INF = 2139062143;
const int nINF = -2139062144;
const ll LINF = 9187201950435737471LL;
const ll nLINF = -9187201950435737472LL;

#define all(_x) _x.begin(), _x.end()
#define rall(_x) _x.rbegin(), _x.rend()
#define sz(_x) ((int)_x.size())
#define eb emplace_back
#define pb push_back
#define sqr(_x) ((_x) * (_x))

inline void IO() {
#ifdef buyolitsez
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
}

int n, m;
vector <int> adj[MAXN], g[MAXN];
int dist[MAXN];

void BFS(int from) {
    memset(dist, -1, sizeof(dist));
    dist[from] = 0;
    queue <int> q;
    q.push(from);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto u : adj[v]) {
            if (dist[u] == -1) {
                dist[u] = dist[v] + 1;
                q.push(u);
            }
        }
    }
}

inline void solve() {
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        g[a].eb(b);
        adj[b].eb(a);
    }
    int k;
    cin >> k;
    vector <int> trace(k);
    for (int i = 0; i < k; ++i) {
        cin >> trace[i];
    }
    BFS(trace.back());
    int c1 = 0, c2 = 0;
    for (int i = 0; i < k - 1; ++i) {
        int v = trace[i];
        int to = trace[i + 1];
        int y = INF;
        for (auto u : g[v]) {
            if (u != to) {
                y = min(y, dist[u]);
            }
        }
        if (dist[to] > y) {
            c1++;
            c2++;
        }
        else if (dist[to] == y) {
            c2++;
        }
    }
    cout << c1 << " " << c2;
}

signed main() {
    IO();
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
