#include <bits/stdc++.h>

using namespace std;

typedef int64_t ll;

const int MOD = 1e9 + 7;
const int MAXN = 1e6;
const int N = 2e6 + 15;
const int INF = 2139062143;
const int nINF = -2139062144;
const ll LINF = 9187201950435737471LL;
const ll nLINF = -9187201950435737472LL;

#define all(_x) _x.begin(), _x.end()
#define rall(_x) _x.rbegin(), _x.rend()
#define sz(_x) ((int)_x.size())
#define eb emplace_back
#define pb push_back
#define sqr(_x) ((_x) * (_x))

inline void IO() {
#ifdef buyolitsez
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
}

#define int int64_t
int t[4 * N], tadd[4 * N];

void push(int v, int vl, int vr) {
    if (tadd[v] == 0) {return;}
    t[v] += tadd[v];
    if (vl != vr) {
        tadd[2 * v + 1] += tadd[v];
        tadd[2 * v + 2] += tadd[v];
    }
    tadd[v] = 0;
}

void update(int v, int vl, int vr, int l, int r, int val) {
    assert(vl <= vr);
    if (l > r) {return;}
    push(v, vl, vr);
    if (vl > r || vr < l) {return;}
    if (vl >= l && vr <= r) {
        tadd[v] += val;
        push(v, vl, vr);
        return;
    }
    int vm  = vl + (vr - vl) / 2;
    update(2 * v + 1, vl, vm, l, r, val);
    update(2 * v + 2, vm + 1, vr, l, r, val);
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

inline void solve() {
    update(0, 0, MAXN - 1, 0, MAXN - 1, nINF);
    int n, m, p;
    cin >> n >> m >> p;
    vector <pair <int, int >> a(n), b(m);
    vector <tuple <int, int, int> > monsters(p);
    for (auto &[x, y] : a) {
        cin >> x >> y;
        x--;
    }
    sort(all(a));
    set <pair <int, int> > was;
    map <int, int> q;
    for (auto &[x, y] : b) {
        cin >> x >> y;
        x--;
        if (q.find(x) == q.end()) {
            q[x] = y;
        }
        else {
            q[x] = min(q[x], y);
        }
    }
    for (auto [x, y] : q) {
        update(0, 0, MAXN - 1, x, x, -y - nINF);
    }
    for (auto &[attack, defense, cost] : monsters) {
        cin >> attack >> defense >> cost;
        attack--;
        defense--;
    }
    sort(all(monsters));
    int pos = 0;
    int ans = nINF;
    for (auto [x, y] : a) {
        int now = -y;
        while (pos < sz(monsters)) {
            int attack, defense, cost;
            tie(attack, defense, cost) = monsters[pos];
            if (attack < x) {
                update(0, 0, MAXN - 1, defense + 1, MAXN - 1, cost);
                pos++;
            }
            else {
                break;
            }
        }
        push(t[0], 0, MAXN - 1);
        now += t[0];
        ans = max(ans, now);
    }
    cout << ans;
}

signed main() {
    IO();
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
