#include <bits/stdc++.h>

using namespace std;

#define loop(i, n) for(int i = 0; i < n; ++i)
#define vec vector
#define FOR(i, a, n) for(int i = a; i < n; ++i)
#define pb push_back
#define SZ(x) (int) x.size()
#define all(x) x.begin(), x.end()
#define paii pair<int, int>
#define fr first
#define sc second

#define int long long

const int MAXN = 3e5 + 47, inf = 1e16 + 47;

struct mon{
    int x, y, p;
    mon() {
        x = y = p = -1;
    }
};

struct node{
    int l, r, mx, dw;
    node() {
        l = r = mx = -inf;
        dw = 0;
    }
};

int n, m, p;
vec<paii> a, b;
vec<mon> c;

bool cmp(mon a, mon b) {
    return a.x < b.x;
}

vec<int> t1(MAXN);
vec<node> t(4 * MAXN);

void build(int i, int l, int r) {
    t[i].l = l, t[i].r = r;
    if(l == r) {
        t[i].mx = -b[l].sc;
        return ;
    }
    int mid = (l + r) / 2;
    build(i * 2, l, mid);
    build(i * 2 + 1, mid + 1, r);
    t[i].mx = max(t[i * 2].mx, t[i * 2 + 1].mx);
}

void build() {
    t1.resize(m);
    loop(i, m) t1[i] = -b[i].sc;
}

void push(int i) {
    if(t[i].l != t[i].r) {
        t[i * 2].dw += t[i].dw;
        t[i * 2 + 1].dw += t[i].dw;
    }
    t[i].mx += t[i].dw;
    t[i].dw = 0;
}

void update(int i, int l, int r, int add) {
    push(i);
    if(l > t[i].r || t[i].l > r) return;
    if(l <= t[i].l && t[i].r <= r) {
        t[i].dw += add;
        push(i);
        return ;
    }
    update(i * 2, l, r, add);
    update(i * 2 + 1, l, r, add);
    t[i].mx = max(t[i * 2].mx, t[i * 2 + 1].mx);
}

void update(int l, int r, int add) {
    FOR(i, l, r + 1) t1[i] += add;
}

int get() {
    push(1);
    return t[1].mx;
}
int get_1() {
    int mx = -inf;
    loop(i, m - 1) mx = max(mx, t1[i]);
    return mx;
}

void solve() {
    cin >> n >> m >> p;
    a.resize(n), b.resize(m);
    c.resize(p);
    loop(i, n) cin >> a[i].fr >> a[i].sc;
    loop(i, m) cin >> b[i].fr >> b[i].sc;
    sort(all(a)), sort(all(b));
    loop(i, p) {
        cin >> c[i].x >> c[i].y >> c[i].p;
    }
    sort(all(c), cmp);/*
    loop(i, n) cout << a[i].fr << " ";
    cout << endl;
    loop(i, m) cout << b[i].fr << " ";
    cout << endl;
    loop(i, p) cout << c[i].x << " ";
    cout << endl;*/
    int uk = 0, ans = -inf;
    build(1, 0, m - 1);
    loop(i, n) {
        while(uk < p && c[uk].x < a[i].fr) {
            paii tm = {c[uk].y, inf};
            int ind = (int)(upper_bound(all(b), tm) - b.begin());
            update(1, ind, m - 1, c[uk].p);
            //cout << ind << endl;
            uk++;
        }
        //cout << "l" << endl;
        //cout << i << " " << uk << endl;
        //loop(i, m) cout << t[i] << " ";
        //cout << endl;
        ans = max(ans, -a[i].sc + get());
    }
    cout << ans << endl;
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifdef COFFEE_MACHINE
        freopen("input.cpp", "r", stdin);
        freopen("output.cpp", "w", stdout);
    #endif

    int t = 1;
    //cin >> t;
    while(t--) {
        solve();
    }
}

