#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define size(x) int(x.size())
#define mp make_pair

using namespace std;

void using_file() {
    #ifdef MY
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
}

template<typename T>
bool uin(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool uax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
void _debug(T h) {
    cerr << h << "]\n";
}

template<typename T, typename... U>
void _debug(T h, U... t) {
    cerr << h << ", ";
    _debug(t...);
}

#define value(...) cerr << '[' << #__VA_ARGS__ << "] = ["; _debug(__VA_ARGS__);

template<typename T, typename U>
ostream &operator<<(ostream &os, pair<T, U> &a) {
    os << "(" << a.first << ", " << a.second << ")";
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    os << "|";
    for (int i = 0; i < size(a); ++i) {
        os << a[i];
        if (i + 1 < size(a)) {
            os << ", ";
        }
    }
    os << "|";
}

typedef long long ll;
typedef long double ld;

const ll inf = ll(1e12) + 7;
const ll maxn = ll(1e6) + 16;

ll t[4 * maxn] = {};
ll pd[4 * maxn] = {};

bool check(ll v) {
    return 2 * v + 1 < 4 * maxn;
}

void push(ll v) {
    t[v] += pd[v];
    if (check(v)) {
        pd[2 * v] += pd[v];
        pd[2 * v + 1] += pd[v];
    }
    pd[v] = 0;
}

void relax(ll v) {
    if (check(v)) {
        t[v] = max(t[2 * v], t[2 * v + 1]);
    }
}

ll get(ll v, ll l, ll r, ll nl, ll nr) {
    push(v);
    if (l > r || nl > nr) {
        return -inf;
    }
    if (l == nl && r == nr) {
        return t[v];
    }
    ll m = (l + r) / 2;
    ll res = -inf;
    uax(res, get(2 * v, l, m, nl, min(m, nr)));
    uax(res, get(2 * v + 1, m + 1, r, max(nl, m + 1), nr));
    relax(v);
    return res;
}

ll get(ll l, ll r) {
    return get(1, 0, maxn - 1, l, r);
}

void add(ll v, ll l, ll r, ll nl, ll nr, ll x) {
    push(v);
    if (l > r || nl > nr) {
        return;
    }
    if (l == nl && r == nr) {
        pd[v] += x;
        push(v);
        return;
    }
    ll m = (l + r) / 2;
    add(2 * v, l, m, nl, min(m, nr), x);
    add(2 * v + 1, m + 1, r, max(nl, m + 1), nr, x);
    relax(v);
    return;
}

void add(ll l, ll r, ll x) {
    add(1, 0, maxn - 1, l, r, x);
}

void add(ll pos, ll x) {
    add(1, 0, maxn - 1, pos, pos, x);
}

ll cost[maxn] = {};

void pre() {
    for (ll i = 0; i < maxn; ++i) {
        cost[i] = -inf;
    }
}

void build(ll v, ll l, ll r) {
    if (l > r) {
        return;
    }
    if (l == r) {
        t[v] = cost[l];
        return;
    }
    ll m = (l + r) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m + 1, r);
    relax(v);
}

ll n, m, p;
vector<pair<ll, ll>> a, b;
vector<pair<pair<ll, ll>, ll>> c;

void read() {
    cin >> n >> m >> p;
    a.resize(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    b.resize(m);
    for (ll i = 0; i < m; ++i) {
        cin >> b[i].first >> b[i].second;
    }
    c.resize(p);
    for (ll i = 0; i < p; ++i) {
        cin >> c[i].first.first >> c[i].first.second >> c[i].second;
    }
}

void solve() {
    sort(all(c));
    sort(all(a));
    for (ll i = 0; i < m; ++i) {
        uax(cost[b[i].first], -b[i].second);
    }
    build(1, 0, maxn - 1);
    ll ans = -inf;
    ll pos = -1;
    for (ll i = 0; i < n; ++i) {
        while (pos + 1 < p && a[i].first > c[pos + 1].first.first) {
            ++pos;
            add(c[pos].first.second + 1, maxn - 1, c[pos].second);
        }
        uax(ans, get(0, maxn - 1) - a[i].second);
    }
    cout << ans << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    using_file();
    pre();
    read();
    solve();
    return 0;
}
