#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <queue>

#define debug(x) std::cerr << #x << ": " << x << std::endl;
#define read(x) for(auto &now : x) std::cin >> now;
#define print(x) for(auto &now : x) std::cout << now << " ";std::cout << "\n"
using namespace std;
typedef long long ll;
typedef long double ld;

vector<vector<int>> G, G_rev;

int main(){
    int n, m;
    cin >> n >> m;
    G.resize(n);
    G_rev.resize(n);
    for(int i = 0; i < m; ++i){
        int a, b;
        cin >> a >> b; --a; --b;
        G[a].push_back(b);
        G_rev[b].push_back(a);
    }
    int k;
    cin >> k;
    vector<int> path(k);
    for(int i = 0; i < k; ++i){
        cin >> path[i];
        path[i]--;
    }

    queue<int> q;
    vector<int> used(n), d(n);
    q.push(path.back());
    used[path.back()] = 1;
    while(!q.empty()){
        int x = q.front();
        q.pop();
        for(auto to : G_rev[x]){
            if(!used[to]){
                used[to] = 1;
                q.push(to);
                d[to] = d[x] + 1;
            }
        }
    }
    int mn = 0, mx = 0;
    for(int i = 0; i < k - 1; ++i){
        int localMn = 1e9;
        for(auto now : G[path[i]]){
            if(now != path[i+1])
                localMn = min(localMn, d[now]);
        }
        if(localMn < d[path[i+1]]){
            mn++;
            mx++;
        } else if(localMn == d[path[i+1]]){
            mx++;
        }
    }
    cout << mn << " " << mx;
    return 0;
}
