#pragma GCC optimize("Ofast,fast-math,unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define int ll
#define endl '\n'
#define all(C) (C).begin(), (C).end()
#define rall(C) (C).rbegin(), (C).rend()
#define pb emplace_back
#define mp make_pair
#define dbg(x) cerr << #x << " : " << x << endl

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

/*
const int MAX_MEM = 2e8;
char MEM[MAX_MEM];
int CUR_MEM = 0;
void* operator new (size_t x)
{
	auto ret = MEM + CUR_MEM;
	CUR_MEM += x;
	assert(CUR_MEM < MAX_MEM);
	return ret;
}
void operator delete(void*) {}
*/
template <class T>
istream& operator >> (istream &in, vector <T> &a)
{
	for (auto &i : a)
		in >> i;
	return in;
}
template <class T>
ostream& operator << (ostream &out, vector <T> &a)
{
	for (auto &i : a)
		out << i << " ";
	return out;
}
template <class T, class U>
istream& operator >> (istream &in, pair <T, U> &a)
{
	in >> a.first >> a.second;
	return in;
}
template <class T, class U>
ostream& operator << (ostream &out, pair <T, U> &a)
{
	out << a.first << " " << a.second;
	return out;
}

inline void Start()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
}

struct node
{
	int val;
	int vl, vr;
	node *l = 0, *r = 0;
	node() {}
	node(int tl, int tr, vector <int> &a)
	{
		vl = tl, vr = tr;
		if (vr - vl == 1)
		{
			val = a[vl];
			return;
		}
		l = new node(vl, (vl + vr) >> 1, a), r = new node((vl + vr) >> 1, vr, a);
		val = l->val + r->val;
	}
	int get(int ql, int qr)
	{
		if (ql == vl && qr == vr)
		{
			return val;
		}
		int vm = (vl + vr) >> 1;
		if (qr <= vm)
			return l->get(ql, qr);
		if (ql >= vm)
			return r->get(ql, qr);
		return l->get(ql, vm) + r->get(vm, qr);
	}
	void change(int pos, int x)
	{
		if (vr - vl == 1)
		{
			val = x;
			return;
		}
		int vm = (vl + vr) >> 1;
		if (pos < vm)
			l->change(pos, x);
		else
			r->change(pos, x);
	}
};
struct fen
{
	int n;
	vector <int> t;
	fen() {} 
	fen(int _n)
	{
		n = _n;
		t.assign(n + 1, 0);
	}
	int get(int i)
	{
		int ret = 0;
		for (; i; i -= i & -i)
			ret += t[i];
		return ret;
	}
	int get(int l, int r)
	{
		return get(r) - get(l - 1);
	}
	void change(int pos, int x)
	{
		for (; pos <= n; pos += pos & -pos)
			t[pos] += x;
	}
};

signed main()
{
	Start();
	int n;
	cin >> n;
	string s;
	cin >> s;
	s = "$" + s + "$";
	n = s.size();
	vector <vector <int>> dp(n, vector <int> (n));
	for (int len = 0; len < n; ++len)
	{
		for (int l = 0; l + len < n; ++l)
		{
			int r = l + len;
			if (l)
				dp[l - 1][r] = max(dp[l - 1][r], dp[l][r]);
			if (r + 1 < n)
				dp[l][r + 1] = max(dp[l][r + 1], dp[l][r]);
			if (r - l + 1 >= 2 && dp[l][r] == r - l - 1)
			{
				if (s[l] + 1 == s[r])
				{
					dp[l][r + 1] = max(dp[l][r + 1], dp[l][r] + 1);
				}
				if (s[l] == s[r] + 1)
				{
					dp[l - 1][r] = max(dp[l - 1][r], dp[l][r] + 1);
				}
			}
			if (r - l + 1 >= 2)
			{
				if (s[r - 1] + 1 == s[r])
				{
					dp[l][r + 1] = max(dp[l][r + 1], dp[l][r] + 1);
				}
				if (s[l + 1] + 1 == s[l])
				{
					dp[l - 1][r] = max(dp[l - 1][r], dp[l][r] + 1);
				}
				if (s[r + 1] + 1 == s[r])
				{
					dp[l][r + 1] = max(dp[l][r + 1], dp[l][r] + 1);
				}
				if (s[l - 1] + 1 == s[l])
				{
					dp[l - 1][r] = max(dp[l - 1][r], dp[l][r] + 1);
				}
			}
		}
	}
	cout << dp[0][n - 1];
	return 0;
}
