#pragma GCC optimize("Ofast,fast-math,unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define int ll
#define endl '\n'
#define all(C) (C).begin(), (C).end()
#define rall(C) (C).rbegin(), (C).rend()
#define pb emplace_back
#define mp make_pair
#define dbg(x) cerr << #x << " : " << x << endl

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

/*
const int MAX_MEM = 2e8;
char MEM[MAX_MEM];
int CUR_MEM = 0;
void* operator new (size_t x)
{
	auto ret = MEM + CUR_MEM;
	CUR_MEM += x;
	assert(CUR_MEM < MAX_MEM);
	return ret;
}
void operator delete(void*) {}
*/
template <class T>
istream& operator >> (istream &in, vector <T> &a)
{
	for (auto &i : a)
		in >> i;
	return in;
}
template <class T>
ostream& operator << (ostream &out, vector <T> &a)
{
	for (auto &i : a)
		out << i << " ";
	return out;
}
template <class T, class U>
istream& operator >> (istream &in, pair <T, U> &a)
{
	in >> a.first >> a.second;
	return in;
}
template <class T, class U>
ostream& operator << (ostream &out, pair <T, U> &a)
{
	out << a.first << " " << a.second;
	return out;
}

inline void Start()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
}

const int INF = 1e18;

struct node
{
	int val, add = 0;
	int vl, vr;
	node *l = 0, *r = 0;
	node() {}
	node(int tl, int tr, vector <int> &a)
	{
		vl = tl, vr = tr;
		if (vr - vl == 1)
		{
			val = a[vl];
			return;
		}
		l = new node(vl, (vl + vr) >> 1, a), r = new node((vl + vr) >> 1, vr, a);
		val = max(l->val, r->val);
	}
	void push()
	{
		val += add;
		if (l)
			l->add += add, r->add += add;
		add = 0;
	}
	void pull()
	{
		push();
		if (l)
		{
			l->push();
			r->push();
			val = max(l->val, r->val);
		}
	}
	int get(int ql, int qr)
	{
		push();
		if (ql == vl && qr == vr)
		{
			pull();
			return val;
		}
		int ret = -INF;
		int vm = (vl + vr) >> 1;
		if (qr <= vm)
			ret = l->get(ql, qr);
		else if (ql >= vm)
			ret = r->get(ql, qr);
		else
			ret = max(l->get(ql, vm), r->get(vm, qr));
		pull();
		return ret;
	}
	void change(int ql, int qr, int x)
	{
		push();
		if (vl == ql && vr == qr)
		{
			add += x;
			push();
			return;
		}
		int vm = (vl + vr) >> 1;
		if (qr <= vm)
			l->change(ql, qr, x);
		else if (ql >= vm)
			r->change(ql, qr, x);
		else
			l->change(ql, vm, x), r->change(vm, qr, x);
		pull();
	}
};
struct fen
{
	int n;
	vector <int> t;
	fen() {} 
	fen(int _n)
	{
		n = _n;
		t.assign(n + 1, 0);
	}
	int get(int i)
	{
		int ret = 0;
		for (; i; i -= i & -i)
			ret += t[i];
		return ret;
	}
	int get(int l, int r)
	{
		return get(r) - get(l - 1);
	}
	void change(int pos, int x)
	{
		for (; pos <= n; pos += pos & -pos)
			t[pos] += x;
	}
};

signed main()
{
	Start();
	int n, m, p;
	cin >> n >> m >> p;
	vector <pii> a(n), b(m);
	cin >> a >> b;
	sort(all(a));
	sort(all(b));
	vector <int> cb(m);
	for (int i = 0; i < m; ++i)
		cb[i] = -b[i].second;
	node *t = new node(0, m, cb);
	vector <pair <pii, int>> xyz(p);
	cin >> xyz;
	sort(all(xyz));
	int ans = -INF;
	for (int i = 0, j = 0; i < n; ++i)
	{
		while (j < p && xyz[j].first.first < a[i].first)
		{
			int pos = lower_bound(all(b), mp(xyz[j].first.second + 1, -1ll)) - b.begin();
			if (pos < m)
				t->change(pos, m, xyz[j].second);
			++j;
		}
		ans = max(ans, -a[i].second + t->get(0, m));
	}
	cout << ans;
	return 0;
}
