#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#include <map>
#include <deque>

using namespace std;

#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

void files()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
}

vector<int> tree;

void update(int v, int l, int r, int ql, int qr, int val)
{
	if (l >= qr || r <= ql)
		return;
	if (l >= ql && r <= qr)
    {
		tree[v] += val;
		return;
    }
	int m = (l + r) / 2;
	update(2 * v + 1, l, m, ql, qr, val);
	update(2 * v + 2, m, r, ql, qr, val);
	tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

int get(int v, int l, int r, int ql, int qr)
{
	if (l >= qr || r <= ql)
		return 0;
	if (l >= ql && r <= qr)
		return tree[v];
	int m = (l + r) / 2;
	return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
}

int main()
{
	files();
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n, m, p;
	cin >> n >> m >> p;
	int ans = -1e9 - 1e9 - 1e9;
	vector<pair<int, int> > ar;
	for (int i = 0; i < n; ++i)
	{
		int a, b;
		cin >> a >> b;
		ar.push_back(make_pair(a, b));
	}
	vector<pair<int, int> > ar2;
	for (int i = 0; i < m; ++i)
	{
		int a, b;
		cin >> a >> b;
		ar2.push_back(make_pair(a, b));
	}
	vector<vector<int> > ar3(p, vector<int>(3, 0));
	for (int i = 0; i < p; ++i)
	{
		int a, b, c;
		cin >> a >> b >> c;
		ar3[i][1] = a;
		ar3[i][0] = b;
		ar3[i][2] = c;
	}
	sort(ar.begin(), ar.end());
	sort(ar2.begin(), ar2.end());
	sort(ar3.begin(), ar3.end());
	vector<vector<pair<int, int> > > prof(n, vector<pair<int, int> >());
	for (int i = 0; i < p; ++i)
	{
	    pair<int, int> pertyuo = make_pair(ar3[i][1], 1e9);
		int it = upper_bound(ar.begin(), ar.end(), pertyuo) - ar.begin();
		if (it != ar.end() - ar.begin())
		{
			prof[it].push_back(make_pair(ar3[i][0], ar3[i][2]));
		}
	}
	int cost = 1e9;
	for (int i = m - 1; i > -1; --i)
	{
		cost = min(cost, ar2[i].second);
		ar2[i].second = cost;
	}
	int uk = 0;
	int navar = 0;
	int bestsword = -1;
	int navar2 = 0;
	tree = vector<int>(1e4 + 100, 0);
	ans = -1e9 * 3;
	for (int i = 0; i < n; ++i)
	{
	    //cout << i << endl;
		int bestbr = uk;
		int bestnavar2 = -ar2[uk].second;
		int navar3 = 0;
		int uk2 = uk;
		for (int j = 0; j < prof[i].size(); ++j)
		{
			if (prof[i][j].first < ar2[uk2].first)
			{
				navar3 += prof[i][j].second;
				if (bestnavar2 <= navar3 - ar2[uk2].second)
				{
					bestbr = uk2;
					bestnavar2 = navar3 - ar2[uk2].second;
				}
			}
			else
			{
			    pair<int, int> pertyuo = make_pair(prof[i][j].first, 1e9);
				int it = upper_bound(ar2.begin(), ar2.end(), pertyuo) - ar2.begin();
				if (it == ar2.end() - ar2.begin())
					break;
				uk2 = it;
				navar3 += prof[i][j].second;
				navar3 += get(0, 0, 1e6 + 5, ar2[uk2].first, 1e6 + 5);
				if (bestnavar2 <= navar3 - ar2[uk2].second)
				{
					bestbr = uk2;
					bestnavar2 = navar3 - ar2[uk2].second;
				}
			}
		}
		if (navar2 + bestnavar2 - ar[i].second > ans)
		{
			ans = navar2 + bestnavar2 - ar[i].second;
			navar2 += bestnavar2 + ar2[bestbr].second;
			uk = bestbr;
		}
		//cout << ans << endl;
		for (int j = 0; j < prof[i].size(); ++j)
		{
			if (prof[i][j].first >= ar2[uk].first)
			{
				update(0, 0, 1e6 + 5, prof[i][j].first, prof[i][j].first + 1, prof[i][j].second);
			}
		}
	}
	cout << ans << endl;
}
