#include <bits/stdc++.h>
using namespace std;

#define all(x) (x).begin(), (x).end()

const int INF = 1e9;
const int N = 2e5 + 1;
const int L = 20;
vector<pair<int, int>> nw_g[N];
double d[N];
int ans[N];


void solve(vector<int> &start, vector<int> &speed, vector<int> &in) {
    vector<pair<int, pair<int, int>>> q;
    set<pair<double, int>> st;
    for (int i = 0; i < start.size(); ++i) {
        ans[start[i]] = i;
        d[start[i]] = 0;
        st.insert({0, start[i]});
    }
    while (!st.empty()) {
        int v = st.begin()->second;
        st.erase(st.begin());
        for (auto & lll : nw_g[v]) {
            int to = lll.first, cost = lll.second;
            double tim = ((double)(cost + speed[ans[v]] - 1)) / speed[ans[v]];
            if ((d[to] > d[v] + tim) || (d[to] == d[v] + tim && ans[v] < ans[to])) {
                st.erase({d[to], to});
                d[to] = d[v] + tim;
                ans[to] = ans[v];
                st.insert({d[to], to});
            }
        }
    }
    for (auto i : in) {
        cout << ans[i] + 1 << " ";
    }
    cout << '\n';
}

vector<int> g[N];
int tin[N];
int dist[N];
int tim = 1;
int p[N][L];

void dfsCalc(int v, int pr) {
    dist[v] = dist[pr] + 1;
    p[v][0] = pr;
    tin[v] = tim++;
    for (int i = 1; i < L; ++i) {
        p[v][i] = p[p[v][i - 1]][i - 1];
    }
    for (auto i : g[v]) {
        if (i != pr) {
            dfsCalc(i, v);
        }
    }
}

int lca(int a, int b) {
    if (dist[a] < dist[b]) {
        swap(a, b);
    }
    int x = dist[a] - dist[b];
    for (int i = 0; i < L; ++i) {
        if ((x >> i) & 1) {
            a = p[a][i];
        }
    }
    if (a == b) {
        return a;
    }
    for (int i = L - 1; i >= 0; --i) {
        if (p[a][i] != p[b][i]) {
            a = p[a][i];
            b = p[b][i];
        }
    }
    return p[a][0];
}

void solve() {
    int k, m;
    cin >> k >> m;
    vector<int> a(k), speed(k);
    vector<int> al;
    for (int i = 0; i < k; ++i) {
        cin >> a[i] >> speed[i];
        al.push_back(a[i]);
    }
    vector<int> in(m);
    for (int i = 0; i < m; ++i) {
        cin >> in[i];
        al.push_back(in[i]);
    }
    sort(all(al), [&](int a, int b) {
        return tin[a] < tin[b];
    });
    int n = al.size();
    for (int i = 0; i < n - 1; ++i) {
        int aa = al[i];
        int bb = al[i + 1];
        int pr = lca(aa, bb);
        if (aa != pr) {
            nw_g[aa].emplace_back(pr, dist[aa] - dist[pr]);
            nw_g[pr].emplace_back(aa, dist[aa] - dist[pr]);
        }
        if (bb != pr) {
            nw_g[bb].emplace_back(pr, dist[bb]- dist[pr]);
            nw_g[pr].emplace_back(bb, dist[bb] - dist[pr]);
        }
    }
    solve(a, speed, in);
    for (auto i : al) {
        for (auto j : nw_g[i]) {
            ans[j.first] = d[j.first] = INF;
        }
        nw_g[i].clear();
    }
}
signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;
    for (auto &i : d) i = INF;
    for (auto &i : ans) i = INF;


    for (int i = 1; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        g[a].emplace_back(b);
        g[b].emplace_back(a);
    }
    dfsCalc(1, 0);
    int q;
    cin >> q;
    while (q--) {
        solve();
    }

}