#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <map>
#include <queue>
#include <random>
#include <ctime>
#include <cstring>
#include <string>

using namespace std;

#define mp make_pair
#define all(x) x.begin(), x.end()
#define multi_test 0
#define int ll

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ll, int> pli;

void solve();

const int MAXN = 3e5 + 7;
const int MOD = 1e9 + 9;
const int INF = 2e9 + 11;
const ll INF1 = 9e18;
const ld EPS = 1e-8;

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int q = 1;
	if (multi_test) cin >> q;
	while (q--) solve();
}

/*----------------------------------------------------------------------------------------*/

vector<int> bfs(int s, const vector<vector<int>> &g) {
    int n = g.size();
    vector<bool> used(n);
    used[s] = true;
    vector<int> d(n);
    queue<int> q;
    q.push(s);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int i = 0; i < g[v].size(); ++i) {
            int to = g[v][i];
            if (!used[to]) {
                used[to] = true;
                d[to] = d[v] + 1;
                q.push(to);
            }
        }
    }
    return d;
}

void solve() {
	int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n), revg(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].push_back(v);
        revg[v].push_back(u);
    }
    int k;
    cin >> k;
    vector<int> vk(k);
    for (int i = 0; i < k; ++i) {
        cin >> vk[i];
        --vk[i];
    }
    int s = vk[0], f = vk.back();
    vector<int> d = bfs(s, g);
    int ans1 = 0, ans2 = 0;
    for (int i = k - 1; i > 0; --i) {
        if (i != d[vk[i]]) {
            ++ans1;
        } else if (i < k - 1) {
            bool found = false;
            for (int j = 0; j < g[vk[i - 1]].size(); ++j) {
                int toj = g[vk[i - 1]][j];
                if (toj == vk[i])
                    continue;
                for (int l = 0; l < g[toj].size(); ++l) {
                    int tol = g[toj][l];
                    if (tol == vk[i + 1]) {
                        found = true;
                        break;
                    }
                }
                if (found)
                    break;
            }
            if (found){
                ++ans2;
                //cout << i << endl;
            }
        }
    }
    cout << ans1 << ' ' << ans1 + ans2 << '\n';

}
