#include<bits/stdc++.h>
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;

const ll MAXN = 2e5 + 100;
ll t[4 * MAXN], a[MAXN], tAdd[4 * MAXN];


void push(int v, int tl, int tr){
    //cout << v <<  " " << t[v] << " " << tl << " " << tr << " " << tAdd[v] << "\n";
    if(tAdd[v] != 0){
        t[v] += tAdd[v];
        if(tl != tr){
            tAdd[2 * v + 1] += tAdd[v];
            tAdd[2 * v + 2] += tAdd[v];
        }
        tAdd[v] = 0;
    }
}


void build(int v, int tl, int tr, ll a[]){
    if(tl > tr)return;
    if(tl == tr){
        t[v] = a[tl];
        return;
    }
    int tm = (tl + tr) / 2;
    build(2 * v + 1, tl, tm, a);
    build(2 * v + 2, tm + 1, tr, a);
    t[v] = max(t[2 * v + 1],  t[2 * v + 2]);
}

ll query(int v, int tl, int tr, ll l, ll r){
    push(v, tl, tr);
    if(r < tl || l > tr)return -1e18;
    if(tl >= l && tr <= r){
        push(v, tl, tr);
        return t[v];
    }
    int tm = (tl + tr) / 2;
    return max(query(2 * v + 1, tl, tm, l, r), query(2 * v + 2, tm + 1, tr, l, r));
}

void update(int v, int tl, int tr, ll l, ll r, ll add){
    push(v, tl, tr);
    if(r < tl || l > tr)return;
    if(tl >= l && tr <= r){
        tAdd[v] += add;
        push(v, tl, tr);
        return;
    }
    int tm = (tl + tr) / 2;
    update(2 * v + 1, tl, tm, l, r, add);
    update(2 * v + 2, tm + 1, tr, l, r, add);
    push(v, tl, tr);
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}


struct unit{
    ll hp, a, cost;
};

bool cmp(unit a, unit b){
    return a.hp == b.hp ? a.a < b.a : a.hp < b.hp;
}



int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    ll ans = -1e18;
    int n, m, p;
    cin >> n >> m >> p;
    vector<pair<ll, ll> > attack(n), def(m);
    for(int i = 0; i < n; i++){
        cin >> attack[i].first >> attack[i].second;
    }
    for(int i = 0; i < m; i++){
        cin >> def[i].first >> def[i].second;
    }
    vector<unit> enemy(p);
    for(int i = 0; i < p; i++){
        cin >> enemy[i].hp >> enemy[i].a >> enemy[i].cost;
    }
    for(int i = 0; i < n; i++){
        enemy.push_back({attack[i].first, 0, -attack[i].second});
    }
    sort(enemy.begin(), enemy.end(), cmp);
    sort(def.begin(), def.end());
    int cnt = 0;
    for(int i = 0; i < m; i++){
        a[i] = -def[i].second;
    }
    build(0, 0, m - 1, a);
    for(int i = 0; i < n + p; i++){
        if(enemy[i].a == 0){
            ll cur = query(0, 0, m - 1, 0, m - 1);
            //cout << "w " << cur << "\n";
            ans = max(ans, enemy[i].cost + cur);
        }
        else{
            int it = (int)(upper_bound(def.begin(), def.end(), make_pair(enemy[i].a + 1, 0LL)) - def.begin());
            //cout << "e " << it << "\n";
            if(it > m - 1)continue;
            update(0, 0, m - 1, it, m - 1, enemy[i].cost);
        }
    }
    cout << ans;
}
