#include <iostream>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <limits>
#include <map>
#include <vector>
#include <set>
#include <string>
#include <cstdio>
#include <cstring>
#include <cassert>
#include <queue>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define f first
#define s second
#define FAST_IO() ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

namespace __gnu_pbds {
    template<typename T>
    using pbds_tree = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
}
template<typename T>
using pbds_tree = __gnu_pbds::pbds_tree<T>;
// order_of_key
// find_by_order

const int MAXN = 2e5 + 5;
int n, m, k;
vector<int> ord;
vector<int> g[MAXN];
vector<int> rg[MAXN];
int d[MAXN];
int s, t;

void cdist() {
    queue<int> q;
    rep(i, n) {
        d[i] = -1;
    }
    d[t] = 0;
    q.push(t);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto to : rg[v]) {
            if (d[to] != -1) continue;
            d[to] = d[v] + 1;
            q.push(to);
        }
    }
}

int main() {
    FAST_IO();
    cin >> n >> m;
    rep(i, m) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        rg[v].push_back(u);
    }
    cin >> k;
    ord.resize(k);
    rep(i, k) {
        int v;
        cin >> v;
        v--;
        ord[i] = v;
    }
    s = ord[0], t = ord.back();

    cdist();

    int mn = 0, mx = 0;

    for (int i = 0; i + 1 < k; ++i) {
        int cur = ord[i], nxt = ord[i + 1];
        //cout << cur << " -> " << nxt << endl;
        if (d[nxt] == d[cur] - 1) {
            bool ok = false;
            for (auto to : g[cur]) {
                if (to == nxt) continue;
                if (d[to] == d[cur] - 1) {
                    ok = true;
                    break;
                }
            }
            if (ok) mx++;
        } else {
            mn++;
            mx++;
        }
    }

    cout << mn << ' ' << mx << endl;
}

