#include <iostream>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <limits>
#include <map>
#include <vector>
#include <set>
#include <string>
#include <cstdio>
#include <cstring>
#include <cassert>
#include <queue>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define f first
#define s second
#define FAST_IO() ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

namespace __gnu_pbds {
    template<typename T>
    using pbds_tree = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
}
template<typename T>
using pbds_tree = __gnu_pbds::pbds_tree<T>;
// order_of_key
// find_by_order

struct monster {
    int x, y, z;
};
const ll LINF = 1e15;
const int MAXN = 2e5 + 5;
int n, m, k;
pii a[MAXN];
pii b[MAXN];
monster c[MAXN];

ll mx[MAXN * 4];
ll ad[MAXN * 4];

void push(int v) {
    ad[v * 2 + 1] += ad[v];
    ad[v * 2 + 2] += ad[v];
    mx[v] += ad[v];
    ad[v] = 0;
}

ll get(int v) {
    return ad[v] + mx[v];
}

void add(int v, int tl, int tr, int l, int r, ll x) {
    if (r <= tl || tr <= l) return;
    if (l <= tl && tr <= r) {
        ad[v] += x;
        return;
    }

    push(v);
    int tm = tl + (tr - tl) / 2;
    add(v * 2 + 1, tl, tm, l, r, x);
    add(v * 2 + 2, tm, tr, l, r, x);
    mx[v] = max(get(v * 2 + 1), get(v * 2 + 2));
    /*for (int i = l; i < r; ++i) {
        mx[i] += x;
    }*/
}

int main() {
    FAST_IO();
    cin >> n >> m >> k;
    rep(i, n) {
        cin >> a[i].f >> a[i].s;
    }
    rep(i, m) {
        cin >> b[i].f >> b[i].s;
    }
    rep(i, k) {
        cin >> c[i].x >> c[i].y >> c[i].z;
    }

    sort(a, a + n);
    sort(b, b + m);
    sort(c, c + k, [&](const monster &a, const monster &b){
        return a.x < b.x;
    });

    rep(i, m) {
        add(0, 0, m, i, i + 1, -b[i].s);
    }

    /*rep(i, m) {
        cout << mx[i] << ' ';
    }
    cout << endl;*/

    int j = 0;
    ll res = INT64_MIN;
    for (int i = 0; i < n; ++i) {
        while (j < k && c[j].x < a[i].f) {
            int pos = upper_bound(b, b + m, make_pair(c[j].y + 1, -1)) - b;
            add(0, 0, m, pos, m, c[j].z);
            j++;
        }
        res = max(res, get(0) - a[i].s);
    }

    cout << res << endl;
}

