//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("sse,sse2,sse3,sse4,avx,avx2")
#include <iostream>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <limits>
#include <map>
#include <vector>
#include <set>
#include <string>
#include <cstdio>
#include <cstring>
#include <cassert>
#include <queue>
#include <bitset>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define f first
#define s second
#define FAST_IO() ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

namespace __gnu_pbds {
    template<typename T>
    using pbds_tree = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
}
template<typename T>
using pbds_tree = __gnu_pbds::pbds_tree<T>;
// order_of_key
// find_by_order

const int MAXN = 2e5 + 5;
int n;
vector<int> g[MAXN];
int h[MAXN];
int up[MAXN][20];
int tin[MAXN];
int tout[MAXN];
int tt = 0;
vector<pii> gg[MAXN];

void dfs(int v, int p) {
  up[v][0] = (p == -1 ? v : p);
  for (int i = 1; i < 20; ++i) {
    up[v][i] = up[up[v][i - 1]][i - 1];
  }
  tin[v] = tt++;
  for (auto to : g[v]) {
    if (to == p) continue;
    h[to] = h[v] + 1;
    dfs(to, v);
  }
  tout[v] = tt;
}

void init() {
  dfs(0, -1);
}

bool is_par(int a, int b) {
  return tin[a] <= tin[b] && tin[b] < tout[a];
}

int lca(int a, int b) {
  if (is_par(a, b)) return a;
  if (is_par(b, a)) return b;
  for (int i = 20; i >= 0; --i) {
    if (!is_par(up[a][i], b)) {
      a = up[a][i];
    }
  }
  return up[a][0];
}

auto cmp(int a, int b) {
  return tin[a] < tin[b];
}

int cnt;

void build(int v, int &last, const vector<int> &ver) {
  while (last < cnt && is_par(v, last)) {
    gg[v].push_back({last, h[verlast] - h[v]});
    gg[last].push_back({v, h[last] - h[v]});
    last++;
    build(last - 1, last);
  }
}

vector<int> contract(vector<int> ver) {
  cnt = ver.size();
  sort(all(ver), cmp);
  rep(i, cnt) {
    auto v = lca(ver[i], ver[(i + 1) % cnt]);
    ver.push_back(v);
  }
  sort(all(ver));
  ver.erase(unique(all(ver)), ver.end());

sort(all(ver), cmp);

  cnt = ver.size();
  int last = ;
  for (auto it : ver) {
    gg[it].clear();
  }
  build(0, last);
  return ver;
}

int k, m;
int col[MAXN];

struct event {
  int t;
  int v;
  int id;
  int ost;
};

bool operator<(const event &a, const event &b) {
  return a.t < b.t;
}

void solve() {
  cin >> k >> m;
  vector<int> ver;
  vector<pii> virs(k);
  vector<int> tars(m);
  rep(i, k) {
    cin >> virs[i].f >> virs[i].s;
    virs[i].f--;
    ver.push_back(virs[i].f);
  }
  rep(i, m) {
    cin >> tars[i];
    tars[i]--;
    ver.push_back(tars[i]);
  }

  sort(all(ver));
  ver.erase(unique(all(ver)), ver.end());

  ver = contract(ver);
  cout << "ver: ";
  for (auto it : ver) {
    cout << it << ' ';
  }
  cout << endl;
  for (auto it : ver)
  }

  for (auto it : ver) {
    col[it] = -1;
  }
  set<event> ev;
  rep(i, virs.size()) {
    int v = virs[i].f;
    ev.insert({0, v, i, 0});
  }
  while (!ev.empty()) {
    auto cur = *ev.begin();
    ev.erase(ev.begin());

    if (col[cur.v] != -1) continue;
    col[cur.v] = cur.id;
    int id = cur.id;
    for (auto x : gg[cur.v]) {
      int to = x.f, w = x.s - cur.ost;

      if (w > 0) {
        int t = (w + virs[id].s - 1) / virs[id].s;
        int ost = (virs[id].s - w % virs[id].s) % virs[id].s;
        ev.insert({t, to, id, ost});
      } else {
        ev.insert({cur.t, to, id, -w});
      }
    }
  }

  for (auto it : tars) {
    cout << col[it] + 1 << ' ';
  }
  cout << '\n';
}

int main() {
    FAST_IO();
    cin >> n;
    rep(i, n - 1) {
      int u, v;
      cin >> u >> v;
      u--; v--;
      g[u].push_back(v);
      g[v].push_back(u);
    }

    init();

    int t;
    cin >> t;
    rep(tt, t) {
      solve();
    }
}
