#include <iostream>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <limits>
#include <map>
#include <vector>
#include <set>
#include <string>
#include <cstdio>
#include <cstring>
#include <cassert>
#include <queue>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define f first
#define s second
#define FAST_IO() ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

namespace __gnu_pbds {
    template<typename T>
    using pbds_tree = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
}
template<typename T>
using pbds_tree = __gnu_pbds::pbds_tree<T>;
// order_of_key
// find_by_order

const ll bs[] = {37, 31};
const ll md[] = {1'000'000'021, 1'000'000'007};
const int cc = 2;

const int MAXN = 2e5 + 5;
int n;
string s;
vector<pii> a;
vector<pii> b;
ll pw[2][MAXN];

struct Hash {
    vector<ll> h[cc];

    Hash() {}
    Hash(const vector<pii> &a) {
        /*cout << "Hash() from {";
        rep(i, a.size()) {
            if (i) cout << ' ';
            cout << a[i].f << ":" << a[i].s;
        }
        cout << "}" << endl;;*/
        rep(t, cc) {
            h[t].resize(a.size());
            for (int i = 0; i < a.size(); ++i) {
                h[t][i] = (pw[t][i] * (a[i].s + 1));
                if (i) {
                    h[t][i] += h[t][i - 1];
                }
                h[t][i] %= md[t];
            }
        }
        /*
        rep(t, cc) {
            cout << t << " : ";
            for (auto it : h[t]) {
                cout << it << ' ';
            }
            cout << endl;
        }
        cout << "Hash() end" << endl << endl;*/
    }

    ll get(int l, int r, int t) {
        //cout << "get " << l << ' ' << r << ' ' << t << endl;
        ll res = h[t][r];
        if (l) {
            res = (res - h[t][l - 1]) % md[t];
            if (res < 0) res += md[t];
        }
        res = (res * pw[t][h[t].size() - l]) % md[t];
        return res;
    }
};

Hash ah, bh;

void init() {
    rep(t, cc) {
        pw[t][0] = 1;
        for (int i = 1; i < MAXN; ++i) {
            pw[t][i] = (pw[t][i - 1] * bs[t]) % md[t];
        }
    }
}

pii get_seg(int l, int r) {
    l = lower_bound(a.begin(), a.end(), make_pair(l, -1)) - a.begin();
    r = upper_bound(a.begin(), a.end(), make_pair(r, 10000)) - a.begin() - 1;
    return {l, r};
}

bool solve(int origl1, int l1, int r1, int origl2, int l2, int r2) {
    //cout << "solve " << origl1 << ' ' << l1 << ' ' << r1 << ' ' << origl2 << ' ' << l2 << ' ' << r2 << endl;
    if (r2 - l2 != r1 - l1) return false;
    //return cmp(l1, r1, l2, r2);
    if (r1 < l1) return true;
    //cout << (((origl1 - a[l1].f) & 1) ? "ah" : "bh") << ' ' << (((origl2 - a[l2].f) & 1) ? "ah" : "bh") << endl;
    Hash &h1 = (((origl1 - a[l1].f) & 1) ^ a[l1].s) ? ah : bh;
    Hash &h2 = (((origl2 - a[l2].f) & 1) ^ a[l2].s) ? ah : bh;
    rep(t, cc) {
        //auto hh1 = h1.get(l1, r1, t);
        //auto hh2 = h2.get(l2, r2, t);
        //cout << t << " : h1 = " << hh1 << " h2 = " << hh2 << endl;
        if (h1.get(l1, r1, t) != h2.get(l2, r2, t)) {
            return false;
        }
    }
    return true;
}

int main() {
    FAST_IO();
    cin >> n;
    cin >> s;
    rep(i, n) {
        if (s[i] == '1') continue;
        a.push_back({i, i % 2});
        b.push_back({i, 1 - i % 2});
    }

    init();
    ah = Hash(a);
    bh = Hash(b);

    /*for (auto it : a) {
        cout << it.f << ' ' << it.s << endl;
    }*/

    int m;
    cin >> m;
    rep(i, m) {
        int l1, l2, len;
        cin >> l1 >> l2 >> len;
        l1--; l2--;
        auto seg1 = get_seg(l1, l1 + len - 1);
        auto seg2 = get_seg(l2, l2 + len - 1);
        if (solve(l1, seg1.f, seg1.s, l2, seg2.f, seg2.s)) {
            cout << "Yes" << '\n';
        } else {
            cout << "No" << '\n';
        }
        //cout << endl;
    }
}
