#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <algorithm>
#include <iomanip>
#include <string>

using namespace std;
typedef long long ll;
typedef long double ld;
ll n, m, p;
pair <ll, ll> a[200010];
ll cost_b[1000010];
vector <pair <ll, ll>> a_;
pair <pair <ll, ll>, ll> monsters[200010];
ll t[4000010];
ll add[4000010];

void push(ll i, ll l, ll r)
{
    add[2 * i + 1] += add[i];
    add[2 * i + 2] += add[i];
    add[i] = 0;
}

void recount(ll i, ll l, ll r)
{
    t[i] = max(t[2 * i + 1] + add[2 * i + 1], t[2 * i + 2] + add[2 * i + 2]);
}

void build(ll i, ll l, ll r)
{
    if (l + 1 == r)
    {
        t[i] = -cost_b[l];
        add[i] = 0;
        return;
    }
    ll m = (l + r) >> 1;
    build(2 * i + 1, l, m);
    build(2 * i + 2, m, r);
    recount(i, l, r);
}

void add_value(ll i, ll l, ll r, ll ql, ll qr, ll v)
{
    if (ql <= l && r <= qr)
    {
        add[i] += v;
        return;
    }
    if (qr <= l || r <= ql) return;
    ll m = (l + r) >> 1;
    push(i, l, r);
    add_value(2 * i + 1, l, m, ql, qr, v);
    add_value(2 * i + 2, m, r, ql, qr, v);
    recount(i, l, r);
}

ll ans = -1e18;

ll used = 0;

void add_monster(ll i)
{
    add_value(0, 0, 1000001, monsters[i].first.second + 1, 1000001, monsters[i].second);
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m >> p;
    for (ll i = 1; i <= n; ++i) {
        cin >> a[i].first >> a[i].second;
    }

    for (ll i = 0; i <= 1000000; ++i) cost_b[i] = 1e18;

    for (ll i = 1; i <= m; ++i)
    {
        ll u, v;
        cin >> u >> v;
        cost_b[u] = min(cost_b[u], v);
    }

    for (ll i = 1; i <= p; ++i)
    {
        cin >> monsters[i].first.first >> monsters[i].first.second >> monsters[i].second;
    }

    sort(monsters + 1, monsters + 1 + p);

    sort(a + 1, a + 1 + n);

    a_.push_back(a[1]);
    for (ll i = 2; i <= n; ++i)
    {
        while (true)
        {
            if (a_.size() == 0) break;
            if (a_.back().second >= a[i].second)
            {
                a_.pop_back();
            } else
            {
                break;
            }
        }

        a_.push_back(a[i]);
    }
    build(0, 0, 1000001);
    for (ll i = 1; i <= n; ++i)
    {
        while (true)
        {
            if (used == m) break;
            if (monsters[used + 1].first.first < a[i].first)
            {
                ++used;
                add_monster(used);
            }
            else
            {
                break;
            }
        }
        ll new_ans = -a[i].second;
        new_ans += t[0] + add[0];
        ans = max(ans, new_ans);
    }

    cout << ans;
    return 0;
}