#include <iostream>
#include <vector>
#include <set>

using namespace std;

const int max_n = 3e5;

vector<int> g[max_n];
vector<int> parents[max_n];
int p[max_n];
int len[max_n];
int c_p[max_n];

void dijkstra(int n, int from) {
    for(int i = 1; i <= n; i++) {
        len[i] = 1e9;
    }
    len[from] = 0;
    set<pair<int, int> > s;
    s.insert(make_pair(0, from));
    for(int i = 1; i <= n; i++) {
        set<pair<int, int> > :: iterator it = s.begin();
        int v = it->second;
        s.erase(it);
        for(int i = 0; i < g[v].size(); i++) {
            int u = g[v][i];
            if(len[u] > len[v] + 1) {
                s.erase(make_pair(len[u], u));
                len[u] = len[v] + 1;
                s.insert(make_pair(len[u], u));
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, m;
    cin >> n >> m;
    int v, u;
    for(int i = 1; i <= m; i++) {
        cin >> v >> u;
        g[u].push_back(v);
        parents[v].push_back(u);
    }
    int k;
    cin >> k;
    for(int i = 1; i <= k; i++) {
        cin >> p[i];
    }
    dijkstra(n, p[k]);
    for(int i = 1; i <= n; i++) {
        c_p[i] = 0;
    }
    for(int i = 1; i <= n; i++) {
        for(int j = 0; j < parents[i].size(); j++) {
            u = parents[i][j];
            v = i;
            if(len[v] == len[u] + 1) {
                c_p[v]++;
            }
        }
    }
    /*for(int i = 1; i <= n; i++) {
        cout << i << ": ";
        for(int j = 0; j < parents[i].size(); j++) {
            cout << parents[i][j] << ' ';
        }
        cout << endl;
    }*/
    int min_ans = 0;
    int max_ans = 0;
    for(int i = 1; i < k; i++) {
        v = p[i];
        bool r = false;
        for(int j = 0; j < parents[v].size(); j++) {
            u = parents[v][j];
            if(u == p[i + 1]) {
                if(len[v] == len[u] + 1) {
                    r = true;
                }
                break;
            }
        }
        //cout << r << endl;
        if(r == true) {
            if(c_p[v] != 1) {
                max_ans++;
            }
        }
        else {
            min_ans++;
            max_ans++;
        }
    }
    cout << min_ans << ' ' << max_ans;
    return 0;
}
