#include <bits/stdc++.h>

using namespace std;


const int MAX_N = 2e5 + 1;
vector <int> gr_inv[MAX_N];
vector <int> gr[MAX_N];

int h[MAX_N] = { 0 };


void bfs(int v)
{
	queue<int> q;
	q.push(v);
	
	while (!q.empty())
	{
		int cur = q.front();
		q.pop();
		
		for (auto & e: gr_inv[cur])
		{
			if (h[e] == 0)
			{
				h[e] = h[cur] + 1;
				q.push(e);
			}
		}
	}
}

int get_shortest(int v, int to)
{
	return abs(h[v] - h[to]);
}


bool exists(int from, int to, int excl)
{
	int shortest = get_shortest(from, to);
	for (auto e: gr[from])
	{
		int cur_shrt = get_shortest(e, to) + 1;
		if (cur_shrt == shortest && e != excl)
		{
			return 1;
		}
	}
	return 0;
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n, m;
	cin >> n >> m;
	
	for (int i = 0; i < m; ++i)
	{
		int v, u;
		cin >> v >> u;
		gr[v].push_back(u);
		gr_inv[u].push_back(v);
	}
	
	int k;
	cin >> k;
	vector <int> p(k);
	for (int& e: p)
		cin >> e;
	
	h[p[k - 1]] = 1;
	bfs(p[k - 1]);
		
	int mn = 0, mx = 0;
	
	for (int i = 0; i < k - 1; ++i)
	{	
		int shrt = get_shortest(p[i + 1], p.back()) + 1;
		int shrt_from = get_shortest(p[i], p.back());
		if (shrt > shrt_from)
		{
			++mn;
			++mx;
		}
		else if (shrt == shrt_from && exists(p[i], p[k - 1], p[i + 1]))
		{
			++mx;
		}
	}
	
	cout << mn << ' ' << mx;
	
	return 0;
}
	
