#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll inf = ll(1e11) + 5;
const ll maxn = ll(2e5) + 5;

struct node {
    ll x, y;
    ll val, mus;
    node *left, *right;
    node(ll x, ll val): x(x), y(rand() * 11237 + rand()), val(val) {
        left = right = nullptr;
        mus = val;
    }
};

ll get_mus(node* root) {
    if(root == nullptr) {
        return 0;
    }
    return root->mus;
}

void update(node* root) {
    if(root == nullptr) {
        return;
    }
    ll nw = root->val;
    nw += get_mus(root->left);
    nw += get_mus(root->right);
    root->mus = nw;
}

pair<node*, node*> split(node* root, ll x) {
    if(root == nullptr) {
        return {nullptr, nullptr};
    }
    if(root->x <= x) {
        auto res = split(root->right, x);
        root->right = res.first;
        update(root);
        return {root, res.second};
    } else {
        auto res = split(root->left, x);
        root->left = res.second;
        update(root);
        return {res.first, root};
    }
}

node* merge(node* root1, node* root2) {
    if(root1 == nullptr) {
        return root2;
    }
    if(root2 == nullptr) {
        return root1;
    }
    if(root1->y < root2->y) {
        auto res = merge(root1->right, root2);
        root1->right = res;
        update(root1);
        return root1;
    } else {
        auto res = merge(root1, root2->left);
        root2->left = res;
        update(root2);
        return root2;
    }
}

node* add(node* root, ll x, ll val) {
    auto res = split(root, x);
    root = merge(merge(res.first, new node(x, val)), res.second);
    return root;
}

ll get_ans(node* root, ll x) {
    auto res = split(root, x);
    ll ans = get_mus(res.first);
    root = merge(res.first, res.second);
    return ans;
}

ll n, m, p;
vector<pll> a;
vector<pll> b;
vector<pair<pll, ll>> mon;
vector<ll> sufa(ll(1e6) + 3, 0);
vector<ll> vala(sufa.size(), 0);
vector<ll> sufb(ll(1e6) + 3, 0);
vector<ll> valb(sufb.size(), 0);

void solve() {
    cin >> n >> m >> p;
    for(ll i = 0; i < n; i++) {
        ll cur, ccur;
        cin >> cur >> ccur;
        a.pb({cur, ccur});
    }
    for(ll i = 0; i < m; i++) {
        ll cur, ccur;
        cin >> cur >> ccur;
        b.pb({cur, ccur});
    }
    for(ll i = 0; i < p; i++) {
        ll x, y, cost;
        cin >> x >> y >> cost;
        mon.pb({{x, y}, cost});
    }
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    sort(mon.begin(), mon.end());


    ll i = n - 1;
    ll cur = inf;
    ll vl = 0;
    for(ll pos = sufa.size() - 1; pos > 0; pos--) {
        if(i >= 0) {
            if(a[i].first == pos) {
                if(a[i].second < cur) {
                    cur = a[i].second;
                    vl = a[i].first;
                }
                i--;
            }
        }
        sufa[pos] = cur;
        vala[pos] = vl;
    }

    i = m - 1;
    cur = inf;
    vl = 0;
    for(ll pos = sufb.size() - 1; pos > 0; pos--) {
        if(i >= 0) {
            if(b[i].first == pos) {
                if(b[i].second < cur) {
                    cur = b[i].second;
                    vl = b[i].first;
                }
                i--;
            }
        }
        sufb[pos] = cur;
        valb[pos] = vl;
    }

    ll ans = -(sufa[1] + sufb[1]);

    node* root = nullptr;
    for(i = 0; i < p; i++) {
        ll cur = mon[i].second - (sufa[mon[i].first.first + 1] + sufb[mon[i].first.second + 1]);
        //cout << cur << " ";
        cur += get_ans(root, valb[mon[i].first.second + 1] - 1);
        //cout << valb[mon[i].first.second + 1] << endl;
        ans = max(ans, cur);

        root = add(root, mon[i].first.second, mon[i].second);
    }

    cout << ans << endl;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
