#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <stdio.h>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <tuple>

#define forn(i, n) for(int i=0; i<n; i++)
#define pii pair<int,int>
#define mp make_pair
#define ld long double
#define ll long long

#pragma GCC optimize("Ofast,inline,unroll-loops,no-stack-protector")

using namespace std;

const ll INF = 1e18;

struct node{
	int x, y;
	ll n;
	ll mx;
	ll push;
	node*l, *r;
	node():y(rand()<<16+rand()), l(NULL), r(NULL), push(0){};
	node(int x, int n):x(x), n(n), mx(n), y(rand()<<16+rand()), l(NULL), r(NULL), push(0){};
};

ll safe(node*n){
	return n == NULL?-INF:n->mx;
}

void recalc(node*n){
	n->mx = max(n->n, max(safe(n->l), safe(n->r)));
}

void go(node*a, ll x){
	if(a!=NULL){
		a->push+=x;
		a->n+=x;
		a->mx+=x;
	}
}

void pushed(node*n){
	go(n->l, n->push);
	go(n->r, n->push);
	n->push = 0;
}

node*merge(node*a, node*b){
	if(a==NULL)return b;
	if(b==NULL)return a;
	if(a->y>b->y){
		pushed(a);
		a->r = merge(a->r, b);
		recalc(a);
		return a;
	}
	pushed(b);
	b->l = merge(a, b->l);
	recalc(b);
	return b;
}

pair<node*, node*>split(node*a, int x){
	if(a==NULL)return mp(a, a);
	pushed(a);
	if(a->x>=x){
		pair<node*,node*>t = split(a->l, x);
		a->l = t.second;
		t.second = a;
		recalc(a);
		return t;
	}
	pair<node*, node*>t = split(a->r, x);
	a->r = t.first;
	t.first = a;
	recalc(a);
	return t;
}

void push(node*&a, int x, ll n){
	pair<node*, node*>t = split(a, x);
	pair<node*, node*>t1 = split(t.second, x+1);
	if(t1.first == NULL) t1.first = new node(x, -n);
	t1.first->n = max(t1.first->n, -n);
	recalc(t1.first);
	t.second = merge(t1.first,t1.second);
	a = merge(t.first,t.second);
}

ll get(node*&a, int x){
	pair<node*, node*>t = split(a, x);
	ll ans = safe(t.first);
	a = merge(t.first,t.second);
	return ans;
}

void add(node*&a,int x, int n){
	pair<node*, node*>t = split(a, x + 1);
	go(t.second, n);
	a = merge(t.first,t.second);
}

struct monster{
	int x, y, z;
	monster(){};
	monster(int x, int y, int z):x(x),y(y),z(z){};
	void in(){
		cin>>x>>y>>z;
	}
};

bool operator<(const monster&a, const monster&b){
	return a.x<b.x;
}

int main(){
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(0);

	int n,m,p;
	cin>>n>>m>>p;
	node*tree = NULL;
	vector<pair<int,int>>a(n);
	forn(i, n)cin>>a[i].first>>a[i].second;
	sort(a.begin(),a.end());
	forn(i,m){
		int x, c;
		cin>>x>>c;
		push(tree, x, c);
	}
	vector<monster>c(p);
	forn(i, p){
		c[i].in();
	}
	sort(c.begin(),c.end());
	int id = 0;
	ll ans = -INF;
	forn(i,n){
		ll ac = -a[i].second;
		while(id < p && c[id].x < a[i].first){
			add(tree, c[id].y, c[id].z);
			id++;
		}
		ac+=safe(tree);
		ans = max(ans, ac);
	}
	cout<<ans;
}