#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <string>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <math.h>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int long long

const int N = 1000010;

const int LOGN = 21;

int a[N], ca[N];

int b[N], cb[N];

const int INF = 2000000010;

struct monstr {
	int x, y, z, ind;
	bool operator<(const monstr &c) const {
		if (x != c.x)
			return x < c.x;
		if (y != c.y)
			return y < c.y;
		if (z != c.z)
			return z < c.z;
		if (ind != c.ind)
			return ind < c.ind;
		return false;
	}
} mon[N];

int t[N * 4];


int maxa[N], maxb[N];

void build(int v, int tl, int tr) {
	if (tl == tr) {
		t[v] = maxb[tl];
		return;
	}
	int mid = (tl + tr) >> 1;
	build(v * 2 + 1, tl, mid);
	build(v * 2 + 2, mid + 1, tr);
	t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
}

int prib[N * 4];

void push(int v) {
	t[v] += prib[v];
	if (v * 2 + 1 < N)
		prib[v * 2 + 1] += prib[v];
	if(v * 2 + 2 < N)
		prib[v * 2 + 2] += prib[v];
	prib[v] = 0;
}

void add(int v, int tl, int tr, int l, int r, int x) {
	push(v);
	if (tl >= l && tr <= r) {
		prib[v] += x;
		push(v);
		return;
	}
	if (r < tl || l > tr)
		return;
	int mid = (tl + tr) >> 1;
	add(v * 2 + 1, tl, mid, l, r, x);
	add(v * 2 + 2, mid + 1, tr, l, r, x);
	t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
}

int query(int v, int tl, int tr, int l, int r) {
	push(v);
	if (tl >= l && tr <= r) {
		return t[v];
	}
	if (r < tl || l > tr)
		return -INF;
	int mid = (tl + tr) >> 1;
	return max(
		query(v * 2 + 1, tl, mid, l, r),
		query(v * 2 + 2, mid + 1, tr, l, r));
}

int res[N];


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif
	int n, m, p;
	cin >> n >> m >> p;
	fill(maxa, maxa + N, -INF);
	fill(maxb, maxb + N, -INF);
	fill(t, t + N * 4, -INF);
	for (int i = 1; i <= n; ++i) {
		cin >> a[i] >> ca[i];
		maxa[a[i]] = max(maxa[a[i]], -ca[i]);
	}
	for (int i = 1; i <= m; ++i) {
		cin >> b[i] >> cb[i];
		maxb[b[i]] = max(maxb[b[i]], -cb[i]);
	}

	for (int i = N - 2; i >= 0; --i) {
		maxa[i] = max(maxa[i + 1], maxa[i]);
		maxb[i] = max(maxb[i + 1], maxb[i]);
	}
	
	for (int i = 1; i <= p; ++i) {
		cin >> mon[i].x >> mon[i].y >> mon[i].z;
		mon[i].ind = i;
	}
	build(0, 0, N - 1);
	sort(mon + 1, mon + (p + 1));
	int ans = -INF;
	for (int i = 1; i <= p; ++i) {
		int cnt = 0;
		int sum = 0;
		while (i < p && (mon[i].x == mon[i + 1].x)) {
			add(0, 0, N - 1, mon[i].y + 1, N - 1, mon[i].z);
			++i;
		}
		add(0, 0, N - 1, mon[i].y + 1, N - 1, mon[i].z);
		res[i] = query(0, 0, N - 1, 0, N - 1) + maxa[mon[i].x + 1];
		ans = max(ans, res[i]);
	}
	cout << max(ans, maxa[0] + maxb[0]);
}