#ifndef LOCAL
#pragma GCC optimize("Ofast,fast-math,unroll-loops,no-stack-protector,inline")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,sse4a,avx,avx2,abm,mmx,popcnt")
#endif

#include <bits/stdc++.h>

#define int long long

using namespace std;

//const int MAXB = 1000010;
const int MAXB = 10;
const int MAXN = 200000;
const int INF = 1e12;

struct Mons {
  int x, y, z;

  bool operator<(const Mons &oth) const {
    return x < oth.x;
  }
};

int tree[MAXB * 4];
int mod[MAXB * 4];

int N, M, P;
Mons prr[MAXN];
pair<int, int> arr[MAXN], brr[MAXN];

void build(int v, int l, int r) {
  if (l + 1 == r) {
    auto it = lower_bound(brr, brr + M, make_pair(l, -1LL));
    if (it == brr + M)
      tree[v] = -INF;
    else
      tree[v] = -(it->second);
    return;
  }
  int m = (l + r) / 2;
  build(2 * v + 1, l, m);
  build(2 * v + 2, m, r);
  tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

void push(int v, int l, int r) {
  if (mod[v] == 0)
    return;
  tree[v] += mod[v];
  if (l + 1 < r) {
    mod[2 * v + 1] += mod[v];
    mod[2 * v + 2] += mod[v];
  }
  mod[v] = 0;
}

void update(int v, int l, int r, int ql, int qr, int qx) {
  push(v, l, r);
  if (qr <= l || r <= ql)
    return;
  if (ql <= l && r <= qr) {
    mod[v] += qx;
    push(v, l, r);
    return;
  }
  int m = (l + r) / 2;
  update(2 * v + 1, l, m, ql, qr, qx);
  update(2 * v + 2, m, r, ql, qr, qx);
  tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

int get(int v, int l, int r, int ql, int qr) {
  push(v, l, r);
  if (qr <= l || r <= ql)
    return -INF;
  if (ql <= l && r <= qr)
    return tree[v];
  int m = (l + r) / 2;
  int ll = get(2 * v + 1, l, m, ql, qr);
  int rr = get(2 * v + 2, m, r, ql, qr);
  return max(ll, rr);
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  cin >> N >> M >> P;
  for (int i = 0; i < N; ++i) {
    cin >> arr[i].first >> arr[i].second;
  }
  for (int i = 0; i < M; ++i) {
    cin >> brr[i].first >> brr[i].second;
  }
  for (int i = 0; i < P; ++i)
    cin >> prr[i].x >> prr[i].y >> prr[i].z;
  sort(arr, arr + N);
  sort(brr, brr + M);
  sort(prr, prr + P);
  build(0, 0, MAXB);
  int att = 0;
  int ip = 0;
  int ansmax = -INF;
  for (int i = 0; i < N; ++i) {
    att = arr[i].first;
    while (ip < P && prr[ip].x < att) {
      update(0, 0, MAXB, prr[ip].y + 1, MAXB, prr[ip].z);
      ip++;
    }
    int ans = get(0, 0, MAXB, 0, MAXB);
    ans -= arr[i].second;
    if (ans > ansmax)
      ansmax = ans;
  }
  cout << ansmax;
  return 0;
}
