#pragma GCC optimize("Ofast")
#pragma GCC target("tune=native,sse,sse2,sse3,ssse3,avx,mmx,popcnt")
#pragma GCC optimize("unroll-loops,no-stack-protector,btr-bb-exclusive,fast-math")

#include <bits/stdc++.h>

using namespace std;

#define int long long


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;

	vector< vector<int> > adj(n);
	vector< vector<int> > revadj(n);

	for(int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		adj[u].push_back(v);
		revadj[v].push_back(u);
	}

	int k;
	cin >> k;
	vector<int> p(k);
	for(int i = 0; i < k; i++) {
		cin >> p[i];
		p[i]--;
	}
	int s = p[0];
	int t = p.back();

	queue<int> q;
	vector<bool> used(n);
	vector<int> dist(n, 1000000000LL);
	dist[t] = 0;
	q.push(t);
	while(q.size() > 0) {
		int u = q.front();
		q.pop();
		if(used[u]) {
			continue;
		}
		used[u] = true;
		for(int v: revadj[u]) {
			dist[v] = min(dist[v], dist[u] + 1);
			q.push(v);
		}
	}

	int minans = 0, maxans = 0;
	for(int i = 0; i < p.size() - 1; i++) {
		int u = p[i];
		minans++;
		for(int v: adj[u]) {
			if(dist[u] == dist[v] + 1) {
				if(v == p[i + 1]) {
					minans--;
					break;
				}
			}
		}
		for(int v: adj[u]) {
			if(dist[u] == dist[v] + 1) {
				if(v != p[i + 1]) {
					maxans++;
					break;
				}
			}
		}
	}
	cout << minans << " " << maxans << endl;

	return 0;
}