#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <iomanip>

using namespace std;

#define all(x) x.begin(), x.end()
#define allr(x) x.rbegin(), x.rend()
#define mod(x, m) ((((x) % m) + m) % m)

typedef long long ll;
typedef unsigned long long ull;
typedef double dbl;
typedef long double ldbl;

void input() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.fixed;
    cout.precision(10);
#ifdef MY_DEBUG
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif
}

void value(int id, int x, vector<int> &tree) {
    int n = tree.size();
    for (int i = id; i < n; i = (i | (i + 1))) {
        tree[i] += x;
    }
}

int sum(int r, vector<int> &tree) {
    int res = 0;
    for (int i = r; i >= 0; i = (i & (i + 1)) - 1) {
        res += tree[i];
    }
    return res;
}

int sum(int l, int r, vector<int> &tree) {
    return sum(r, tree) - sum(l - 1, tree);
}

int main() {
    input();
    int n;
    cin >> n;
    vector<int> win(n), lose(n);
    for (int i = 0; i < n; i++) {
        cin >> win[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> lose[i];
    }
    int w1 = 0, w2 = 0, l1 = 0, l2 = 0;
    for (int i = 0; i < n; i++) {
        if (win[i] > lose[i])
            w1++;
        else if (lose[i] > win[i])
            l1++;
        if (win[i])
            w2++;
        if (lose[i])
            l2++;
    }
    if (w1 == 0) {
        cout << -1;
        return 0;
    }
    //cout << w1 << ' ' << w2 << ' ' << l1 << ' ' << l2;
    int i = 1;
    while (true) {
        if (w2 * i - (l2 - l1) * i - l1 > 0) {
            cout << i;
            return 0;
        }
        i++;
    }
    return 0;
}
