#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <iomanip>

using namespace std;

#define all(x) x.begin(), x.end()
#define allr(x) x.rbegin(), x.rend()
#define mod(x, m) ((((x) % m) + m) % m)

typedef long long ll;
typedef unsigned long long ull;
typedef double dbl;
typedef long double ldbl;

void input() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.fixed;
    cout.precision(10);
#ifdef MY_DEBUG
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif
}

void value(int id, int x, vector<int> &tree) {
    int n = tree.size();
    for (int i = id; i < n; i = (i | (i + 1))) {
        tree[i] += x;
    }
}

int sum(int r, vector<int> &tree) {
    int res = 0;
    for (int i = r; i >= 0; i = (i & (i + 1)) - 1) {
        res += tree[i];
    }
    return res;
}

int sum(int l, int r, vector<int> &tree) {
    return sum(r, tree) - sum(l - 1, tree);
}

struct En{
    int x, y, z;
};

int main() {
    input();
    int n;
    cin >> n;
    vector<int> bs(n);
    vector<int> b(n);
    map<int, ll> dict;
    for (int i = 0; i < n; i++) {
        cin >> bs[i];
        if (dict.find(bs[i] - i) == dict.end())
            dict[bs[i] - i] = 0;
        dict[bs[i] - i] += bs[i];
    }
    ll ans = 0;
    for (auto i: dict) {
        ans = max(ans, i.second);
    }
    cout << ans;
    return 0;
}
