#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <iomanip>

using namespace std;

#define all(x) x.begin(), x.end()
#define allr(x) x.rbegin(), x.rend()
#define mod(x, m) ((((x) % m) + m) % m)

typedef long long ll;
typedef unsigned long long ull;
typedef double dbl;
typedef long double ldbl;

void input() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.fixed;
    cout.precision(10);
#ifdef MY_DEBUG
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif
}

void value(int id, int x, vector<int> &tree) {
    int n = tree.size();
    for (int i = id; i < n; i = (i | (i + 1))) {
        tree[i] += x;
    }
}

int sum(int r, vector<int> &tree) {
    int res = 0;
    for (int i = r; i >= 0; i = (i & (i + 1)) - 1) {
        res += tree[i];
    }
    return res;
}

int sum(int l, int r, vector<int> &tree) {
    return sum(r, tree) - sum(l - 1, tree);
}

int main() {
    input();
    int n;
    cin >> n;
    string s;
    cin >> s;
    ll ans = s.size();
    vector<char> str;
    for (int i = 0; i < s.size(); i++) {
        str.push_back(s[i]);
    }
    set<int> er;
    for (char i = 'z'; i >= 'b'; i--) {
        int last = -1;
        while (last != er.size()) {
            last = er.size();
            for (int j = 0; j < str.size(); j++) {
                if (str[j] != i)
                    continue;
                int q = 1;
                while (er.find(j - q) != er.end())
                    q++;
                if (j - q >= 0 && str[j] == i && str[j - q] == i - 1) {
                    er.insert(j);
                    continue;
                }
                q = 1;
                while (er.find(j + q) != er.end())
                    q++;
                if (j + q < n && str[j] == i && str[j + q] == i - 1)
                    er.insert(j);
            }
        }
    }
    cout << (int)er.size();
    return 0;
}
