#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <iomanip>

using namespace std;

#define all(x) x.begin(), x.end()
#define allr(x) x.rbegin(), x.rend()
#define mod(x, m) ((((x) % m) + m) % m)

typedef long long ll;
typedef unsigned long long ull;
typedef double dbl;
typedef long double ldbl;

void input() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.fixed;
    cout.precision(10);
#ifdef MY_DEBUG
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif
}

void value(int id, int x, vector<int> &tree) {
    int n = tree.size();
    for (int i = id; i < n; i = (i | (i + 1))) {
        tree[i] += x;
    }
}

int sum(int r, vector<int> &tree) {
    int res = 0;
    for (int i = r; i >= 0; i = (i & (i + 1)) - 1) {
        res += tree[i];
    }
    return res;
}

int sum(int l, int r, vector<int> &tree) {
    return sum(r, tree) - sum(l - 1, tree);
}

struct En{
    int x, y, z;
};

int main() {
    input();
    int n, m;
    cin >> n >> m;
    vector<vector<int> > graph(n), graphT(n);
    map<ll, int> dict;
    for (int i = 0; i < m; i++) {
        int b, e;
        cin >> b >> e;
        b--; e--;
        graph[b].push_back(e);
        graphT[e].push_back(b);
        ll b1 = min(b, e);
        ll e1 = max(b, e);
        dict[(ll)b1 * n + e1] = i;
    }
    int k;
    cin >> k;
    vector<int> way(k);
    for (int i = 0; i < k; i++) {
        cin >> way[i];
        way[i]--;
    }
    vector<pair<int, int> > dist(n, {1e9, 1});
    queue<int> q;
    q.push(way[k - 1]);
    dist[way[k - 1]].first = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int i: graphT[v]) {
            if (dist[i].first == 1e9) {
                dist[i].first = dist[v].first + 1;
                q.push(i);
            }
            else if (dist[i].first == dist[v].first + 1) {
                dist[i].second++;
            }
        }
    }
    ll ansmn = 0, ansmx = 0;
    for (int i = 1; i < k; i++) {
        if (dist[way[i - 1]].first <= dist[way[i]].first) {
            ansmn++;
        }
        else {
            if (dist[way[i - 1]].second > 1) {
                ansmx++;
            }
        }
    }
    cout << ansmn << ' ' << ansmx + ansmn;
    return 0;
}
