//#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,avx,avx2,popcnt,tune=native")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

template<typename T>
using kawaii_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) (x).begin(), (x).end()

void FAST_IO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//cout.setf(ios::fixed);
	//cout.precision(20);
	#ifndef _offline
		//freopen("input.txt", "r", stdin);
		//freopen("output.txt", "w", stdout);
	#endif
}

const ll INF = 1e10 + 7;
const int MAXA = 1e6 + 100;
const int MAXN = 2e5 + 100;
vector<int> addw[MAXA];
vector<pii> addm[MAXA];
pii a[MAXN], b[MAXN];
ll fta[MAXN], t[MAXN * 4], add[MAXN * 4];

void build(int v, int tl, int tr) {
	if (tl + 1 == tr) {
		t[v] = -fta[tl];
		return;
	}
	int tm = (tl + tr) >> 1;
	build(v * 2 + 1, tl, tm);
	build(v * 2 + 2, tm, tr);
	t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
}

void push(int v, int tl, int tr) {
	t[v] += add[v];
	if (tl + 1 != tr) {
		add[v * 2 + 1] += add[v];
		add[v * 2 + 2] += add[v];
	}
	add[v] = 0;
}

void update(int v, int tl, int tr, int l, int r, int val) {
	push(v, tl, tr);
	if (tl >= r || tr <= l) {
		return;
	}
	if (tl >= l && tr <= r) {
		add[v] += val;
		push(v, tl, tr);
		return;
	}
	int tm = (tl + tr) >> 1;
	update(v * 2 + 1, tl, tm, l, r, val);
	update(v * 2 + 2, tm, tr, l, r, val);
	t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
}

signed main() {
	FAST_IO();
	int n, m, p;
	cin >> n >> m >> p;
	for (int i = 0; i < n; ++i) {
		cin >> a[i].first >> a[i].second;
		addw[a[i].first].push_back(a[i].second);
	}
	vector<int> xs;
	for (int i = 0; i < m; ++i) {
		cin >> b[i].first >> b[i].second;
		xs.push_back(b[i].first);
	}
	sort(all(xs));
	xs.resize(unique(all(xs)) - xs.begin());
	int sz = xs.size();
	fill(fta, fta + sz, INF);
	for (int i = 0; i < m; ++i) {
		int pos = lower_bound(all(xs), b[i].first) - xs.begin();
		fta[pos] = min<ll>(fta[pos], b[i].second);
	}
	for (int i = 0; i < p; ++i) {
		int x, y, z;
		cin >> x >> y >> z;
		int pos = upper_bound(all(xs), y) - xs.begin();
		if (y == sz) {
			continue;
		}
		addm[x].push_back({pos, z});
	}
	build(0, 0, sz);
	ll ans = -INF;
	for (int i = 1; i < MAXA; ++i) {
		for (int c : addw[i]) {
			ans = max(ans, t[0] - c);
		}
		for (auto &[pos, c] : addm[i]) {
			update(0, 0, sz, pos, sz, c);
		}
	}
	cout << ans << '\n';
}