//#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,avx,avx2,popcnt,tune=native")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

template<typename T>
using kawaii_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) (x).begin(), (x).end()

void FAST_IO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//cout.setf(ios::fixed);
	//cout.precision(20);
	#ifndef _offline
		//freopen("input.txt", "r", stdin);
		//freopen("output.txt", "w", stdout);
	#endif
}

const int INF = 1e9 + 7;
const int LOGN = 20;
const int MAXN = 2e5 + 100;
vector<int> g[MAXN];
vector<pii> gc[MAXN];
int up[LOGN][MAXN], h[MAXN], tin[MAXN], tout[MAXN], timer = 0;
int col[MAXN];
tuple<int, int, int> res[MAXN];
set<pii> upd;

void dfs(int u, int p) {
	tin[u] = timer++;
	up[0][u] = p;
	for (int i = 1; i < LOGN; ++i) {
		up[i][u] = up[i - 1][up[i - 1][u]];
	}
	for (int to : g[u]) {
		if (to == p) {
			continue;
		}
		h[to] = h[u] + 1;
		dfs(to, u);
	}
	tout[u] = timer;
}

bool is_parent(int u, int v) {
	return (tin[u] <= tin[v] && tout[u] >= tout[v]);
}

int lca(int u, int v) {
	if (h[u] > h[v]) {
		swap(u, v);
	}
	for (int i = LOGN - 1; i >= 0; --i) {
		if (is_parent(u, up[i][v])) {
			v = up[i][v];
		}
	}
	if (u == v) {
		return u;
	}
	for (int i = LOGN - 1; i >= 0; --i) {
		if (up[i][u] != up[i][v]) {
			u = up[i][u];
			v = up[i][v];
		}
	}
	return up[0][u];
}

bool cmp(int u, int v) {
	return tin[u] < tin[v];
}

void dfs1(int u, int kek) {
	for (auto &[to, d] : gc[u]) {
		if (col[to] == -1 && d <= kek) {
			col[to] = col[u];
			upd.insert({u, to});
			dfs1(to, kek - d);
		}
	}
}

void dfs2(int u, int kek, int w, int ss, set<pair<tuple<int, int, int>, int>> &setik) {
	for (auto &[to, d] : gc[u]) {
		if (col[to] == -1) {
			pii p = {w + (d - kek + ss - 1) / ss, col[u]};
			tuple<int, int, int> cur = {p.first, p.second, col[u] * (p.first - w) - (d - kek)};
			if (cur < res[to]) {
				setik.erase({res[to], to});
				res[to] = cur;
				setik.insert({res[to], to});
			}	
		}
	}
	for (auto &[to, d] : gc[u]) {
		if (col[to] == col[u] && upd.count({u, to})) {
			dfs2(to, kek - d, w, ss, setik);
		}
	}
}

signed main() {
	FAST_IO();
	int n;
	cin >> n;
	for (int i = 0; i < n - 1; ++i) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	dfs(0, 0);
	int q;
	cin >> q;
	while (q--) {
		int k, m;
		cin >> k >> m;
		vector<int> ks(k), s(k), ms(m), good;
		for (int i = 0; i < k; ++i) {
			cin >> ks[i] >> s[i];
			ks[i]--;
			good.push_back(ks[i]);
		}
		for (int i = 0; i < m; ++i) {
			cin >> ms[i];
			ms[i]--;
			good.push_back(ms[i]);
		}
		sort(all(good));
		good.resize(unique(all(good)) - good.begin());
		sort(all(good), cmp);
		vector<int> nw_good;
		nw_good.push_back(good[0]);
		for (int i = 1; i < (int)good.size(); ++i) {
			nw_good.push_back(good[i]);
			nw_good.push_back(lca(good[i - 1], good[i]));
		}
		good.swap(nw_good);
		sort(all(good));
		good.resize(unique(all(good)) - good.begin());
		sort(all(good), cmp);
		for (int u : good) {
			col[u] = -1; 
			gc[u].clear();
		}
		vector<int> st;
		st.push_back(good[0]);
		for (int i = 1; i < (int)good.size(); ++i) {
			int u = good[i];
			while (!is_parent(st.back(), u)) {
				st.pop_back();
			}
			gc[st.back()].push_back({u, h[u] - h[st.back()]});
			gc[u].push_back({st.back(), h[u] - h[st.back()]});
			st.push_back(u);
		}
		for (int i = 0; i < k; ++i) {
			col[ks[i]] = i;
		}
		set<pair<tuple<int, int, int>, int>> setik;
		for (int u : good) {
			if (col[u] != -1) {
				continue;
			}
			tuple<int, int, int> p = {INF, -1, INF};
			for (auto &[to, d] : gc[u]) {
				if (col[to] != -1) {
					pii cur = {(d + s[col[to]] - 1) / s[col[to]], col[to]};
					tuple<int, int, int> curt = {cur.first, cur.second, s[col[to]] * cur.first - d};
					p = min(p, curt);
				}
			}
			res[u] = p;
			setik.insert({p, u});
		}
		while (setik.size()) {
			int w = get<0>(setik.begin()->first);
			int c = get<1>(setik.begin()->first);
			int kek = get<2>(setik.begin()->first);
			int u = setik.begin()->second;
			setik.erase(setik.begin());
			col[u] = c;
			dfs1(u, kek);
			dfs2(u, kek, w, s[c], setik);
			for (auto &[u, v] : upd) {
				setik.erase({res[v], v});
			}
			upd.clear();
		}
		for (int i = 0; i < m; ++i) {
			cout << col[ms[i]] + 1 << ' ';
		}
		cout << '\n';
 	}
} 