#define FASTIO ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

#ifndef BZ
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")
#pragma target ("sse,sse2,sse3,ssse3,sse4,avx,abm,mmx,popcnt")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define mt make_tuple
#define forEach(c) for (auto &it : c)
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()

#ifdef LOCAL
#define LOG(v) cout << #v << ": " << v << "\n";
#else
#define LOG(v) ;
#endif

template <class T>
void chMin(T &a, T b) {
	if (b < a) a = b;
}

template <class T>
void chMax(T &a, T b) {
	if (a < b) a = b;
}

inline ll divUp(ll a, ll b) {
	return (a + b - 1) / b;
}

vector<vector<ll>> adj;
vector<vector<ll>> radj;
vector<ll> dist;

void solve() {
	ll n, m;
	cin >> n >> m;
	dist.assign(n, -1);
	adj.assign(n, vector<ll>());
	radj.assign(n, vector<ll>());
	for (ll i = 0; i < m; i++) {
		ll a, b;
		cin >> a >> b;
		a--, b--;
		adj[b].pb(a);
		radj[a].pb(b);
	}
	ll k;
	cin >> k;
	vector<ll> p(k);
	forEach(p) {
		cin >> it;
		it--;
	}
	ll s = p.front();
	ll t = p.back();
	/// dist from t to others
	deque<ll> q;
	q.pb(t);
	dist[t] = 0;
	while (!q.empty()) {
		ll v = q.front(); q.pop_front();
		forEach(adj[v]) {
			if (dist[it] == -1) {
				dist[it] = dist[v] + 1;
				q.pb(it);
			} else if (dist[it] > dist[v] + 1) {
				dist[it] = dist[v] + 1;
				q.pb(it);
			}
		}
	}
	swap(adj, radj);
	ll cntMin = 0;
	ll cntMax = 0;
	for (ll i = 0; i < p.size() - 1; i++) {
		ll cntLess = 0;
		forEach(adj[p[i]]) {
			if (dist[p[i]] > dist[it]) {
				cntLess++;
				assert(dist[p[i]] == dist[it] + 1);
			}
		}
		if (dist[p[i + 1]] + 1 == dist[p[i]]) {
			if (cntLess > 1) cntMax++;
		} else {
			cntMin++;
			cntMax++;
		}
	}
	cout << cntMin << " " << cntMax << "\n";
}

int main() {
	FASTIO
	solve();
	return 0;
}