#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,avx,avx2,mmx,tune=native")
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define pll pair<ll, ll>

ll const INF = 1e18, N = 1e6, P = 257, M = 228228227;
ld const EPS = 1e-10;

vector<ll> g[N];
bool used[N];

ll pdsu[N], rankdsu[N];

ll PDSU(ll v) {
    if (pdsu[v] == v) {
        return v;
    }

    return (pdsu[v] = PDSU(pdsu[v]));
}

void Unite(ll a, ll b) {
    a = PDSU(a);
    b = PDSU(b);
    if (rankdsu[a] > rankdsu[b]) {
        swap(a, b);
    }

    pdsu[a] = b;
    rankdsu[b] += rankdsu[a];
}

void zfunc(string s) {
    vector<ll> z;
    for (int i = 0; i < s.size(); ++i) {
        z.push_back(0);
    }
    ll l = 0, r = 0;
    for (int i = 1; i < s.size(); ++i) {
        if (r >= i) {
            z[i] = min(z[i - l], r - i + 1);
        }
        while (i + z[i] < s.size() && s[z[i]] == s[i + z[i]]) {
            z[i]++;
        }
        if (i + z[i] - 1 > r) {
            r = i + z[i] - 1;
            l = i;
        }
    }
}

void pfunc(string s) {
    vector<ll> p;
    for (int i = 0; i < s.size(); ++i) {
        p.push_back(0);
    }
    for (int i = 1; i < s.size(); ++i) {
        ll j = p[i - 1];
        while (j > 0 && s[i] != s[j]) {
            j = p[j - 1];
        }
        if (s[j] == s[i]) {
            ++j;
        }
        p[i] = j;
    }
}

void Dfs(ll v) {
    used[v] = true;
    for (int i = 0; i < g[v].size(); ++i) {
        if (! used[g[v][i]]) {
            Dfs(g[v][i]);
        }
    }
}

void Build(ll v, ll l, ll r) {
    if (r - l == 1) {
        return;
    }


    ll m = (l + r) / 2;
    Build(v * 2, l, m);
    Build(v * 2 + 1, m, r);
}

void Upd(ll v, ll l, ll r, ll pos, ll val) {
    if (r - l == 1 && l == pos) {
        return;
    }

    if (l > pos || r <= pos) {
        return;
    }

    ll m = (l + r) / 2;
    Upd(v * 2, l, m, pos, val);
    Upd(v * 2 + 1, m, r, pos, val);
}

ll Get(ll v, ll l, ll r, ll ql, ll qr) {
    if (l >= qr || r <= ql) {
        return 0;
    }

    if (l >= ql && r <= qr) {
        return 1;
    }

    ll m = (l + r) / 2;
    return Get(v * 2, l, m, ql, qr) + Get(v * 2 + 1, m, r, ql, qr);
}

struct Node {
    ll x, sz, pr;
    Node* left = nullptr;
    Node* right = nullptr;
    Node() {}
    Node(ll _x) {
        x = _x;
        sz = 1;
        pr = rand();
    }
};

ll GetSz(Node* tree) {
    return (tree ? tree->sz : 0);
}

void UpdSz(Node* tree) {
    tree->sz = GetSz(tree->left) + GetSz(tree->right) + 1;
}

Node* Merge(Node* left, Node* right) {
    if (! left) {
        return right;
    }
    if (! right) {
        return left;
    }

    if (left->pr > right->pr) {
        left->right = Merge(left->right, right);
        UpdSz(left);
        return left;
    }
    else {
        right->left = Merge(left, right->left);
        UpdSz(right);
        return right;
    }
}

pair<Node*, Node*> Split(Node* tree, ll x) {
    if (! tree) {
        return {tree, tree};
    }

    if (GetSz(tree->left) == x - 1) {
        auto tmp = tree->right;
        tree->right = nullptr;
        UpdSz(tree);
        return {tree, tmp};
    }
    else if (GetSz(tree->left) > x - 1) {
        auto tmp = Split(tree->left, x);
        tree->left = tmp.second;
        UpdSz(tree);
        return {tmp.first, tree};
    }
    else {
        auto tmp = Split(tree->right, x - GetSz(tree->left) - 1);
        tree->right = tmp.first;
        UpdSz(tree);
        return {tree, tmp.second};
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    srand(time(NULL));

    ll n;
    string t;
    cin >> n >> t;

    vector<char> tmp;
    for (int i = 0; i < n; ++i) {
        tmp.push_back(t[i]);
    }

    /*ll dp[n][n];
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            dp[i][j] = 0;
        }
    }

    for (int i = 1; i < n; ++i) {
        for (int j = 0; i + j < n; ++j) {
            vector<char> tmp;
            for (int k = j; k <= i + j; ++k) {
                tmp.push_back(t[k]);
            }
            for (int k = 0; k < tmp.size(); ++k) {
                if (k == 0) {
                    if ((ll)tmp[0] - (ll)tmp[1] == 1) {
                        dp[j][i + j] = max(dp[j][i + j], dp[j + 1][i + j] + 1);
                    }
                }
                else if (k == tmp.size() - 1) {
                    if ((ll)tmp[tmp.size() - 1] - (ll)tmp[tmp.size() - 2] == 1) {

                        dp[j][i + j] = max(dp[j][i + j], dp[j][i + j - 1] + 1);
                    }
                }
                else {
                    if ((ll)tmp[k] - (ll)tmp[k - 1] == 1 || (ll)tmp[k] - (ll)tmp[k + 1] == 1) {
                        dp[j][i + j] = max(dp[j][i + j], dp[j][j + k - 1] + dp[j + k + 1][i + j] + 1);
                    }
                }
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cout << dp[i][j] << ' ';
        }
        cout << '\n';
    }

    cout << dp[0][n - 1];*/

    ll cur = (ll)('z');
    while (cur > (ll)('a')) {
        bool flag = true;
        while (flag) {
            flag = false;
            vector<char> s;
            for (int k = 0; k < tmp.size(); ++k) {
                if ((ll)tmp[k] != cur) {
                    continue;
                }
                if (k == 0) {
                    if ((ll)tmp[0] - (ll)tmp[1] == 1) {
                        flag = true;
                        for (int i = 1; i < tmp.size(); ++i) {
                            s.push_back(tmp[i]);
                        }
                        tmp = s;
                        break;
                    }
                }
                else if (k == tmp.size() - 1) {
                    if ((ll)tmp[tmp.size() - 1] - (ll)tmp[tmp.size() - 2] == 1) {
                        flag = true;
                        for (int i = 0; i < tmp.size() - 1; ++i) {
                            s.push_back(tmp[i]);
                        }
                        tmp = s;
                        break;
                    }
                }
                else {
                    if ((ll)tmp[k] - (ll)tmp[k - 1] == 1 || (ll)tmp[k] - (ll)tmp[k + 1] == 1) {
                        flag = true;
                        for (int i = 0; i < k; ++i) {
                            s.push_back(tmp[i]);
                        }
                        for (int i = k + 1; i < tmp.size(); ++i) {
                            s.push_back(tmp[i]);
                        }
                        tmp = s;
                        break;
                    }
                }
            }
        }
        cur--;
    }

    cout << n - tmp.size();

    return 0;
}
