#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 8e5;
const ll INF = 9e18;

struct monster
{
    ll x, y, z;
};

ll x[MAXN];
ll d[MAXN];

void push(int t)
{
    x[t] += d[t];

    if (2 * t + 1 < MAXN)
    {
        d[2 * t] += d[t];
        d[2 * t + 1] += d[t];
    }

    d[t] = 0;
}

void build(int t, int l, int r, vector<ll> &a)
{
    if (l == r - 1)
    {
        x[t] = a[l];
        return;
    }

    int m = (l + r) / 2;
    build(2 * t, l, m, a);
    build(2 * t + 1, m, r, a);
    x[t] = max(x[2 * t], x[2 * t + 1]);
}

ll get(int t, int l, int r, int L, int R)
{
    if (l >= r || L >= R || L < l || R > r)
        return -INF;

    push(t);

    if (l == L && r == R)
        return x[t];

    int m = (l + r) / 2;
    return max(get(2 * t, l, m, L, min(m, R)),
               get(2 * t + 1, m, r, max(L, m), R));
}

void update(int t, int l, int r, int L, int R, ll v)
{
    if (l >= r || L >= R || L < l || R > r)
        return;

    push(t);

    if (l == L && r == R)
    {
        d[t] += v;
        push(t);
        return;
    }

    int m = (l + r) / 2;
    update(2 * t, l, m, L, min(m, R), v);
    update(2 * t + 1, m, r, max(L, m), R, v);
    x[t] = max(x[2 * t], x[2 * t + 1]);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m, p;
    cin >> n >> m >> p;

    vector<pair<ll, ll>> weapons(n);
    for (int i = 0; i < n; i++)
        cin >> weapons[i].first >> weapons[i].second;

    vector<pair<ll, ll>> armor(m);
    for (int i = 0; i < m; i++)
        cin >> armor[i].first >> armor[i].second;

    vector<monster> monsters(p);
    for (int i = 0; i < p; i++)
        cin >> monsters[i].x >> monsters[i].y >> monsters[i].z;

    sort(weapons.begin(), weapons.end());
    sort(armor.begin(), armor.end());
    sort(monsters.begin(), monsters.end(), [](monster a, monster b){return a.x < b.x;});

    vector<ll> negcosts(m);
    for (int i = 0; i < m; i++)
        negcosts[i] = -armor[i].second;

    build(1, 0, m, negcosts);

    ll ans = -INF;
    int cur = 0;
    for (int i = 0; i < n; i++)
    {
        while (cur < p && monsters[cur].x < weapons[i].first)
        {
            pair<ll, ll> key = {monsters[cur].y, 9e18};
            int f = upper_bound(armor.begin(), armor.end(), key) - armor.begin();
            update(1, 0, m, f, m, monsters[cur].z);
            cur++;
        }

        ans = max(ans, -weapons[i].second + get(1, 0, m, 0, m));
    }

    cout << ans << endl;

    return 0;
}
