#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll BASE = 1e6;
const ll MOD = 1200720071;

vector<ll> hashes;
vector<ll> bases;

ll hashsub(int l, int r)
{
    return ((hashes[r] - (hashes[l] * bases[r - l]) % MOD) + MOD) % MOD;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    string s;
    cin >> s;

    bases.resize(BASE);
    bases[0] = 1;
    for (int i = 1; i < BASE; i++)
        bases[i] = (bases[i - 1] * BASE) % MOD;

    vector<pair<int, int>> groups;
    vector<ll> hs;
    int last = 0;
    for (int i = 1; i < n; i++)
    {
        if (s[i] != s[i - 1])
        {
            if (s[i - 1] == '1')
            {
                if ((i - last) % 2 == 0)
                {
                    if (hs.size() == 0)
                        groups.push_back({last, -1e9});
                    else
                        groups.push_back({last, -hs.size()});
                }
                else
                {
                    groups.push_back({last, hs.size()});
                    hs.push_back(0);
                }
            }
            else
            {
                groups.push_back({last, hs.size()});
                hs.push_back(i - last);
            }

            last = i;
        }
    }

    if (s[n - 1] == '1')
    {
        if ((n - last) % 2 == 0)
        {
            if (hs.size() == 0)
                groups.push_back({last, -1e9});
            else
                groups.push_back({last, -hs.size()});
        }
        else
        {
            groups.push_back({last, hs.size()});
            hs.push_back(0);
        }
    }
    else
    {
        groups.push_back({last, hs.size()});
        hs.push_back(n - last);
    }

    hashes.resize(hs.size() + 1, 0);
    for (int i = 0; i < hs.size(); i++)
        hashes[i + 1] = ((hashes[i] * BASE) % MOD + hs[i]) % MOD;

    vector<int> total_ones(n + 1, 0);
    for (int i = 0; i < n; i++)
    {
        total_ones[i + 1] = total_ones[i];
        if (s[i] == '1')
            total_ones[i + 1]++;
    }

    int q;
    cin >> q;

    for (int i = 0; i < q; i++)
    {
        int l1, l2, len;
        cin >> l1 >> l2 >> len;
        l1--;
        l2--;

        int r1 = l1 + len - 1;
        int r2 = l2 + len - 1;

        if (total_ones[r1 + 1] - total_ones[l1] != total_ones[r2 + 1] - total_ones[l2])
        {
            cout << "No" << endl;
            continue;
        }

        // find NEXT group
        pair<int, int> key = {l1, 1e9};
        auto pl1 = *(upper_bound(groups.begin(), groups.end(), key) - 1);

        key = {l2, 1e9};
        auto pl2 = *(upper_bound(groups.begin(), groups.end(), key) - 1);

        key = {r1, 1e9};
        auto pr1 = *(upper_bound(groups.begin(), groups.end(), key) - 1);

        key = {r2, 1e9};
        auto pr2 = *(upper_bound(groups.begin(), groups.end(), key) - 1);

        if (((pl1.second < 0 || pl2.second < 0) ||
             (pl1.second >= 0 && pl2.second >= 0 && hs[pl1.second] == hs[pl2.second])) &&
            ((pr1.second < 0 || pr2.second < 0) ||
             (pr1.second >= 0 && pr2.second >= 0 && hs[pr1.second] == hs[pr2.second])))
        {
            int il1, il2, ir1, ir2;
            if (pl1.second == -1e9)
                il1 = 0;
            else if (pl1.second < 0)
                il1 = -pl1.second;
            else
                il1 = pl1.second + 1;

            if (pl2.second == -1e9)
                il2 = 0;
            else if (pl2.second < 0)
                il2 = -pl2.second;
            else
                il2 = pl2.second + 1;

            if (pr1.second == -1e9)
                ir1 = -1;
            else if (pr1.second < 0)
                ir1 = -pr1.second - 1;
            else
                ir1 = pr1.second - 1;

            if (pr2.second == -1e9)
                ir2 = -1;
            else if (pr2.second < 0)
                ir2 = -pr2.second - 1;
            else
                ir2 = pr2.second - 1;

            if (il1 - ir1 == il2 - ir2 && (il1 > ir1 || hashsub(il1, ir1 + 1) == hashsub(il2, ir2 + 1)))
                cout << "Yes" << endl;
            else
                cout << "No" << endl;
        }
        else
            cout << "No" << endl;
    }


    return 0;
}
