#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

struct Fen {
    int n;
    int *t;
    Fen (int _n) {
        n = _n;
        t = new int[n];
        memset(t, 0, sizeof(t[0]) * n);
    }
    void add(int i, int x) {
        for (;i < n; i = i | (i + 1))
            t[i] += x;
    }
    int get(int r) {
        r--;
        int res = 0;
        for (;r >= 0; r = (r & (r + 1)) - 1)
            res += t[r];
        return res;
    }
};
struct SegTree {
    int n;
    int *t, *d;

    int merge(int x, int y) {
        return min(x, y);
    }
    void push(int v) {
        t[v] += d[v];
        d[2 * v + 1] += d[v];
        d[2 * v + 2] += d[v];
        d[v] = 0;
    }
    int getV(int v) {
        return t[v] + d[v];
    }

    void upd(int v, int vl, int vr, int l, int r, int x) {
        if (vl == l && vr == r) {
            d[v] += x;
        } else {
            int m = (vl + vr) / 2;
            push(v);

            if (r <= m)
                upd(2 * v + 1, vl, m, l, r, x);
            else if (m <= l)
                upd(2 * v + 2, m, vr, l, r, x);
            else
                upd(2 * v + 1, vl, m, l, m, x), upd(2 * v + 2, m, vr, m, r, x);

            t[v] = merge(getV(2 * v + 1), getV(2 * v + 2));
        }
    }
    int get(int v, int vl, int vr, int l, int r) {
        if (vl == l && vr == r) {
            return getV(v);
        } else {
            int m = (vl + vr) / 2;
            push(v);

            if (r <= m)
                return get(2 * v + 1, vl, m, l, r);
            else if (m <= l)
                return get(2 * v + 2, m, vr, l, r);
            else
                return merge(get(2 * v + 1, vl, m, l, m), get(2 * v + 2, m, vr, m, r));
        }
    }

    void upd(int l, int r, int x) {
        upd(0, 0, n, l, r, x);
    }
    int get(int l, int r) {
        return get(0, 0, n, l, r);
    }
};
struct PrefSums {
    ll *t;

    PrefSums(int n, int *a) {
        t = new ll[n + 1];

        t[0] = 0;
        for (int i = 1; i <= n; ++i)
            t[i] = t[i - 1] + a[i - 1];
    }

    ll get(int l, int r) {
        return t[r] - t[l];
    }
};

const int T = 1e6;

ll res[T];

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int n;
    cin >> n;

    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        res[x + n - i] += x;
    }

    ll ans = 0;

    for (int i = 0; i < T; ++i) {
        ans = max(ans, res[i]);
    }

    cout << ans;
    return 0;
}