#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define int long long

/*
struct Fen {
    int n;
    int *t;
    Fen (int _n) {
        n = _n;
        t = new int[n];
        memset(t, 0, sizeof(t[0]) * n);
    }
    void add(int i, int x) {
        for (;i < n; i = i | (i + 1))
            t[i] += x;
    }
    int get(int r) {
        r--;
        int res = 0;
        for (;r >= 0; r = (r & (r + 1)) - 1)
            res += t[r];
        return res;
    }
};
 */

struct SegTree {
    int n;
    int *t, *d;

    SegTree(int _n) {
        n = _n;

        int sz = 1;
        while (sz < n * 2) sz *= 2;

        t = new int[sz];
        d = new int[sz];

        for (int i = 0; i < sz; ++i)
            t[i] = d[i] = 0;
    }

    int merge(int x, int y) {
        return max(x, y);
    }
    void push(int v) {
        t[v] += d[v];
        d[2 * v + 1] += d[v];
        d[2 * v + 2] += d[v];
        d[v] = 0;
    }
    int getV(int v) {
        return t[v] + d[v];
    }

    void upd(int v, int vl, int vr, int l, int r, int x) {
        if (vl == l && vr == r) {
            d[v] += x;
        } else {
            int m = (vl + vr) / 2;
            push(v);

            if (r <= m)
                upd(2 * v + 1, vl, m, l, r, x);
            else if (m <= l)
                upd(2 * v + 2, m, vr, l, r, x);
            else
                upd(2 * v + 1, vl, m, l, m, x), upd(2 * v + 2, m, vr, m, r, x);

            t[v] = merge(getV(2 * v + 1), getV(2 * v + 2));
        }
    }
    int get(int v, int vl, int vr, int l, int r) {
        if (vl == l && vr == r) {
            return getV(v);
        } else {
            int m = (vl + vr) / 2;
            push(v);

            if (r <= m)
                return get(2 * v + 1, vl, m, l, r);
            else if (m <= l)
                return get(2 * v + 2, m, vr, l, r);
            else
                return merge(get(2 * v + 1, vl, m, l, m), get(2 * v + 2, m, vr, m, r));
        }
    }

    void upd(int l, int r, int x) {
        if (l < r)
            upd(0, 0, n, l, r, x);
    }
    int get(int l, int r) {
        return get(0, 0, n, l, r);
    }
};

/*
struct PrefSums {
    ll *t;

    PrefSums(int n, int *a) {
        t = new ll[n + 1];

        t[0] = 0;
        for (int i = 1; i <= n; ++i)
            t[i] = t[i - 1] + a[i - 1];
    }

    ll get(int l, int r) {
        return t[r] - t[l];
    }
};

 */

struct Item {
    int x, c;
};

struct R {
    int x, y, z;
};

bool comp(const Item &a, const int &x) {
    return a.x < x;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, m, p;
    cin >> n >> m >> p;

    //int a[n], ca[n], b[m], cb[m];
    Item a[n], b[m];
    R c[p];

    for (int i = 0; i < n; ++i)
        cin >> a[i].x >> a[i].c;
    for (int i = 0; i < m; ++i)
        cin >> b[i].x >> b[i].c;
    for (int i = 0; i < p; ++i)
        cin >> c[i].x >> c[i].y >> c[i].z;

    sort(a, a + n, [](Item &a, Item &b) {
       return a.x < b.x;
    });

    sort(b, b + m, [](Item &a, Item &b) {
        return a.x < b.x;
    });

    sort(c, c + m, [](R &a, R &b) {
        return a.x < b.x;
    });

    SegTree s(m);

    for (int i = 0; i < m; ++i) {
        s.upd(i, i + 1, -b[i].c);
    }

    ll res = -1e18;

    for (int i = 0, j = 0; i < n; ++i) {
        while (j < p && a[i].x > c[j].x) {
            int ind = lower_bound(b, b + m, c[j].y + 1, comp) - b;

            if (ind < m)
                s.upd(ind, m, c[j].z);

            j++;
        }

        res = max(res, (ll)-a[i].c + (ll)s.get(0, n));
    }

    cout << res;

    return 0;
}