#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 2e5 + 7;
const ll inf = 1e18 + 7;

ll t[4 * N];
ll lz[4 * N];

void push(int v, int tl, int tr) {
  if (!lz[v]) return;
  t[v] += lz[v];
  if (tl != tr) {
    lz[2 * v + 1] += lz[v];
    lz[2 * v + 2] += lz[v];
  }
  lz[v] = 0;
}

void upd(int v, int tl, int tr, int l, int r, int x) {
  push(v, tl, tr);
  if (l > tr || r < tl) {
    return;
  } else if (tl >= l && tr <= r) {
    lz[v] += x;
    push(v, tl, tr);
  } else {
    int tm = (tl + tr) / 2;
    upd(2 * v + 1, tl, tm, l, r, x);
    upd(2 * v + 2, tm + 1, tr, l, r, x);
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
  }
}

ll get(int v, int tl, int tr, int l, int r) {
  push(v, tl, tr);
  if (l > tr || r < tl) {
    return -inf;
  } else if (tl >= l && tr <= r) {
    return t[v];
  } else {
    int tm = (tl + tr) / 2;
    return max(get(2 * v + 1, tl, tm, l, r), get(2 * v + 2, tm + 1, tr, l, r));
  }
}


struct triple {
  int x, y, k;
};

bool operator < (const triple  &a, const triple &b) {
  if (a.x == b.x) {
    if (a.y == b.y) {
      return a.k < b.k;
    }
    return a.y < b.y;
  }
  return a.x < b.x;
}

int main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  int n, m, p;
  cin >> n >> m >> p;
  vector <pair <int, int> > a(n);
  for (int i = 0; i < n; i++) {
    int x, y;
    cin >> x >> y;
    a[i] = {x, y};
  }
  sort(a.begin(), a.end());
  vector <pair <int, int> > b(m);
  vector <int> val;
  for (int i = 0; i < m; i++) {
    int x, y;
    cin >> x >> y;
    val.push_back(x);
    b[i] = {x, y};
  }
  sort(b.begin(), b.end());
  sort(val.begin(), val.end());
  vector <triple> qr;
  for (int i = 0; i < p; i++) {
    int x, y, k;
    cin >> x >> y >> k;
    qr.push_back({x, y, k});
  }
  sort(qr.begin(), qr.end());
  for (int i = 0; i < m; i++) {
    upd(0, 0, m - 1, i, i, -b[i].second);
  }
  vector <ll> res;
  int ptr = 0;
  for (int i = 0; i < n; i++) {
    while (ptr < p && qr[ptr].x < a[i].first) {
      int x = qr[ptr].x;
      int y = qr[ptr].y;
      int k = qr[ptr].k;
      auto it = upper_bound(val.begin(), val.end(), y);
      if (it != val.end()) {
        int pos = it - val.begin();
        upd(0, 0, m - 1, pos, m - 1, k);
      }
      ptr++;
    }
    res.push_back(get(0, 0, m - 1, 0, m - 1) - (ll) a[i].second);
  }
  sort(res.begin(), res.end());
  cout << res.back() << '\n';
  return 0;
}
