#include <iostream>
#include <sstream>
#include <string>
#include <cmath>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <map>
#include <queue>

using namespace std;

int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;
	vector<vector<int>> gr(n), regr(n);
	for(int i = 0; i < m; ++i){
		int u, v;
		cin >> u >> v;--u;--v;
		gr[u].emplace_back(v);
		regr[v].emplace_back(u);
	}
	int k;
	cin >> k;
	vector<int> polypath(k);
	for(auto &elem : polypath){
		cin >> elem; --elem;
	}
	vector<int> minpaths(n, m);
	minpaths[polypath.back()] = 0;
	queue<int> bfs;
	bfs.emplace(polypath.back());
	while(!bfs.empty()){
		int vnow = bfs.front();
		bfs.pop();
		for(auto v : regr[vnow]){
			if(minpaths[v] == m){
				minpaths[v] = minpaths[vnow] + 1;
				bfs.emplace(v);
			}
		}
	}
	int minans = 0, maxans = 0;
	for(int i = 0; i < k - 1; ++i){
		if(minpaths[polypath[i + 1]] != minpaths[polypath[i]] - 1){
			++minans; ++maxans;
		}
		else{
			for(auto v : gr[polypath[i]]){
				if(v != polypath[i + 1] && minpaths[v] == minpaths[polypath[i]] - 1){
					++maxans;
					break;
				}
			}
		}
	}
	cout << minans << " " << maxans;

	return 0;
}