#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
#include <map>
#include <queue>

using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define inf 1000000000ll;
#define x first
#define y second
#define ll long long

vector<ll> zfunc(string s)
{
	int n = s.length();
	vector<ll> z(n);
	z[0] = 0;
	ll l = 0, r = 0;
	for(int i = 1; i < n; i++)
	{
		if(i <= r)
		{
			z[i] = min(r - i + 1, z[l - i]);
		}
		while(i + z[i] < n && s[z[i]] == s[i + z[i]]) z[i]++;
	}
	return z;
}

int main()
{
	//---------------------------------------------
	#define int long long
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);
	//---------------------------------------------
	int n, m;
	cin >> n >> m;
	vector<vector<int>> a(n, vector<int>(0));
	for(int i = 0; i < m; i++)
	{
		int x, y;
		cin >> x >> y;
		x--;
		y--;
		a[y].push_back(x);
	}
	int k;
	cin >> k;
	vector<int> path(k);
	for(int i = 0; i < k; i++)
	{
		cin >> path[i];
		path[i]--;
	}
	vector<int> dp(n, 10000000);
	int s = path[0], t = path[k - 1];
	dp[t] = 0;
	queue<int> q;
	q.push(t);
	while(!q.empty())
	{
		auto x = q.front();
		q.pop();
		for(int ii = 0; ii < a[x].size(); ii++)
		{
			auto i = a[x][ii];
			if(dp[i] != 10000000) continue;
			dp[i] = dp[x] + 1;
			q.push(i);
		}
	}

	vector<int> kolvo(n, 0);
	for(int i = 0; i < n; i++)
	{
		for(int j = 0; j < a[i].size(); j++)
		{
			auto x = a[i][j];
			if(dp[x] == dp[i] + 1) kolvo[x]++;
		}
	}

	int mn = 0, mx = 0;
	for(int ii = 1; ii < k; ii++)
	{
		auto i = path[ii];
		if(dp[i] - dp[path[ii - 1]] != -1) 
		{
			mn++;
			mx++;
			continue;
		}
		if(kolvo[path[ii - 1]] > 1) mx++;
	}
	cout << mn << " " << mx;

#ifdef _DEBUG
	system("pause");
#endif
	return 0;
}