#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
#include <map>
#include <queue>

using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define inf 1000000000ll;
#define x first
#define y second
#define ll long long

vector<pair<ll, ll>> rmq;

void update(ll v, ll l, ll r, ll tl, ll tr, ll x)
{
	if(l == tl && r == tr)
	{
		rmq[v].x += x;
		rmq[v].y += x;
		return;
	}

	int m = (l + r) / 2;
	rmq[v + v].x += rmq[v].y;
	rmq[v + v].y += rmq[v].y;
	rmq[v + v + 1].x += rmq[v].y;
	rmq[v + v + 1].y += rmq[v].y;
	rmq[v].y = 0;
	if(tr < m) update(v + v, l, m, tl, tr, x);
	else if(tl >= m) update(v + v + 1, m, r, tl, tr, x);
	else
	{
		update(v + v, l, m, tl, m, x);
		update(v + v + 1, m, r, m, tr, x);
	}
	rmq[v].x = max(rmq[v + v].x, rmq[v + v + 1].x);
}

int main()
{
	//---------------------------------------------
	#define int long long
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);
	//---------------------------------------------
	int n, m, p;
	cin >> n >> m >> p;
	vector<pair<int, int>> a(n);
	vector<pair<int, int>> b(m);
	vector<pair<pair<int, int>, int>> x(p);
	for(int i = 0; i < n; i++) cin >> a[i].x >> a[i].y;
	for(int i = 0; i < m; i++) cin >> b[i].x >> b[i].y;
	for(int i = 0; i < p; i++) cin >> x[i].x.x >> x[i].x.y >> x[i].y;
	sort(all(a));
	sort(all(b));

	int mn = 1e9 + 1;
	for(int i = n - 1; i >= 0; i--)
	{
		if(a[i].y < mn) mn = a[i].y;
		else a[i].y = mn;
	}
	mn = 1e9 + 1;
	for(int i = m - 1; i >= 0; i--)
	{
		if(b[i].y < mn) mn = b[i].y;
		else b[i].y = mn;
	}

	sort(all(x));
	vector<pair<pair<int, int>, int>> nw;
	for(int i = 0; i < p; i++)
	{
		auto t = upper_bound(all(a), make_pair(x[i].x.x, (int)(1e9 + 1)));
		if(t == a.end()) break;
		x[i].x.x = (int)(t - a.begin());
		t = upper_bound(all(b), make_pair(x[i].x.y, (int)(1e9 + 1)));
		if(t == b.end()) continue;
		x[i].x.y = (int)(t - b.begin());
		nw.push_back(x[i]);
	}
	n = nw.size();

	rmq.resize(4 * (m + 1), make_pair(0, 0));
	int ans = a[0].y + b[0].y;
	ans = -ans;
	
	int last = 0;
	for(int i = 0; i < m; i++)
	{
		update(1ll, 0ll, m + 1, i + 1, m + 1, last - b[i].y);
		last = b[i].y;
	}

	for(int i = 0; i < n; i++)
	{
		update(1ll, 0ll, m + 1, nw[i].x.y + 1, m + 1, nw[i].y);
		ans = max(ans, rmq[1].x - a[nw[i].x.x].y);
	}
	cout << ans;
#ifdef _DEBUG
	system("pause");
#endif
	return 0;
}