#include <bits/stdc++.h>

using namespace std;

struct monster {
    int x, y, z;
    monster() = default;
    monster(int x, int y, int z) : x(x), y(y), z(z) {}

    bool operator < (const monster &a) const {
        return x < a.x;
    }
};

const int MAXN = 2e5;

long long t[MAXN * 4], add[MAXN * 4];
int sz;

void build(vector<pair<int, int>> &arr, int v = 0, int vl = 0, int vr = sz) {
    if (vr - vl == 1) {
        t[v] = -arr[vl].second;
        return;
    }
    int vm = (vl + vr) / 2;
    build(arr, v * 2 + 1, vl, vm);
    build(arr, v * 2 + 2, vm, vr);
    t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
}

void push(int v, int vl, int vr) {
    t[v] += add[v];
    if (vr - vl != 1) {
        add[v * 2 + 1] += add[v];
        add[v * 2 + 2] += add[v];
    }
    add[v] = 0;
}

void modify(int l, int r, int d, int v = 0, int vl = 0, int vr = sz) {
    push(v, vl, vr);
    if (vr <= l || r <= vl) {
        return;
    }
    if (l <= vl && vr <= r) {
        add[v] = d;
        push(v, vl, vr);
        return;
    }
    int vm = (vl + vr) / 2;
    modify(l, r, d, v * 2 + 1, vl, vm);
    modify(l, r, d, v * 2 + 2, vm, vr);
    t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
}

main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, p;
    cin >> n >> m >> p;
    vector<pair<int, int>> a(n);
    for (auto &i : a) {
        cin >> i.first >> i.second;
    }
    sort(a.begin(), a.end());
    vector<pair<int, int>> b(m);
    for (auto &i : b) {
        cin >> i.first >> i.second;
    }
    sort(b.begin(), b.end());
    sz = b.size();
    vector<monster> w(p);
    for (auto &[x, y, z] : w) {
        cin >> x >> y >> z;
    }
    sort(w.begin(), w.end());
    int now = 0;
    build(b);
    long long ans = -1e18;
    for (int i = 0; i < n; i++) {
        while (now != p && w[now].x < a[i].first) {
            int id = upper_bound(b.begin(), b.end(), make_pair(w[now].y + 1, 0)) - b.begin();
            if (id != m) {
                modify(id, m, w[now].z);
                ans = max(ans, t[0] - a[i].second);
            }
            now++;
        }
    }
    cout << ans;
    return 0;
}