#include <bits/stdc++.h>
using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define pii pair<int, int>
#define vi vector<int>

typedef long long ll;
typedef long double ld;
typedef short inth;

const int N = 1e6;
const int M = N + 7;
const int MOD = 2e9 + 7;
const ll INF = 1e16 + 17;
const double EPS = 1e-10;

ll g[M * 4], q[M * 4];

int px[M], py[M];

void build(int v = 1, int tl = 1, int tr = N) {
    if (tl == tr) {
        g[v] = py[tl] ? -py[tl] : -INF;
        return;
    }
    int tm = (tl + tr) >> 1;
    build(v << 1, tl, tm);
    build(v << 1 | 1, tm + 1, tr);
    g[v] = max(g[v << 1], g[v << 1 | 1]);
}

void push(int v, bool leaf) {
    g[v] += q[v];
    if (!leaf) {
        q[v << 1] += q[v];
        q[v << 1 | 1] += q[v];
    }
    q[v] = 0;
}

void upd(int l, int r, int val, int v = 1, int tl = 1, int tr = N) {
    push(v, tl == tr);
    if (tr < l || r < tl)
        return;
    if (l <= tl && tr <= r) {
        q[v] += val;
        push(v, tl == tr);
        return;
    }
    int tm = (tl + tr) >> 1;
    upd(l, r, val, v << 1, tl, tm);
    upd(l, r, val, v << 1 | 1, tm + 1, tr);
    g[v] = max(g[v << 1], g[v << 1 | 1]);
}

int main() {
    int n, m, k;
    scanf("%d %d %d", &n, &m, &k);

    for (int i = 1; i <= n; ++i) {
        int a, ca;
        scanf("%d %d", &a, &ca);
        px[a] = min(ca, px[a] ? px[a] : MOD);
    }
    for (int i = 1; i <= m; ++i) {
        int b, cb;
        scanf("%d %d", &b, &cb);
        py[b] = min(cb, py[b] ? py[b] : MOD);
    }

    build();

    vector<pii> vec[M];
    for (int i = 1; i <= k; ++i) {
        int x, y, c;
        scanf("%d %d %d", &x, &y, &c);
        vec[x].pb({y, c});
    }

    ll ans = -INF;
    for (int x = 1; x <= 11; ++x) {
        if (px[x]) {
            push(1, 0);
            ll cur = g[1] - px[x];
            ans = max(ans, cur);
        }

        for (int i = 0; i < sz(vec[x]); ++i) {
            int y = vec[x][i].fi, c = vec[x][i].se;
            upd(y + 1, N, c);
        }
    }

    printf("%lld\n", ans);
    return 0;
}