#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 2e5 + 5;
const int MAXC = 1e6 + 5;
const ll INF = 2e9 + 5;

int n, m, p;
int x[MAXN], y[MAXN], z[MAXN];
int b[MAXN], a[MAXN];
ll cb[MAXN], ca[MAXN];
ll mincost[MAXC];

bool cmpb(int i, int j) {
	return b[i] < b[j];
}

bool cmpp(int i, int j) {
	return y[i] < y[j];
}

bool cmpa(int i, int j) {
	return a[i] < a[j];
}

ll tree[4 * MAXC];
ll adding[4 * MAXC];

int lson(int v) {
	return 2 * v + 1;
}

int rson(int v) {
	return 2 * v + 2;
}

void build(int v = 0, int tl = 0, int tr = MAXC - 1) {
	if (tl == tr) {
		tree[v] = -mincost[tl];
		return;
	}
	int tm = (tl + tr) / 2;
	build(lson(v), tl, tm);
	build(rson(v), tm + 1, tr);
	tree[v] = max(tree[lson(v)], tree[rson(v)]);
}

void push(int v) {
	adding[lson(v)] += adding[v];
	adding[rson(v)] += adding[v];
	tree[lson(v)] += adding[v];
	tree[rson(v)] += adding[v];
	adding[v] = 0;
}

void add_on_seg(int l, int r, ll x, int v = 0, int tl = 0, int tr = MAXC - 1) {
	if (tl > r || tr < l) return;
	if (tl >= l && tr <= r) {
		adding[v] += x;
		tree[v] += x;
		return;  
	}
	push(v);
	int tm = (tl + tr) / 2;
	add_on_seg(l, r, x, lson(v), tl, tm);
	add_on_seg(l, r, x, rson(v), tm + 1, tr);
	tree[v] = max(tree[lson(v)], tree[rson(v)]);
}

ll max_on_seg(int l, int r, int v = 0, int tl = 0, int tr = MAXC - 1) {
	if (tl > r || tr < l) return -INF;
	if (tl >= l && tr <= r) {
		return tree[v];
	}
	int tm = (tl + tr) / 2;
	push(v);
	return max(max_on_seg(l, r, lson(v), tl, tm), max_on_seg(l, r, rson(v), tm + 1, tr));
}

void solve() {
	vector<int> indicesb;
	for (int i = 0; i < m; ++i) indicesb.push_back(i);
	sort(indicesb.begin(), indicesb.end(), cmpb); 
	vector<int> indicesp;
	for (int i = 0; i < p; ++i) indicesp.push_back(i);
	sort(indicesp.begin(), indicesp.end(), cmpp);
	for (int i = 0; i < MAXC; ++i) mincost[i] = INF;
	for (int i = 0; i < n; ++i) {
		mincost[a[i]] = min(mincost[a[i]], ca[i]);
	}
	for (int i = MAXC - 2; i >= 0; --i) {
		mincost[i] = min(mincost[i], mincost[i + 1]);
	}
	int ptr = 0;
	ll ans = -INF;
	build();
	for (auto bind : indicesb) {
		ll curdef = b[bind];
		while (ptr < p && y[indicesp[ptr]] < curdef) {
			//update(x[indicesp[ptr]], z[indicesp[ptr]]);
			add_on_seg(x[indicesp[ptr]] + 1, MAXC - 1, z[indicesp[ptr]]);
			++ptr;
		}
		//TODO
		ll curans = -cb[bind] + max_on_seg(0, MAXC - 1);
		ans = max(ans, curans);
	}
	cout << ans << endl;
}

int main() {
	cin >> n >> m >> p;
	for (int i = 0; i < n; ++i) {
		cin >> a[i] >> ca[i];
	}
	for (int i = 0; i < m; ++i) {
		cin >> b[i] >> cb[i];
	}
	for (int i = 0; i < p; ++i) {
		cin >> x[i] >> y[i] >> z[i];
	}
	solve();
	return 0;
}