#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <map>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <cmath>
#include <ctime>
#include <random>
#include <stack>
#include <queue>
#include <deque>
#include <math.h>

using namespace std;

#define int long long
#define double long double
mt19937 rnd(time(0));
int INF = 1e18;
int EPS = 1e-10;
double PI = atan2(1.0, 0.0) * 2;

void dfs(int u, int fin, int have, vector<vector<int>> &g, vector<int> &cnt, vector<bool> &used) {
    used[u] = 1;
    if (have == 0 && u == fin) cnt[u] = 1;
    if (have != 0) {
        for (auto v : g[u]) {
            if (!used[v]) {
                if(!cnt[v]) dfs(v, fin, have - 1, g, cnt, used);
                cnt[u] += cnt[v];
            }
        }
    }
    used[u] = 0;
}

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(20);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    vector<vector<int>> gor(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[v].push_back(u);
        gor[u].push_back(v);
    }
    int k;
    cin >> k;
    vector<int> way(k);
    for (auto &i : way) cin >> i;
    for (auto &i : way) i--;
    vector<int> dist(n, INF);
    set<pair<int, int>> q;
    int s = way[0], f = way[k - 1];
    swap(s,f);
    dist[s] = 0;
    q.insert({0, s});
    vector<bool> used(n, 0);
    while (!q.empty()) {
        auto[w, u] = *q.begin();
        q.erase(q.begin());
        if (!used[u]) {
            used[u] = 1;
            for (auto v : g[u]) {
                if (dist[u] + 1 < dist[v]) {
                    q.erase({dist[v], v});
                    dist[v] = dist[u] + 1;
                    q.insert({dist[u] + 1, v});
                }
            }
        }
    }
    int mx = 0, mn = 1e9;
    vector<int> cnt(n, 0);
    for(int i = 0; i < k - 1; i++){
        if(dist[way[i]] == k - i - 1){
            mn = min(mn, i);
        }
        for(auto v : gor[way[i]]){
            if(dist[v] == dist[way[i]] - 1) cnt[way[i]]++;
        }
        if(i > 0){
            if(dist[way[i - 1]] - 1 != dist[way[i]])mx++;
            else {
                if(cnt[way[i - 1]] >= 2) mx++;
            }
        }
    }
    cout << mn << " " << mx;
}