#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second
#define pb push_back
#define int long long
#define sz(x) (int)x.size()
#define mp make_pair
#define all(x) x.begin(), x.end()

#ifndef MY
    #define endl '\n'
#endif

typedef pair <int,int> pii;
typedef long double db;

struct Node {
    int x, y, c;
    Node (int x = 0, int y = 0, int c = 0) : x(x), y(y), c(c) {};
};

const int N = 2e5 + 5;
const int M = 1e6 + 5;
const int inf = 1e10 + 7;
int deg = 1;
Node a[N];
Node b[N];
Node lst[N];
int push[M];
int tree[M];

bool cmp(const Node& a, const Node& b) {
    if (a.x == b.x) {
        return a.y < b.y;
    }
    return a.x < b.x;
}

void build(int n) {
    while (deg < n) {
        deg *= 2;
    }
    for (int i = n; i < deg; i++) {
        tree[i + deg] = -inf;
    }
    for (int i = deg - 1; i > 0; i--) {
        tree[i] = max(tree[i * 2], tree[i * 2 + 1]);
    }
}

void upd(int v) {
    tree[v] += push[v];
    if (v < deg) {
        push[v * 2] += push[v];
        push[v * 2 + 1] += push[v];
    }
    push[v] = 0;
}

void add(int ql, int qr, int x, int v = 1, int l = 0, int r = deg) {
    upd(v);
    if (r <= ql || qr <= l) {
        return;
    }
    if (ql <= l && r <= qr) {
        push[v] += x;
        upd(v);
        return;
    }
    int m = (l + r) / 2;
    add(ql, qr, x, v * 2, l, m);
    add(ql, qr, x, v * 2 + 1, m, r);
    tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
}

int get_max(int ql, int qr, int v = 1, int l = 0, int r = deg) {
    upd(v);
    if (r <= ql || qr <= l) {
        return -inf;
    }
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    int m = (l + r) / 2;
    int x = get_max(ql, qr, v * 2, l, m);
    int y = get_max(ql, qr, v * 2 + 1, m, r);
    return max(x, y);
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, p;
    cin >> n >> m >> p;
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].c;
    }
    for (int i = 0; i < m; i++) {
        cin >> b[i].y >> b[i].c;
    }
    for (int i = 0; i < p; i++) {
        cin >> lst[i].x >> lst[i].y >> lst[i].c;
    }
    sort(a, a + n, cmp);
    sort(b, b + m, cmp);
    sort(lst, lst + p, cmp);
    build(m);
    for (int i = 0; i < m; i++) {
        add(i, i + 1, -b[i].c);
    }
    int q = 0;
    int ans = -inf;
    for (int i = 0; i < n; i++) {
        while (q < p && lst[q].x < a[i].x) {
            int l = -1, r = m;
            while (l + 1 != r) {
                int mid = (l + r) / 2;
                if (b[mid].y > lst[q].y) {
                    r = mid;
                } else {
                    l = mid;
                }
            }
            add(r, m, lst[q].c);
            q++;
        }
        int res = get_max(0, m) - a[i].c;
        ans = max(ans, res);
    }
    cout << ans;
}
