#include <bits/stdc++.h>
#pragma GCC target "avx,avx2"

using namespace std;

#define int long long

const int MAX_N = 4 * 1e5 + 42;
pair < int, int > a[MAX_N];
pair < int, int > b[MAX_N];
int cnt[MAX_N];

struct Node{
    int x;
    int y;
    int z;
    Node() {}
    Node(int x, int y, int z): x(x), y(y), z(z) {}
    bool operator < (Node a) {
        if (a.x != x) {
            return x < a.x;
        }
        if (a.y != y) {
            return y < a.y;
        }
        return z < a.z;
    }
};

Node c[MAX_N];
int tree[MAX_N * 2];
int flag[MAX_N * 2];
const int INF = INT_MIN;

void build(int sz) {
    for (int i = sz; i < sz * 2; i++) {
        tree[i] = cnt[i - sz];
    }
    for (int i = sz - 1; i > 0; i--) {
        tree[i] = max(tree[i * 2], tree[i * 2 + 1]);
    }
}

int n, m, p;
int sz = 1;

void push(int v, int vl, int vr) {
    if (vl + 1 == vr) {
        return;
    }
    tree[v * 2] += flag[v];
    tree[v * 2 + 1] += flag[v];
    flag[v * 2] += flag[v];
    flag[v * 2 + 1] += flag[v];
    flag[v] = 0;
}

void change(int v, int vl, int vr, int l, int r, int x) {
    push(v, vl, vr);
    if (vl >= r || l >= vr) {
        return;
    }
    if (l <= vl && vr <= r) {
        tree[v] += x;
        flag[v] += x;
        push(v, vl, vr);
        return;
    }
    int vm = (vl + vr) / 2;
    change(v * 2, vl, vm, l, r, x);
    change(v * 2 + 1, vm, vr, l, r, x);
    tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
}

void add(Node f) {
    int l = -1;
    int r = m;
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (b[m].first <= f.y) {
            l = m;
        } else {
            r = m;
        }
    }
    if (r == m) {
        return;
    }
    change(1, 0, sz, r, m, f.z);
}

int get_max(int v, int vl, int vr, int l, int r) {
    push(v, vl, vr);
    if (vl >= r || l >= vr) {
        return INF;
    }
    if (l <= vl && vr <= r) {
        return tree[v];
    }
    int vm = (vl + vr) / 2;
    return max(get_max(v * 2, vl, vm, l, r), get_max(v * 2 + 1, vm, vr, l, r));
}

signed main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> p;
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    for (int i = 0; i < m; i++) {
        cin >> b[i].first >> b[i].second;
    }
    sort(a, a + n);
    sort(b, b + m);
    while (sz < m) {
        sz *= 2;
    }
    fill(cnt, cnt + sz, INF);
    for (int i = 0; i < m; i++) {
        cnt[i] = -b[i].second;
    }
    build(sz);
    int ans = INT_MIN;
    for (int i = 0; i < p; i++) {
        int x, y, z;
        cin >> x >> y >> z;
        c[i] = {x, y, z};
    }
    sort(c, c + p);
    int k = -1;
    for (int i = 0; i < n; i++) {
        while (k + 1 < p && c[k + 1].x < a[i].first) {
            k++;
            add(c[k]);
        }
        ans = max(ans, tree[1] - a[i].second);
    }
    cout << ans;
    return 0;
}
