import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.lang.reflect.Array;
import java.util.*;

import static java.lang.Math.*;

public class Main {
    ArrayList<Integer> g[];
    HashSet<Integer> from[];
    Queue<Integer> q = new ArrayDeque<>();
    boolean used[];
    int[] dist;

    void bfs() {
        while (!q.isEmpty()) {
            int v = q.poll();
            for (Integer to : g[v]) {
                if (!used[to]) {
                    used[to] = true;
                    dist[to] = dist[v] + 1;
                    q.add(to);
                }
                if (dist[to] == dist[v] + 1) from[to].add(v);
            }
        }
    }

    void run() throws IOException {
        int n = nextInt();
        int m = nextInt();
        used = new boolean[n];
        dist = new int[n];
        g = new ArrayList[n];
        from = new HashSet[n];
        for (int i = 0; i < n; i++) {
            g[i] = new ArrayList<>();
            from[i] = new HashSet<>();
        }
        for (int i = 0; i < m; i++) {
            int u = nextInt() - 1;
            int v = nextInt() - 1;
            g[v].add(u);
        }
        int k = nextInt();
        int[] p = new int[k];
        for (int i = 0; i < k; i++) {
            p[i] = nextInt() - 1;
        }
        used[p[k - 1]] = true;
        q.add(p[k - 1]);
        bfs();
        int min = 0;
        int max = 0;
        for (int i = 0; i < p.length - 1; i++) {
            int v = p[i];
            if (from[p[i]].contains(p[i + 1])) {
                if (from[p[i]].size() > 1) max++;
            } else {
                min++;
                max++;
            }
        }
        pw.print(min + " " + max);
        pw.close();
    }

    static BufferedReader br;
    static StringTokenizer st = new StringTokenizer("");
    static PrintWriter pw;

    public static String next() throws IOException {
        while (!st.hasMoreTokens()) st = new StringTokenizer(br.readLine());
        return st.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);
        new Main().run();
    }

}
