import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.lang.reflect.Array;
import java.util.*;

import static java.lang.Math.*;

public class Main {


    void run() throws IOException {
          int n = nextInt();
        int m = nextInt();
        int p = nextInt();
        pair[] a = new pair[n];
        pair[] b = new pair[m];
        for (int i = 0; i < a.length; i++) {
            a[i] = new pair(nextInt(), nextInt());
        }
        Arrays.sort(a);
        Stack<Integer> st = new Stack<>();
        for (int i = 0; i < a.length; i++) {
            while (!st.isEmpty() && a[st.peek()].c >= a[i].c) st.pop();
            st.push(i);
        }
        TreeMap<Long, Long> tm_a = new TreeMap<>();
        while (!st.isEmpty()) {
            int x = st.pop();
            tm_a.put(a[x].x, a[x].c);
        }
        for (int i = 0; i < m; i++) {
            b[i] = new pair(nextInt(), nextInt());
        }
        Arrays.sort(b);
        st = new Stack<>();
        for (int i = 0; i < b.length; i++) {
            while (!st.isEmpty() && b[st.peek()].c >= b[i].c) st.pop();
            st.push(i);
        }
        TreeMap<Long, Long> tm_b = new TreeMap<>();
        while (!st.isEmpty()) {
            int x = st.pop();
            tm_b.put(b[x].x, b[x].c);
        }
        ArrayList<pair> al = new ArrayList<>();
        for (int i = 0; i < p; i++) {
            long x = nextInt();
            long y = nextInt();
            long z = nextInt();
            if (x >= tm_a.lastKey() || y >= tm_b.lastKey()) continue;
            long best_a = tm_a.ceilingKey(x + 1);
            long best_b = tm_b.ceilingKey(y + 1);
            al.add(new pair((long) (best_a * 1e9 + best_b), z));
        }
        Collections.sort(al);
        long[] prefs = new long[al.size() + 1];
        for (int i = 0; i < al.size(); i++) {
            prefs[i + 1] = prefs[i] + al.get(i).c;
        }
        long best_ans = Long.MIN_VALUE;
        for (int i = 0; i < al.size(); i++) {
            pair t = al.get(i);
            long x1 = (long) (t.x / (long)1e9);
            long y1 = (long) (t.x % (long)1e9);
            long sum = 0;
            sum += prefs[i + 1] - tm_a.get(x1) - tm_b.get(y1);
            best_ans = max(sum, best_ans);
        }
        pw.print(best_ans);
        pw.close();
    }

    class pair implements Comparable<pair> {
        long x, c;

        public pair(long x, long c) {
            this.x = x;
            this.c = c;
        }

        @Override
        public int compareTo(pair o) {
            if (o.x == this.x) return Long.compare(o.c, this.c);
            return -Long.compare(o.x, this.x);
        }
    }

    static BufferedReader br;
    static StringTokenizer st = new StringTokenizer("");
    static PrintWriter pw;

    public static String next() throws IOException {
        while (!st.hasMoreTokens()) st = new StringTokenizer(br.readLine());
        return st.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);
        new Main().run();
    }

}
