#include <bits/stdc++.h>

#define int long long
#define double long double
#define ff first
#define ss second
#define pb push_back
#define pf push_front
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

using namespace std;

const int inf = 1e18;
const double eps = 1e-6;
const int maxw = 1e6 + 10;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count() + 2003);

int val[maxw];

int tree[4 * maxw], add[4 * maxw];


void make_tree(int v, int tl, int tr)
{
    if (tl == tr)
    {
        tree[v] = val[tl];
        return;
    }
    int m = (tl + tr) / 2;
    make_tree(2 * v + 1, tl, m);
    make_tree(2 * v + 2, m + 1, tr);
    tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

void push(int v, int tl, int tr)
{
    tree[v] += add[v];
    if (tl == tr)
    {
        add[v] = 0;
        return;
    }
    add[2 * v + 1] += add[v];
    add[2 * v + 2] += add[v];
    add[v] = 0;
}

void upd(int v, int tl, int tr, int l, int r, int x)
{
    push(v, tl, tr);
    if (l > r || max(tl, l) > min(tr, r)) return;
    if (l <= tl && tr <= r)
    {
        add[v] += x;
        push(v, tl, tr);
        return;
    }
    int m = (tl + tr) / 2;
    upd(2 * v + 1, tl, m, l, r, x);
    upd(2 * v + 2, m + 1, tr, l, r, x);
    tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

int get(int v, int tl, int tr, int l, int r)
{
    push(v, tl, tr);
    if (l > r || max(tl, l) > min(tr, r)) return -inf;
    if (l <= tl && tr <= r) return tree[v];
    int m = (tl + tr) / 2;
    return max(get(2 * v + 1, tl, m, l, r), get(2 * v + 2, m + 1, tr, l, r));
}

signed main()
{
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int n, m, p;
    cin >> n >> m >> p;
    for (int i = 0; i < maxw; ++i) val[i] = -inf;
    vector<pair<int, int>> v;
    for (int i = 0; i < n; ++i)
    {
        int x, c;
        cin >> x >> c;
        v.pb({x, c});
    }
    sort(all(v));
    for (int i = n - 2; i >= 0; --i) v[i].ss = min(v[i].ss, v[i + 1].ss);
    for (int i = 0; i < m; ++i)
    {
        int y, c;
        cin >> y >> c;
        val[y] = -c;
    }
    int ans = -inf;
    for (int i = maxw - 2; i >= 0; --i)
    {
        val[i] = max(val[i - 1], val[i]);
        ans = max(ans, val[i] - v[0].ss);
    }
    vector<pair<pair<int, int>, int>> t;
    for (int i = 0; i < p; ++i)
    {

        int x, y, z;
        cin >> x >> y >> z;
        t.pb({{x, y}, z});
    }
    sort(all(t));
    make_tree(0, 0, maxw - 1);
    int pos = 0;
    for (auto vi : v)
    {
        int x, c;
        tie(x, c) = vi;
        while (pos < sz(t) && t[pos].ff.ff < x)
        {
            upd(0, 0, maxw - 1, t[pos].ff.ss + 1, maxw - 1, t[pos].ss);
            ++pos;
        }
        ans = max(ans, get(0, 0, maxw - 1, 0, maxw - 1) - c);
    }
    cout << ans;
    return 0;
}
