#include<iostream>
#include<algorithm>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<assert.h>
#include<cmath>

using namespace std;

//#define int long long


struct node {
	int aa, bb, cost, ind;
};



bool cmp(node a, node b) {
	if(a.bb == b.bb) {
		if(a.aa == b.aa) {
			return a.ind < b.ind;
		}
		return a.aa < b.aa;
	}
	return a.bb < b.bb;
}

int n, m, p;

vector<pair<int, int>> a;
vector<pair<int, int>> b;
vector<node> ev;

vector<int> tree;
vector<int> ph;


void build(int v, int tl, int tr) {
	if(tl + 1 == tr) {
		tree[v] = -a[tl].second;
		return;
	}
	int tm = (tl + tr) / 2;
	build(v * 2, tl, tm);
	build(v * 2 + 1, tm, tr);
	tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
}
/*
int get(int v, int tl, int tr, int l, int r) {
	if(tl >= r || tr <= l) {
		return -1e9;
	}
	if(l <= tl && tr <= r) {
		return tree[v];
	}
	int tm = (tl + tr) / 2;
	return max(get(v * 2, tl, tm, l, r), get(v * 2 + 1, tm, tr, l, r));
}
*/
void update(int v, int tl, int tr, int pos, int cost) {
	if(tl + 1 < tr) {
		tree[v * 2] += ph[v];
		tree[v * 2 + 1] += ph[v];
		ph[v * 2] += ph[v];
		ph[v * 2 + 1] += ph[v];
		ph[v] = 0;
	}
	if(a[tr - 1].first <= pos) {
		return;
	}
	if(a[tl].first > pos) {
		tree[v] += cost;
		ph[v] += cost;
		return;
	}
	int tm = (tl + tr) / 2;
	update(v * 2, tl, tm, pos, cost);
	update(v * 2 + 1, tm, tr, pos, cost);
	tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
}

signed main() {
	cin >> n >> m >> p;
	a.resize(n);
	b.resize(m);
	ev.resize(p);
	tree.resize(1e5 * 8);
	ph.resize(1e5 * 8, 0);
	for(int i = 0; i < n; i++) {
		cin >> a[i].first >> a[i].second;
	}
	for(int i = 0; i < m; i++) {
		cin >> b[i].first >> b[i].second;
	}
	for(int i = 0; i < p; i++){
		cin >> ev[i].aa >> ev[i].bb >> ev[i].cost;
		ev[i].ind = i;
	}
	sort(a.begin(), a.end());
	sort(ev.begin(), ev.end(), cmp);
	build(1, 0, n);
	sort(b.begin(), b.end());
	int it = 0;
	int ans = -a[0].second - b[0].second;
	for(int i = 0; i < m; i++) {
		int pownow = b[i].first;
		while(it < n && ev[it].bb < pownow) {
			update(1, 0, n, ev[it].aa, ev[it].cost);
			it++;
		}
		ans = max(tree[1] - b[i].second, ans);
	}
	cout << ans;
}