#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <string>

using namespace std;

const int N = 2e5;

int n, m, k;
vector<int> g[N], rev_g[N];
int p[N];

bool used[N];
int lvl[N];

void bfs1(int s){
	queue<int> q;
	auto push = [&](int v, int dist){
		q.push(v);
		used[v] = true;
		lvl[v] = dist;
	};
	push(s, 0);
	while (!q.empty()){
		int v = q.front();
		q.pop();
		for (int i = 0; i < g[v].size(); ++i){
			int u = g[v][i];
			if (!used[u]){
				push(u, lvl[v] + 1);
			}
		}
	}
}

int rofl[N];

void bfs2(int s){
	fill(used, used + n, false);
	queue<int> q;
	auto push = [&](int v, int dist){
		q.push(v);
		used[v] = true;
		rofl[v] = dist;
	};
	push(s, 0);
	while (!q.empty()){
		int v = q.front();
		q.pop();
		for (int i = 0; i < rev_g[v].size(); ++i){
			int u = rev_g[v][i];
			if (!used[u]){
				push(u, rofl[v] + 1);
			}
		}
	}
}

int kek[N];

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    cin >> n >> m;
	for (int i = 0; i < m; ++i){
		int v, u;
		cin >> v >> u;
		g[--v].push_back(--u);
		rev_g[u].push_back(v);
	}
	cin >> k;
	for (int i = 0; i < k; ++i){
		cin >> p[i];
		--p[i];
	}
	bfs1(p[0]);
	bfs2(p[k - 1]);
	for (int v = 0; v < n; ++v){
		kek[v] = -2;
		for (int i = 0; i < g[v].size(); ++i){
			int u = g[v][i];
			if (rofl[v] == rofl[u] + 1){
				if (kek[v] != -2){
					kek[v] = -1;
				}
				else{
					kek[v] = u;
				}
			}
		}
	}
	int ans1 = 0, ans2 = 0;
	for (int i = 1; i < k; ++i){
		ans1 += (lvl[p[i]] != lvl[p[i - 1]] + 1);
		ans2 += (kek[p[i - 1]] != p[i]);
	}
	cout << ans1 << ' ' << ans2 << '\n';
	//system("pause");
    return 0;
}