#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <string>

using namespace std;

const int N = 2e5;
const int K = 20;

int n, m, p;

struct A{ int a, c; } a[N];
struct B{ int b, c; } b[N];
struct C{ int a, b, c; } c[N];

int d[1 << K];
int t[1 << K];

void build(int pos, int l, int r){
	if (r - l == 1){
		t[pos] = -a[l].c;
	}
	else{
		build(2 * pos + 1, l, l + r >> 1);
		build(2 * pos + 2, l + r >> 1, r);
		t[pos] = max(t[2 * pos + 1], t[2 * pos + 2]);
	}
}

void push(int pos, int l, int r){
	if (d[pos]){
		if (r - l != 1){
			d[2 * pos + 1] += d[pos];
			d[2 * pos + 2] += d[pos];
		}
		t[pos] += d[pos];
		d[pos] = 0;
	}
}

void upd(int pos, int l, int r, int ul, int ur, int x){
	push(pos, l, r);
	if (r <= ul || ur <= l){
		return;
	}
	else if (ul <= l && r <= ur){
		d[pos] += x;
		push(pos, l, r);
	}
	else{
		upd(2 * pos + 1, l, l + r >> 1, ul, ur, x);
		upd(2 * pos + 2, l + r >> 1, r, ul, ur, x);
		t[pos] = max(t[2 * pos + 1], t[2 * pos + 2]);
	}
}

int get(){
	push(0, 0, n);
	return t[0];
}

int dp[N];

void build_dp(){
	build(0, 0, n);
	for (int i = 0; i < p; ++i){
		int l = -1, r = n;
		while (r - l > 1){
			int mid = l + r >> 1;
			(a[mid].a > c[i].a ? l : r) = mid;
		}
		if (r){
			upd(0, 0, n, 0, r, c[i].c);
		}
		dp[i] = get();
	}
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
	cin >> n >> m >> p;
	for (int i = 0; i < n; ++i){
		cin >> a[i].a >> a[i].c;
	}
	for (int i = 0; i < m; ++i){
		cin >> b[i].b >> b[i].c;
	}
	for (int i = 0; i < p; ++i){
		cin >> c[i].a >> c[i].b >> c[i].c;
	}
	sort(a, a + n, [](A x, A y){return x.a > y.a;});
	//sort(b, b + m, [](B x, B y){return x.b < y.b;});
	sort(c, c + p, [](C x, C y){return x.b < y.b;});
	build_dp();
	int ans = -2e9;
	for (int i = 0; i < m; ++i){
		int l = -1, r = p;
		while (r - l > 1){
			int mid = l + r >> 1;
			(c[mid].b < b[i].b ? l : r) = mid;
		}
		if (r){
			ans = max(ans, dp[l] - b[i].c);
		}
	}
	cout << ans << '\n';
	//system("pause");
    return 0;
}