#define _CRT_SECURE_NO_WARNINGS
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <forward_list>
#include <initializer_list>
#include <random>
#include <regex>
#include <system_error>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>

#ifndef _DEBUG
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=naitve")
#endif // _DEBUG

using namespace std;

#define ll long long
#define ld long double
#define itn int

#define endl '\n'

mt19937 gen(41);
mt19937_64 genl(41);
//chrono::system_clock::now().time_since_epoch().count()

#ifdef MY
template <typename T> using ordered_set = tree <T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>;
#endif // MY

int gcd(int a, int b) {
    while(b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

ll gcdl(ll a, ll b) {
    while(b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

bool uax(int &a, int &b) {
    if(a < b) {
        a = b;
        return true;
    }
    return false;
}

bool uin(int &a, int &b) {
    if(a > b) {
        a = b;
        return true;
    }
    return false;
}


vector<int> z_function(string &s) {
    int n = s.size();
    vector<int> z(n);
    for(int i = 1, l = 0, r = 0; i < n; i++) {
        if(i <= r)
            z[i] = min(r - i + 1, z[i - l]);
        while(i + z[i] < n && s[i + z[i]] == s[z[i]])
            z[i]++;
        if(i + z[i] > r) {
            r = i + z[i];
            l = i;
        }
    }
    return z;
}

const ll N = 2000000 + 7;
const ld eps = 1e-7;
const ll INFl = 1e18;
const ll INF = 1e12;

ll a[200000 + 7];
ll t[N * 4];
ll delta[N * 4];

void push(ll v) {
	if(v >= N * 4)
		return;
    if(delta[v] != 0) {
        t[v] += delta[v];
        if(v * 2 < N * 4 && v * 2 + 1 < N * 4) {
            delta[v * 2] += delta[v];
            delta[v * 2 + 1] += delta[v];
        }
        delta[v] = 0;
    }
}

void add(int v, int l, int r, int tl, int tr, ll y, bool f) {
    if(l > r || tl > tr)
        return;
	push(v);
    if(tl == l && tr == r) {
		if(l == r && f) {
			t[v] = y;
			return;
		}
        delta[v] += y;
		push(v);
        return;
    }
    int m = (l + r) / 2;
    add(v * 2, l, m, tl, min(m, tr), y, f);
    add(v * 2 + 1, m + 1, r, max(tl, m + 1), tr, y, f);
	push(v * 2);
	push(v * 2 + 1);
	t[v] = max(t[v * 2 + 1], t[v * 2]);
}

ll get(int v, int l, int r, int tl, int tr) {
    if(l > r || tl > tr)
        return -1e9;
    push(v);
    if(l == tl && r == tr) {
        return t[v];
    }
    int m = (l + r) / 2;
	push(v * 2);
	push(v * 2 + 1);
    return max(get(v * 2, l, m, tl, min(m, tr)), get(v * 2 + 1, m + 1, r, max(tl, m + 1), r));
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#endif // _DEBUG
cout << fixed << setprecision(10);
//---------------------------------------------------------//
    fill(t, t + N * 4, -INF);
    int n, m, k;
    cin >> n >> m >> k;
    vector<pair<ll, ll>> a(n), b(m);
    vector<pair<pair<ll, ll>, ll>> c(k);
    for(ll i = 0; i < n; i++)
        cin >> a[i].first >> a[i].second;
    for(ll j = 0; j < m; j++)
        cin >> b[j].first >> b[j].second;
    for(ll i = 0; i < k; i++)
        cin >> c[i].first.first >> c[i].first.second >> c[i].second;
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    sort(c.begin(), c.end());
    for(int i = 0; i < m; i++) {
        add(1, 0, N, b[i].first, b[i].first, -b[i].second, true);
    }
    ll ii = 0;
    ll res = -INF;
    for(int i = 0; i < n; i++) {
        while(ii < k && c[ii].first.first < a[i].first) {
            add(1, 0, N, c[ii].first.second + 1, N, c[ii].second, false);
            ii++;
        }
        res = max(res, get(1, 0, N, 0, N) - a[i].second);
    }
    cout << res;
//---------------------------------------------------------//
    return 0;
}
