#pragma GCC optimize("Ofast,O3,O2")
#pragma GCC target("sse,sse2,sse4,avx,avx2")

#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <stdlib.h>
#include <set>
#include <unordered_set>
#include <queue>
using namespace std;

typedef long long ll;
const ll INF = 1e18;

void fastIO(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

void dfs(vector<unordered_set<ll>>& brat, vector<vector<ll>>& rgf, ll f) {
	ll n = rgf.size();
	vector<bool> used(n, false);
	vector<ll> dist(n, INF);
	queue<ll> q;
	q.push(f);
	used[f] = true;
	dist[f] = 0;
	while (!q.empty()) {
		ll v = q.front();
		q.pop();
		//ll v = temp.first, p = temp.second;
		for (ll i = 0; i < rgf[v].size(); ++i) {
			ll to = rgf[v][i];
			if (used[to]) {
				if (dist[to] == dist[v] + 1) {
					brat[to].insert(v);
				}
			} else {
				dist[to] = dist[v] + 1;
				brat[to].insert(v);
				used[to] = true;
				q.push(to);
			}
		}
	}
}

int main() {
	ll n, m, a, b, k, temp;
	cin >> n >> m;
	vector<vector<ll>> gf(n), rgf(n);
	for (ll i = 0; i < m; ++i) {
		cin >> a >> b;
		--a, --b;
		gf[a].push_back(b);
		rgf[b].push_back(a);
	}
	cin >> k;
	vector<ll> p(k);
	for (ll i = 0; i < k; ++i) {
		cin >> p[i];
		--p[i];
	}
	vector<unordered_set<ll>> brat(n);
	dfs(brat, rgf, p[k - 1]);
	ll ansMin = 0, ansMax = 0;
	for (ll i = 0; i < k - 1; ++i) {
		ll v = p[i], to = p[i + 1];
		if (brat[v].count(to) > 0) {
			if (brat[v].size() != 1) {
				++ansMax;
			}
		} else {
			++ansMax, ++ansMin;
		}
	}
	cout << ansMin << " " << ansMax << endl;
	char qwer;
	cin >> qwer;
    return 0;
}