#include <iostream>
#include <iomanip>
#include <string>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <cassert>
#include <cmath>
#include <algorithm>
#include <random>
#include <memory>
#include <chrono>

using namespace std;

random_device rd;
mt19937 rnd(rd());

//#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2")

#define ll long long
#define ull unsigned long long
//#define int ll
#define F first
#define S second
const int inf = 2e9;
const int mod = 1e9 + 7;
const int SZ = 100 + 4;

int n;
string s;

void read() {
    cin >> n >> s;
}

void solve() {
    char dp[SZ][SZ];
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            dp[i][j] = 0;
        }
    }
    for (int i = 0; i < n; ++i) {
        dp[i][i] = s[i];
    }
    for (int l = 2; l <= n; ++l) {
        for (int i = 0; i + l - 1 < n; ++i) {
            int j = i + l - 1;
            for (int k = i; k < j; ++k) {
                if (dp[i][k] != 0 && dp[k + 1][j] != 0 && abs(dp[i][k] - dp[k + 1][j]) == 1) {
                    dp[i][j] = min(dp[i][k], dp[k + 1][j]);
                }
            }
        }
    }

    vector<int> ans(n, inf);
    for (int i = 0; i < n; ++i) {
        if (dp[0][i] != 0) {
            ans[i] = 1;
            continue;
        }
        for (int j = 0; j < i; ++j) {
            if (ans[j] != inf && dp[j + 1][i] != 0) {
                ans[i] = min(ans[i], ans[j] + 1);
            }
        }
    }
    cout << n - ans[n - 1];
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    solve();

    return 0;
}