#include <iostream>
#include <iomanip>
#include <string>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <cassert>
#include <cmath>
#include <algorithm>
#include <random>
#include <memory>
#include <chrono>

using namespace std;

random_device rd;
mt19937 rnd(rd());

//#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2")

#define ll long long
#define ull unsigned long long
#define int ll
#define pii pair<int, int>
#define F first
#define S second
const int inf = 2e9;
const int mod = 1e9 + 7;
const int SZ = 2e5 + 4;

int n, m;
set<int> h[SZ];

int k;
int p[SZ];

void read() {
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        h[v].insert(u);
    }
    cin >> k;
    for (int i = 0; i < k; ++i) {
        cin >> p[i];
        --p[i];
    }
}

bool used[SZ];

vector<pair<int, bool>> bfs(int u) {
    vector<pair<int, bool>> d(n, {inf, false});
    d[u] = {0, false};
    used[u] = true;
    queue<int> q;
    q.push(u);
    while (!q.empty()) {
        u = q.front();
        q.pop();

        for (int v : h[u]) {
            if (!used[v]) {
                d[v] = d[u];
                ++d[v].F;
                used[v] = true;
                q.push(v);
            } else if (d[v].F == d[u].F + 1) {
                d[v].S = true;
            }
        }
    }
    return d;
}

void solve() {
    vector<pair<int, bool>> d = bfs(p[k - 1]);

    int mx = 0, mn = 0;
    for (int i = 0; i < k - 1; ++i) {
        if (d[p[i]].F == k - i - 1) {
            if (d[p[i]].S) {
                ++mx;
            }
        } else {
            ++mx;
            ++mn;
        }
    }
    cout << mn << " " << mx << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    solve();

    return 0;
}