#include <iostream>
#include <iomanip>
#include <string>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <cassert>
#include <cmath>
#include <algorithm>
#include <random>
#include <memory>
#include <chrono>

using namespace std;

random_device rd;
mt19937 rnd(rd());

//#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2")

#define ll long long
#define ull unsigned long long
#define int ll
#define pii pair<int, int>
#define F first
#define S second
const int inf = 2e9;
const int mod = 1e9 + 7;
const int SZ = 2e5 + 4;

int n, m;
vector<int> h[SZ];

int k;
int p[SZ];

void read() {
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        h[v].push_back(u);
    }
    cin >> k;
    for (int i = 0; i < k; ++i) {
        cin >> p[i];
        --p[i];
    }
}

bool used[SZ];

void solve() {
    vector<pair<int, bool>> d(n, {inf, false});
    vector<int> parent(n);
    d[p[k - 1]] = {0, false};
    used[p[k - 1]] = true;
    queue<int> q;
    q.push(p[k - 1]);

    while (!q.empty()) {
        int u = q.front();
        q.pop();

        for (int v : h[u]) {
            if (!used[v]) {
                d[v].F = d[u].F + 1;
                d[v].S = false;
                q.push(v);
                used[v] = true;
                parent[v] = u;
            } else if (d[v].F == d[u].F + 1) {
                d[v].S = true;
            }
        }
    }

    int mn = 0, mx = 0;
    for (int i = 0; i < k - 1; ++i) {
        if (d[p[i]].S) {
            ++mx;
        }
        if (d[p[i]].F != d[p[i + 1]].F + 1) {
            ++mn;
        }
    }
    cout << mn << " " << mx;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    solve();

    return 0;
}