#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <deque>
#include <queue>
#include <cassert>
#include <cmath>

#define ll long long
#define pii pair<int,int>
#define pll pair<ll,ll>

const int INF = 1e9+1;

using namespace std;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n, m;
	cin >> n >> m;

	vector<vector<int>> gr(n);
	vector<vector<int>> r_gr(n);
	for(int i = 0; i < m; i++){
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		gr[a].push_back(b);
		r_gr[b].push_back(a);
	}
	int k;
	cin >> k;
	vector<int> path(k);
	for(int i = 0; i < k; i++){
		cin >> path[i];
		path[i]--;
	}

	int s = path.back();
	queue<int> q;
	vector<int> dist(n, INF);
	vector<set<int>> vert(n);
	vector<bool> used(n);
	dist[s] = 0;
	q.push(s);

	while(!q.empty()){
		int v = q.front();
		q.pop();
		if(used[v])
			continue;
		used[v] = true;
		
		for(int i = 0; i < r_gr[v].size(); i++){
			int u = r_gr[v][i];
			if(used[u])
				continue;
			if(dist[v] + 1 < dist[u])
			{
				dist[u] = dist[v] + 1;
				vert[u].clear();
				q.push(u);
			}
			if(dist[v] + 1 == dist[u])
			{
				vert[u].insert(v);
			}
		}
	}

	int mn = 0, mx = 0;

  	for(int i = 0; i < k-1; i++){
		int u, v;
		u = path[i];
		v = path[i+1];
		if(vert[u].find(v) == vert[u].end())
		{
			mn++;
			mx++;
		}
		else if(vert[u].size() > 1)
			mx++;
	}

	cout << mn << " " << mx;
} 
