#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 1;
const ll MOD = 1e9 + 7;
const ll ALPH = 26;
const ld EPS = 1e-9;

#define size(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()

void bye() {
    cout << "\n";
    exit(0);
}

struct Solution {

    int n, m;
    vector<vector<int> > g;
    vector<vector<int> > gp;
    vector<vector<int> > dist;

    void bfs(int s, int id) {
        queue<int> q;
        q.push(s);
        dist[id][s] = 0;
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            if (!id) {
                for (auto to : g[v]) {
                    if (dist[id][to] > dist[id][v] + 1) {
                        q.push(to);
                        dist[id][to] = dist[id][v] + 1;
                    }
                }
            } else {
                for (auto to : gp[v]) {
                    if (dist[id][to] > dist[id][v] + 1) {
                        q.push(to);
                        dist[id][to] = dist[id][v] + 1;
                    }
                }
            }
        }
    }

    void solve() {
        cin >> n >> m;
        g.resize(n);
        gp.resize(n);
        dist.resize(2, vector<int>(n, INF));
        for (int i = 0; i < m; i++) {
            int u, v;
            cin >> u >> v;
            --u, --v;
            g[u].push_back(v);
            gp[v].push_back(u);
        }
        ll k;
        cin >> k;
        vector<int> path(k);
        for (int i = 0; i < k; i++) {
            cin >> path[i];
            --path[i];
        }
        int s = path[0];
        int t = path.back();
        bfs(s, 0);
        bfs(t, 1);
        int mn = 0, mx = 0;
        for (int i = 0; i < k - 1; i++) {
            int v = path[i];
            int u = path[i + 1];
            int addMn = 1;
            int addMx = 0;
            for (auto to : g[v]) {
                if (to == u) {
                    if (dist[1][to] + 1 == dist[1][v]) {
                        addMn = 0;
                    }
                } else {
                    if (dist[1][to] + 1 == dist[1][v]) {
                        addMx = 1;
                    }
                }
            }
            mn += addMn;
            mx += addMx;
        }
        cout << mn << " " << mx;
    }
};

signed main() {
    #ifdef _TIM
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _TIM
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll TEST_COUNT = 1;
//    cin >> TEST_COUNT;
    while (TEST_COUNT--) {
        Solution now;
        now.solve();
    }
    bye();
}
