#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e12 + 1;
const ll MOD = 1e9 + 7;
ll MAXN = 1e6 + 1;
const ll ALPH = 26;
const ld EPS = 1e-9;

#define size(x) (ll)(x).size()
#define all(x) (x).begin(),(x).end()

void bye() {
    cout << "\n";
    exit(0);
}

struct Dragon {
    ll y, z;
};

struct Solution {
    vector<ll> optA, optB;
    vector<ll> tree;
    vector<ll> add;
    ll h = 1;

    void push(ll v) {
        add[2 * v + 1] += add[v];
        add[2 * v + 2] += add[v];
        add[v] = 0;
    }

    ll get_true(ll v) {
        return tree[v] + add[v];
    }

    void build(ll v, ll l, ll r) {
        if (l + 1 == r) {
            tree[v] = -optB[l];
            return;
        }
        ll mid = (l + r) / 2;
        build(2 * v + 1, l, mid);
        build(2 * v + 2, mid, r);
        tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
    }

    void upd(ll v, ll l, ll r, ll ql, ll qr, ll val) {
        if (ql <= l && r <= qr) {
            add[v] += val;
            if (l + 1 == r) {
                return;
            }
            return;
        } else if (r <= ql || qr <= l) {
            if (l + 1 == r) {
                return;
            }
            return;
        }
        ll mid = (l + r) / 2;
        push(v);
        upd(2 * v + 1, l, mid, ql, qr, val);
        upd(2 * v + 2, mid, r, ql, qr, val);
        tree[v] = max(get_true(2 * v + 1), get_true(2 * v + 2));
    }

    void solve() {
        while (h < MAXN) {
            h *= 2;
        }
        MAXN = h;
        optA.resize(MAXN, INF);
        optB.resize(MAXN, INF);
        tree.resize(2 * MAXN, INF);
        add.resize(2 * MAXN, 0);
        ll n, m, p;
        ll mx = 0;
        cin >> n >> m >> p;
        for (ll i = 0; i < n; i++) {
            ll x, y;
            cin >> x >> y;
            mx = max(mx, x);
            optA[x] = min(optA[x], y);
        }
        for (ll i = 0; i < m; i++) {
            ll x, y;
            cin >> x >> y;
            optB[x] = min(optB[x], y);
        }
        for (ll i = MAXN - 2; i >= 0; i--) {
            optA[i] = min(optA[i], optA[i + 1]);
            optB[i] = min(optB[i], optB[i + 1]);
        }
        build(0, 0, h);
        vector<vector<Dragon> > pts(1e6 + 1);
        for (ll i = 0; i < p; i++) {
            ll x, y, z;
            cin >> x >> y >> z;
            pts[x + 1].push_back({y + 1, z});
        }
        ll ans = -1e18;
        for (ll i = 0; i <= mx; i++) {
            for (auto v : pts[i]) {
                upd(0, 0, h, v.y, MAXN, v.z);
            }
            ans = max(ans, get_true(0) - optA[i]);
        }
        cout << ans;
    }
};

signed main() {
    #ifdef _TIM
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _TIM
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll TEST_COUNT = 1;
//    cin >> TEST_COUNT;
    while (TEST_COUNT--) {
        Solution now;
        now.solve();
    }
    bye();
}
