#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <cmath>
#include <cassert>
#include <string>
#define int long long

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pa;
typedef pair<ll, ll> pal;

const int N = 1e6 + 5, inf = 1e18;

struct go{
	int a, c;
};

struct str{
	int x, y, z;
};

bool cmp(go a, go b){
	if (a.c == b.c)
		return a.a > b.a;
	return a.c < b.c;
}

bool cmp2(str a, str b){
	return a.y < b.y;
}

int t[4 * N], mod[4 * N];

void push(int v, int l, int r){
	if (l + 1 == r){
		t[v] += mod[v];
		mod[v] = 0;
		return ;
	}
	mod[2 * v] += mod[v], mod[2 * v + 1] += mod[v];
	mod[v] = 0;
	t[v] = max(t[2 * v] + mod[2 * v], t[2 * v + 1] + mod[2 * v + 1]);
}

void upd(int v, int l, int r, int L, int R, int x){
	push(v, l, r);
	if (L <= l && r <= R){
		mod[v] += x;
	} else if (l >= R || r <= L){
		return;
	} else{
		int m = (l + r) / 2;
		upd(2 * v, l, m, L, R, x);
		upd(2 * v + 1, m, r, L, R, x);
	}
	push(v, l, r);
}

int val(int v, int l, int r, int L, int R){
	push(v, l, r);
	if (L <= l && r <= R){
		return t[v];
	} else if (l >= R || r <= L){
		return -inf;
	} else{
		int m = (l + r) / 2;
		return max(val(2 * v, l, m, L, R), val(2 * v + 1, m, r, L, R));
	}
	push(v, l, r);
}

vector<go> good(vector<go> a){
	sort(a.begin(), a.end(), cmp);

	vector<go> y;
	y.push_back(a[0]);

	for (int i = 1; i < a.size(); ++i){
		if (y.back().c != a[i].c && y.back().a < a[i].a)
			y.push_back(a[i]);
	}
	return y;
}

signed main(){
	//freopen("txt.in", "r", stdin);
	
	int n, m, p;
	cin >> n >> m >> p;
	vector<go> a(n), b(m);
	for (int i = 0; i < n; ++i)
		cin >> a[i].a >> a[i].c;
	for (int i = 0; i < m; ++i)
		cin >> b[i].a >> b[i].c;
	a = good(a);
	b = good(b);
	vector<int> xx;
	for (int i = 0; i < b.size(); ++i)
		xx.push_back(b[i].a);
	n = a.size(), m = b.size();
	vector<str> ps(p);
	for (int i = 0; i < p; ++i)
		cin >> ps[i].x >> ps[i].y >> ps[i].z;

	sort(ps.begin(), ps.end(), cmp2);

	int ans = -inf;

	for (int i = 0; i < m; ++i){
		int delta = b[i].c;
		if (i)
			delta -= b[i - 1].c;
		upd(1, 0, N, b[i].a, b.back().a + 1, -delta);
	}
	int j = 0;
	for (int i = 0; i < n; ++i){
		int delta = a[i].c;
		if (i)
			delta -= a[i - 1].c;
		upd(1, 0, N, 0, N, -delta);
		while (j < ps.size() && a[i].a > ps[j].y){
			int cost = ps[j].z;
			int X = upper_bound(xx.begin(), xx.end(), ps[j].y) - xx.begin();
			j++;
			if (X == xx.size())
				continue;
			upd(1, 0, N, b[X].a, b.back().a + 1, cost);
		}
		ans = max(ans, val(1, 0, N, 0, N));
	}
	cout << ans;

	return 0;
}