#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define debug(x) cerr << #x << ": " << x << endl

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; };
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; };



namespace sgt
{
    const int logN = 20;
    const int N = 1 << logN;
    ll mx[4 * N];
    ll down[4 * N];
    
    void init()
    {
        fill(mx, mx + 4 * N, -1e18);
    }

    void push(int v, int vl, int vr)
    {
        if (vl == vr)
        {
            down[v] = 0;
            return;
        }
        if (!down[v]) return;
        down[v << 1] += down[v];
        mx[v << 1] += down[v];
        down[v << 1 | 1] += down[v];
        mx[v << 1 | 1] += down[v];
        down[v] = 0;
    }

    void upd(int v, int vl, int vr)
    {
        if (vl != vr) mx[v] = max(mx[v << 1], mx[v << 1 | 1]);
    }

    void mdf(int v, int vl, int vr, int pos, ll val)
    {
        if (vl == vr)
        {
            chkmax(mx[v], val);
            return;
        }
        int vm = (vl + vr) >> 1;
        push(v, vl, vr);
        if (pos <= vm)
            mdf(v << 1, vl, vm, pos, val);
        else
            mdf(v << 1 | 1, vm + 1, vr, pos, val);
        upd(v, vl, vr);
    }

    void add(int v, int vl, int vr, int l, int r, ll d)
    {
        if (l > r || vr < l || r < vl) return;
        if (l <= vl && vr <= r)
        {
            down[v] += d;
            mx[v] += d;
            return;
        }
        int vm = (vl + vr) >> 1;
        push(v, vl, vr);
        add(v << 1, vl, vm, l, r, d);
        add(v << 1 | 1, vm + 1, vr, l, r, d);
        upd(v, vl, vr);
    }

    ll gt()
    {
        return mx[1];
    }
}

struct gay
{
    int x, y;
    ll z;
    gay() {}
    gay(int _x, int _y, ll _z): x(_x), y(_y), z(_z)
    {}
};

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m, k;
    cin >> n >> m >> k;
    vector<pll> a(n), b(m);
    for (auto &e : a) cin >> e.first >> e.second;
    for (auto &e : b) cin >> e.first >> e.second;
    sort(all(a));
    sort(all(b));
    sgt::init();
    for (auto e : b)
    {
        sgt::mdf(1, 0, sgt::N - 1, e.first, -e.second);
    }
    vector<gay> g(k);
    for (auto &e : g) cin >> e.x >> e.y >> e.z;
    sort(all(g), [&](gay a, gay b) -> bool
    {
        return a.x < b.x;
    });
    int ptr = 0;
    ll ans = -1e18;
    for (int i = 0; i < n; ++i)
    {
        while (ptr < k && g[ptr].x < a[i].first)
        {
            int y = g[ptr].y;
            ll z = g[ptr++].z;
            sgt::add(1, 0, sgt::N - 1, y + 1, sgt::N - 1, z);
        }
        chkmax(ans, -a[i].second + sgt::gt());
    }
    cout << ans << '\n';

    return 0;
}
