#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define debug(x) cerr << #x << ": " << x << endl

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; };
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; };

const int maxN = 200005;
int n;
string s;
int pref[2][maxN];
int two[maxN];

struct Hash
{
    static const int MA = 1000992299, MB = 998244353;

    int a;
    int b;

    Hash(): a(0), b(0)
    {
    }
    Hash(int _a): a(_a), b(_a)
    {
    }
    Hash(int _a, int _b): a(_a), b(_b)
    {
    }

    Hash operator + (const Hash &H) const
    {
        return Hash((a + H.a) % MA, (b + H.b) % MB);
    }
    Hash operator + (int x) const
    {
        return Hash((a + x) % MA, (b + x) % MB);
    }
    Hash operator - (const Hash &H) const
    {
        return Hash((a - H.a + MA) % MA, (b - H.b + MB) % MB);
    }
    Hash operator - (int x) const
    {
        return Hash((a - x + MA) % MA, (b - x + MB) % MB);
    }
    Hash operator * (const Hash &H) const
    {
        return Hash((a * (ll)H.a) % MA, b * (ll)H.b % MB);
    }
    Hash operator * (int x) const
    {
        return Hash((a *(ll) x) % MA, b * (ll)x % MB);
    }
    bool operator == (const Hash &H)
    {
        return a == H.a && b == H.b;
    }
};
const Hash BASE(3);
Hash pw[maxN];
Hash ph[maxN];

Hash append(Hash h, char x)
{
    h = h * BASE + (x - '0' + 1);
}

ll gt(int u, int l, int r)
{
    return pref[u][r + 1] - pref[u][l];
}

ll gttwo(int l, int r)
{
    if (l >= r) return 0;
    return two[r + 1] - two[l + 1];
}

Hash gth(int l, int r)
{
    return ph[r + 1] - ph[l] * pw[r - l + 1];
}

bool eq(int l1, int r1, int l2, int r2)
{
    return gth(l1, r1) == gth(l2, r2);
}

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    pw[0] = Hash(1);
    for (int i = 1; i < maxN; ++i) pw[i] = BASE * pw[i - 1];

    cin >> n;
    cin >> s;
    ph[0] = 0;
    for (int i = 0; i < n; ++i)
    {
        ph[i + 1] = append(ph[i], s[i]);
        pref[0][i + 1] = pref[0][i];
        pref[1][i + 1] = pref[1][i];
        if (s[i] == '1')
        {
            pref[i & 1][i + 1]++;
        }
        two[i + 1] = two[i];
        if (i > 0 && s[i - 1] == '1' && s[i] == '1')
            ++two[i + 1];
    }
    int q;
    cin >> q;
    while (q--)
    {
        int l1, l2, len;
        cin >> l1 >> l2 >> len;
        l1--;
        l2--;
        int r1 = l1 + len - 1;
        int r2 = l2 + len - 1;
        if (gt(l1 & 1, l1, r1) != gt(l2 & 1, l2, r2) || gt(l1 & 1 ^ 1, l1, r1) != gt(l2 & 1 ^ 1, l2, r2))
        {
            cout << "No\n";
            continue;
        }
        if (!gttwo(l1, r1) || !gttwo(l2, r2))
        {
            if (eq(l1, r1, l2, r2))
                cout << "Yes\n";
            else
                cout << "No\n";
            continue;
        }
        else
        {
            cout << "Yes\n";
        }
    }

    return 0;
}
