#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define debug(x) cerr << #x << ": " << x << endl

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; };
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; };

const int maxN = 200005;
int n;
string s;

struct Hash
{
    static const int MA = 1000992299, MB = 998244353;

    int a;
    int b;

    Hash(): a(0), b(0)
    {
    }
    Hash(int _a): a(_a), b(_a)
    {
    }
    Hash(int _a, int _b): a(_a), b(_b)
    {
    }

    Hash operator + (const Hash &H) const
    {
        return Hash((a + H.a) % MA, (b + H.b) % MB);
    }
    Hash operator + (int x) const
    {
        return Hash((a + x) % MA, (b + x) % MB);
    }
    Hash operator - (const Hash &H) const
    {
        return Hash((a - H.a + MA) % MA, (b - H.b + MB) % MB);
    }
    Hash operator - (int x) const
    {
        return Hash((a - x + MA) % MA, (b - x + MB) % MB);
    }
    Hash operator * (const Hash &H) const
    {
        return Hash((a * (ll)H.a) % MA, b * (ll)H.b % MB);
    }
    Hash operator * (int x) const
    {
        return Hash((a *(ll) x) % MA, b * (ll)x % MB);
    }
    bool operator == (const Hash &H)
    {
        return a == H.a && b == H.b;
    }
};
const Hash BASE(3);
Hash pw[maxN];
Hash H[maxN];
int ln[maxN];
int R[maxN];

Hash append(Hash h, char x)
{
    h = h * BASE + (x - '0' + 1);
}

pair<Hash, int> gt(int l, int r)
{
    int z = min(r + 1, R[l]);
    if (~(z - l) & 1)
    {
        return {H[r + 1] - H[l] * pw[ln[r + 1] - ln[l]], 1}
    }
    else
    {
        int cnt = ln[r + 1] - ln[l + 1];
        Hash cur = H[r + 1] - H[l + 1] * pw[cnt];
        cur = cur + (pw[cnt] * 2);
        return {cur, 2};
    }
}

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    pw[0] = Hash(1);
    for (int i = 1; i < maxN; ++i) pw[i] = BASE * pw[i - 1];

    cin >> n;
    cin >> s;
    for (int i = 0; i < n; ++i)
    {
        if (s[i] == '0')
        {
            H[i + 1] = append(H[i], s[i]);
            ln[i + 1] = ln[i] + 1;
        }
        else
        {
            if (i > 0 && s[i - 1] == '1')
            {
                H[i + 1] = H[i - 1];
                ln[i + 1] = ln[i - 1];
            }
            else
            {
                H[i + 1] = append(H[i], s[i]);
                ln[i + 1] = ln[i] + 1;
            }
        }
    }
    R[n] = n;
    for (int i = n - 1; i >= 0; --i)
    {
        R[i] = R[i + 1];
        if (s[i] == '0')
            R[i] = i;
    }
    int q;
    cin >> q;
    while (q--)
    {
        int l1, l2, len;
        cin >> l1 >> l2 >> len;
        l1--;
        l2--;
        int r1 = l1 + len - 1;
        int r2 = l2 + len - 1;
        if (gt(l1, r1) == gt(l2, r2))
            cout << "Yes\n";
        else
            cout << "No\n";
    }

    return 0;
}
