#include<bits/stdc++.h>
using namespace std;

#define int long long
#define ll long long
#define ld long double

#define x first
#define y second
#define pb push_back
#define mp make_pair

#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()

const int N = 1e6 + 7;

struct Node {
    int mx, topush;

    Node() {}
    Node(int mx, int topush) : mx(mx), topush(topush) {}
};

Node comb(Node a, Node b) {
    return {max(a.mx, b.mx), 0};
}

Node t[4 * N];

void push(int v, int l, int r) {
    if (t[v].topush != 0) {
        if (r - l != 1) {
            t[2 * v].topush += t[v].topush;
            t[2 * v + 1].topush += t[v].topush;
        }
        t[v].mx += t[v].topush;
        t[v].topush = 0;
    }
}

void pull(int v, int l, int r) {
    int m = (l + r) / 2;
    push(2 * v, l, m);
    push(2 * v + 1, m, r);
    t[v] = comb(t[2 * v], t[2 * v + 1]);
}

int cost[N], need[N];

void build(int v, int l, int r) {
    if (r - l == 1) {
        t[v] = {-cost[l], 0};
    } else {
        int m = (l + r) / 2;
        build(2 * v, l, m);
        build(2 * v + 1, m, r);
        pull(v, l, r);
    }
}

void upd(int v, int tl, int tr, int l, int r, int x) {
    push(v, tl, tr);
    if (tl == l && tr == r) {
        t[v].topush += x;
    } else {
        int tm = (tl + tr) / 2;
        if (r <= tm) upd(2 * v, tl, tm, l, r, x); else {
            if (l >= tm) upd(2 * v + 1, tm, tr, l, r, x); else {
                upd(2 * v, tl, tm, l, tm, x);
                upd(2 * v + 1, tm, tr, tm, r, x);
            }
        }
        pull(v, tl, tr);
    }
}

int get(int v, int tl, int tr, int l, int r) {
    push(v, tl, tr);
    if (tl == l && tr == r) return t[v].mx;
    int tm = (tl + tr) / 2;
    if (r <= tm) return get(2 * v, tl, tm, l, r);
    if (l >= tm) return get(2 * v + 1, tm, tr, l, r);
    return max(get(2 * v, tl, tm, l, tm), get(2 * v + 1, tm, tr, tm, r));
}

struct Monster {
    int x, y, z;
    Monster() {}
    Monster(int x, int y, int z) : x(x), y(y), z(z) {}
};

bool cmp(const Monster &a, const Monster &b) {
    return a.y < b.y || (a.y == b.y && a.x < b.x) || (a.x == b.x && a.y == b.y && a.z > b.z);
}

const int oo = 1e9 + 7;

int n, m, p;
/*
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

void check() {
    n = rnd() % 100 + 1;
    m = rnd() % 100 + 1;
    p = rnd() % 100 + 1;
    for (int i = 0; i < N; i++) {
        cost[i] = oo;
        need[i] = oo;
    }
    for (int i = 0; i < n; i++) {
        int a = rnd() % 100 + 1, ca = rnd() % 100 + 1;
        cost[a] = min(cost[a], ca);
    }
    for (int i = 0; i < m; i++) {
        int b = rnd() % 100 + 1, cb = rnd() % 100 + 1;
        need[b] = min(need[b], cb);
    }
    for (int i = N - 2; i > -1; i--) cost[i] = min(cost[i], cost[i + 1]);
    for (int i = N - 2; i > -1; i--) need[i] = min(need[i], need[i + 1]);
    build(1, 0, N);
    vector<Monster> monsters;
    for (int i = 0; i < p; i++) {
        int x = rnd() % 100 + 1, y = rnd() % 100 + 1, z = rnd() % 100 + 1;
        x++;
        y++;
        if (cost[x] != oo && need[y] != oo) monsters.pb({x, y, z});
    }
    sort(all(monsters), cmp);
    int smartans = -cost[1] - need[1];
    for (auto monster : monsters) {
        upd(1, 0, N, monster.x, N, monster.z);
        smartans = max(smartans, get(1, 0, N, 0, N) - need[monster.y]);
    }
    int dumbans = -cost[1] - need[1];
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            int newans = 0;
            for (auto monster : monsters) {
                if (monster.x <= i && monster.y <= j) newans += monster.z;
            }
            newans -= cost[i];
            newans -= need[j];
            dumbans = max(dumbans, newans);
        }
    }
    if (smartans != dumbans) {
        cout << "fail\n";
        cout << smartans << " " << dumbans << endl;
        exit(0);
    }
}
*/
int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    /*int tests = 100;
    while (tests--) {
        check();
    }*/
    cin >> n >> m >> p;
    for (int i = 0; i < N; i++) {
        cost[i] = oo;
        need[i] = oo;
    }
    for (int i = 0; i < n; i++) {
        int a, ca;
        cin >> a >> ca;
        cost[a] = min(cost[a], ca);
    }
    for (int i = 0; i < m; i++) {
        int b, cb;
        cin >> b >> cb;
        need[b] = min(need[b], cb);
    }
    for (int i = N - 2; i > -1; i--) cost[i] = min(cost[i], cost[i + 1]);
    for (int i = N - 2; i > -1; i--) need[i] = min(need[i], need[i + 1]);
    build(1, 0, N);
    vector<Monster> monsters;
    for (int i = 0; i < p; i++) {
        int x, y, z;
        cin >> x >> y >> z;
        x++;
        y++;
        if (cost[x] != oo && need[y] != oo) monsters.pb({x, y, z});
    }
    sort(all(monsters), cmp);
    int ans = -cost[1] - need[1];
    for (auto monster : monsters) {
        upd(1, 0, N, monster.x, N, monster.z);
        ans = max(ans, get(1, 0, N, 0, N) - need[monster.y]);
    }
    cout << ans;
    return 0;
}
