#include <bits/stdc++.h>

// #define int long long
#define forn(i, from, to) for (int i = (int)(from); i < (int)(to); ++i)
#define vi vector <int>
#define pii pair <int, int>
#define all(v) v.begin(), v.end()

using namespace std;

const int INF = 1e9 + 9;

int n, m, p;

struct STM{
	vi mi;
	
	void resize(int _sz){
		mi.resize(_sz);
	}
	void build(int v, int vl, int vr, vi &a){
		if (vl == vr - 1){
			mi[v] = a[vl];
			return;
		}
		int mid = (vl + vr) >> 1;
		build(2 * v + 1, vl, mid, a);
		build(2 * v + 2, mid, vr, a);
		mi[v] = min(mi[2 * v + 1], mi[2 * v + 2]);
	}
};

struct STS{
	vi sum, add, mx, sz;
	
	void resize(int _sz){
		sum.resize(_sz);
		add.resize(_sz);
		sz.resize(_sz);
		mx.resize(_sz);
	}
	void build(int v, int vl, int vr){
		if (vl == vr - 1){
			sum[v] = add[v] = 0;
			sz[v] = 1;
			mx[v] = 0;
			return;
		}
		int mid = (vl + vr) >> 1;
		build(2 * v + 1, vl, mid);
		build(2 * v + 2, mid, vr);
		sz[v] = sz[2 * v + 1] + sz[2 * v + 2];
	}
	void push(int v, int vl, int vr){
		sum[v] += add[v] * sz[v];
		mx[v] += add[v];
		if (vl != vr - 1){
			add[2 * v + 1] += add[v];
			add[2 * v + 2] += add[v];
		}
		add[v] = 0;
	}
	void qAdd(int v, int vl, int vr, int l, int r, int val){
		push(v, vl, vr);
		if (r <= vl || l >= vr) return;
		if (l == vl && r == vr){
			add[v] += val;
			push(v, vl, vr);
			return;
		}
		int mid = (vl + vr) >> 1;
		qAdd(2 * v + 1, vl, mid, l, min(r, mid), val);
		qAdd(2 * v + 2, mid, vr, max(l, mid), r, val);
		sum[v] = sum[2 * v + 1] + sum[2 * v + 2];
		mx[v] = max(mx[2 * v + 1], mx[2 * v + 2]);
	}
	int qSum(int v, int vl, int vr, int l, int r){
		push(v, vl, vr);
		if (r <= vl || l >= vr) return 0;
		if (l == vl && r == vr)
			return sum[v];
		int mid = (vl + vr) >> 1;
		return qSum(2 * v + 1, vl, mid, l, min(r, mid)) + 
		qSum(2 * v + 2, mid, vr, max(l, mid), r);
	}
	int qMax(int v, int vl, int vr, int l, int r){
		push(v, vl, vr);
		if (r <= vl || l >= vr) return -INF;
		if (l == vl && r == vr)
			return mx[v];
		int mid = (vl + vr) >> 1;
		return max(qMax(2 * v + 1, vl, mid, l, min(r, mid)),
		qMax(2 * v + 2, mid, vr, max(l, mid), r));
	}
};

struct ev{
	int x, y, z;
	
	bool operator< (const ev &a) const {
		return make_tuple(x, y, z) < make_tuple(a.x, a.y, a.z);
	}
};

signed main(){
	ios_base::sync_with_stdio(false);
	cin.tie(); cout.tie();

#ifdef LOCAL
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif

	cin >> n >> m >> p;
	STS *tree = new STS;
	tree->resize(4 * (int(1e6) + 1));
	tree->build(0, 0, int(1e6) + 1);
	vector <pii> a(n), b(m);
	forn(i, 0, n){
		cin >> a[i].first >> a[i].second;
	}
	forn(i, 0, m){
		cin >> b[i].first >> b[i].second;
		//tree->qAdd(0, 0, int(1e6) + 1, b[i].first, int(1e6) + 1, b[i].second);
	}
	sort(all(b));
	int mi = b[m - 1].second;
	tree->qAdd(0, 0, int(1e6) + 1, b[m - 1].first + 1, int(1e6) + 1, -INF);
	for (int i = m - 1; i > 0; --i){
		mi = min(mi, b[i].second);
		tree->qAdd(0, 0, int(1e6) + 1, b[i - 1].first + 1, b[i].first + 1, -mi);
	}
	mi = min(mi, b[0].second);
	tree->qAdd(0, 0, int(1e6) + 1, 0, b[0].first + 1, -mi);
	//cout << tree->qMax(0, 0, int(1e6) + 1, 0, int(1e6) + 1) << '\n';
	sort(all(a));
	vector <ev> e(p);
	forn(i, 0, p)
		cin >> e[i].x >> e[i].y >> e[i].z;
	sort(all(e));
	//forn(i, 0, p){
	//	cout << e[i].x << ' ' << e[i].y << ' ' << e[i].z << '\n';
	//}
	int ans = -a[0].second - b[0].second;
	forn(i, 0, p){
		if (e[i].x < a[0].first && e[i].y < b[0].first)
			ans += e[i].z;
	}
	vi sufs(n, 0);
	sufs[n - 1] = a[n - 1].second;
	for (int i = n - 2; i >= 0; --i)
		sufs[i] = min(sufs[i + 1], a[i].second);
	int last = 0;
	forn(i, 0, p){
		tree->qAdd(0, 0, int(1e6) + 1, e[i].y + 1, int(1e6) + 1, e[i].z);
		int l = last - 1, r = n - 1;
		while (r - l > 1){
			int mid = (l + r) >> 1;
			if (a[mid].first > e[i].x)
				r = mid;
			else
				l = mid;
		}
		if (a[r].first < e[i].x)
			continue;
		//cout << e[i].x << ' ' << r << ' ' << tree->qMax(0, 0, int(1e6) + 1, 0, int(1e6) + 1) << '\n';
		ans = max(ans, tree->qMax(0, 0, int(1e6) + 1, 0, int(1e6) + 1) - sufs[r]);
	}
	cout << ans;
	return 0;
}
