#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>

using namespace std;

vector <vector <int> > G, G2;
int p[200005];
int d[200005];
bool used[200005];
int n, m, k;
queue <int> q;

void bfs(int v) {
	q.push(v);
	d[v] = 0;
	while (!(q.empty())) {
		v = q.front();
		q.pop();
		used[v] = true;
		for (int u : G[v]) {
			if (!used[u]) {
				d[u] = d[v] + 1;
				used[u] = true;
				q.push(u);
			}
		}
	}
}

int main() {
	cin >> n >> m;
	G.resize(n + 1);
	G2.resize(n + 1);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		G[v].push_back(u);
		G2[u].push_back(v);
	}
	cin >> k;
	for (int i = 0; i < k; ++i)
		cin >> p[i];
	int s, t;
	s = p[0];
	t = p[k - 1];
	bfs(t);
	int min, max;
	min = 0;
	max = 0;
	int v = s;
	for (int i = 1; i < k; ++i) {
		int u = p[i];
		if (d[v] != d[u] + 1) {
			min += 1;
			max += 1;
		} else {
			int cnt = 0;
			for (int j : G2[v]) {
				if (d[j] == d[u])
					++cnt;
			}
			if (cnt > 1)
				max += 1;
		}
		
		v = u;
	}
	cout << min << ' ' << max;
    return 0;
}
