#include <iostream>
#include <algorithm>

using namespace std;

long long tree[800005];
long long d[800005];
pair <long long, long long> a[200005], b[200005];
long long b1[200005];
pair <pair <long long, long long>, long long > x[200005];

void build(int v, int L, int R) {
	d[v] = 0;
	if (R - L == 1) {
		tree[v] = -b[L].second;
		return;
	}
	int M = (L + R) / 2;
	build(2 * v + 1, L, M);
	build(2 * v + 2, M, R);
	tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

void push(int v, int L, int R) {
	if (d[v]) {
		int M = (L + R) / 2;
		if (M - L >= 1) {
			d[2 * v + 1] += d[v];
		}
		if (R - M >= 1) {
			d[2 * v + 2] += d[v];
		}
		tree[v] += d[v];
		d[v] = 0;
	}
}

void upd(int v, int L, int R, int l, int r, long long x) {
	push(v, L, R);
	if (l >= R || L >= r) {
		return;
	}
	if (l <= L && R <= r) {
		d[v] += x;
		push(v, L, R);
		return;
	}
	int M = (L + R) / 2;
	upd(2 * v + 1, L, M, l, r, x);
	upd(2 * v + 2, M, R, l, r, x);
	tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

int main() {
	int n, m, p;
	cin >> n >> m >> p;
	for (int i = 0; i < n; ++i)
		cin >> a[i].first >> a[i].second;
	for (int i = 0; i < m; ++i)
		cin >> b[i].first >> b[i].second;
	sort(a, a + n);
	sort(b, b + m);
	for (int i = 0; i < m; ++i)
		b1[i] = b[i].first;
	build(0, 0, m);
	for (int i = 0; i < p; ++i)
		cin >> x[i].first.first >> x[i].first.second >> x[i].second;
	sort(x, x + p);
	int j = 0;
	long long ans = -a[0].second - b[0].second;
	for (int i = 0; i < n; ++i) {
		while (j < p && x[j].first.first < a[i].first) {
			int k;
			k = upper_bound(b1, b1 + m, x[j].first.second) - b1;
			upd(0, 0, m, k, m, x[j].second);
			++j;
		}
		push(0, 0, m);
		ans = max(ans, tree[0] - a[i].second);
	}
	cout << ans;
	return 0;
}
