#include "bits/stdc++.h"

using namespace std;

typedef long long ll;

#define int ll

const int BIG_INT = 1e9 + 33;
vector<int> dist;
vector<vector<int>> graph;
vector<bool> used;

int dfs(int v) {
    if (used[v])
        return BIG_INT;
    if (dist[v] < BIG_INT)
        return dist[v];
    int mi = BIG_INT;
    used[v] = true;
    for (auto u : graph[v])
    {
        mi = min(mi, dfs(u));
    }
    used[v] = false;
    dist[v] = mi + 1;
    return mi + 1;
}

signed main() {
    int n, m;
    cin >> n >> m;
    graph = vector<vector<int>>(n);
    used = vector<bool>(n, false);

    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        graph[a - 1].push_back(b - 1);
    }

    int k;
    cin >> k;

    int sure = 0;
    int maybe = 0;

    vector<int> route(k);
    for (int i = 0; i < k; i++)
        cin >> route[i];

    dist = vector<int>(n, BIG_INT);
    int s = route[0], t = route[k - 1];
    dist[t - 1] = 0;
    for (int i = 1; i < k; i++)
    {
        int v = route[k - 1 - i] - 1;
        int olen = i;
        bool wereLess = false;
        bool wereEqual = false;
        for (auto u : graph[v]) {
            if (u == route[k - i] - 1)
                continue;
            int len = dfs(u) + 1;
            if (len < olen)
            {
                sure++;
                wereLess = true;
                break;
            }
            if (len == olen)
            {
                wereEqual = true;
            }
        }
        if (wereLess)
            continue;
        if (wereEqual)
            maybe++;
    }
    cout << sure << " " << sure + maybe << "\n";
}