
/*
Буду очень признателен за взлом :)
*/

#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <assert.h>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <stack>
#include <cmath>

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define int long long

const int INF = 2e10;
const int MOD = 1e9 + 7;
const int MB = 20;

using namespace std;

vector<vector<int>> g;
vector<int> h, link, a;

void dfs1(int v, int p = -1){
	link[v] = a.size();
	h[v] = p == -1 ? 0 : h[p] + 1;
	a.pb(v);
	for(int i =0 ;i<g[v].size();i++){
		int u = g[v][i];
		if(u != p){
			dfs1(u, v);
			a.pb(v);
		}
	}
}

struct SparseTable{
	vector<vector<pair<int, int>>> t;
	vector<int> log;
	SparseTable(int n){
		t.resize(MB, vector<pair<int, int>>(n));
		for(int i = 0;i<n;i++){
			t[0][i] = make_pair(h[a[i]], a[i]);
		}
		for(int bit = 0;bit < MB - 1;bit++){
			for(int i = 0, h = 1 << bit, j = i + h;j + h <=n;i++,j++){
				t[bit + 1][i] = t[bit][i].first < t[bit][j].first ? t[bit][i] : t[bit][j];
			}
		}
		log.resize(n + 1);
		for(int i = 2;i<=n;i++){
			log[i] = log[i / 2] + 1;
		}
	}

	int get(int l, int r){
		if(l > r) swap(l, r);
		int b = log[r - l + 1];
		r = r - (1 << b) + 1;
		return t[b][l].first < t[b][r].first ? t[b][l].second : t[b][r].second;
	}
};

bool cmp(const int& one, const int& two){
	return link[one] < link[two];
}

vector<int> nums;

int getLca(int one, int two, SparseTable& sparse){
	int l = link[one];
	int r = link[two];
	int res = sparse.get(l, r);
	return res;
}

void go(int n, SparseTable& sparse){
	int k , m;
	cin >> k >> m;
	vector<int> virus(k), s(k);
	for(int i = 0;i<k;i++){
		cin >> virus[i] >> s[i];
		virus[i]--;
	}
	vector<int> interest(m);
	for(int i =0 ;i<m;i++){
		cin >> interest[i];
		interest[i]--;
	}
	vector<int> help;
	
	for(int i = 0;i<k;i++) help.pb(virus[i]);
	for(int i =0 ;i<m;i++) help.pb(interest[i]);
	sort(all(help), cmp);
	int x = help.size();
	for(int i = 0;i<x - 1;i++){
		help.pb(getLca(help[i], help[i + 1], sparse));
	}
	sort(all(help), cmp);
	help.erase(unique(all(help)), help.end());


	x = help.size();
	vector<vector<pair<int, int>>> ng(x);
	for(int i = 0;i<x;i++){
		nums[help[i]] = i;
	}

	stack<int> st;
	st.push(help[0]);
	for(int i = 1;i<x;i++){
		int v = help[i];
		while(true){
			int u = st.top();
			st.pop();
			int lca = getLca(v, u, sparse);
			if(lca != u) continue;
			int d = h[v] - h[u];
			ng[nums[v]].pb(make_pair(nums[u], d));
			ng[nums[u]].pb(make_pair(nums[v], d));
			st.push(u);
			break;
		}
		st.push(v);
	}

	deque<pair<pair<int, int>, pair<int, int>>> q;
	for(int i = 0;i<k;i++){
		q.pb(make_pair(make_pair(nums[virus[i]], 1), make_pair(s[i], i)));
	}

	vector<int> used(x, -1);
	while(!q.empty()){
		pair<pair<int, int>, pair<int ,int>> p = q.front();
		q.pop_front();
		int v = p.first.first;
		int ev = p.first.second;
		int ost = p.second.first;
		int vir = p.second.second;
		if(used[v] != -1 && used[v] != vir) continue;

		if(!ev){
			if(s[vir] >= ost){
				q.push_front(make_pair(make_pair(v, 1), make_pair(s[vir] - ost, vir)));
				used[v] = vir;
			}else{
				q.push_back(make_pair(make_pair(v, 0), make_pair(ost - s[vir], vir)));
			}
			continue;
		}

		used[v] = vir;
		for(int i = 0;i<ng[v].size();i++){
			int u = ng[v][i].first;
			int w = ng[v][i].second;
			if(ost >= w && used[u] == -1){
				used[u] = vir;
				q.push_front(make_pair(make_pair(u, 1), make_pair(ost - w, vir)));
			}
			if(ost < w && used[u] == -1){
				q.push_back(make_pair(make_pair(u, 0), make_pair(w - ost, vir)));
			}
		}
	}

	for(int i = 0;i<m;i++){
		int v = interest[i];
		v = nums[v];
		cout << used[v] + 1 << " ";
	}
	cout << '\n';
}


void solve(){
	int n;
	cin >> n;
	g.resize(n);
	for(int i = 0;i<n - 1;i++){
		int from, to;
		cin >> from >> to;
		from--;to--;
		g[from].pb(to);
		g[to].pb(from);
	}
	h.resize(n);
	link.resize(n);
	dfs1(0);
	SparseTable sparse(a.size());
	nums.resize(n);
	int q;
	cin >> q;
	for(int i = 0;i<q;i++){
		go(n, sparse);
	}
}

signed main(){
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	solve();
}

/*
Не забываем про претесты!!!
Рассматриваем все частные случаи!!!
Получаем призера!!!
*/