#include <bits/stdc++.h>
using namespace std;
#define int long long
const int INF = 1000000000000000;

struct npc {
    int a, b;
    int price;
};

void reduce(vector<pair <int, int>>& a) {
    vector <pair <int, int>> ans;
    sort(a.begin(), a.end());
    for (auto& i : a) {
        while (!ans.empty() && i.second < ans.back().second) {
            ans.pop_back();
        }
        ans.push_back(i);
    }
    a = ans;
}

struct node {
    int l, r;
    node *cl, *cr;
    int sum = 0;
};

node* build(int l, int r) {
    node* root = new node();
    root->l = l;
    root-> r = r;
    root->sum = 0;
    if (l != r) {
        int m = (l + r) / 2;
        root->cl = build(l, m);
        root->cr = build(m + 1, r);
    }
    return root;
}

node* change(node* root, int x, int val) {
    if (x < root->l || x > root->r) return root;
    if (root->l == x && root->r == x) {
        node* nw = new node;
        nw->l = x;
        nw->r = x;
        nw->sum = root->sum + val;
        return nw;
    }
    node* nw = new node;
    nw->l = root->l;
    nw->r = root->r;
    nw->cl = change(root->cl, x, val);
    nw->cr = change(root->cr, x, val);
    nw->sum = nw->cl->sum + nw->cr->sum;
    return nw;
}

int query(node* root, int l, int r) {
    if (l <= root->l && root->r <= r) return root->sum;
    else if (l > root->r || r < root->l) return 0;
    return query(root->cl, l, r) + query(root->cr, l, r);
}

int ans = -1000000000000000;
vector <pair <int, int>> a, b;
vector <npc> c;
vector <node*> nodes, nodes2;

int get_price(int i, int j) {
    int price = -a[i].second - b[j].second;

    int get1 = 0;
    for (auto& u : c) {
        if (a[i].first >= u.a && b[j].first >= u.b) {
            get1 += u.price;
        }
    }
//    if (get1 != query(nodes2[i], 0, b[j].first)) {
//        cout << "ALARM\n";
//    }

    price += query(nodes2[i], 0, b[j].first);
    return price;
}

void solve(int l, int r, int _l, int _r) {
    int mid = (l + r) / 2;
    int kopt = _l, kans = -1000000000000000;
    for (int k = _l; k <= _r; ++k) {
        int to = get_price(mid, k);
        if (to > kans) {
            kans = to;
            kopt = k;
        }
    }
    ans = max(ans, kans);
    if (l < mid) solve(l, mid - 1, _l, kopt);
    if (mid < r) solve(mid + 1, r, kopt, _r);
}

void solve() {
    int n, m, p;
    cin >> n >> m >> p;
    a.resize(n);
    b.resize(m);
    c.resize(p);
    for (auto& i : a) cin >> i.first >> i.second;
    for (auto& i : b) cin >> i.first >> i.second;
    for (auto& i : c) {
        cin >> i.a >> i.b >> i.price;
        ++i.a;
        ++i.b;
    }
    reduce(a);
    reduce(b);
    sort(c.begin(), c.end(), [&](npc p1, npc p2){ return p1.a < p2.a; });

    nodes.push_back(build(0, 100000));
    int pt = 0;
    for (int i = 0; i < n; ++i) {
        while (pt < c.size() && c[pt].a <= a[i].first) {
            nodes.push_back(change(nodes.back(), c[pt].b, c[pt].price));
            ++pt;
        }
        nodes2.push_back(nodes.back());
    }

    /*set <int> st;
    map <int, int> mp;
    int ppp = 0;
    for (auto& i : a) st.insert(i.first);
    for (auto& i : c) st.insert(i.a);

    for (auto& i : st) {
        mp[i] = ppp++;
    }
    for (auto& i : a) i.first = mp[i.first];
    for (auto& i : c) i.a = mp[i.a];
    set <int> st2;
    map <int, int> mp2;
    ppp = 0;
    for (auto& i : b) st2.insert(i.first);
    for (auto& i : c) st2.insert(i.b);
    for (auto& i : st2) {
        mp2[i] = ppp++;
    }
    for (auto& i : b) i.first = mp2[i.first];
    for (auto& i : c) i.b = mp2[i.b];*/

    solve(0, n - 1, 0, m - 1);
    cout << ans;
}

int32_t main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif
    int test = 1;
//    cin >> t;
    while (test--) {
        solve();
    }
}